/* DUPLICATOR-LITE (PHP BUILD MODE) MYSQL SCRIPT CREATED ON : 2023-01-19 04:47:08 */

/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

SET FOREIGN_KEY_CHECKS = 0;

CREATE TABLE `wp_commentmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `comment_id` (`comment_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_comments` (
  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',
  `comment_author` tinytext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_author_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_url` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_author_IP` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `comment_content` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `comment_karma` int(11) NOT NULL DEFAULT '0',
  `comment_approved` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '1',
  `comment_agent` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'comment',
  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`comment_ID`),
  KEY `comment_post_ID` (`comment_post_ID`),
  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),
  KEY `comment_date_gmt` (`comment_date_gmt`),
  KEY `comment_parent` (`comment_parent`),
  KEY `comment_author_email` (`comment_author_email`(10))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_duplicator_packages` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(250) NOT NULL,
  `hash` varchar(50) NOT NULL,
  `status` int(11) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `owner` varchar(60) NOT NULL,
  `package` longtext NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hash` (`hash`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

CREATE TABLE `wp_links` (
  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `link_url` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_name` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_image` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_target` varchar(25) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_description` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_visible` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'Y',
  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',
  `link_rating` int(11) NOT NULL DEFAULT '0',
  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `link_rel` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `link_notes` mediumtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `link_rss` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`link_id`),
  KEY `link_visible` (`link_visible`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_options` (
  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `option_name` varchar(191) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `option_value` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `autoload` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'yes',
  PRIMARY KEY (`option_id`),
  UNIQUE KEY `option_name` (`option_name`),
  KEY `autoload` (`autoload`)
) ENGINE=InnoDB AUTO_INCREMENT=56564 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_postmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `post_id` (`post_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=470 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_posts` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',
  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_title` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_excerpt` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'publish',
  `comment_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `ping_status` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'open',
  `post_password` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `post_name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `to_ping` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `pinged` text COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `post_content_filtered` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guid` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `menu_order` int(11) NOT NULL DEFAULT '0',
  `post_type` varchar(20) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT 'post',
  `post_mime_type` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `comment_count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `post_name` (`post_name`(191)),
  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),
  KEY `post_parent` (`post_parent`),
  KEY `post_author` (`post_author`)
) ENGINE=InnoDB AUTO_INCREMENT=234 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_relationships` (
  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `term_order` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`object_id`,`term_taxonomy_id`),
  KEY `term_taxonomy_id` (`term_taxonomy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_term_taxonomy` (
  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `description` longtext COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',
  `count` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_taxonomy_id`),
  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),
  KEY `taxonomy` (`taxonomy`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_termmeta` (
  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`meta_id`),
  KEY `term_id` (`term_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_terms` (
  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `slug` varchar(200) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `term_group` bigint(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`term_id`),
  KEY `slug` (`slug`(191)),
  KEY `name` (`name`(191))
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_usermeta` (
  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',
  `meta_key` varchar(255) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `meta_value` longtext COLLATE utf8mb4_unicode_520_ci,
  PRIMARY KEY (`umeta_id`),
  KEY `user_id` (`user_id`),
  KEY `meta_key` (`meta_key`(191))
) ENGINE=InnoDB AUTO_INCREMENT=35 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_users` (
  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `user_login` varchar(60) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_pass` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_nicename` varchar(50) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_email` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_url` varchar(100) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_activation_key` varchar(255) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  `user_status` int(11) NOT NULL DEFAULT '0',
  `display_name` varchar(250) COLLATE utf8mb4_unicode_520_ci NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `user_login_key` (`user_login`),
  KEY `user_nicename` (`user_nicename`),
  KEY `user_email` (`user_email`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_yoast_indexable` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `permalink` longtext COLLATE utf8mb4_unicode_520_ci,
  `permalink_hash` varchar(40) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `object_id` bigint(20) DEFAULT NULL,
  `object_type` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `object_sub_type` varchar(32) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `author_id` bigint(20) DEFAULT NULL,
  `post_parent` bigint(20) DEFAULT NULL,
  `title` text COLLATE utf8mb4_unicode_520_ci,
  `description` mediumtext COLLATE utf8mb4_unicode_520_ci,
  `breadcrumb_title` text COLLATE utf8mb4_unicode_520_ci,
  `post_status` varchar(20) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `is_public` tinyint(1) DEFAULT NULL,
  `is_protected` tinyint(1) DEFAULT '0',
  `has_public_posts` tinyint(1) DEFAULT NULL,
  `number_of_pages` int(11) unsigned DEFAULT NULL,
  `canonical` longtext COLLATE utf8mb4_unicode_520_ci,
  `primary_focus_keyword` varchar(191) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `primary_focus_keyword_score` int(3) DEFAULT NULL,
  `readability_score` int(3) DEFAULT NULL,
  `is_cornerstone` tinyint(1) DEFAULT '0',
  `is_robots_noindex` tinyint(1) DEFAULT '0',
  `is_robots_nofollow` tinyint(1) DEFAULT '0',
  `is_robots_noarchive` tinyint(1) DEFAULT '0',
  `is_robots_noimageindex` tinyint(1) DEFAULT '0',
  `is_robots_nosnippet` tinyint(1) DEFAULT '0',
  `twitter_title` text COLLATE utf8mb4_unicode_520_ci,
  `twitter_image` longtext COLLATE utf8mb4_unicode_520_ci,
  `twitter_description` longtext COLLATE utf8mb4_unicode_520_ci,
  `twitter_image_id` varchar(191) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `twitter_image_source` text COLLATE utf8mb4_unicode_520_ci,
  `open_graph_title` text COLLATE utf8mb4_unicode_520_ci,
  `open_graph_description` longtext COLLATE utf8mb4_unicode_520_ci,
  `open_graph_image` longtext COLLATE utf8mb4_unicode_520_ci,
  `open_graph_image_id` varchar(191) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `open_graph_image_source` text COLLATE utf8mb4_unicode_520_ci,
  `open_graph_image_meta` mediumtext COLLATE utf8mb4_unicode_520_ci,
  `link_count` int(11) DEFAULT NULL,
  `incoming_link_count` int(11) DEFAULT NULL,
  `prominent_words_version` int(11) unsigned DEFAULT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `blog_id` bigint(20) NOT NULL DEFAULT '1',
  `language` varchar(32) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `region` varchar(32) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `schema_page_type` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `schema_article_type` varchar(64) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  `has_ancestors` tinyint(1) DEFAULT '0',
  `estimated_reading_time_minutes` int(11) DEFAULT NULL,
  `version` int(11) DEFAULT '1',
  `object_last_modified` datetime DEFAULT NULL,
  `object_published_at` datetime DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `object_type_and_sub_type` (`object_type`,`object_sub_type`),
  KEY `object_id_and_type` (`object_id`,`object_type`),
  KEY `permalink_hash_and_object_type` (`permalink_hash`,`object_type`),
  KEY `subpages` (`post_parent`,`object_type`,`post_status`,`object_id`),
  KEY `prominent_words` (`prominent_words_version`,`object_type`,`object_sub_type`,`post_status`),
  KEY `published_sitemap_index` (`object_published_at`,`is_robots_noindex`,`object_type`,`object_sub_type`)
) ENGINE=InnoDB AUTO_INCREMENT=80 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_yoast_indexable_hierarchy` (
  `indexable_id` int(11) unsigned NOT NULL DEFAULT '0',
  `ancestor_id` int(11) unsigned NOT NULL DEFAULT '0',
  `depth` int(11) unsigned DEFAULT NULL,
  `blog_id` bigint(20) NOT NULL DEFAULT '1',
  PRIMARY KEY (`indexable_id`,`ancestor_id`),
  KEY `indexable_id` (`indexable_id`),
  KEY `ancestor_id` (`ancestor_id`),
  KEY `depth` (`depth`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_yoast_migrations` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `version` varchar(191) COLLATE utf8mb4_unicode_520_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `wp_yoast_migrations_version` (`version`)
) ENGINE=InnoDB AUTO_INCREMENT=24 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_yoast_primary_term` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `post_id` bigint(20) DEFAULT NULL,
  `term_id` bigint(20) DEFAULT NULL,
  `taxonomy` varchar(32) COLLATE utf8mb4_unicode_520_ci NOT NULL,
  `created_at` datetime DEFAULT NULL,
  `updated_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `blog_id` bigint(20) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `post_taxonomy` (`post_id`,`taxonomy`),
  KEY `post_term` (`post_id`,`term_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_520_ci;

CREATE TABLE `wp_yoast_seo_links` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) DEFAULT NULL,
  `post_id` bigint(20) unsigned DEFAULT NULL,
  `target_post_id` bigint(20) unsigned DEFAULT NULL,
  `type` varchar(8) DEFAULT NULL,
  `indexable_id` int(11) unsigned DEFAULT NULL,
  `target_indexable_id` int(11) unsigned DEFAULT NULL,
  `height` int(11) unsigned DEFAULT NULL,
  `width` int(11) unsigned DEFAULT NULL,
  `size` int(11) unsigned DEFAULT NULL,
  `language` varchar(32) DEFAULT NULL,
  `region` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `link_direction` (`post_id`,`type`),
  KEY `indexable_link_direction` (`indexable_id`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=114 DEFAULT CHARSET=utf8;

/***** TABLE CREATION END *****/


/* INSERT TABLE DATA: wp_duplicator_packages */
INSERT INTO `wp_duplicator_packages` VALUES("1", "2023_01_19_cabinetorthopediepodologiea", "7e5b19f61af022e77317_20230119044702", "21", "2023-01-19 04:47:08", "Admin-site-wp", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2023-01-19 04:47:02\";s:7:\"Version\";s:5:\"1.5.1\";s:9:\"VersionWP\";s:5:\"6.1.1\";s:9:\"VersionDB\";s:6:\"5.7.40\";s:10:\"VersionPHP\";s:6:\"7.4.29\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";i:1;s:4:\"Name\";s:38:\"2023_01_19_cabinetorthopediepodologiea\";s:4:\"Hash\";s:35:\"7e5b19f61af022e77317_20230119044702\";s:8:\"NameHash\";s:74:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";s:84:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";s:4:\"21.1\";s:6:\"WPUser\";s:13:\"Admin-site-wp\";s:7:\"Archive\";O:11:\"DUP_Archive\":26:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";s:86:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702_archive.zip\";s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:17:\"/home/orthopa/www\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:9:\"dirsCount\";i:1017;s:5:\"Files\";a:0:{}s:10:\"filesCount\";i:7659;s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":6:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":7:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2023-01-19 04:47:02\";s:7:\"Version\";s:5:\"1.5.1\";s:9:\"VersionWP\";s:5:\"6.1.1\";s:9:\"VersionDB\";s:6:\"5.7.40\";s:10:\"VersionPHP\";s:6:\"7.4.29\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:38:\"2023_01_19_cabinetorthopediepodologiea\";s:4:\"Hash\";s:35:\"7e5b19f61af022e77317_20230119044702\";s:8:\"NameHash\";s:74:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:21;s:9:\"Installer\";O:13:\"DUP_Installer\":15:{s:4:\"File\";s:92:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702_installer.php.bak\";s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:13:\"OptsDBCharset\";s:0:\"\";s:15:\"OptsDBCollation\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:65;s:17:\"\0*\0origFileManger\";N;s:32:\"\0DUP_Installer\0configTransformer\";O:44:\"Duplicator\\Libs\\WpConfig\\WPConfigTransformer\":3:{s:17:\"\0*\0wp_config_path\";s:31:\"/home/orthopa/www/wp-config.php\";s:16:\"\0*\0wp_config_src\";N;s:13:\"\0*\0wp_configs\";a:0:{}}}s:8:\"Database\";O:12:\"DUP_Database\":15:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";s:87:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702_database.sql\";s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":23:{s:9:\"buildMode\";s:3:\"PHP\";s:11:\"charSetList\";a:0:{}s:13:\"collationList\";a:0:{}s:10:\"engineList\";a:0:{}s:17:\"isTablesUpperCase\";b:0;s:15:\"isNameUpperCase\";b:0;s:4:\"name\";s:0:\"\";s:15:\"tablesBaseCount\";i:0;s:16:\"tablesFinalCount\";i:0;s:20:\"muFilteredTableCount\";i:0;s:14:\"tablesRowCount\";i:0;s:16:\"tablesSizeOnDisk\";i:0;s:10:\"tablesList\";a:0:{}s:18:\"varLowerCaseTables\";i:0;s:8:\"dbEngine\";s:0:\"\";s:7:\"version\";i:0;s:14:\"versionComment\";i:0;s:9:\"viewCount\";i:0;s:9:\"procCount\";i:0;s:9:\"funcCount\";i:0;s:11:\"triggerList\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:1;s:24:\"\0DUP_Database\0tempDbPath\";s:122:\"/home/orthopa/www/wp-snapshots/tmp/2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702_database.sql\";s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;s:19:\"sameNameTableExists\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:65;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:3:{i:0;s:26:\"/home/orthopa/www/wp-admin\";i:1;s:29:\"/home/orthopa/www/wp-includes\";i:2;s:38:\"/home/orthopa/www/wp-content/languages\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:7:{i:0;s:17:\"/home/orthopa/www\";i:1;s:17:\"/home/orthopa/www\";i:2;s:28:\"/home/orthopa/www/wp-content\";i:3;s:36:\"/home/orthopa/www/wp-content/uploads\";i:4;s:36:\"/home/orthopa/www/wp-content/plugins\";i:5;s:39:\"/home/orthopa/www/wp-content/mu-plugins\";i:6;s:35:\"/home/orthopa/www/wp-content/themes\";}s:31:\"\0DUP_Archive\0relativeFiltersDir\";a:2:{i:0;s:34:\"/home/orthopa/www/wp-snapshots/tmp\";i:1;s:15:\"backups-dup-pro\";}s:24:\"\0DUP_Archive\0listFileObj\";N;s:23:\"\0DUP_Archive\0listDirObj\";N;}s:9:\"Installer\";r:86;s:8:\"Database\";r:105;s:13:\"BuildProgress\";r:144;}");

/* INSERT TABLE DATA: wp_options */
INSERT INTO `wp_options` VALUES("1", "siteurl", "https://www.orthopedie-podologie-anthoard-grenoble.com", "yes");
INSERT INTO `wp_options` VALUES("2", "home", "https://www.orthopedie-podologie-anthoard-grenoble.com", "yes");
INSERT INTO `wp_options` VALUES("3", "blogname", "Cabinet Orthopedie Podologie a Grenoble ANTHOARD - Aubertin", "yes");
INSERT INTO `wp_options` VALUES("4", "blogdescription", "Présentation du Cabinet d&#039;orthopédie de Podologie et de Posturologie ANTHOARD de M Aubertin Roger à Grenoble", "yes");
INSERT INTO `wp_options` VALUES("5", "users_can_register", "0", "yes");
INSERT INTO `wp_options` VALUES("6", "admin_email", "contact@cabare.net", "yes");
INSERT INTO `wp_options` VALUES("7", "start_of_week", "1", "yes");
INSERT INTO `wp_options` VALUES("8", "use_balanceTags", "0", "yes");
INSERT INTO `wp_options` VALUES("9", "use_smilies", "1", "yes");
INSERT INTO `wp_options` VALUES("10", "require_name_email", "1", "yes");
INSERT INTO `wp_options` VALUES("11", "comments_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("12", "posts_per_rss", "10", "yes");
INSERT INTO `wp_options` VALUES("13", "rss_use_excerpt", "0", "yes");
INSERT INTO `wp_options` VALUES("14", "mailserver_url", "mail.example.com", "yes");
INSERT INTO `wp_options` VALUES("15", "mailserver_login", "login@example.com", "yes");
INSERT INTO `wp_options` VALUES("16", "mailserver_pass", "password", "yes");
INSERT INTO `wp_options` VALUES("17", "mailserver_port", "110", "yes");
INSERT INTO `wp_options` VALUES("18", "default_category", "1", "yes");
INSERT INTO `wp_options` VALUES("19", "default_comment_status", "open", "yes");
INSERT INTO `wp_options` VALUES("20", "default_ping_status", "open", "yes");
INSERT INTO `wp_options` VALUES("21", "default_pingback_flag", "0", "yes");
INSERT INTO `wp_options` VALUES("22", "posts_per_page", "1", "yes");
INSERT INTO `wp_options` VALUES("23", "date_format", "j F Y", "yes");
INSERT INTO `wp_options` VALUES("24", "time_format", "G\\hi", "yes");
INSERT INTO `wp_options` VALUES("25", "links_updated_date_format", "d F Y G\\hi", "yes");
INSERT INTO `wp_options` VALUES("26", "comment_moderation", "0", "yes");
INSERT INTO `wp_options` VALUES("27", "moderation_notify", "1", "yes");
INSERT INTO `wp_options` VALUES("28", "permalink_structure", "/%postname%/", "yes");
INSERT INTO `wp_options` VALUES("30", "hack_file", "0", "yes");
INSERT INTO `wp_options` VALUES("31", "blog_charset", "UTF-8", "yes");
INSERT INTO `wp_options` VALUES("32", "moderation_keys", "", "no");
INSERT INTO `wp_options` VALUES("33", "active_plugins", "a:7:{i:0;s:41:\"advanced-gutenberg/advanced-gutenberg.php\";i:1;s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";i:2;s:25:\"duplicator/duplicator.php\";i:3;s:33:\"kadence-blocks/kadence-blocks.php\";i:4;s:33:\"virtue-toolkit/virtue_toolkit.php\";i:5;s:24:\"wordpress-seo/wp-seo.php\";i:6;s:33:\"wp-maintenance/wp-maintenance.php\";}", "yes");
INSERT INTO `wp_options` VALUES("34", "category_base", "", "yes");
INSERT INTO `wp_options` VALUES("35", "ping_sites", "http://rpc.pingomatic.com/", "yes");
INSERT INTO `wp_options` VALUES("36", "comment_max_links", "2", "yes");
INSERT INTO `wp_options` VALUES("37", "gmt_offset", "", "yes");
INSERT INTO `wp_options` VALUES("38", "default_email_category", "1", "yes");
INSERT INTO `wp_options` VALUES("39", "recently_edited", "a:3:{i:0;s:70:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/kadence-blocks.php\";i:1;s:52:\"/home/orthopa/www/wp-content/themes/virtue/style.css\";i:2;s:0:\"\";}", "no");
INSERT INTO `wp_options` VALUES("40", "template", "virtue", "yes");
INSERT INTO `wp_options` VALUES("41", "stylesheet", "virtue", "yes");
INSERT INTO `wp_options` VALUES("42", "comment_registration", "0", "yes");
INSERT INTO `wp_options` VALUES("43", "html_type", "text/html", "yes");
INSERT INTO `wp_options` VALUES("44", "use_trackback", "0", "yes");
INSERT INTO `wp_options` VALUES("45", "default_role", "subscriber", "yes");
INSERT INTO `wp_options` VALUES("46", "db_version", "53496", "yes");
INSERT INTO `wp_options` VALUES("47", "uploads_use_yearmonth_folders", "1", "yes");
INSERT INTO `wp_options` VALUES("48", "upload_path", "", "yes");
INSERT INTO `wp_options` VALUES("49", "blog_public", "1", "yes");
INSERT INTO `wp_options` VALUES("50", "default_link_category", "2", "yes");
INSERT INTO `wp_options` VALUES("51", "show_on_front", "page", "yes");
INSERT INTO `wp_options` VALUES("52", "tag_base", "", "yes");
INSERT INTO `wp_options` VALUES("53", "show_avatars", "1", "yes");
INSERT INTO `wp_options` VALUES("54", "avatar_rating", "G", "yes");
INSERT INTO `wp_options` VALUES("55", "upload_url_path", "", "yes");
INSERT INTO `wp_options` VALUES("56", "thumbnail_size_w", "150", "yes");
INSERT INTO `wp_options` VALUES("57", "thumbnail_size_h", "150", "yes");
INSERT INTO `wp_options` VALUES("58", "thumbnail_crop", "1", "yes");
INSERT INTO `wp_options` VALUES("59", "medium_size_w", "300", "yes");
INSERT INTO `wp_options` VALUES("60", "medium_size_h", "300", "yes");
INSERT INTO `wp_options` VALUES("61", "avatar_default", "mystery", "yes");
INSERT INTO `wp_options` VALUES("62", "large_size_w", "1024", "yes");
INSERT INTO `wp_options` VALUES("63", "large_size_h", "1024", "yes");
INSERT INTO `wp_options` VALUES("64", "image_default_link_type", "none", "yes");
INSERT INTO `wp_options` VALUES("65", "image_default_size", "", "yes");
INSERT INTO `wp_options` VALUES("66", "image_default_align", "", "yes");
INSERT INTO `wp_options` VALUES("67", "close_comments_for_old_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("68", "close_comments_days_old", "14", "yes");
INSERT INTO `wp_options` VALUES("69", "thread_comments", "1", "yes");
INSERT INTO `wp_options` VALUES("70", "thread_comments_depth", "5", "yes");
INSERT INTO `wp_options` VALUES("71", "page_comments", "0", "yes");
INSERT INTO `wp_options` VALUES("72", "comments_per_page", "50", "yes");
INSERT INTO `wp_options` VALUES("73", "default_comments_page", "newest", "yes");
INSERT INTO `wp_options` VALUES("74", "comment_order", "asc", "yes");
INSERT INTO `wp_options` VALUES("75", "sticky_posts", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("76", "widget_categories", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("77", "widget_text", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("78", "widget_rss", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("79", "uninstall_plugins", "a:1:{s:33:\"wp-maintenance/wp-maintenance.php\";a:2:{i:0;s:14:\"WP_maintenance\";i:1;s:20:\"wpm_dashboard_remove\";}}", "no");
INSERT INTO `wp_options` VALUES("80", "timezone_string", "Europe/Paris", "yes");
INSERT INTO `wp_options` VALUES("81", "page_for_posts", "0", "yes");
INSERT INTO `wp_options` VALUES("82", "page_on_front", "8", "yes");
INSERT INTO `wp_options` VALUES("83", "default_post_format", "0", "yes");
INSERT INTO `wp_options` VALUES("84", "link_manager_enabled", "0", "yes");
INSERT INTO `wp_options` VALUES("85", "finished_splitting_shared_terms", "1", "yes");
INSERT INTO `wp_options` VALUES("86", "site_icon", "0", "yes");
INSERT INTO `wp_options` VALUES("87", "medium_large_size_w", "768", "yes");
INSERT INTO `wp_options` VALUES("88", "medium_large_size_h", "0", "yes");
INSERT INTO `wp_options` VALUES("89", "wp_page_for_privacy_policy", "3", "yes");
INSERT INTO `wp_options` VALUES("90", "show_comments_cookies_opt_in", "1", "yes");
INSERT INTO `wp_options` VALUES("91", "admin_email_lifespan", "1686141684", "yes");
INSERT INTO `wp_options` VALUES("92", "disallowed_keys", "", "no");
INSERT INTO `wp_options` VALUES("93", "comment_previously_approved", "1", "yes");
INSERT INTO `wp_options` VALUES("94", "auto_plugin_theme_update_emails", "a:0:{}", "no");
INSERT INTO `wp_options` VALUES("95", "auto_update_core_dev", "enabled", "yes");
INSERT INTO `wp_options` VALUES("96", "auto_update_core_minor", "enabled", "yes");
INSERT INTO `wp_options` VALUES("97", "auto_update_core_major", "enabled", "yes");
INSERT INTO `wp_options` VALUES("98", "wp_force_deactivated_plugins", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("99", "initial_db_version", "49752", "yes");
INSERT INTO `wp_options` VALUES("100", "wp_user_roles", "a:7:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:70:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:20:\"wpseo_manage_options\";b:1;s:19:\"edit_advgb_profiles\";b:1;s:26:\"edit_others_advgb_profiles\";b:1;s:21:\"create_advgb_profiles\";b:1;s:22:\"publish_advgb_profiles\";b:1;s:21:\"delete_advgb_profiles\";b:1;s:28:\"delete_others_advgb_profiles\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:39:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;s:28:\"wpseo_edit_advanced_metadata\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;s:19:\"edit_advgb_profiles\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:13:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:19:\"edit_advgb_profiles\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:7:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:18:\"read_advgb_profile\";b:1;s:27:\"read_private_advgb_profiles\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}s:13:\"wpseo_manager\";a:2:{s:4:\"name\";s:11:\"SEO Manager\";s:12:\"capabilities\";a:38:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;s:28:\"wpseo_edit_advanced_metadata\";b:1;s:20:\"wpseo_manage_options\";b:1;s:23:\"view_site_health_checks\";b:1;}}s:12:\"wpseo_editor\";a:2:{s:4:\"name\";s:10:\"SEO Editor\";s:12:\"capabilities\";a:36:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:15:\"wpseo_bulk_edit\";b:1;s:28:\"wpseo_edit_advanced_metadata\";b:1;}}}", "yes");
INSERT INTO `wp_options` VALUES("101", "fresh_site", "0", "yes");
INSERT INTO `wp_options` VALUES("102", "WPLANG", "fr_FR", "yes");
INSERT INTO `wp_options` VALUES("103", "widget_block", "a:6:{i:2;a:1:{s:7:\"content\";s:19:\"<!-- wp:search /-->\";}i:3;a:1:{s:7:\"content\";s:159:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Articles récents</h2><!-- /wp:heading --><!-- wp:latest-posts /--></div><!-- /wp:group -->\";}i:4;a:1:{s:7:\"content\";s:233:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Commentaires récents</h2><!-- /wp:heading --><!-- wp:latest-comments {\"displayAvatar\":false,\"displayDate\":false,\"displayExcerpt\":false} /--></div><!-- /wp:group -->\";}i:5;a:1:{s:7:\"content\";s:146:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Archives</h2><!-- /wp:heading --><!-- wp:archives /--></div><!-- /wp:group -->\";}i:6;a:1:{s:7:\"content\";s:151:\"<!-- wp:group --><div class=\"wp-block-group\"><!-- wp:heading --><h2>Catégories</h2><!-- /wp:heading --><!-- wp:categories /--></div><!-- /wp:group -->\";}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("104", "sidebars_widgets", "a:6:{s:19:\"wp_inactive_widgets\";a:0:{}s:15:\"sidebar-primary\";a:5:{i:0;s:7:\"block-2\";i:1;s:7:\"block-3\";i:2;s:7:\"block-4\";i:3;s:7:\"block-5\";i:4;s:7:\"block-6\";}s:8:\"sidebar1\";a:0:{}s:15:\"footer_double_1\";a:0:{}s:15:\"footer_double_2\";a:0:{}s:13:\"array_version\";i:3;}", "yes");
INSERT INTO `wp_options` VALUES("105", "cron", "a:13:{i:1674104975;a:1:{s:34:\"wp_privacy_delete_old_export_files\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1674108205;a:3:{s:32:\"recovery_mode_clean_expired_keys\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:18:\"wp_https_detection\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1674108778;a:2:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}s:25:\"delete_expired_transients\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1674108779;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1674109692;a:1:{s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1674109887;a:1:{s:21:\"wp_update_user_counts\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1674116542;a:1:{s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1674135354;a:1:{s:31:\"wpseo_permalink_structure_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1674138439;a:1:{s:21:\"ai1wm_storage_cleanup\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1674151830;a:1:{s:13:\"wpseo-reindex\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1674626605;a:1:{s:30:\"wp_site_health_scheduled_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"weekly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:604800;}}}i:1676471239;a:1:{s:27:\"delete_block_library_folder\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:7:\"monthly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:2678400;}}}s:7:\"version\";i:2;}", "yes");
INSERT INTO `wp_options` VALUES("106", "widget_pages", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("107", "widget_calendar", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("108", "widget_archives", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("109", "widget_media_audio", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("110", "widget_media_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("111", "widget_media_gallery", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("112", "widget_media_video", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("113", "widget_meta", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("114", "widget_search", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("115", "widget_tag_cloud", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("116", "widget_nav_menu", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("117", "widget_custom_html", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("119", "theme_mods_twentytwentyone", "a:2:{s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1630418572;s:4:\"data\";a:3:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:7:\"block-2\";i:1;s:7:\"block-3\";i:2;s:7:\"block-4\";}s:9:\"sidebar-2\";a:2:{i:0;s:7:\"block-5\";i:1;s:7:\"block-6\";}}}}", "yes");
INSERT INTO `wp_options` VALUES("120", "recovery_keys", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("121", "https_detection_errors", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("152", "finished_updating_comment_type", "1", "yes");
INSERT INTO `wp_options` VALUES("163", "recently_activated", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("170", "yoast_migrations_free", "a:1:{s:7:\"version\";s:5:\"19.14\";}", "yes");
INSERT INTO `wp_options` VALUES("171", "wpseo", "a:99:{s:8:\"tracking\";b:0;s:22:\"license_server_version\";b:0;s:15:\"ms_defaults_set\";b:0;s:40:\"ignore_search_engines_discouraged_notice\";b:0;s:19:\"indexing_first_time\";b:0;s:16:\"indexing_started\";b:0;s:15:\"indexing_reason\";s:26:\"permalink_settings_changed\";s:29:\"indexables_indexing_completed\";b:1;s:13:\"index_now_key\";s:0:\"\";s:7:\"version\";s:5:\"19.14\";s:16:\"previous_version\";s:5:\"19.13\";s:20:\"disableadvanced_meta\";b:1;s:30:\"enable_headless_rest_endpoints\";b:1;s:17:\"ryte_indexability\";b:0;s:11:\"baiduverify\";s:0:\"\";s:12:\"googleverify\";s:0:\"\";s:8:\"msverify\";s:0:\"\";s:12:\"yandexverify\";s:0:\"\";s:9:\"site_type\";s:0:\"\";s:20:\"has_multiple_authors\";s:0:\"\";s:16:\"environment_type\";s:0:\"\";s:23:\"content_analysis_active\";b:1;s:23:\"keyword_analysis_active\";b:1;s:34:\"inclusive_language_analysis_active\";b:0;s:21:\"enable_admin_bar_menu\";b:1;s:26:\"enable_cornerstone_content\";b:1;s:18:\"enable_xml_sitemap\";b:1;s:24:\"enable_text_link_counter\";b:1;s:16:\"enable_index_now\";b:1;s:22:\"show_onboarding_notice\";b:1;s:18:\"first_activated_on\";i:1635882368;s:13:\"myyoast-oauth\";b:0;s:26:\"semrush_integration_active\";b:1;s:14:\"semrush_tokens\";a:0:{}s:20:\"semrush_country_code\";s:2:\"us\";s:19:\"permalink_structure\";s:12:\"/%postname%/\";s:8:\"home_url\";s:54:\"https://www.orthopedie-podologie-anthoard-grenoble.com\";s:18:\"dynamic_permalinks\";b:0;s:17:\"category_base_url\";s:0:\"\";s:12:\"tag_base_url\";s:0:\"\";s:21:\"custom_taxonomy_slugs\";a:1:{s:14:\"portfolio-type\";s:14:\"portfolio-type\";}s:29:\"enable_enhanced_slack_sharing\";b:1;s:25:\"zapier_integration_active\";b:0;s:19:\"zapier_subscription\";a:0:{}s:14:\"zapier_api_key\";s:0:\"\";s:23:\"enable_metabox_insights\";b:0;s:23:\"enable_link_suggestions\";b:1;s:26:\"algolia_integration_active\";b:0;s:14:\"import_cursors\";a:0:{}s:13:\"workouts_data\";a:1:{s:13:\"configuration\";a:1:{s:13:\"finishedSteps\";a:0:{}}}s:28:\"configuration_finished_steps\";a:0:{}s:36:\"dismiss_configuration_workout_notice\";b:0;s:34:\"dismiss_premium_deactivated_notice\";b:0;s:19:\"importing_completed\";a:0:{}s:26:\"wincher_integration_active\";b:1;s:14:\"wincher_tokens\";a:0:{}s:36:\"wincher_automatically_add_keyphrases\";b:0;s:18:\"wincher_website_id\";s:0:\"\";s:28:\"wordproof_integration_active\";b:0;s:29:\"wordproof_integration_changed\";b:0;s:18:\"first_time_install\";b:0;s:34:\"should_redirect_after_install_free\";b:0;s:34:\"activation_redirect_timestamp_free\";i:1652258756;s:18:\"remove_feed_global\";b:0;s:27:\"remove_feed_global_comments\";b:0;s:25:\"remove_feed_post_comments\";b:0;s:19:\"remove_feed_authors\";b:0;s:22:\"remove_feed_categories\";b:0;s:16:\"remove_feed_tags\";b:0;s:29:\"remove_feed_custom_taxonomies\";b:0;s:22:\"remove_feed_post_types\";b:0;s:18:\"remove_feed_search\";b:0;s:21:\"remove_atom_rdf_feeds\";b:0;s:17:\"remove_shortlinks\";b:0;s:21:\"remove_rest_api_links\";b:0;s:20:\"remove_rsd_wlw_links\";b:0;s:19:\"remove_oembed_links\";b:0;s:16:\"remove_generator\";b:0;s:20:\"remove_emoji_scripts\";b:0;s:24:\"remove_powered_by_header\";b:0;s:22:\"remove_pingback_header\";b:0;s:28:\"clean_campaign_tracking_urls\";b:0;s:16:\"clean_permalinks\";b:0;s:32:\"clean_permalinks_extra_variables\";s:0:\"\";s:14:\"search_cleanup\";b:0;s:20:\"search_cleanup_emoji\";b:0;s:23:\"search_cleanup_patterns\";b:0;s:22:\"search_character_limit\";i:50;s:20:\"deny_search_crawling\";b:0;s:21:\"deny_wp_json_crawling\";b:0;s:27:\"redirect_search_pretty_urls\";b:0;s:29:\"least_readability_ignore_list\";a:0:{}s:27:\"least_seo_score_ignore_list\";a:0:{}s:23:\"most_linked_ignore_list\";a:0:{}s:24:\"least_linked_ignore_list\";a:0:{}s:28:\"indexables_page_reading_list\";a:5:{i:0;b:0;i:1;b:0;i:2;b:0;i:3;b:0;i:4;b:0;}s:25:\"indexables_overview_state\";s:21:\"dashboard-not-visited\";s:28:\"last_known_public_post_types\";a:4:{i:0;s:4:\"post\";i:1;s:4:\"page\";i:2;s:10:\"attachment\";i:3;s:9:\"portfolio\";}s:28:\"last_known_public_taxonomies\";a:4:{i:0;s:8:\"category\";i:1;s:8:\"post_tag\";i:2;s:11:\"post_format\";i:3;s:14:\"portfolio-type\";}}", "yes");
INSERT INTO `wp_options` VALUES("172", "wpseo_titles", "a:106:{s:17:\"forcerewritetitle\";b:0;s:9:\"separator\";s:7:\"sc-dash\";s:16:\"title-home-wpseo\";s:42:\"%%sitename%% %%page%% %%sep%% %%sitedesc%%\";s:18:\"title-author-wpseo\";s:50:\"%%name%%, auteur/autrice sur %%sitename%% %%page%%\";s:19:\"title-archive-wpseo\";s:38:\"%%date%% %%page%% %%sep%% %%sitename%%\";s:18:\"title-search-wpseo\";s:65:\"Vous avez cherché %%searchphrase%% %%page%% %%sep%% %%sitename%%\";s:15:\"title-404-wpseo\";s:38:\"Page non trouvée %%sep%% %%sitename%%\";s:25:\"social-title-author-wpseo\";s:8:\"%%name%%\";s:26:\"social-title-archive-wpseo\";s:8:\"%%date%%\";s:31:\"social-description-author-wpseo\";s:0:\"\";s:32:\"social-description-archive-wpseo\";s:0:\"\";s:29:\"social-image-url-author-wpseo\";s:0:\"\";s:30:\"social-image-url-archive-wpseo\";s:0:\"\";s:28:\"social-image-id-author-wpseo\";i:0;s:29:\"social-image-id-archive-wpseo\";i:0;s:19:\"metadesc-home-wpseo\";s:0:\"\";s:21:\"metadesc-author-wpseo\";s:0:\"\";s:22:\"metadesc-archive-wpseo\";s:0:\"\";s:9:\"rssbefore\";s:0:\"\";s:8:\"rssafter\";s:64:\"L’article %%POSTLINK%% est apparu en premier sur %%BLOGLINK%%.\";s:20:\"noindex-author-wpseo\";b:0;s:28:\"noindex-author-noposts-wpseo\";b:1;s:21:\"noindex-archive-wpseo\";b:1;s:14:\"disable-author\";b:0;s:12:\"disable-date\";b:0;s:19:\"disable-post_format\";b:0;s:18:\"disable-attachment\";b:1;s:20:\"breadcrumbs-404crumb\";s:30:\"Erreur 404 : Page introuvable\";s:29:\"breadcrumbs-display-blog-page\";b:1;s:20:\"breadcrumbs-boldlast\";b:0;s:25:\"breadcrumbs-archiveprefix\";s:13:\"Archives pour\";s:18:\"breadcrumbs-enable\";b:1;s:16:\"breadcrumbs-home\";s:7:\"Accueil\";s:18:\"breadcrumbs-prefix\";s:0:\"\";s:24:\"breadcrumbs-searchprefix\";s:18:\"Vous avez cherché\";s:15:\"breadcrumbs-sep\";s:7:\"&raquo;\";s:12:\"website_name\";s:0:\"\";s:11:\"person_name\";s:0:\"\";s:11:\"person_logo\";s:0:\"\";s:22:\"alternate_website_name\";s:0:\"\";s:12:\"company_logo\";s:0:\"\";s:12:\"company_name\";s:0:\"\";s:17:\"company_or_person\";s:7:\"company\";s:25:\"company_or_person_user_id\";b:0;s:17:\"stripcategorybase\";b:0;s:26:\"open_graph_frontpage_title\";s:12:\"%%sitename%%\";s:25:\"open_graph_frontpage_desc\";s:0:\"\";s:26:\"open_graph_frontpage_image\";s:0:\"\";s:10:\"title-post\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-post\";s:0:\"\";s:12:\"noindex-post\";b:0;s:23:\"display-metabox-pt-post\";b:1;s:23:\"post_types-post-maintax\";i:0;s:21:\"schema-page-type-post\";s:7:\"WebPage\";s:24:\"schema-article-type-post\";s:7:\"Article\";s:17:\"social-title-post\";s:9:\"%%title%%\";s:23:\"social-description-post\";s:0:\"\";s:21:\"social-image-url-post\";s:0:\"\";s:20:\"social-image-id-post\";i:0;s:10:\"title-page\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:13:\"metadesc-page\";s:0:\"\";s:12:\"noindex-page\";b:0;s:23:\"display-metabox-pt-page\";b:1;s:23:\"post_types-page-maintax\";i:0;s:21:\"schema-page-type-page\";s:7:\"WebPage\";s:24:\"schema-article-type-page\";s:4:\"None\";s:17:\"social-title-page\";s:9:\"%%title%%\";s:23:\"social-description-page\";s:0:\"\";s:21:\"social-image-url-page\";s:0:\"\";s:20:\"social-image-id-page\";i:0;s:16:\"title-attachment\";s:39:\"%%title%% %%page%% %%sep%% %%sitename%%\";s:19:\"metadesc-attachment\";s:0:\"\";s:18:\"noindex-attachment\";b:0;s:29:\"display-metabox-pt-attachment\";b:1;s:29:\"post_types-attachment-maintax\";i:0;s:27:\"schema-page-type-attachment\";s:7:\"WebPage\";s:30:\"schema-article-type-attachment\";s:4:\"None\";s:18:\"title-tax-category\";s:57:\"Archives des %%term_title%% %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-category\";s:0:\"\";s:28:\"display-metabox-tax-category\";b:1;s:20:\"noindex-tax-category\";b:0;s:25:\"social-title-tax-category\";s:27:\"Archives des %%term_title%%\";s:31:\"social-description-tax-category\";s:0:\"\";s:29:\"social-image-url-tax-category\";s:0:\"\";s:28:\"social-image-id-tax-category\";i:0;s:18:\"title-tax-post_tag\";s:57:\"Archives des %%term_title%% %%page%% %%sep%% %%sitename%%\";s:21:\"metadesc-tax-post_tag\";s:0:\"\";s:28:\"display-metabox-tax-post_tag\";b:1;s:20:\"noindex-tax-post_tag\";b:0;s:25:\"social-title-tax-post_tag\";s:27:\"Archives des %%term_title%%\";s:31:\"social-description-tax-post_tag\";s:0:\"\";s:29:\"social-image-url-tax-post_tag\";s:0:\"\";s:28:\"social-image-id-tax-post_tag\";i:0;s:21:\"title-tax-post_format\";s:57:\"Archives des %%term_title%% %%page%% %%sep%% %%sitename%%\";s:24:\"metadesc-tax-post_format\";s:0:\"\";s:31:\"display-metabox-tax-post_format\";b:1;s:23:\"noindex-tax-post_format\";b:1;s:28:\"social-title-tax-post_format\";s:27:\"Archives des %%term_title%%\";s:34:\"social-description-tax-post_format\";s:0:\"\";s:32:\"social-image-url-tax-post_format\";s:0:\"\";s:31:\"social-image-id-tax-post_format\";i:0;s:14:\"person_logo_id\";i:0;s:15:\"company_logo_id\";i:0;s:17:\"company_logo_meta\";b:0;s:16:\"person_logo_meta\";b:0;s:29:\"open_graph_frontpage_image_id\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("173", "wpseo_social", "a:18:{s:13:\"facebook_site\";s:0:\"\";s:13:\"instagram_url\";s:0:\"\";s:12:\"linkedin_url\";s:0:\"\";s:11:\"myspace_url\";s:0:\"\";s:16:\"og_default_image\";s:0:\"\";s:19:\"og_default_image_id\";s:0:\"\";s:18:\"og_frontpage_title\";s:0:\"\";s:17:\"og_frontpage_desc\";s:0:\"\";s:18:\"og_frontpage_image\";s:0:\"\";s:21:\"og_frontpage_image_id\";s:0:\"\";s:9:\"opengraph\";b:1;s:13:\"pinterest_url\";s:0:\"\";s:15:\"pinterestverify\";s:0:\"\";s:7:\"twitter\";b:1;s:12:\"twitter_site\";s:0:\"\";s:17:\"twitter_card_type\";s:19:\"summary_large_image\";s:11:\"youtube_url\";s:0:\"\";s:13:\"wikipedia_url\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("193", "wpseo_ryte", "a:2:{s:6:\"status\";i:1;s:10:\"last_fetch\";i:1649166078;}", "yes");
INSERT INTO `wp_options` VALUES("204", "auto_update_plugins", "a:6:{i:0;s:24:\"wordpress-seo/wp-seo.php\";i:1;s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";i:2;s:33:\"kadence-blocks/kadence-blocks.php\";i:3;s:33:\"virtue-toolkit/virtue_toolkit.php\";i:4;s:41:\"advanced-gutenberg/advanced-gutenberg.php\";i:11;s:33:\"wp-maintenance/wp-maintenance.php\";}", "no");
INSERT INTO `wp_options` VALUES("222", "widget_recent-posts", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("224", "widget_recent-comments", "a:2:{i:1;a:0:{}s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("227", "theme_mods_twentynineteen", "a:1:{s:18:\"custom_css_post_id\";i:-1;}", "yes");
INSERT INTO `wp_options` VALUES("232", "current_theme", "Virtue", "yes");
INSERT INTO `wp_options` VALUES("233", "theme_mods_twentyseventeen", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:0:{}s:18:\"custom_css_post_id\";i:-1;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1630420132;s:4:\"data\";a:4:{s:19:\"wp_inactive_widgets\";a:0:{}s:9:\"sidebar-1\";a:3:{i:0;s:7:\"block-2\";i:1;s:7:\"block-3\";i:2;s:7:\"block-4\";}s:9:\"sidebar-2\";a:2:{i:0;s:7:\"block-5\";i:1;s:7:\"block-6\";}s:9:\"sidebar-3\";a:0:{}}}}", "yes");
INSERT INTO `wp_options` VALUES("234", "theme_switched", "", "yes");
INSERT INTO `wp_options` VALUES("246", "theme_mods_virtue", "a:4:{i:0;b:0;s:18:\"nav_menu_locations\";a:5:{s:18:\"primary_navigation\";i:3;s:20:\"secondary_navigation\";i:4;s:17:\"topbar_navigation\";i:2;s:17:\"footer_navigation\";i:5;s:17:\"mobile_navigation\";i:6;}s:18:\"custom_css_post_id\";i:172;s:6:\"virtue\";a:10:{s:6:\"topbar\";s:1:\"1\";s:14:\"show_cartcount\";s:1:\"0\";s:13:\"topbar_search\";s:1:\"0\";s:13:\"topbar_widget\";s:1:\"0\";s:25:\"default_page_show_sidebar\";s:2:\"no\";s:12:\"boxed_layout\";s:5:\"boxed\";s:13:\"footer_layout\";s:4:\"twoc\";s:11:\"logo_layout\";s:8:\"logoleft\";s:21:\"x1_virtue_logo_upload\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:16:\"logo_padding_top\";s:2:\"25\";}}", "yes");
INSERT INTO `wp_options` VALUES("247", "widget_widget_kadence_contact", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("248", "widget_widget_kadence_social", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("249", "widget_kadence_recent_posts", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("250", "widget_kadence_image_grid", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("251", "widget_virtue_about_with_image", "a:1:{s:12:\"_multiwidget\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("282", "kadence_toolkit_flushpermalinks", "2", "yes");
INSERT INTO `wp_options` VALUES("283", "virtue", "a:149:{s:8:\"last_tab\";s:0:\"\";s:12:\"boxed_layout\";s:5:\"boxed\";s:13:\"footer_layout\";s:4:\"twoc\";s:11:\"logo_layout\";s:8:\"logoleft\";s:21:\"x1_virtue_logo_upload\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:21:\"x2_virtue_logo_upload\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:15:\"font_logo_style\";a:9:{s:11:\"font-family\";s:8:\"Aclonica\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:4:\"true\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:5:\"latin\";s:9:\"font-size\";s:4:\"32px\";s:11:\"line-height\";s:4:\"40px\";s:5:\"color\";s:0:\"\";}s:15:\"logo_below_text\";s:0:\"\";s:18:\"font_tagline_style\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"20px\";s:5:\"color\";s:7:\"#444444\";}s:16:\"logo_padding_top\";s:2:\"25\";s:19:\"logo_padding_bottom\";s:2:\"10\";s:17:\"logo_padding_left\";s:1:\"0\";s:18:\"logo_padding_right\";s:1:\"0\";s:15:\"menu_margin_top\";s:2:\"40\";s:18:\"menu_margin_bottom\";s:2:\"10\";s:20:\"virtue_banner_upload\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:6:\"topbar\";s:1:\"1\";s:12:\"topbar_icons\";s:1:\"0\";s:16:\"topbar_icon_menu\";a:1:{i:0;a:12:{s:6:\"icon_o\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:4:\"sort\";s:1:\"0\";s:13:\"attachment_id\";s:0:\"\";s:5:\"thumb\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"target\";s:1:\"0\";}}s:14:\"show_cartcount\";s:1:\"0\";s:13:\"topbar_search\";s:1:\"0\";s:13:\"topbar_widget\";s:1:\"0\";s:13:\"topbar_layout\";s:1:\"0\";s:13:\"choose_slider\";s:4:\"none\";s:11:\"home_slider\";a:2:{i:0;a:11:{s:3:\"url\";s:0:\"\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:4:\"sort\";s:1:\"0\";s:13:\"attachment_id\";s:0:\"\";s:5:\"thumb\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"target\";s:1:\"0\";}i:1;a:11:{s:3:\"url\";s:0:\"\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:13:\"attachment_id\";s:0:\"\";s:5:\"thumb\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"target\";s:1:\"0\";}}s:11:\"slider_size\";s:3:\"400\";s:17:\"slider_size_width\";s:4:\"1170\";s:15:\"slider_autoplay\";s:1:\"1\";s:16:\"slider_pausetime\";s:4:\"7000\";s:10:\"trans_type\";s:4:\"fade\";s:16:\"slider_transtime\";s:3:\"600\";s:15:\"slider_captions\";s:1:\"0\";s:11:\"video_embed\";s:0:\"\";s:13:\"mobile_switch\";s:1:\"0\";s:20:\"choose_mobile_slider\";s:4:\"none\";s:18:\"home_mobile_slider\";a:2:{i:0;a:11:{s:3:\"url\";s:0:\"\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:4:\"sort\";s:1:\"0\";s:13:\"attachment_id\";s:0:\"\";s:5:\"thumb\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"target\";s:1:\"0\";}i:1;a:11:{s:3:\"url\";s:0:\"\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:4:\"sort\";s:0:\"\";s:13:\"attachment_id\";s:0:\"\";s:5:\"thumb\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"target\";s:1:\"0\";}}s:18:\"mobile_slider_size\";s:3:\"300\";s:24:\"mobile_slider_size_width\";s:3:\"480\";s:22:\"mobile_slider_autoplay\";s:1:\"1\";s:23:\"mobile_slider_pausetime\";s:4:\"7000\";s:17:\"mobile_trans_type\";s:4:\"fade\";s:23:\"mobile_slider_transtime\";s:3:\"600\";s:22:\"mobile_slider_captions\";s:1:\"0\";s:18:\"mobile_video_embed\";s:0:\"\";s:19:\"home_sidebar_layout\";s:4:\"full\";s:12:\"home_sidebar\";s:15:\"sidebar-primary\";s:15:\"homepage_layout\";a:2:{s:8:\"disabled\";a:4:{s:7:\"placebo\";s:7:\"placebo\";s:10:\"block_five\";s:17:\"Articles récents\";s:9:\"block_six\";s:23:\"Carrousel de portefolio\";s:11:\"block_seven\";s:14:\"Menu d\'icônes\";}s:7:\"enabled\";a:3:{s:7:\"placebo\";s:7:\"placebo\";s:9:\"block_one\";s:16:\"Titre de la page\";s:10:\"block_four\";s:18:\"Contenu de la page\";}}s:10:\"blog_title\";s:0:\"\";s:15:\"home_post_count\";s:1:\"4\";s:15:\"portfolio_title\";s:0:\"\";s:29:\"home_portfolio_carousel_count\";s:1:\"6\";s:20:\"home_portfolio_order\";s:10:\"menu_order\";s:19:\"portfolio_show_type\";s:1:\"0\";s:9:\"icon_menu\";a:1:{i:0;a:12:{s:6:\"icon_o\";s:0:\"\";s:3:\"url\";s:0:\"\";s:5:\"title\";s:0:\"\";s:11:\"description\";s:0:\"\";s:4:\"link\";s:0:\"\";s:4:\"sort\";s:1:\"0\";s:13:\"attachment_id\";s:0:\"\";s:5:\"thumb\";s:0:\"\";s:5:\"image\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:6:\"target\";s:1:\"0\";}}s:21:\"home_icon_menu_column\";s:1:\"3\";s:17:\"home_post_summery\";s:7:\"summery\";s:11:\"shop_layout\";s:4:\"full\";s:12:\"shop_sidebar\";s:15:\"sidebar-primary\";s:17:\"products_per_page\";s:2:\"12\";s:11:\"shop_rating\";s:1:\"1\";s:22:\"product_quantity_input\";s:1:\"1\";s:21:\"product_cat_img_ratio\";s:13:\"widelandscape\";s:15:\"font_shop_title\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:3:\"700\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"16px\";s:11:\"line-height\";s:4:\"20px\";s:5:\"color\";s:0:\"\";}s:20:\"shop_title_uppercase\";s:1:\"0\";s:21:\"shop_title_min_height\";s:2:\"40\";s:18:\"product_img_resize\";s:1:\"1\";s:19:\"product_simg_resize\";s:1:\"1\";s:22:\"product_gallery_slider\";s:1:\"0\";s:20:\"product_gallery_zoom\";s:1:\"0\";s:12:\"product_tabs\";s:1:\"1\";s:16:\"related_products\";s:1:\"1\";s:15:\"skin_stylesheet\";s:11:\"default.css\";s:13:\"primary_color\";s:0:\"\";s:15:\"primary20_color\";s:0:\"\";s:15:\"gray_font_color\";s:0:\"\";s:16:\"footerfont_color\";s:0:\"\";s:16:\"content_bg_color\";s:0:\"\";s:17:\"bg_content_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:17:\"content_bg_repeat\";s:0:\"\";s:21:\"content_bg_placementx\";s:0:\"\";s:21:\"content_bg_placementy\";s:0:\"\";s:15:\"topbar_bg_color\";s:7:\"#1d87d3\";s:16:\"bg_topbar_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:16:\"topbar_bg_repeat\";s:0:\"\";s:20:\"topbar_bg_placementx\";s:0:\"\";s:20:\"topbar_bg_placementy\";s:0:\"\";s:15:\"header_bg_color\";s:7:\"#c9c9c9\";s:16:\"bg_header_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:16:\"header_bg_repeat\";s:0:\"\";s:20:\"header_bg_placementx\";s:0:\"\";s:20:\"header_bg_placementy\";s:0:\"\";s:13:\"menu_bg_color\";s:0:\"\";s:14:\"bg_menu_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:14:\"menu_bg_repeat\";s:0:\"\";s:18:\"menu_bg_placementx\";s:0:\"\";s:18:\"menu_bg_placementy\";s:0:\"\";s:15:\"mobile_bg_color\";s:0:\"\";s:16:\"bg_mobile_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:16:\"mobile_bg_repeat\";s:0:\"\";s:20:\"mobile_bg_placementx\";s:0:\"\";s:20:\"mobile_bg_placementy\";s:0:\"\";s:15:\"footer_bg_color\";s:0:\"\";s:16:\"bg_footer_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:16:\"footer_bg_repeat\";s:0:\"\";s:20:\"footer_bg_placementx\";s:0:\"\";s:20:\"footer_bg_placementy\";s:0:\"\";s:14:\"boxed_bg_color\";s:7:\"#dd9933\";s:15:\"bg_boxed_bg_img\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:15:\"boxed_bg_repeat\";s:0:\"\";s:19:\"boxed_bg_placementx\";s:0:\"\";s:19:\"boxed_bg_placementy\";s:0:\"\";s:14:\"boxed_bg_fixed\";s:0:\"\";s:7:\"font_h1\";a:9:{s:11:\"font-family\";s:7:\"Pattaya\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"38px\";s:11:\"line-height\";s:4:\"40px\";s:5:\"color\";s:7:\"#1e73be\";}s:7:\"font_h2\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:0:\"\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"32px\";s:11:\"line-height\";s:4:\"40px\";s:5:\"color\";s:7:\"#0cbfd3\";}s:7:\"font_h3\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"28px\";s:11:\"line-height\";s:4:\"40px\";s:5:\"color\";s:7:\"#28fcf5\";}s:7:\"font_h4\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"24px\";s:11:\"line-height\";s:4:\"40px\";s:5:\"color\";s:0:\"\";}s:7:\"font_h5\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"700\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"18px\";s:11:\"line-height\";s:4:\"24px\";s:5:\"color\";s:0:\"\";}s:6:\"font_p\";a:9:{s:11:\"font-family\";s:26:\"\'Bookman Old Style\', serif\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"21px\";s:11:\"line-height\";s:4:\"30px\";s:5:\"color\";s:0:\"\";}s:17:\"font_primary_menu\";a:9:{s:11:\"font-family\";s:4:\"Lato\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"14px\";s:11:\"line-height\";s:4:\"20px\";s:5:\"color\";s:0:\"\";}s:19:\"font_secondary_menu\";a:9:{s:11:\"font-family\";s:7:\"Pattaya\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"22px\";s:11:\"line-height\";s:4:\"26px\";s:5:\"color\";s:0:\"\";}s:23:\"mobile_submenu_collapse\";s:1:\"0\";s:16:\"font_mobile_menu\";a:9:{s:11:\"font-family\";s:11:\"Philosopher\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:1:\"1\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:0:\"\";s:9:\"font-size\";s:4:\"16px\";s:11:\"line-height\";s:4:\"20px\";s:5:\"color\";s:0:\"\";}s:23:\"paragraph_margin_bottom\";s:2:\"16\";s:15:\"page_title_show\";s:1:\"1\";s:26:\"default_page_content_width\";s:9:\"contained\";s:25:\"default_page_show_sidebar\";s:2:\"no\";s:14:\"close_comments\";s:1:\"0\";s:13:\"page_comments\";s:1:\"0\";s:18:\"portfolio_comments\";s:1:\"0\";s:14:\"portfolio_link\";s:0:\"\";s:22:\"portfolio_type_columns\";s:1:\"3\";s:26:\"portfolio_type_under_title\";s:1:\"1\";s:20:\"post_summery_default\";s:12:\"img_portrait\";s:26:\"post_summery_default_image\";a:5:{s:3:\"url\";s:0:\"\";s:2:\"id\";s:0:\"\";s:6:\"height\";s:0:\"\";s:5:\"width\";s:0:\"\";s:9:\"thumbnail\";s:0:\"\";}s:17:\"post_head_default\";s:4:\"none\";s:14:\"show_postlinks\";s:1:\"0\";s:11:\"hide_author\";s:1:\"1\";s:19:\"post_author_default\";s:2:\"no\";s:21:\"post_carousel_default\";s:2:\"no\";s:17:\"blog_archive_full\";s:7:\"summery\";s:17:\"hide_image_border\";s:1:\"0\";s:13:\"contact_email\";s:13:\"test@test.com\";s:11:\"footer_text\";s:34:\"[copyright] [the-year] [site-name]\";s:13:\"cust_sidebars\";a:1:{i:0;s:0:\"\";}s:14:\"virtue_gallery\";s:1:\"1\";s:16:\"kadence_lightbox\";s:1:\"0\";s:14:\"google_map_api\";s:0:\"\";s:10:\"custom_css\";s:0:\"\";s:17:\"custom_css[virtue\";s:44:\".topbarmenu ul li a {\n    font-size: 20px;\n}\";}", "yes");
INSERT INTO `wp_options` VALUES("284", "virtue-transients", "a:2:{s:14:\"changed_values\";a:1:{s:15:\"font_logo_style\";a:9:{s:11:\"font-family\";s:7:\"Pattaya\";s:12:\"font-options\";s:0:\"\";s:6:\"google\";s:4:\"true\";s:11:\"font-weight\";s:3:\"400\";s:10:\"font-style\";s:0:\"\";s:7:\"subsets\";s:5:\"latin\";s:9:\"font-size\";s:4:\"32px\";s:11:\"line-height\";s:4:\"40px\";s:5:\"color\";s:0:\"\";}}s:9:\"last_save\";i:1635320057;}", "yes");
INSERT INTO `wp_options` VALUES("291", "new_admin_email", "contact@cabare.net", "yes");
INSERT INTO `wp_options` VALUES("298", "category_children", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("339", "nav_menu_options", "a:2:{i:0;b:0;s:8:\"auto_add\";a:0:{}}", "yes");
INSERT INTO `wp_options` VALUES("575", "auto_core_update_notified", "a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:18:\"contact@cabare.net\";s:7:\"version\";s:5:\"6.1.1\";s:9:\"timestamp\";i:1668580116;}", "no");
INSERT INTO `wp_options` VALUES("1768", "ai1wm_secret_key", "zotQVT4xfJYd", "yes");
INSERT INTO `wp_options` VALUES("1769", "ai1wm_backups_labels", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("1770", "ai1wm_sites_links", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("1771", "ai1wm_status", "a:2:{s:4:\"type\";s:8:\"download\";s:7:\"message\";s:476:\"<a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/ai1wm-backups/www.orthopedie-podologie-anthoard-grenoble.com-20230119-043436-b6fl9g.wpress\" class=\"ai1wm-button-green ai1wm-emphasize ai1wm-button-download\" title=\"www.orthopedie-podologie-anthoard-grenoble.com\" download=\"www.orthopedie-podologie-anthoard-grenoble.com-20230119-043436-b6fl9g.wpress\"><span>Télécharger www.orthopedie-podologie-anthoard-grenoble.com</span><em>Taille : 92 Mo</em></a>\";}", "yes");
INSERT INTO `wp_options` VALUES("1772", "swift_performance_plugin_organizer", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("1773", "jetpack_active_modules", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("1795", "_site_transient_ai1wm_last_check_for_updates", "1674068784", "no");
INSERT INTO `wp_options` VALUES("1796", "ai1wm_updater", "a:0:{}", "yes");
INSERT INTO `wp_options` VALUES("1892", "_transient_health-check-site-status-result", "{\"good\":\"25\",\"recommended\":\"2\",\"critical\":\"0\"}", "yes");
INSERT INTO `wp_options` VALUES("2231", "advgb_version", "3.1.2", "yes");
INSERT INTO `wp_options` VALUES("2232", "advgb_settings", "a:9:{s:16:\"gallery_lightbox\";i:1;s:24:\"gallery_lightbox_caption\";s:1:\"1\";s:17:\"blocks_icon_color\";s:7:\"#5952de\";s:15:\"disable_wpautop\";i:0;s:27:\"enable_columns_visual_guide\";i:1;s:19:\"enable_block_access\";i:1;s:20:\"enable_custom_styles\";i:1;s:19:\"enable_advgb_blocks\";i:1;s:18:\"enable_pp_branding\";i:1;}", "yes");
INSERT INTO `wp_options` VALUES("2234", "advgb_blocks_list", "a:113:{i:0;a:4:{s:4:\"name\";s:21:\"yoast-seo/breadcrumbs\";s:4:\"icon\";s:62:\"<span class=\"dashicon dashicons dashicons-admin-links\"></span>\";s:5:\"title\";s:23:\"Fil d’Ariane de Yoast\";s:8:\"category\";s:29:\"yoast-internal-linking-blocks\";}i:1;a:4:{s:4:\"name\";s:14:\"kadence/spacer\";s:4:\"icon\";s:973:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\"><circle cx=\"14.437\" cy=\"23.593\" r=\"2.77\"></circle><circle cx=\"24.054\" cy=\"23.593\" r=\"2.77\"></circle><circle cx=\"33.563\" cy=\"23.593\" r=\"2.77\"></circle><path d=\"M46.88,14.158l-45.76,0c-0.492,0 -0.896,0.405 -0.896,0.897c0,0.492 0.404,0.897 0.896,0.897l45.76,0c0.492,0 0.896,-0.405 0.896,-0.897c0,-0.492 -0.404,-0.897 -0.896,-0.897Z\" fillrule=\"nonzero\"></path><path d=\"M46.88,32.048l-18.939,0c-0.492,0 -0.897,0.405 -0.897,0.897c0,0.492 0.405,0.897 0.897,0.897l18.939,0c0.492,0 0.896,-0.405 0.896,-0.897c0,-0.492 -0.404,-0.897 -0.896,-0.897Z\" fillrule=\"nonzero\"></path><path d=\"M0.224,32.945c0,0.492 0.404,0.897 0.896,0.897l18.919,0c0.492,0 0.896,-0.405 0.896,-0.897c0,-0.492 -0.404,-0.897 -0.896,-0.897l-18.919,0c-0.492,0 -0.896,0.405 -0.896,0.897Z\" fillrule=\"nonzero\"></path></g></svg>\";s:5:\"title\";s:14:\"Spacer/Divider\";s:8:\"category\";s:14:\"kadence-blocks\";}i:2;a:4:{s:4:\"name\";s:19:\"kadence/advancedbtn\";s:4:\"icon\";s:810:\"<svg viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\" fillrule=\"nonzero\"><path d=\"M42.82,13.431l-37.64,0c-2.742,0.003 -4.998,2.259 -5.001,5.001l0,11.136c0.003,2.742 2.259,4.998 5.001,5.001l37.64,0c2.742,-0.003 4.998,-2.259 5.001,-5.001l0,-11.136c-0.003,-2.742 -2.259,-4.998 -5.001,-5.001Zm3.204,5.001l0,8.687c-0.003,1.757 -1.448,3.201 -3.204,3.204l-37.64,0c-1.756,-0.003 -3.201,-1.447 -3.204,-3.204l0,-8.687c0.003,-1.757 1.448,-3.201 3.204,-3.204l37.64,0c1.756,0.003 3.201,1.447 3.204,3.204Z\"></path><path d=\"M40.471,26.364l-32.942,0c-0.493,0 -0.898,0.406 -0.898,0.899c0,0.493 0.405,0.898 0.898,0.898l32.942,0c0.493,0 0.898,-0.405 0.898,-0.898c0,-0.493 -0.405,-0.899 -0.898,-0.899Z\"></path></g></svg>\";s:5:\"title\";s:15:\"Advanced Button\";s:8:\"category\";s:14:\"kadence-blocks\";}i:3;a:4:{s:4:\"name\";s:17:\"kadence/rowlayout\";s:4:\"icon\";s:1385:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><path d=\"M46.506,7.877l-45.012,0c-0.484,0 -0.882,0.398 -0.882,0.882l0,23.645c0,0.484 0.398,0.882 0.882,0.882l45.012,0c0.484,0 0.882,-0.398 0.882,-0.882l0,-23.65c-0.003,-0.482 -0.4,-0.877 -0.882,-0.877Zm-0.882,23.65l-43.248,0l0,-21.886l43.248,0l0,21.886Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><rect x=\"4.587\" y=\"11.533\" width=\"38.825\" height=\"18.096\" fill=\"#0058b0\"></rect><path d=\"M43.413,29.63l-38.826,0l0,-18.097l38.826,0l0,18.097Zm-37.061,-16.332l0,14.567l35.296,0l0,-14.567l-35.296,0Z\" fill=\"#0058b0\"></path><path d=\"M24,40.123c4.365,0 7.957,-3.592 7.957,-7.957c0,-4.365 -3.592,-7.957 -7.957,-7.957c-4.365,0 -7.957,3.592 -7.957,7.957c0,0.001 0,0.002 0,0.003c0,4.363 3.591,7.954 7.954,7.954c0.001,0 0.002,0 0.003,0Z\" fill=\"#0058b0\" fillrule=\"nonzero\" stroke=\"#fff\" strokewidth=\"1.76\"></path><path d=\"M20.811,31.539l2.307,0l0,-2.309c0,-0.484 0.398,-0.882 0.882,-0.882c0.484,0 0.882,0.398 0.882,0.882l0,2.309l2.307,0c0.483,0 0.882,0.398 0.882,0.882c0,0.484 -0.399,0.882 -0.882,0.882l-2.307,0l0,2.307c0,0.484 -0.398,0.882 -0.882,0.882c-0.484,0 -0.882,-0.398 -0.882,-0.882l0,-2.307l-2.307,0c-0.483,0 -0.882,-0.398 -0.882,-0.882c0,-0.484 0.399,-0.882 0.882,-0.882Z\" fill=\"#fff\" fillrule=\"nonzero\"></path></svg>\";s:5:\"title\";s:10:\"Row Layout\";s:8:\"category\";s:14:\"kadence-blocks\";}i:4;a:5:{s:4:\"name\";s:14:\"kadence/column\";s:4:\"icon\";s:397:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><path d=\"M47.612,40.008l-19.999,0l0,-32.016l13.566,0l6.433,0.023l0,31.993Z\" fill=\"#177ee5\" fillrule=\"nonzero\"></path><path d=\"M20.383,40l-20.036,0l0,-32l20.036,0.019l0,31.981Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path></svg>\";s:5:\"title\";s:7:\"Section\";s:8:\"category\";s:14:\"kadence-blocks\";s:6:\"parent\";a:1:{i:0;s:17:\"kadence/rowlayout\";}}i:5;a:4:{s:4:\"name\";s:12:\"kadence/icon\";s:4:\"icon\";s:1411:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\" fillrule=\"nonzero\"><path d=\"M24,8.944c-8.26,0 -15.056,6.796 -15.056,15.056c0,8.26 6.796,15.056 15.056,15.056c8.26,0 15.056,-6.796 15.056,-15.056c0,-8.26 -6.796,-15.056 -15.056,-15.056Zm8.46,14.277l-2.813,2.743c-0.301,0.296 -0.437,0.723 -0.362,1.139l0.663,3.871c0.012,0.071 0.018,0.143 0.018,0.216c0,0.706 -0.581,1.287 -1.287,1.287c-0.208,0 -0.413,-0.051 -0.598,-0.148l-3.476,-1.812c-0.373,-0.199 -0.822,-0.199 -1.196,0l-3.476,1.812c-0.184,0.097 -0.39,0.148 -0.598,0.148c-0.706,0 -1.287,-0.581 -1.287,-1.287c0,-0.073 0.007,-0.145 0.019,-0.216l0.663,-3.871c0.074,-0.416 -0.061,-0.843 -0.362,-1.139l-2.813,-2.743c-0.237,-0.241 -0.37,-0.565 -0.37,-0.903c0,-0.633 0.468,-1.177 1.095,-1.272l3.885,-0.565c0.41,-0.074 0.76,-0.344 0.935,-0.722l1.74,-3.523c0.217,-0.437 0.665,-0.714 1.153,-0.714c0.488,0 0.935,0.277 1.152,0.714l1.755,3.523c0.186,0.38 0.549,0.643 0.967,0.703l3.886,0.566c0.626,0.095 1.094,0.639 1.094,1.272c0,0.347 -0.14,0.679 -0.387,0.921Z\"></path><path d=\"M44.75,46.019c0.696,0 1.269,-0.573 1.269,-1.269l0,-41.5c0,-0.696 -0.573,-1.269 -1.269,-1.269l-41.5,0c-0.696,0 -1.269,0.573 -1.269,1.269l0,41.5c0,0.696 0.573,1.269 1.269,1.269l41.5,0Zm-40.232,-41.501l38.964,0l0,38.964l-38.964,0l0,-38.964Z\"></path></g></svg>\";s:5:\"title\";s:4:\"Icon\";s:8:\"category\";s:14:\"kadence-blocks\";}i:6;a:4:{s:4:\"name\";s:23:\"kadence/advancedheading\";s:4:\"icon\";s:620:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\" fillrule=\"nonzero\"><path d=\"M45.013,46.298c0.705,0 1.285,-0.58 1.285,-1.285l0,-42.026c0,-0.705 -0.58,-1.285 -1.285,-1.285l-42.026,0c-0.705,0 -1.285,0.58 -1.285,1.285l0,42.026c0,0.705 0.58,1.285 1.285,1.285l42.026,0Zm-40.741,-42.026l39.456,0l0,39.456l-39.456,0l0,-39.456Z\"></path><path d=\"M11.221,8.736l7.36,0l0,12.117l10.838,0l0,-12.117l7.361,0l0,30.518l-7.361,0l0,-12.743l-10.838,0l0,12.743l-7.36,0l0,-30.518Z\"></path></g></svg>\";s:5:\"title\";s:16:\"Advanced Heading\";s:8:\"category\";s:14:\"kadence-blocks\";}i:7;a:4:{s:4:\"name\";s:12:\"kadence/tabs\";s:4:\"icon\";s:8663:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><path d=\"M13.864,6.719l0.02,0l0.019,0.001l0.019,0.001l0.02,0.002l0.019,0.002l0.018,0.003l0.019,0.003l0.019,0.003l0.018,0.004l0.018,0.005l0.019,0.005l0.017,0.005l0.018,0.006l0.018,0.006l0.017,0.007l0.017,0.007l0.017,0.007l0.017,0.008l0.016,0.008l0.016,0.009l0.016,0.008l0.016,0.01l0.015,0.009l0.016,0.011l0.015,0.01l0.014,0.011l0.015,0.011l0.014,0.011l0.014,0.012l0.014,0.012l0.013,0.013l0.013,0.012l0.013,0.013l0.012,0.013l0.012,0.014l0.012,0.014l0.011,0.014l0.011,0.015l0.011,0.014l0.011,0.015l0.01,0.016l0.009,0.015l0.01,0.016l0.008,0.016l0.009,0.016l0.008,0.017l0.008,0.016l0.007,0.017l0.007,0.017l0.007,0.017l0.006,0.018l0.006,0.018l0.005,0.017l0.005,0.019l0.005,0.018l0.004,0.018l0.003,0.019l0.003,0.019l0.003,0.019l0.002,0.018l0.002,0.02l0.001,0.019l0.001,0.019l0,0.02l0,5.225l32.775,0.007l0,27.817l0,0.02l-0.001,0.019l-0.001,0.019l-0.002,0.02l-0.002,0.019l-0.003,0.019l-0.003,0.018l-0.004,0.019l-0.004,0.018l-0.004,0.018l-0.005,0.018l-0.005,0.018l-0.006,0.018l-0.006,0.018l-0.007,0.017l-0.007,0.017l-0.007,0.017l-0.008,0.017l-0.008,0.016l-0.009,0.016l-0.009,0.016l-0.009,0.016l-0.01,0.016l-0.01,0.015l-0.01,0.015l-0.011,0.014l-0.011,0.015l-0.011,0.014l-0.012,0.014l-0.012,0.013l-0.012,0.014l-0.013,0.013l-0.013,0.013l-0.014,0.012l-0.013,0.012l-0.014,0.012l-0.014,0.011l-0.015,0.011l-0.014,0.011l-0.015,0.01l-0.016,0.01l-0.015,0.01l-0.016,0.009l-0.016,0.009l-0.016,0.009l-0.016,0.008l-0.017,0.008l-0.017,0.007l-0.017,0.007l-0.018,0.007l-0.017,0.006l-0.018,0.006l-0.018,0.005l-0.018,0.005l-0.018,0.004l-0.018,0.004l-0.019,0.004l-0.019,0.003l-0.018,0.003l-0.02,0.002l-0.019,0.002l-0.019,0.001l-0.019,0.001l-0.02,0l-45.28,0l-0.02,0l-0.019,-0.001l-0.019,-0.001l-0.019,-0.002l-0.02,-0.002l-0.019,-0.003l-0.018,-0.003l-0.019,-0.004l-0.018,-0.004l-0.019,-0.004l-0.017,-0.005l-0.018,-0.005l-0.018,-0.006l-0.018,-0.006l-0.017,-0.007l-0.017,-0.007l-0.017,-0.007l-0.017,-0.008l-0.016,-0.008l-0.016,-0.009l-0.016,-0.009l-0.016,-0.009l-0.016,-0.01l-0.015,-0.01l-0.015,-0.01l-0.014,-0.011l-0.015,-0.011l-0.014,-0.011l-0.014,-0.012l-0.014,-0.012l-0.013,-0.012l-0.013,-0.013l-0.013,-0.013l-0.012,-0.014l-0.012,-0.013l-0.012,-0.014l-0.011,-0.014l-0.011,-0.015l-0.011,-0.014l-0.01,-0.015l-0.01,-0.015l-0.01,-0.016l-0.009,-0.016l-0.009,-0.016l-0.009,-0.016l-0.008,-0.016l-0.008,-0.017l-0.007,-0.017l-0.007,-0.017l-0.007,-0.017l-0.006,-0.018l-0.006,-0.018l-0.005,-0.018l-0.005,-0.018l-0.004,-0.018l-0.004,-0.018l-0.004,-0.019l-0.003,-0.018l-0.003,-0.019l-0.002,-0.019l-0.002,-0.02l-0.001,-0.019l-0.001,-0.019l0,-0.02l0,-33.052l0,-0.019l0.001,-0.02l0.001,-0.019l0.002,-0.019l0.002,-0.019l0.003,-0.019l0.003,-0.019l0.004,-0.019l0.004,-0.018l0.004,-0.018l0.005,-0.018l0.005,-0.018l0.006,-0.018l0.006,-0.017l0.007,-0.018l0.007,-0.017l0.007,-0.017l0.008,-0.016l0.008,-0.017l0.009,-0.016l0.009,-0.016l0.009,-0.016l0.01,-0.015l0.01,-0.015l0.01,-0.016l0.011,-0.014l0.011,-0.015l0.011,-0.014l0.012,-0.014l0.012,-0.013l0.012,-0.014l0.013,-0.013l0.013,-0.012l0.013,-0.013l0.014,-0.012l0.014,-0.011l0.014,-0.012l0.015,-0.011l0.014,-0.011l0.015,-0.01l0.015,-0.01l0.016,-0.01l0.016,-0.009l0.016,-0.009l0.016,-0.009l0.016,-0.008l0.017,-0.008l0.017,-0.007l0.017,-0.007l0.017,-0.007l0.018,-0.006l0.018,-0.005l0.018,-0.006l0.017,-0.005l0.019,-0.004l0.018,-0.004l0.019,-0.004l0.018,-0.003l0.019,-0.002l0.02,-0.003l0.019,-0.002l0.019,-0.001l0.019,-0.001l0.02,0l12.505,0.003Zm-11.496,32.798l43.262,0l0,-25.042l-32.775,-0.006l0,-5.984l-10.487,-0.002l0,31.034Z\" fill=\"#0058b0\"></path><path d=\"M30.246,6.72l0.021,0.001l0.02,0.001l0.02,0.002l0.02,0.002l0.019,0.003l0.02,0.003l0.019,0.004l0.019,0.004l0.019,0.005l0.019,0.005l0.019,0.006l0.018,0.006l0.019,0.006l0.018,0.007l0.018,0.007l0.017,0.008l0.018,0.008l0.017,0.009l0.017,0.009l0.016,0.009l0.017,0.01l0.016,0.01l0.016,0.01l0.016,0.011l0.015,0.011l0.015,0.012l0.015,0.012l0.029,0.024l0.013,0.014l0.014,0.013l0.013,0.013l0.013,0.014l0.013,0.014l0.012,0.015l0.012,0.015l0.012,0.015l0.011,0.015l0.01,0.016l0.011,0.016l0.01,0.016l0.01,0.016l0.009,0.017l0.009,0.017l0.009,0.017l0.008,0.017l0.007,0.018l0.008,0.018l0.007,0.018l0.006,0.018l0.006,0.019l0.005,0.018l0.006,0.019l0.004,0.019l0.005,0.019l0.003,0.02l0.003,0.019l0.003,0.02l0.002,0.02l0.002,0.02l0.001,0.02l0.001,0.02l0.001,0.021l0,6.165l-14.034,0l0,-6.165l0.001,-0.021l0.001,-0.02l0.001,-0.02l0.002,-0.02l0.002,-0.02l0.003,-0.02l0.003,-0.019l0.003,-0.02l0.005,-0.019l0.004,-0.019l0.006,-0.019l0.005,-0.018l0.006,-0.019l0.006,-0.018l0.007,-0.018l0.008,-0.018l0.007,-0.018l0.008,-0.017l0.009,-0.017l0.009,-0.017l0.009,-0.017l0.01,-0.016l0.01,-0.016l0.011,-0.016l0.01,-0.016l0.011,-0.015l0.012,-0.015l0.012,-0.015l0.012,-0.015l0.013,-0.014l0.013,-0.014l0.013,-0.013l0.014,-0.013l0.013,-0.014l0.015,-0.012l0.014,-0.012l0.015,-0.012l0.015,-0.012l0.015,-0.011l0.016,-0.011l0.016,-0.01l0.016,-0.01l0.017,-0.01l0.016,-0.009l0.017,-0.009l0.017,-0.009l0.018,-0.008l0.017,-0.008l0.018,-0.007l0.018,-0.007l0.019,-0.006l0.018,-0.006l0.019,-0.006l0.019,-0.005l0.019,-0.005l0.019,-0.004l0.019,-0.004l0.02,-0.003l0.019,-0.003l0.02,-0.002l0.02,-0.002l0.02,-0.001l0.021,-0.001l0.02,0l12.452,0l0.02,0Z\" fill=\"#0058b0\"></path><path d=\"M46.626,6.72l0.02,0.001l0.02,0.001l0.02,0.002l0.02,0.002l0.02,0.003l0.019,0.003l0.02,0.004l0.019,0.004l0.019,0.005l0.019,0.005l0.019,0.006l0.018,0.006l0.018,0.006l0.018,0.007l0.018,0.007l0.018,0.008l0.017,0.008l0.017,0.009l0.017,0.009l0.017,0.009l0.017,0.01l0.016,0.01l0.016,0.01l0.015,0.011l0.015,0.011l0.016,0.012l0.014,0.012l0.029,0.024l0.014,0.014l0.013,0.013l0.014,0.013l0.013,0.014l0.012,0.014l0.013,0.015l0.012,0.015l0.011,0.015l0.011,0.015l0.011,0.016l0.011,0.016l0.01,0.016l0.009,0.016l0.01,0.017l0.009,0.017l0.008,0.017l0.008,0.017l0.008,0.018l0.007,0.018l0.007,0.018l0.007,0.018l0.006,0.019l0.005,0.018l0.005,0.019l0.005,0.019l0.004,0.019l0.004,0.02l0.003,0.019l0.003,0.02l0.002,0.02l0.002,0.02l0.001,0.02l0.001,0.02l0,0.021l0,6.165l-14.033,0l0,-6.165l0,-0.021l0.001,-0.02l0.001,-0.02l0.002,-0.02l0.002,-0.02l0.003,-0.02l0.003,-0.019l0.004,-0.02l0.004,-0.019l0.005,-0.019l0.005,-0.019l0.006,-0.018l0.005,-0.019l0.007,-0.018l0.007,-0.018l0.007,-0.018l0.008,-0.018l0.008,-0.017l0.009,-0.017l0.008,-0.017l0.01,-0.017l0.009,-0.016l0.011,-0.016l0.01,-0.016l0.011,-0.016l0.011,-0.015l0.012,-0.015l0.012,-0.015l0.012,-0.015l0.013,-0.014l0.012,-0.014l0.014,-0.013l0.013,-0.013l0.014,-0.014l0.014,-0.012l0.015,-0.012l0.015,-0.012l0.015,-0.012l0.015,-0.011l0.016,-0.011l0.016,-0.01l0.016,-0.01l0.016,-0.01l0.017,-0.009l0.017,-0.009l0.017,-0.009l0.017,-0.008l0.018,-0.008l0.018,-0.007l0.018,-0.007l0.018,-0.006l0.019,-0.006l0.018,-0.006l0.019,-0.005l0.019,-0.005l0.019,-0.004l0.02,-0.004l0.019,-0.003l0.02,-0.003l0.02,-0.002l0.02,-0.002l0.02,-0.001l0.02,-0.001l0.021,0l12.452,0l0.02,0Z\" fill=\"#0058b0\"></path><path d=\"M19.753,18.081l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.884 0.884,0.884l11.238,0c0.484,0 0.883,-0.399 0.883,-0.884c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M19.753,23.146l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.884c0,0.484 0.399,0.883 0.884,0.883l11.238,0c0.484,0 0.883,-0.399 0.883,-0.883c0,-0.485 -0.399,-0.884 -0.883,-0.884Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M19.753,28.681l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.884 0.884,0.884l11.238,0c0.484,0 0.883,-0.399 0.883,-0.884c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M19.753,33.746l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.884 0.884,0.884l11.238,0c0.484,0 0.883,-0.399 0.883,-0.884c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M39.461,18.081l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.884 0.884,0.884l11.238,0c0.484,0 0.883,-0.399 0.883,-0.884c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M39.461,23.146l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.884c0,0.484 0.399,0.883 0.884,0.883l11.238,0c0.484,0 0.883,-0.399 0.883,-0.883c0,-0.485 -0.399,-0.884 -0.883,-0.884Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M39.461,28.681l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.884 0.884,0.884l11.238,0c0.484,0 0.883,-0.399 0.883,-0.884c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M39.461,33.746l-11.238,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.884 0.884,0.884l11.238,0c0.484,0 0.883,-0.399 0.883,-0.884c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path></svg>\";s:5:\"title\";s:4:\"Tabs\";s:8:\"category\";s:14:\"kadence-blocks\";}i:8;a:5:{s:4:\"name\";s:11:\"kadence/tab\";s:4:\"icon\";s:397:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><path d=\"M47.612,40.008l-19.999,0l0,-32.016l13.566,0l6.433,0.023l0,31.993Z\" fill=\"#0073e6\" fillrule=\"nonzero\"></path><path d=\"M20.383,40l-20.036,0l0,-32l20.036,0.019l0,31.981Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path></svg>\";s:5:\"title\";s:3:\"Tab\";s:8:\"category\";s:14:\"kadence-blocks\";s:6:\"parent\";a:1:{i:0;s:12:\"kadence/tabs\";}}i:9;a:4:{s:4:\"name\";s:15:\"kadence/infobox\";s:4:\"icon\";s:1847:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\" fillrule=\"nonzero\"><path d=\"M24,26.945c0.001,0 0.002,0 0.003,0c4.371,0 7.968,-3.597 7.968,-7.969c0,-4.371 -3.597,-7.968 -7.968,-7.968c-4.372,0 -7.969,3.597 -7.969,7.968c0,0.001 0,0.002 0,0.003c0,4.37 3.596,7.966 7.966,7.966Zm-4.098,-9.541l2.057,-0.297c0.218,-0.036 0.406,-0.175 0.504,-0.374l0.919,-1.862c0.115,-0.232 0.352,-0.379 0.61,-0.379c0.259,0 0.496,0.147 0.611,0.379l0.918,1.862c0.098,0.199 0.287,0.338 0.505,0.374l2.057,0.297c0.333,0.049 0.582,0.338 0.582,0.675c0,0.183 -0.073,0.358 -0.204,0.486l-1.489,1.451c-0.159,0.157 -0.231,0.382 -0.194,0.603l0.351,2.049c0.006,0.037 0.009,0.075 0.009,0.114c0,0.373 -0.307,0.681 -0.681,0.681c-0.111,0 -0.219,-0.027 -0.317,-0.079l-1.837,-0.966c-0.199,-0.103 -0.437,-0.103 -0.636,0l-1.837,0.966c-0.098,0.052 -0.207,0.079 -0.317,0.079c-0.374,0 -0.682,-0.308 -0.682,-0.681c0,-0.039 0.004,-0.077 0.01,-0.114l0.351,-2.049c0.037,-0.221 -0.036,-0.446 -0.195,-0.603l-1.488,-1.451c-0.13,-0.128 -0.203,-0.303 -0.203,-0.485c0,-0.341 0.257,-0.633 0.596,-0.676Z\"></path><path d=\"M46.529,6.719l-45.058,0c-0.485,0 -0.884,0.398 -0.884,0.883l0,32.796c0,0.485 0.399,0.883 0.884,0.883l45.058,0c0.485,0 0.884,-0.398 0.884,-0.883l0,-32.801c-0.003,-0.483 -0.401,-0.878 -0.884,-0.878Zm-0.883,32.801l-43.292,0l0,-31.035l43.292,0l0,31.035Z\"></path><path d=\"M29.659,30.091l-11.318,0c-0.485,0 -0.884,0.399 -0.884,0.883c0,0.485 0.399,0.883 0.884,0.883l11.318,0c0.485,0 0.884,-0.398 0.884,-0.883c0,-0.484 -0.399,-0.883 -0.884,-0.883Z\"></path><path d=\"M29.425,34.769l-10.85,0c-0.484,0 -0.883,0.399 -0.883,0.883c0,0.485 0.399,0.883 0.883,0.883l10.85,0c0.484,0 0.883,-0.398 0.883,-0.883c0,-0.484 -0.399,-0.883 -0.883,-0.883Z\"></path></g></svg>\";s:5:\"title\";s:8:\"Info Box\";s:8:\"category\";s:14:\"kadence-blocks\";}i:10;a:4:{s:4:\"name\";s:17:\"kadence/accordion\";s:4:\"icon\";s:1547:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\"><path d=\"M46.524,6.723l-45.048,0c-0.485,0 -0.883,0.398 -0.883,0.883l0,32.788c0,0.485 0.398,0.883 0.883,0.883l45.048,0c0.485,0 0.883,-0.398 0.883,-0.883l0,-32.793c-0.002,-0.483 -0.4,-0.878 -0.883,-0.878Zm-17.451,3.985c0,0.485 -0.399,0.883 -0.883,0.883l-18.249,0c-0.484,0 -0.882,-0.398 -0.882,-0.883c0,-0.484 0.398,-0.883 0.882,-0.883l18.249,0c0.484,0 0.883,0.399 0.883,0.883Zm-21.846,0c0,0.678 -0.558,1.236 -1.236,1.236c-0.678,0 -1.236,-0.558 -1.236,-1.236c0,-0.678 0.558,-1.236 1.236,-1.236c0.678,0 1.236,0.558 1.236,1.236Zm38.414,3.784l0,15.893l-43.282,0l0,-15.893l43.282,0Zm0,25.009l-43.282,0l0,-7.35l43.282,0l0,7.35Z\" fillrule=\"nonzero\"></path><path d=\"M7.578,20.774l32.476,0.04c0.484,0 0.883,-0.399 0.883,-0.883c0,-0.484 -0.399,-0.883 -0.883,-0.883l-32.474,-0.04c-0.484,0 -0.883,0.398 -0.883,0.883c0,0.484 0.399,0.883 0.883,0.883l-0.002,0Z\" fillrule=\"nonzero\"></path><path d=\"M40.046,24.194l-32.466,-0.04c-0.484,0 -0.883,0.398 -0.883,0.883c0,0.484 0.399,0.883 0.883,0.883l32.466,0.04c0.485,0 0.883,-0.398 0.883,-0.883c0,-0.484 -0.398,-0.883 -0.883,-0.883Z\" fillrule=\"nonzero\"></path><path d=\"M10.925,36.734l14.942,0c0.484,0 0.883,-0.398 0.883,-0.883c0,-0.484 -0.399,-0.883 -0.883,-0.883l-14.942,0c-0.484,0 -0.883,0.399 -0.883,0.883c0,0.485 0.399,0.883 0.883,0.883Z\" fillrule=\"nonzero\"></path><circle cx=\"6.072\" cy=\"35.851\" r=\"1.236\"></circle></g></svg>\";s:5:\"title\";s:9:\"Accordion\";s:8:\"category\";s:14:\"kadence-blocks\";}i:11;a:5:{s:4:\"name\";s:12:\"kadence/pane\";s:4:\"icon\";s:1547:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><g fill=\"#0058b0\"><path d=\"M46.524,6.723l-45.048,0c-0.485,0 -0.883,0.398 -0.883,0.883l0,32.788c0,0.485 0.398,0.883 0.883,0.883l45.048,0c0.485,0 0.883,-0.398 0.883,-0.883l0,-32.793c-0.002,-0.483 -0.4,-0.878 -0.883,-0.878Zm-17.451,3.985c0,0.485 -0.399,0.883 -0.883,0.883l-18.249,0c-0.484,0 -0.882,-0.398 -0.882,-0.883c0,-0.484 0.398,-0.883 0.882,-0.883l18.249,0c0.484,0 0.883,0.399 0.883,0.883Zm-21.846,0c0,0.678 -0.558,1.236 -1.236,1.236c-0.678,0 -1.236,-0.558 -1.236,-1.236c0,-0.678 0.558,-1.236 1.236,-1.236c0.678,0 1.236,0.558 1.236,1.236Zm38.414,3.784l0,15.893l-43.282,0l0,-15.893l43.282,0Zm0,25.009l-43.282,0l0,-7.35l43.282,0l0,7.35Z\" fillrule=\"nonzero\"></path><path d=\"M7.578,20.774l32.476,0.04c0.484,0 0.883,-0.399 0.883,-0.883c0,-0.484 -0.399,-0.883 -0.883,-0.883l-32.474,-0.04c-0.484,0 -0.883,0.398 -0.883,0.883c0,0.484 0.399,0.883 0.883,0.883l-0.002,0Z\" fillrule=\"nonzero\"></path><path d=\"M40.046,24.194l-32.466,-0.04c-0.484,0 -0.883,0.398 -0.883,0.883c0,0.484 0.399,0.883 0.883,0.883l32.466,0.04c0.485,0 0.883,-0.398 0.883,-0.883c0,-0.484 -0.398,-0.883 -0.883,-0.883Z\" fillrule=\"nonzero\"></path><path d=\"M10.925,36.734l14.942,0c0.484,0 0.883,-0.398 0.883,-0.883c0,-0.484 -0.399,-0.883 -0.883,-0.883l-14.942,0c-0.484,0 -0.883,0.399 -0.883,0.883c0,0.485 0.399,0.883 0.883,0.883Z\" fillrule=\"nonzero\"></path><circle cx=\"6.072\" cy=\"35.851\" r=\"1.236\"></circle></g></svg>\";s:5:\"title\";s:4:\"Pane\";s:8:\"category\";s:14:\"kadence-blocks\";s:6:\"parent\";a:1:{i:0;s:17:\"kadence/accordion\";}}i:12;a:4:{s:4:\"name\";s:16:\"kadence/iconlist\";s:4:\"icon\";s:2187:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><path d=\"M5.945,18.719c2.916,0 5.284,2.368 5.284,5.284c0,2.916 -2.368,5.283 -5.284,5.283c-2.916,0 -5.283,-2.367 -5.283,-5.283c0,-2.916 2.367,-5.284 5.283,-5.284Zm-1.157,8.089c0.133,0.136 0.352,0.138 0.488,0.005l4.068,-3.986c0.137,-0.134 0.139,-0.352 0.006,-0.488l-0.574,-0.595c-0.133,-0.137 -0.351,-0.139 -0.488,-0.005l-3.271,3.203l-1.495,-1.527c-0.134,-0.136 -0.352,-0.138 -0.488,-0.005l-0.551,0.541c-0.136,0.133 -0.139,0.352 -0.005,0.488l2.31,2.369Z\" fill=\"#0058b0\"></path><path d=\"M5.895,2.016c2.916,0 5.283,2.367 5.283,5.283c0,2.916 -2.367,5.284 -5.283,5.284c-2.916,0 -5.283,-2.368 -5.283,-5.284c0,-2.916 2.367,-5.283 5.283,-5.283Zm-1.157,8.088c0.133,0.136 0.352,0.139 0.488,0.005l4.068,-3.986c0.136,-0.133 0.139,-0.352 0.005,-0.488l-0.573,-0.595c-0.133,-0.136 -0.352,-0.138 -0.488,-0.005l-3.271,3.204l-1.495,-1.527c-0.134,-0.136 -0.352,-0.139 -0.489,-0.005l-0.55,0.54c-0.137,0.134 -0.139,0.352 -0.006,0.489l2.311,2.368Z\" fill=\"#0058b0\"></path><path d=\"M5.895,35.427c2.916,0 5.283,2.367 5.283,5.283c0,2.916 -2.367,5.284 -5.283,5.284c-2.916,0 -5.283,-2.368 -5.283,-5.284c0,-2.916 2.367,-5.283 5.283,-5.283Zm-1.157,8.088c0.133,0.136 0.352,0.139 0.488,0.005l4.068,-3.986c0.136,-0.133 0.139,-0.351 0.005,-0.488l-0.573,-0.595c-0.133,-0.136 -0.352,-0.138 -0.488,-0.005l-3.271,3.204l-1.495,-1.527c-0.134,-0.136 -0.352,-0.139 -0.489,-0.005l-0.55,0.54c-0.137,0.134 -0.139,0.352 -0.006,0.489l2.311,2.368Z\" fill=\"#0058b0\"></path><g fill=\"#0058b0\"><path d=\"M47.451,6.488c0,-0.611 -0.496,-1.107 -1.107,-1.107l-30.283,0c-0.611,0 -1.107,0.496 -1.107,1.107l0,2.214c0,0.611 0.496,1.107 1.107,1.107l30.283,0c0.611,0 1.107,-0.496 1.107,-1.107l0,-2.214Z\"></path><path d=\"M47.451,23.074c0,-0.607 -0.493,-1.1 -1.1,-1.1l-30.297,0c-0.607,0 -1.1,0.493 -1.1,1.1l0,2.2c0,0.607 0.493,1.1 1.1,1.1l30.297,0c0.607,0 1.1,-0.493 1.1,-1.1l0,-2.2Z\"></path><path d=\"M47.451,39.902c0,-0.607 -0.493,-1.1 -1.1,-1.1l-30.297,0c-0.607,0 -1.1,0.493 -1.1,1.1l0,2.2c0,0.607 0.493,1.1 1.1,1.1l30.297,0c0.607,0 1.1,-0.493 1.1,-1.1l0,-2.2Z\"></path></g></svg>\";s:5:\"title\";s:9:\"Icon List\";s:8:\"category\";s:14:\"kadence-blocks\";}i:13;a:4:{s:4:\"name\";s:20:\"kadence/testimonials\";s:4:\"icon\";s:4476:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"1.414\"><path d=\"M46.053,6.607l0.053,0.004l0.052,0.007l0.051,0.009l0.05,0.011l0.049,0.014l0.048,0.017l0.047,0.018l0.046,0.021l0.045,0.023l0.043,0.025l0.042,0.027l0.041,0.029l0.039,0.031l0.038,0.032l0.036,0.034l0.034,0.036l0.033,0.038l0.031,0.039l0.028,0.041l0.027,0.042l0.025,0.043l0.023,0.045l0.021,0.046l0.019,0.047l0.016,0.048l0.014,0.049l0.011,0.05l0.01,0.051l0.006,0.052l0.004,0.053l0.002,0.053l0,26.999l-0.002,0.053l-0.004,0.053l-0.006,0.051l-0.01,0.051l-0.011,0.05l-0.014,0.05l-0.016,0.048l-0.019,0.047l-0.021,0.046l-0.023,0.044l-0.025,0.044l-0.027,0.042l-0.028,0.041l-0.031,0.039l-0.033,0.037l-0.034,0.036l-0.036,0.035l-0.038,0.032l-0.039,0.031l-0.041,0.029l-0.042,0.027l-0.043,0.025l-0.045,0.023l-0.046,0.021l-0.047,0.018l-0.048,0.016l-0.049,0.014l-0.05,0.012l-0.051,0.009l-0.052,0.007l-0.053,0.004l-0.053,0.001l-15.751,0l-6.366,5.717l-6.397,-5.717l-15.486,0l-0.053,-0.001l-0.053,-0.004l-0.052,-0.007l-0.051,-0.009l-0.05,-0.012l-0.049,-0.014l-0.048,-0.016l-0.047,-0.018l-0.046,-0.021l-0.045,-0.023l-0.043,-0.025l-0.042,-0.027l-0.041,-0.029l-0.039,-0.031l-0.038,-0.032l-0.036,-0.035l-0.034,-0.036l-0.033,-0.037l-0.031,-0.039l-0.028,-0.041l-0.027,-0.042l-0.025,-0.044l-0.023,-0.044l-0.021,-0.046l-0.019,-0.047l-0.016,-0.048l-0.014,-0.05l-0.011,-0.05l-0.01,-0.051l-0.006,-0.051l-0.004,-0.053l-0.002,-0.053l0,-26.999l0.002,-0.053l0.004,-0.053l0.006,-0.052l0.01,-0.051l0.011,-0.05l0.014,-0.049l0.016,-0.048l0.019,-0.047l0.021,-0.046l0.023,-0.045l0.025,-0.043l0.027,-0.042l0.028,-0.041l0.031,-0.039l0.033,-0.038l0.034,-0.036l0.036,-0.034l0.038,-0.032l0.039,-0.031l0.041,-0.029l0.042,-0.027l0.043,-0.025l0.045,-0.023l0.046,-0.021l0.047,-0.018l0.048,-0.017l0.049,-0.014l0.05,-0.011l0.051,-0.009l0.052,-0.007l0.053,-0.004l0.053,-0.001l44,0l0.053,0.001Zm-43.09,1.999l0,25.071l15.287,0l5.63,5.032l5.603,-5.032l15.554,0l0,-25.071l-42.074,0Z\" fill=\"#0058b0\"></path><path d=\"M5.395,19.137l2.412,-0.349c0.257,-0.042 0.477,-0.205 0.592,-0.438l1.078,-2.184c0.134,-0.272 0.413,-0.445 0.716,-0.445c0.304,0 0.582,0.173 0.716,0.445l1.078,2.184c0.115,0.233 0.336,0.396 0.592,0.438l2.412,0.349c0.391,0.058 0.684,0.396 0.684,0.791c0,0.215 -0.086,0.421 -0.24,0.571l-1.746,1.702c-0.187,0.184 -0.272,0.449 -0.228,0.708l0.411,2.403c0.008,0.044 0.012,0.089 0.012,0.134c0,0.438 -0.361,0.799 -0.8,0.799c-0.129,0 -0.257,-0.032 -0.372,-0.092l-2.155,-1.134c-0.233,-0.121 -0.512,-0.121 -0.746,0l-2.155,1.134c-0.114,0.06 -0.242,0.092 -0.372,0.092c-0.438,0 -0.799,-0.361 -0.799,-0.799c0,-0.045 0.004,-0.09 0.011,-0.134l0.411,-2.403c0.044,-0.259 -0.041,-0.524 -0.227,-0.708l-1.747,-1.702c-0.152,-0.15 -0.237,-0.355 -0.237,-0.569c0,-0.4 0.301,-0.742 0.699,-0.793Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M19.21,19.137l2.412,-0.349c0.257,-0.042 0.477,-0.205 0.591,-0.438l1.078,-2.184c0.134,-0.272 0.413,-0.445 0.716,-0.445c0.304,0 0.582,0.173 0.716,0.445l1.078,2.184c0.115,0.233 0.336,0.396 0.592,0.438l2.412,0.349c0.391,0.058 0.684,0.396 0.684,0.791c0,0.215 -0.085,0.421 -0.239,0.571l-1.746,1.702c-0.188,0.184 -0.272,0.449 -0.229,0.708l0.412,2.403c0.008,0.044 0.012,0.089 0.012,0.134c0,0.438 -0.361,0.799 -0.8,0.799c-0.13,0 -0.258,-0.032 -0.372,-0.092l-2.156,-1.134c-0.233,-0.121 -0.512,-0.121 -0.745,0l-2.156,1.134c-0.114,0.06 -0.242,0.092 -0.372,0.092c-0.438,0 -0.799,-0.361 -0.799,-0.799c0,-0.045 0.005,-0.09 0.011,-0.134l0.412,-2.403c0.044,-0.259 -0.041,-0.524 -0.227,-0.708l-1.747,-1.702c-0.152,-0.15 -0.237,-0.355 -0.237,-0.569c0,-0.4 0.3,-0.742 0.699,-0.793Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path><path d=\"M33.067,19.137l2.412,-0.349c0.257,-0.042 0.477,-0.205 0.592,-0.438l1.078,-2.184c0.134,-0.272 0.413,-0.445 0.716,-0.445c0.304,0 0.582,0.173 0.716,0.445l1.078,2.184c0.115,0.233 0.336,0.396 0.592,0.438l2.412,0.349c0.391,0.058 0.684,0.396 0.684,0.791c0,0.215 -0.086,0.421 -0.24,0.571l-1.746,1.702c-0.187,0.184 -0.272,0.449 -0.228,0.708l0.411,2.403c0.008,0.044 0.012,0.089 0.012,0.134c0,0.438 -0.361,0.799 -0.8,0.799c-0.129,0 -0.257,-0.032 -0.372,-0.092l-2.155,-1.134c-0.233,-0.121 -0.512,-0.121 -0.746,0l-2.155,1.134c-0.114,0.06 -0.242,0.092 -0.372,0.092c-0.438,0 -0.799,-0.361 -0.799,-0.799c0,-0.045 0.004,-0.09 0.011,-0.134l0.411,-2.403c0.044,-0.259 -0.041,-0.524 -0.227,-0.708l-1.747,-1.702c-0.152,-0.15 -0.237,-0.355 -0.237,-0.569c0,-0.4 0.301,-0.742 0.699,-0.793Z\" fill=\"#0058b0\" fillrule=\"nonzero\"></path></svg>\";s:5:\"title\";s:12:\"Testimonials\";s:8:\"category\";s:14:\"kadence-blocks\";}i:14;a:4:{s:4:\"name\";s:23:\"kadence/advancedgallery\";s:4:\"icon\";s:1151:\"<svg width=\"20px\" height=\"20px\" viewbox=\"0 0 48 48\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"2\"><g fill=\"#0058b0\" fillrule=\"nonzero\"><path d=\"M46.652,11.743l-38.504,0c-0.414,0 -0.755,0.341 -0.755,0.755l0,28.023c0,0.414 0.341,0.755 0.755,0.755l38.504,0c0.414,0 0.755,-0.341 0.755,-0.755l0,-28.029c-0.003,-0.412 -0.344,-0.749 -0.755,-0.749Zm-0.754,28.017l-36.995,0l0,-26.508l36.995,0l0,26.508Z\"></path><path d=\"M1.53,5.125l38.504,0c0.412,0 0.752,0.337 0.755,0.749l0,4.421l-1.509,0l0,-3.66l-36.995,0l0,26.507l3.772,0l0,1.516l-4.527,0c-0.414,0 -0.755,-0.341 -0.755,-0.755l0,-28.023c0,-0.414 0.341,-0.755 0.755,-0.755Z\"></path><path d=\"M35,37.002l8.603,0l-9.256,-11.785l-4.302,5.476l-6.946,-8.846l-11.902,15.155l23.803,0Z\"></path><path d=\"M37.607,24.719c2.402,-0.003 4.378,-1.98 4.378,-4.382c0,-2.403 -1.978,-4.381 -4.382,-4.381c-2.403,0 -4.381,1.978 -4.381,4.381c0.003,2.404 1.981,4.381 4.385,4.382Zm0,-7.254c1.574,0.003 2.868,1.299 2.868,2.872c0,1.576 -1.297,2.872 -2.872,2.872c-1.576,0 -2.872,-1.296 -2.872,-2.872c0.001,-1.575 1.299,-2.872 2.874,-2.872l0.002,0Z\"></path></g></svg>\";s:5:\"title\";s:16:\"Advanced Gallery\";s:8:\"category\";s:14:\"kadence-blocks\";}i:15;a:4:{s:4:\"name\";s:12:\"kadence/form\";s:4:\"icon\";s:3855:\"<svg viewbox=\"0 0 48 48\" fillrule=\"evenodd\" cliprule=\"evenodd\" strokelinejoin=\"round\" width=\"20px\" height=\"20px\" strokemiterlimit=\"2\"><path d=\"M45.073 15.23l.052.002.051.003.05.005.05.005.05.007.05.009.049.009.048.011.049.011.047.013.048.014.046.015.047.017.045.017.045.019.045.019.044.021.044.021.042.023.043.024.041.024.041.026.041.026.039.028.039.028.038.029.038.031.036.031.036.032.035.032.035.034.033.034.033.035.032.036.031.037.03.037.03.039.028.039.027.039.027.04.025.041.025.042.024.042.022.043.022.044.021.044.019.044.019.045.017.046.016.046.015.047.014.047.013.048.012.048.011.049.009.049.008.049.007.05.006.051.005.05.003.051.002.051v16.075l-.002.051-.003.051-.005.051-.006.05-.007.05-.008.05-.009.049-.011.048-.012.049-.013.047-.014.048-.015.046-.016.047-.017.045-.019.045-.019.045-.021.044-.022.044-.022.042-.024.043-.025.041-.025.041-.027.04-.027.04-.028.039-.03.038-.03.038-.031.036-.032.036-.033.035-.033.035-.035.033-.035.033-.036.032-.036.031-.038.03-.038.029-.039.029-.039.027-.041.027-.041.025-.041.025-.043.024-.042.022-.044.022-.044.02-.045.02-.045.018-.045.018-.047.016-.046.015-.048.014-.047.013-.049.012-.048.011-.049.009-.05.008-.05.007-.05.006-.05.005-.051.003-.052.002H2.975l-.052-.002-.051-.003-.05-.005-.051-.006-.049-.007-.05-.008-.049-.009-.049-.011-.048-.012-.048-.013-.047-.014-.047-.015-.046-.016-.046-.018-.045-.018-.044-.02-.044-.02-.044-.022-.043-.022-.042-.024-.042-.025-.04-.025-.041-.027-.039-.027-.039-.029-.038-.029-.038-.03-.037-.031-.036-.032-.035-.033-.034-.033-.034-.035-.032-.035-.032-.036-.031-.036-.03-.038-.03-.038-.028-.039-.028-.04-.026-.04-.026-.041-.024-.041-.024-.043-.023-.042-.021-.044-.021-.044-.019-.045-.019-.045-.017-.045-.016-.047-.016-.046-.014-.048-.013-.047-.011-.049-.011-.048-.009-.049-.009-.05-.007-.05-.005-.05-.005-.051-.003-.051-.002-.051-.001-.052V17.231l.001-.052.002-.051.003-.051.005-.05.005-.051.007-.05.009-.049.009-.049.011-.049.011-.048.013-.048.014-.047.016-.047.016-.046.017-.046.019-.045.019-.044.021-.044.021-.044.023-.043.024-.042.024-.042.026-.041.026-.04.028-.039.028-.039.03-.039.03-.037.031-.037.032-.036.032-.035.034-.034.034-.034.035-.032.036-.032.037-.031.038-.031.038-.029.039-.028.039-.028.041-.026.04-.026.042-.024.042-.024.043-.023.044-.021.044-.021.044-.019.045-.019.046-.017.046-.017.047-.015.047-.014.048-.013.048-.011.049-.011.049-.009.05-.009.049-.007.051-.005.05-.005.051-.003.052-.002.051-.001h41.996l.051.001zM3.524 17.729v14.975h40.999V17.729H3.524zM46.281 5.839l.04.003.039.005.038.007.038.008.037.011.037.012.035.014.035.016.034.017.032.019.032.021.031.021.03.024.028.024.027.026.026.027.025.029.023.029.022.031.02.032.019.033.017.033.016.035.014.036.012.036.011.037.009.038.006.038.005.04.003.039.001.041v6.244l-.001.041-.003.039-.005.04-.006.038-.009.038-.011.037-.012.036-.014.036-.016.035-.017.033-.019.033-.02.032-.022.031-.023.029-.025.029-.026.027-.027.026-.028.024-.03.024-.031.021-.032.021-.032.019-.034.017-.035.016-.035.014-.037.012-.037.01-.038.009-.038.007-.039.005-.04.003-.04.001H1.807l-.04-.001-.04-.003-.039-.005-.039-.007-.037-.009-.038-.01-.036-.012-.035-.014-.035-.016-.034-.017-.033-.019-.031-.021-.031-.021-.03-.024-.028-.024-.027-.026-.026-.027-.025-.029-.023-.029-.022-.031-.02-.032-.019-.033-.017-.033-.016-.035-.014-.036-.012-.036-.011-.037-.009-.038-.007-.038-.005-.04-.003-.039-.001-.041V6.621l.001-.041.003-.039.005-.04.007-.038.009-.038.011-.037.012-.036.014-.036.016-.035.017-.033.019-.033.02-.032.022-.031.023-.029.025-.029.026-.027.027-.026.028-.024.03-.024.031-.021.031-.021.033-.019.034-.017.035-.016.035-.014.036-.012.038-.011.037-.008.039-.007.039-.005.04-.003.04-.001h44.434l.04.001zM3.524 8.338v2.81h40.999v-2.81H3.524zM22.012 38.096c0-.748-.607-1.355-1.355-1.355H2.332c-.748 0-1.355.607-1.355 1.355v2.711c0 .748.607 1.355 1.355 1.355h18.325c.748 0 1.355-.607 1.355-1.355v-2.711z\" fill=\"#0058b0\"></path></svg>\";s:5:\"title\";s:4:\"Form\";s:8:\"category\";s:14:\"kadence-blocks\";}i:16;a:4:{s:4:\"name\";s:23:\"kadence/tableofcontents\";s:4:\"icon\";s:1683:\"<svg width=\"20px\" height=\"20px\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"2\" cliprule=\"evenodd\" viewbox=\"0 0 48 48\"><path fill=\"#0058b0\" fillrule=\"nonzero\" d=\"M46.051 3.307H1.943a.87.87 0 00-.865.865v39.194a.87.87 0 00.865.865h44.108a.869.869 0 00.864-.865V4.167a.868.868 0 00-.864-.86zm-2.887 3.396c0 .877-.722 1.598-1.599 1.598a1.606 1.606 0 01-1.598-1.598c0-.876.722-1.598 1.598-1.598.877 0 1.599.722 1.599 1.598zm-5.928 0c0 .877-.722 1.598-1.598 1.598a1.605 1.605 0 01-1.598-1.598c0-.876.721-1.598 1.598-1.598.876 0 1.598.722 1.598 1.598zm-5.459 0c0 .877-.721 1.598-1.598 1.598a1.605 1.605 0 01-1.598-1.598c0-.874.717-1.594 1.591-1.598h.007c.877 0 1.598.722 1.598 1.598zM2.807 42.497v-31.58h42.379v31.58H2.807z\"></path><circle cx=\"8.451\" cy=\"16.499\" r=\"1.184\" fill=\"#0058b0\"></circle><circle cx=\"8.451\" cy=\"30.323\" r=\"1.184\" fill=\"#0058b0\"></circle><circle cx=\"8.451\" cy=\"37.095\" r=\"1.184\" fill=\"#0058b0\"></circle><circle cx=\"13.625\" cy=\"23.282\" r=\"1.184\" fill=\"#0058b0\"></circle><path fill=\"#0058b0\" fillrule=\"nonzero\" d=\"M31.861 15.353H13.714c-.584 0-1.064.517-1.064 1.146 0 .629.48 1.146 1.064 1.146h18.147c.583 0 1.064-.517 1.064-1.146 0-.629-.481-1.146-1.064-1.146zM28.871 21.926H18.448c-.583 0-1.064.517-1.064 1.146 0 .629.481 1.146 1.064 1.146h10.423c.583 0 1.064-.517 1.064-1.146 0-.629-.481-1.146-1.064-1.146zM27.153 29.108H13.615c-.584 0-1.064.517-1.064 1.146 0 .629.48 1.146 1.064 1.146h13.538c.583 0 1.064-.517 1.064-1.146 0-.629-.481-1.146-1.064-1.146zM35.183 35.68H13.718c-.584 0-1.064.518-1.064 1.146 0 .629.48 1.147 1.064 1.147h21.465c.583 0 1.064-.518 1.064-1.147 0-.628-.481-1.146-1.064-1.146z\"></path></svg>\";s:5:\"title\";s:17:\"Table of Contents\";s:8:\"category\";s:14:\"kadence-blocks\";}i:17;a:4:{s:4:\"name\";s:13:\"kadence/posts\";s:4:\"icon\";s:1464:\"<svg width=\"20px\" height=\"20px\" xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" strokelinejoin=\"round\" strokemiterlimit=\"2\" cliprule=\"evenodd\" viewbox=\"0 0 216 216\"><path fill=\"#0073e6\" fillrule=\"nonzero\" d=\"M197.29 17.213H18.71c-1.92 0-3.5 1.58-3.5 3.5v174.574c0 1.92 1.58 3.5 3.5 3.5h178.58c1.92 0 3.5-1.58 3.5-3.5V20.693a3.517 3.517 0 00-3.5-3.48zm-3.5 174.594H22.21V24.213h171.58v167.594z\"></path><path fill=\"#0073e6\" fillrule=\"nonzero\" d=\"M107.582 55.78h72.05c1.92 0 3.5-2.266 3.5-5.019 0-2.754-1.58-5.019-3.5-5.019h-72.05c-1.92 0-3.5 2.265-3.5 5.019 0 2.753 1.58 5.019 3.5 5.019zM107.598 136.891h72.05c1.92 0 3.5-2.265 3.5-5.019 0-2.753-1.58-5.019-3.5-5.019h-72.05c-1.92 0-3.5 2.266-3.5 5.019 0 2.754 1.58 5.019 3.5 5.019zM107.814 73.972h70.993c1.92 0 3.5-1.58 3.5-3.5s-1.58-3.5-3.5-3.5h-70.993c-1.92 0-3.5 1.58-3.5 3.5s1.58 3.5 3.5 3.5zM107.829 155.083h70.994c1.92 0 3.5-1.58 3.5-3.5s-1.58-3.5-3.5-3.5h-70.994c-1.92 0-3.5 1.58-3.5 3.5s1.58 3.5 3.5 3.5zM108.024 89.288h57c1.92 0 3.5-1.58 3.5-3.5s-1.58-3.5-3.5-3.5h-57c-1.92 0-3.5 1.58-3.5 3.5s1.58 3.5 3.5 3.5zM108.039 170.4h57c1.92 0 3.5-1.58 3.5-3.5s-1.58-3.5-3.5-3.5h-57c-1.92 0-3.5 1.58-3.5 3.5s1.58 3.5 3.5 3.5z\"></path><path fill=\"#0073e6\" d=\"M92.747 36.132H32.6v62.111h60.147V36.132zm-5.738 43.343h-49.17l18.063-23.001 10.539 13.425 6.526-8.306 14.042 17.882zM92.763 117.244H32.615v62.111h60.148v-62.111zm-5.738 43.342h-49.17l18.063-23.001 10.538 13.425 6.527-8.305 14.042 17.881z\"></path></svg>\";s:5:\"title\";s:5:\"Posts\";s:8:\"category\";s:14:\"kadence-blocks\";}i:18;a:4:{s:4:\"name\";s:17:\"kadence/countdown\";s:4:\"icon\";s:1152:\"<svg xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" strokelinecap=\"round\" strokelinejoin=\"round\" width=\"20px\" height=\"20px\" strokemiterlimit=\"1.5\" cliprule=\"evenodd\" viewbox=\"0 0 216 216\"><path fill=\"#0073e6\" d=\"M136.708 9.633a3.762 3.762 0 00-3.76-3.76H80.46a3.761 3.761 0 00-3.759 3.76v7.519a3.761 3.761 0 003.759 3.76h52.488a3.762 3.762 0 003.76-3.76V9.633zM56.711 26.914a2.084 2.084 0 00-2.934-.273L27.533 48.406a2.085 2.085 0 00-.274 2.934l2.661 3.208a2.085 2.085 0 002.934.274l26.244-21.766a2.085 2.085 0 00.274-2.934l-2.661-3.208z\"></path><path fill=\"#0073e6\" d=\"M95.617 17.317H117.664V35.903H95.617z\"></path><circle cx=\"108\" cy=\"120.001\" r=\"87.354\" fill=\"none\" stroke=\"#0073e6\" strokewidth=\"10\"></circle><path fill=\"none\" stroke=\"#0073e6\" strokewidth=\"8\" d=\"M106.542 63.759l.162-.001c13.323 0 25.57 4.643 35.213 12.398M158.611 98.325a56 56 0 014.336 21.676 56.15 56.15 0 01-2.402 16.299\"></path><path fill=\"#0073e6\" d=\"M42.958 148.19l7.904-21.067 18.01 13.486-25.914 7.581z\"></path><path fill=\"none\" stroke=\"#0073e6\" strokewidth=\"8\" d=\"M148.157 156.025a55.959 55.959 0 01-30.252 17.371c-26.492 5.529-52.554-8.601-63-32.452\"></path></svg>\";s:5:\"title\";s:9:\"Countdown\";s:8:\"category\";s:14:\"kadence-blocks\";}i:19;a:5:{s:4:\"name\";s:23:\"kadence/countdown-timer\";s:4:\"icon\";s:1287:\"<svg xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" strokelinecap=\"round\" strokelinejoin=\"round\" strokemiterlimit=\"1.5\" cliprule=\"evenodd\" width=\"20px\" height=\"20px\" viewbox=\"0 0 216 216\"><path fill=\"#0073e6\" d=\"M126.139 46.723a2.377 2.377 0 00-2.376-2.375H90.599a2.376 2.376 0 00-2.375 2.375v4.751a2.377 2.377 0 002.375 2.376h33.164a2.378 2.378 0 002.376-2.376v-4.751zM75.594 57.642a1.318 1.318 0 00-1.854-.173L57.158 71.222a1.317 1.317 0 00-.173 1.854l1.681 2.026c.464.56 1.294.637 1.854.173l16.582-13.752a1.317 1.317 0 00.173-1.854l-1.681-2.027z\"></path><path fill=\"#0073e6\" d=\"M100.176 51.579H114.106V63.323H100.176z\"></path><circle cx=\"108\" cy=\"116.458\" r=\"55.194\" fill=\"none\" stroke=\"#0073e6\" strokewidth=\"10\"></circle><path fill=\"none\" stroke=\"#0073e6\" strokewidth=\"8\" d=\"M107.079 80.922h.102a35.381 35.381 0 0122.249 7.833M139.978 102.762a35.395 35.395 0 012.74 13.696c0 3.582-.531 7.04-1.518 10.298\"></path><path fill=\"#0073e6\" d=\"M65.613 142.563l6.285-21.605 18.98 12.083-25.265 9.522z\"></path><path fill=\"none\" stroke=\"#0073e6\" strokewidth=\"8\" d=\"M133.373 139.22a35.36 35.36 0 01-19.114 10.975c-14.898 3.109-29.58-3.62-37.283-15.762\"></path><path fill=\"none\" stroke=\"#0073e6\" strokemiterlimit=\"1\" strokewidth=\"8\" d=\"M11.525 24.244H204.475V191.757H11.525z\"></path></svg>\";s:5:\"title\";s:15:\"Countdown Timer\";s:8:\"category\";s:14:\"kadence-blocks\";s:6:\"parent\";a:1:{i:0;s:17:\"kadence/countdown\";}}i:20;a:5:{s:4:\"name\";s:23:\"kadence/countdown-inner\";s:4:\"icon\";s:1287:\"<svg xmlns=\"http://www.w3.org/2000/svg\" fillrule=\"evenodd\" strokelinecap=\"round\" strokelinejoin=\"round\" strokemiterlimit=\"1.5\" cliprule=\"evenodd\" width=\"20px\" height=\"20px\" viewbox=\"0 0 216 216\"><path fill=\"#0073e6\" d=\"M126.139 46.723a2.377 2.377 0 00-2.376-2.375H90.599a2.376 2.376 0 00-2.375 2.375v4.751a2.377 2.377 0 002.375 2.376h33.164a2.378 2.378 0 002.376-2.376v-4.751zM75.594 57.642a1.318 1.318 0 00-1.854-.173L57.158 71.222a1.317 1.317 0 00-.173 1.854l1.681 2.026c.464.56 1.294.637 1.854.173l16.582-13.752a1.317 1.317 0 00.173-1.854l-1.681-2.027z\"></path><path fill=\"#0073e6\" d=\"M100.176 51.579H114.106V63.323H100.176z\"></path><circle cx=\"108\" cy=\"116.458\" r=\"55.194\" fill=\"none\" stroke=\"#0073e6\" strokewidth=\"10\"></circle><path fill=\"none\" stroke=\"#0073e6\" strokewidth=\"8\" d=\"M107.079 80.922h.102a35.381 35.381 0 0122.249 7.833M139.978 102.762a35.395 35.395 0 012.74 13.696c0 3.582-.531 7.04-1.518 10.298\"></path><path fill=\"#0073e6\" d=\"M65.613 142.563l6.285-21.605 18.98 12.083-25.265 9.522z\"></path><path fill=\"none\" stroke=\"#0073e6\" strokewidth=\"8\" d=\"M133.373 139.22a35.36 35.36 0 01-19.114 10.975c-14.898 3.109-29.58-3.62-37.283-15.762\"></path><path fill=\"none\" stroke=\"#0073e6\" strokemiterlimit=\"1\" strokewidth=\"8\" d=\"M11.525 24.244H204.475V191.757H11.525z\"></path></svg>\";s:5:\"title\";s:17:\"Countdown Content\";s:8:\"category\";s:14:\"kadence-blocks\";s:6:\"parent\";a:1:{i:0;s:17:\"kadence/countdown\";}}i:21;a:4:{s:4:\"name\";s:18:\"yoast/how-to-block\";s:4:\"icon\";s:60:\"<span class=\"dashicon dashicons dashicons-editor-ol\"></span>\";s:5:\"title\";s:18:\"Tutoriels de Yoast\";s:8:\"category\";s:28:\"yoast-structured-data-blocks\";}i:22;a:4:{s:4:\"name\";s:15:\"yoast/faq-block\";s:4:\"icon\";s:60:\"<span class=\"dashicon dashicons dashicons-editor-ul\"></span>\";s:5:\"title\";s:12:\"FAQ de Yoast\";s:8:\"category\";s:28:\"yoast-structured-data-blocks\";}i:23;a:5:{s:4:\"name\";s:15:\"advgb/accordion\";s:4:\"icon\";s:287:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><rect x=\"3\" y=\"17\" width=\"18\" height=\"2\"></rect><path d=\"M19,12v1H5v-1H19 M21,10H3v5h18V10L21,10z\"></path><rect x=\"3\" y=\"6\" width=\"18\" height=\"2\"></rect></svg>\";s:5:\"title\";s:9:\"Accordion\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:24;a:6:{s:4:\"name\";s:20:\"advgb/accordion-item\";s:4:\"icon\";s:287:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><rect x=\"3\" y=\"17\" width=\"18\" height=\"2\"></rect><path d=\"M19,12v1H5v-1H19 M21,10H3v5h18V10L21,10z\"></path><rect x=\"3\" y=\"6\" width=\"18\" height=\"2\"></rect></svg>\";s:5:\"title\";s:14:\"Accordion Item\";s:8:\"category\";s:14:\"advgb-category\";s:6:\"parent\";a:1:{i:0;s:16:\"advgb/accordions\";}s:9:\"iconColor\";s:7:\"#5952de\";}i:25;a:5:{s:4:\"name\";s:16:\"advgb/accordions\";s:4:\"icon\";s:237:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path d=\"M0 0h24v24H0z\" fill=\"none\"></path><path d=\"M2 20h20v-4H2v4zm2-3h2v2H4v-2zM2 4v4h20V4H2zm4 3H4V5h2v2zm-4 7h20v-4H2v4zm2-3h2v2H4v-2z\"></path></svg>\";s:5:\"title\";s:18:\"Advanced Accordion\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:26;a:5:{s:4:\"name\";s:12:\"advgb/button\";s:4:\"icon\";s:241:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path d=\"M19 7H5c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V9c0-1.1-.9-2-2-2zm0 8H5V9h14v6z\"></path></svg>\";s:5:\"title\";s:15:\"Advanced Button\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:27;a:5:{s:4:\"name\";s:10:\"advgb/icon\";s:4:\"icon\";s:351:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path d=\"M19 1H5c-1.1 0-1.99.9-1.99 2L3 15.93c0 .69.35 1.3.88 1.66L12 23l8.11-5.41c.53-.36.88-.97.88-1.66L21 3c0-1.1-.9-2-2-2zm-7 19.6l-7-4.66V3h14v12.93l-7 4.67zm-2.01-7.42l-2.58-2.59L6 12l4 4 8-8-1.42-1.42z\"></path></svg>\";s:5:\"title\";s:13:\"Advanced Icon\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:28;a:5:{s:4:\"name\";s:11:\"advgb/image\";s:4:\"icon\";s:300:\"<svg height=\"20\" viewbox=\"2 2 22 22\" width=\"20\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M0 0h24v24H0V0z\" fill=\"none\"></path><path d=\"M1 5h2v14H1zm4 0h2v14H5zm17 0H10c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h12c.55 0 1-.45 1-1V6c0-.55-.45-1-1-1zM11 17l2.5-3.15L15.29 16l2.5-3.22L21 17H11z\"></path></svg>\";s:5:\"title\";s:14:\"Advanced Image\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:29;a:5:{s:4:\"name\";s:10:\"advgb/list\";s:4:\"icon\";s:236:\"<svg height=\"20\" viewbox=\"2 2 22 22\" width=\"20\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M3 13h2v-2H3v2zm0 4h2v-2H3v2zm0-8h2V7H3v2zm4 4h14v-2H7v2zm0 4h14v-2H7v2zM7 7v2h14V7H7z\"></path><path d=\"M0 0h24v24H0z\" fill=\"none\"></path></svg>\";s:5:\"title\";s:13:\"Advanced List\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:30;a:5:{s:4:\"name\";s:11:\"advgb/table\";s:4:\"icon\";s:222:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path d=\"M3 3v18h18V3H3zm8 16H5v-6h6v6zm0-8H5V5h6v6zm8 8h-6v-6h6v6zm0-8h-6V5h6v6z\"></path><path d=\"M0 0h24v24H0z\" fill=\"none\"></path></svg>\";s:5:\"title\";s:14:\"Advanced Table\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:31;a:5:{s:4:\"name\";s:14:\"advgb/adv-tabs\";s:4:\"icon\";s:302:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path d=\"M21,3H3C1.9,3,1,3.9,1,5v14c0,1.1,0.9,2,2,2h18c1.1,0,2-0.9,2-2V5C23,3.9,22.1,3,21,3z M21,19H3V5h10v4h8V19z\"></path></svg>\";s:5:\"title\";s:13:\"Advanced Tabs\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:32;a:6:{s:4:\"name\";s:9:\"advgb/tab\";s:4:\"icon\";s:302:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path d=\"M21,3H3C1.9,3,1,3.9,1,5v14c0,1.1,0.9,2,2,2h18c1.1,0,2-0.9,2-2V5C23,3.9,22.1,3,21,3z M21,19H3V5h10v4h8V19z\"></path></svg>\";s:5:\"title\";s:8:\"Tab Item\";s:8:\"category\";s:14:\"advgb-category\";s:6:\"parent\";a:1:{i:0;s:14:\"advgb/adv-tabs\";}s:9:\"iconColor\";s:7:\"#5952de\";}i:33;a:5:{s:4:\"name\";s:11:\"advgb/video\";s:4:\"icon\";s:297:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path d=\"M0 0h24v24H0z\" fill=\"none\"></path><path d=\"M10 16.5l6-4.5-6-4.5v9zM12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8z\"></path></svg>\";s:5:\"title\";s:14:\"Advanced Video\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:34;a:5:{s:4:\"name\";s:13:\"advgb/columns\";s:4:\"icon\";s:57:\"<span class=\"dashicon dashicons dashicons-layout\"></span>\";s:5:\"title\";s:15:\"Columns Manager\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:35;a:6:{s:4:\"name\";s:12:\"advgb/column\";s:4:\"icon\";s:198:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path d=\"M10 18h5V5h-5v13zm-6 0h5V5H4v13zM16 5v13h5V5h-5z\"></path><path d=\"M0 0h24v24H0z\" fill=\"none\"></path></svg>\";s:5:\"title\";s:11:\"Adv. Column\";s:8:\"category\";s:14:\"advgb-category\";s:6:\"parent\";a:1:{i:0;s:13:\"advgb/columns\";}s:9:\"iconColor\";s:7:\"#5952de\";}i:36;a:5:{s:4:\"name\";s:18:\"advgb/contact-form\";s:4:\"icon\";s:270:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path d=\"M22 6c0-1.1-.9-2-2-2H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6zm-2 0l-8 4.99L4 6h16zm0 12H4V8l8 5 8-5v10z\"></path></svg>\";s:5:\"title\";s:12:\"Contact Form\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:37;a:5:{s:4:\"name\";s:15:\"advgb/container\";s:4:\"icon\";s:211:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path d=\"M3 5v14h19V5H3zm2 2h15v4H5V7zm0 10v-4h4v4H5zm6 0v-4h9v4h-9z\"></path></svg>\";s:5:\"title\";s:9:\"Container\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:38;a:5:{s:4:\"name\";s:14:\"advgb/count-up\";s:4:\"icon\";s:763:\"<svg height=\"20\" viewbox=\"2 2 22 22\" width=\"20\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M0 0h24v24H0zm0 0h24v24H0z\" fill=\"none\"></path><path d=\"M16.05 16.29l2.86-3.07c.38-.39.72-.79 1.04-1.18.32-.39.59-.78.82-1.17.23-.39.41-.78.54-1.17.13-.39.19-.79.19-1.18 0-.53-.09-1.02-.27-1.46-.18-.44-.44-.81-.78-1.11-.34-.31-.77-.54-1.26-.71-.51-.16-1.08-.24-1.72-.24-.69 0-1.31.11-1.85.32-.54.21-1 .51-1.36.88-.37.37-.65.8-.84 1.3-.18.47-.27.97-.28 1.5h2.14c.01-.31.05-.6.13-.87.09-.29.23-.54.4-.75.18-.21.41-.37.68-.49.27-.12.6-.18.96-.18.31 0 .58.05.81.15.23.1.43.25.59.43.16.18.28.4.37.65.08.25.13.52.13.81 0 .22-.03.43-.08.65-.06.22-.15.45-.29.7-.14.25-.32.53-.56.83-.23.3-.52.65-.88 1.03l-4.17 4.55V18H22v-1.71h-5.95zM8 7H6v4H2v2h4v4h2v-4h4v-2H8V7z\"></path></svg>\";s:5:\"title\";s:8:\"Count Up\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:39;a:5:{s:4:\"name\";s:19:\"advgb/images-slider\";s:4:\"icon\";s:368:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\" class=\"dashicon\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path d=\"M20 4h-3.17L15 2H9L7.17 4H4c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zM9.88 4h4.24l1.83 2H20v12H4V6h4.05\"></path><path d=\"M15 11H9V8.5L5.5 12 9 15.5V13h6v2.5l3.5-3.5L15 8.5z\"></path></svg>\";s:5:\"title\";s:13:\"Images Slider\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:40;a:5:{s:4:\"name\";s:13:\"advgb/infobox\";s:4:\"icon\";s:252:\"<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" x=\"0px\" y=\"0px\" viewbox=\"0 0 250 250\"><path d=\"M114,110h23v69.1h-23V110z M114,63.9v23h23v-23H114z M225,22v11v177v11h-11H37H26v-11V33V22h11h177H225z M214,33H37v177h177V33z\"></path></svg>\";s:5:\"title\";s:8:\"Info Box\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:41;a:5:{s:4:\"name\";s:16:\"advgb/login-form\";s:4:\"icon\";s:406:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path d=\"M11 12c2.21 0 4-1.79 4-4s-1.79-4-4-4-4 1.79-4 4 1.79 4 4 4zm0-6c1.1 0 2 .9 2 2s-.9 2-2 2-2-.9-2-2 .9-2 2-2zM5 18c.2-.63 2.57-1.68 4.96-1.94l2.04-2c-.39-.04-.68-.06-1-.06-2.67 0-8 1.34-8 4v2h9l-2-2H5zm15.6-5.5l-5.13 5.17-2.07-2.08L12 17l3.47 3.5L22 13.91z\"></path></svg>\";s:5:\"title\";s:19:\"Login/Register Form\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:42;a:5:{s:4:\"name\";s:9:\"advgb/map\";s:4:\"icon\";s:347:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"2 2 22 22\" class=\"dashicon\"><path d=\"M20.5 3l-.16.03L15 5.1 9 3 3.36 4.9c-.21.07-.36.25-.36.48V20.5c0 .28.22.5.5.5l.16-.03L9 18.9l6 2.1 5.64-1.9c.21-.07.36-.25.36-.48V3.5c0-.28-.22-.5-.5-.5zM15 19l-6-2.11V5l6 2.11V19z\"></path><path d=\"M0 0h24v24H0z\" fill=\"none\"></path></svg>\";s:5:\"title\";s:3:\"Map\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:43;a:5:{s:4:\"name\";s:16:\"advgb/newsletter\";s:4:\"icon\";s:519:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path><path fill-opacity=\".9\" d=\"M12 1.95c-5.52 0-10 4.48-10 10s4.48 10 10 10h5v-2h-5c-4.34 0-8-3.66-8-8s3.66-8 8-8 8 3.66 8 8v1.43c0 .79-.71 1.57-1.5 1.57s-1.5-.78-1.5-1.57v-1.43c0-2.76-2.24-5-5-5s-5 2.24-5 5 2.24 5 5 5c1.38 0 2.64-.56 3.54-1.47.65.89 1.77 1.47 2.96 1.47 1.97 0 3.5-1.6 3.5-3.57v-1.43c0-5.52-4.48-10-10-10zm0 13c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3z\"></path></svg>\";s:5:\"title\";s:10:\"Newsletter\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:44;a:5:{s:4:\"name\";s:18:\"advgb/recent-posts\";s:4:\"icon\";s:418:\"<svg width=\"20\" height=\"20\" viewbox=\"2 2 22 22\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><rect x=\"13\" y=\"7.5\" width=\"5\" height=\"2\"></rect><rect x=\"13\" y=\"14.5\" width=\"5\" height=\"2\"></rect><path d=\"M19,3H5C3.9,3,3,3.9,3,5v14c0,1.1,0.9,2,2,2h14c1.1,0,2-0.9,2-2V5C21,3.9,20.1,3,19,3z M19,19H5V5h14V19z\"></path><path d=\"M11,6H6v5h5V6z M10,10H7V7h3V10z\"></path><path d=\"M11,13H6v5h5V13z M10,17H7v-3h3V17z\"></path></svg>\";s:5:\"title\";s:15:\"Content Display\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:45;a:5:{s:4:\"name\";s:16:\"advgb/search-bar\";s:4:\"icon\";s:241:\"<svg fill=\"none\" height=\"20\" width=\"20\" stroke=\"currentColor\" strokewidth=\"2\" viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\"><circle fill=\"none\" cx=\"11\" cy=\"11\" r=\"8\"></circle><line x1=\"21\" x2=\"16.65\" y1=\"21\" y2=\"16.65\"></line></svg>\";s:5:\"title\";s:10:\"Search Bar\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:46;a:5:{s:4:\"name\";s:18:\"advgb/social-links\";s:4:\"icon\";s:757:\"<svg width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><g fill=\"currentColor\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path d=\"M18,16.08c-0.76,0-1.44,0.3-1.96,0.77L8.91,12.7C8.96,12.47,9,12.24,9,12s-0.04-0.47-0.09-0.7l7.05-4.11 C16.5,7.69,17.21,8,18,8c1.66,0,3-1.34,3-3c0-1.66-1.34-3-3-3s-3,1.34-3,3c0,0.24,0.04,0.47,0.09,0.7L8.04,9.81 C7.5,9.31,6.79,9,6,9c-1.66,0-3,1.34-3,3c0,1.66,1.34,3,3,3c0.79,0,1.5-0.31,2.04-0.81l7.12,4.16c-0.05,0.21-0.08,0.43-0.08,0.65 c0,1.61,1.31,2.92,2.92,2.92s2.92-1.31,2.92-2.92C20.92,17.39,19.61,16.08,18,16.08z M18,4c0.55,0,1,0.45,1,1s-0.45,1-1,1 s-1-0.45-1-1S17.45,4,18,4z M6,13c-0.55,0-1-0.45-1-1s0.45-1,1-1s1,0.45,1,1S6.55,13,6,13z M18,20.02c-0.55,0-1-0.45-1-1 s0.45-1,1-1s1,0.45,1,1S18.55,20.02,18,20.02z\"></path></g></svg>\";s:5:\"title\";s:12:\"Social Links\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:47;a:5:{s:4:\"name\";s:13:\"advgb/summary\";s:4:\"icon\";s:211:\"<svg height=\"20\" viewbox=\"2 2 22 22\" width=\"20\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M14 17H4v2h10v-2zm6-8H4v2h16V9zM4 15h16v-2H4v2zM4 5v2h16V5H4z\"></path><path d=\"M0 0h24v24H0z\" fill=\"none\"></path></svg>\";s:5:\"title\";s:17:\"Table of Contents\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:48;a:5:{s:4:\"name\";s:10:\"advgb/tabs\";s:4:\"icon\";s:302:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path d=\"M21,3H3C1.9,3,1,3.9,1,5v14c0,1.1,0.9,2,2,2h18c1.1,0,2-0.9,2-2V5C23,3.9,22.1,3,21,3z M21,19H3V5h10v4h8V19z\"></path></svg>\";s:5:\"title\";s:4:\"Tabs\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:49;a:5:{s:4:\"name\";s:17:\"advgb/testimonial\";s:4:\"icon\";s:385:\"<svg height=\"20\" viewbox=\"2 2 22 22\" width=\"20\" xmlns=\"http://www.w3.org/2000/svg\"><path d=\"M19 2H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h4l3 3 3-3h4c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-7 3.3c1.49 0 2.7 1.21 2.7 2.7 0 1.49-1.21 2.7-2.7 2.7-1.49 0-2.7-1.21-2.7-2.7 0-1.49 1.21-2.7 2.7-2.7zM18 16H6v-.9c0-2 4-3.1 6-3.1s6 1.1 6 3.1v.9z\"></path><path d=\"M0 0h24v24H0z\" fill=\"none\"></path></svg>\";s:5:\"title\";s:11:\"Testimonial\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:50;a:5:{s:4:\"name\";s:18:\"advgb/woo-products\";s:4:\"icon\";s:517:\"<svg width=\"20\" height=\"20\" viewbox=\"0 0 24 24\"><path fill=\"none\" d=\"M0,0h24v24H0V0z\"></path><path d=\"M15.55,13c0.75,0,1.41-0.41,1.75-1.03l3.58-6.49C21.25,4.82,20.77,4,20.01,4H5.21L4.27,2H1v2h2l3.6,7.59l-1.35,2.44 C4.52,15.37,5.48,17,7,17h12v-2H7l1.1-2H15.55z M6.16,6h12.15l-2.76,5H8.53L6.16,6z\"></path><path d=\"M7,18c-1.1,0-1.99,0.9-1.99,2c0,1.1,0.89,2,1.99,2c1.1,0,2-0.9,2-2C9,18.9,8.1,18,7,18z\"></path><path d=\"M17,18c-1.1,0-1.99,0.9-1.99,2c0,1.1,0.89,2,1.99,2c1.1,0,2-0.9,2-2C19,18.9,18.1,18,17,18z\"></path></svg>\";s:5:\"title\";s:12:\"Woo Products\";s:8:\"category\";s:14:\"advgb-category\";s:9:\"iconColor\";s:7:\"#5952de\";}i:51;a:4:{s:4:\"name\";s:14:\"core/paragraph\";s:4:\"icon\";s:206:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M18.3 4H9.9v-.1l-.9.2c-2.3.4-4 2.4-4 4.8s1.7 4.4 4 4.8l.7.1V20h1.5V5.5h2.9V20h1.5V5.5h2.7V4z\"></path></svg>\";s:5:\"title\";s:10:\"Paragraphe\";s:8:\"category\";s:4:\"text\";}i:52;a:4:{s:4:\"name\";s:10:\"core/image\";s:4:\"icon\";s:391:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM5 4.5h14c.3 0 .5.2.5.5v8.4l-3-2.9c-.3-.3-.8-.3-1 0L11.9 14 9 12c-.3-.2-.6-.2-.8 0l-3.6 2.6V5c-.1-.3.1-.5.4-.5zm14 15H5c-.3 0-.5-.2-.5-.5v-2.4l4.1-3 3 1.9c.3.2.7.2.9-.1L16 12l3.5 3.4V19c0 .3-.2.5-.5.5z\"></path></svg>\";s:5:\"title\";s:5:\"Image\";s:8:\"category\";s:5:\"media\";}i:53;a:4:{s:4:\"name\";s:12:\"core/heading\";s:4:\"icon\";s:148:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M6.2 5.2v13.4l5.8-4.8 5.8 4.8V5.2z\"></path></svg>\";s:5:\"title\";s:5:\"Titre\";s:8:\"category\";s:4:\"text\";}i:54;a:4:{s:4:\"name\";s:12:\"core/gallery\";s:4:\"icon\";s:502:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M20.2 8v11c0 .7-.6 1.2-1.2 1.2H6v1.5h13c1.5 0 2.7-1.2 2.7-2.8V8h-1.5zM18 16.4V4.6c0-.9-.7-1.6-1.6-1.6H4.6C3.7 3 3 3.7 3 4.6v11.8c0 .9.7 1.6 1.6 1.6h11.8c.9 0 1.6-.7 1.6-1.6zM4.5 4.6c0-.1.1-.1.1-.1h11.8c.1 0 .1.1.1.1V12l-2.3-1.7c-.3-.2-.6-.2-.9 0l-2.9 2.1L8 11.3c-.2-.1-.5-.1-.7 0l-2.9 1.5V4.6zm0 11.8v-1.8l3.2-1.7 2.4 1.2c.2.1.5.1.8-.1l2.8-2 2.8 2v2.5c0 .1-.1.1-.1.1H4.6c0-.1-.1-.2-.1-.2z\"></path></svg>\";s:5:\"title\";s:7:\"Galerie\";s:8:\"category\";s:5:\"media\";}i:55;a:4:{s:4:\"name\";s:9:\"core/list\";s:4:\"icon\";s:216:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M4 4v1.5h16V4H4zm8 8.5h8V11h-8v1.5zM4 20h16v-1.5H4V20zm4-8c0-1.1-.9-2-2-2s-2 .9-2 2 .9 2 2 2 2-.9 2-2z\"></path></svg>\";s:5:\"title\";s:5:\"Liste\";s:8:\"category\";s:4:\"text\";}i:56;a:4:{s:4:\"name\";s:10:\"core/quote\";s:4:\"icon\";s:315:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M13 6v6h5.2v4c0 .8-.2 1.4-.5 1.7-.6.6-1.6.6-2.5.5h-.3v1.5h.5c1 0 2.3-.1 3.3-1 .6-.6 1-1.6 1-2.8V6H13zm-9 6h5.2v4c0 .8-.2 1.4-.5 1.7-.6.6-1.6.6-2.5.5h-.3v1.5h.5c1 0 2.3-.1 3.3-1 .6-.6 1-1.6 1-2.8V6H4v6z\"></path></svg>\";s:5:\"title\";s:8:\"Citation\";s:8:\"category\";s:4:\"text\";}i:57;a:4:{s:4:\"name\";s:14:\"core/shortcode\";s:4:\"icon\";s:228:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M16 4.2v1.5h2.5v12.5H16v1.5h4V4.2h-4zM4.2 19.8h4v-1.5H5.8V5.8h2.5V4.2h-4l-.1 15.6zm5.1-3.1l1.4.6 4-10-1.4-.6-4 10z\"></path></svg>\";s:5:\"title\";s:11:\"Code court \";s:8:\"category\";s:7:\"widgets\";}i:58;a:4:{s:4:\"name\";s:13:\"core/archives\";s:4:\"icon\";s:373:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 6.2h-5.9l-.6-1.1c-.3-.7-1-1.1-1.8-1.1H5c-1.1 0-2 .9-2 2v11.8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V8.2c0-1.1-.9-2-2-2zm.5 11.6c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h5.8c.2 0 .4.1.4.3l1 2H19c.3 0 .5.2.5.5v9.5zM8 12.8h8v-1.5H8v1.5zm0 3h8v-1.5H8v1.5z\"></path></svg>\";s:5:\"title\";s:8:\"Archives\";s:8:\"category\";s:7:\"widgets\";}i:59;a:4:{s:4:\"name\";s:10:\"core/audio\";s:4:\"icon\";s:308:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M17.7 4.3c-1.2 0-2.8 0-3.8 1-.6.6-.9 1.5-.9 2.6V14c-.6-.6-1.5-1-2.5-1C8.6 13 7 14.6 7 16.5S8.6 20 10.5 20c1.5 0 2.8-1 3.3-2.3.5-.8.7-1.8.7-2.5V7.9c0-.7.2-1.2.5-1.6.6-.6 1.8-.6 2.8-.6h.3V4.3h-.4z\"></path></svg>\";s:5:\"title\";s:5:\"Audio\";s:8:\"category\";s:5:\"media\";}i:60;a:5:{s:4:\"name\";s:11:\"core/button\";s:4:\"icon\";s:291:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 6.5H5c-1.1 0-2 .9-2 2v7c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-7c0-1.1-.9-2-2-2zm.5 9c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5v-7c0-.3.2-.5.5-.5h14c.3 0 .5.2.5.5v7zM8 12.8h8v-1.5H8v1.5z\"></path></svg>\";s:5:\"title\";s:6:\"Bouton\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:12:\"core/buttons\";}}i:61;a:4:{s:4:\"name\";s:12:\"core/buttons\";s:4:\"icon\";s:464:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M17 3H7c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm.5 6c0 .3-.2.5-.5.5H7c-.3 0-.5-.2-.5-.5V5c0-.3.2-.5.5-.5h10c.3 0 .5.2.5.5v4zm-8-1.2h5V6.2h-5v1.6zM17 13H7c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2zm.5 6c0 .3-.2.5-.5.5H7c-.3 0-.5-.2-.5-.5v-4c0-.3.2-.5.5-.5h10c.3 0 .5.2.5.5v4zm-8-1.2h5v-1.5h-5v1.5z\"></path></svg>\";s:5:\"title\";s:7:\"Boutons\";s:8:\"category\";s:6:\"design\";}i:62;a:4:{s:4:\"name\";s:13:\"core/calendar\";s:4:\"icon\";s:330:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm.5 16c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V7h15v12zM9 10H7v2h2v-2zm0 4H7v2h2v-2zm4-4h-2v2h2v-2zm4 0h-2v2h2v-2zm-4 4h-2v2h2v-2zm4 0h-2v2h2v-2z\"></path></svg>\";s:5:\"title\";s:10:\"Calendrier\";s:8:\"category\";s:7:\"widgets\";}i:63;a:4:{s:4:\"name\";s:15:\"core/categories\";s:4:\"icon\";s:717:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M6 5.5h3a.5.5 0 01.5.5v3a.5.5 0 01-.5.5H6a.5.5 0 01-.5-.5V6a.5.5 0 01.5-.5zM4 6a2 2 0 012-2h3a2 2 0 012 2v3a2 2 0 01-2 2H6a2 2 0 01-2-2V6zm11-.5h3a.5.5 0 01.5.5v3a.5.5 0 01-.5.5h-3a.5.5 0 01-.5-.5V6a.5.5 0 01.5-.5zM13 6a2 2 0 012-2h3a2 2 0 012 2v3a2 2 0 01-2 2h-3a2 2 0 01-2-2V6zm5 8.5h-3a.5.5 0 00-.5.5v3a.5.5 0 00.5.5h3a.5.5 0 00.5-.5v-3a.5.5 0 00-.5-.5zM15 13a2 2 0 00-2 2v3a2 2 0 002 2h3a2 2 0 002-2v-3a2 2 0 00-2-2h-3zm-9 1.5h3a.5.5 0 01.5.5v3a.5.5 0 01-.5.5H6a.5.5 0 01-.5-.5v-3a.5.5 0 01.5-.5zM4 15a2 2 0 012-2h3a2 2 0 012 2v3a2 2 0 01-2 2H6a2 2 0 01-2-2v-3z\" fillrule=\"evenodd\" cliprule=\"evenodd\"></path></svg>\";s:5:\"title\";s:11:\"Catégories\";s:8:\"category\";s:7:\"widgets\";}i:64;a:4:{s:4:\"name\";s:9:\"core/code\";s:4:\"icon\";s:299:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M20.8 10.7l-4.3-4.3-1.1 1.1 4.3 4.3c.1.1.1.3 0 .4l-4.3 4.3 1.1 1.1 4.3-4.3c.7-.8.7-1.9 0-2.6zM4.2 11.8l4.3-4.3-1-1-4.3 4.3c-.7.7-.7 1.8 0 2.5l4.3 4.3 1.1-1.1-4.3-4.3c-.2-.1-.2-.3-.1-.4z\"></path></svg>\";s:5:\"title\";s:4:\"Code\";s:8:\"category\";s:4:\"text\";}i:65;a:4:{s:4:\"name\";s:12:\"core/columns\";s:4:\"icon\";s:314:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 6H6c-1.1 0-2 .9-2 2v9c0 1.1.9 2 2 2h13c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm-4.1 1.5v10H10v-10h4.9zM5.5 17V8c0-.3.2-.5.5-.5h2.5v10H6c-.3 0-.5-.2-.5-.5zm14 0c0 .3-.2.5-.5.5h-2.6v-10H19c.3 0 .5.2.5.5v9z\"></path></svg>\";s:5:\"title\";s:8:\"Colonnes\";s:8:\"category\";s:6:\"design\";}i:66;a:5:{s:4:\"name\";s:11:\"core/column\";s:4:\"icon\";s:288:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 6H6c-1.1 0-2 .9-2 2v9c0 1.1.9 2 2 2h13c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zM6 17.5c-.3 0-.5-.2-.5-.5V8c0-.3.2-.5.5-.5h3v10H6zm13.5-.5c0 .3-.2.5-.5.5h-3v-10h3c.3 0 .5.2.5.5v9z\"></path></svg>\";s:5:\"title\";s:7:\"Colonne\";s:8:\"category\";s:4:\"text\";s:6:\"parent\";a:1:{i:0;s:12:\"core/columns\";}}i:67;a:4:{s:4:\"name\";s:10:\"core/cover\";s:4:\"icon\";s:324:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M18.7 3H5.3C4 3 3 4 3 5.3v13.4C3 20 4 21 5.3 21h13.4c1.3 0 2.3-1 2.3-2.3V5.3C21 4 20 3 18.7 3zm.8 15.7c0 .4-.4.8-.8.8H5.3c-.4 0-.8-.4-.8-.8V5.3c0-.4.4-.8.8-.8h6.2v8.9l2.5-3.1 2.5 3.1V4.5h2.2c.4 0 .8.4.8.8v13.4z\"></path></svg>\";s:5:\"title\";s:9:\"Bannière\";s:8:\"category\";s:5:\"media\";}i:68;a:4:{s:4:\"name\";s:10:\"core/embed\";s:4:\"icon\";s:355:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm.5 16c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V9.8l4.7-5.3H19c.3 0 .5.2.5.5v14zm-6-9.5L16 12l-2.5 2.8 1.1 1L18 12l-3.5-3.5-1 1zm-3 0l-1-1L6 12l3.5 3.8 1.1-1L8 12l2.5-2.5z\"></path></svg>\";s:5:\"title\";s:17:\"Contenu embarqué\";s:8:\"category\";s:5:\"embed\";}i:69;a:4:{s:4:\"name\";s:9:\"core/file\";s:4:\"icon\";s:334:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 6.2h-5.9l-.6-1.1c-.3-.7-1-1.1-1.8-1.1H5c-1.1 0-2 .9-2 2v11.8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V8.2c0-1.1-.9-2-2-2zm.5 11.6c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h5.8c.2 0 .4.1.4.3l1 2H19c.3 0 .5.2.5.5v9.5z\"></path></svg>\";s:5:\"title\";s:7:\"Fichier\";s:8:\"category\";s:5:\"media\";}i:70;a:4:{s:4:\"name\";s:10:\"core/group\";s:4:\"icon\";s:452:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18 4h-7c-1.1 0-2 .9-2 2v3H6c-1.1 0-2 .9-2 2v7c0 1.1.9 2 2 2h7c1.1 0 2-.9 2-2v-3h3c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-4.5 14c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5v-7c0-.3.2-.5.5-.5h3V13c0 1.1.9 2 2 2h2.5v3zm0-4.5H11c-.3 0-.5-.2-.5-.5v-2.5H13c.3 0 .5.2.5.5v2.5zm5-.5c0 .3-.2.5-.5.5h-3V11c0-1.1-.9-2-2-2h-2.5V6c0-.3.2-.5.5-.5h7c.3 0 .5.2.5.5v7z\"></path></svg>\";s:5:\"title\";s:6:\"Groupe\";s:8:\"category\";s:6:\"design\";}i:71;a:4:{s:4:\"name\";s:13:\"core/freeform\";s:4:\"icon\";s:388:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M20 6H4c-1.1 0-2 .9-2 2v9c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V8c0-1.1-.9-2-2-2zm.5 11c0 .3-.2.5-.5.5H4c-.3 0-.5-.2-.5-.5V8c0-.3.2-.5.5-.5h16c.3 0 .5.2.5.5v9zM10 10H8v2h2v-2zm-5 2h2v-2H5v2zm8-2h-2v2h2v-2zm-5 6h8v-2H8v2zm6-4h2v-2h-2v2zm3 0h2v-2h-2v2zm0 4h2v-2h-2v2zM5 16h2v-2H5v2z\"></path></svg>\";s:5:\"title\";s:9:\"Classique\";s:8:\"category\";s:4:\"text\";}i:72;a:4:{s:4:\"name\";s:9:\"core/html\";s:4:\"icon\";s:305:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M4.8 11.4H2.1V9H1v6h1.1v-2.6h2.7V15h1.1V9H4.8v2.4zm1.9-1.3h1.7V15h1.1v-4.9h1.7V9H6.7v1.1zM16.2 9l-1.5 2.7L13.3 9h-.9l-.8 6h1.1l.5-4 1.5 2.8 1.5-2.8.5 4h1.1L17 9h-.8zm3.8 5V9h-1.1v6h3.6v-1H20z\"></path></svg>\";s:5:\"title\";s:18:\"HTML personnalisé\";s:8:\"category\";s:7:\"widgets\";}i:73;a:4:{s:4:\"name\";s:15:\"core/media-text\";s:4:\"icon\";s:188:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M3 18h8V6H3v12zM14 7.5V9h7V7.5h-7zm0 5.3h7v-1.5h-7v1.5zm0 3.7h7V15h-7v1.5z\"></path></svg>\";s:5:\"title\";s:14:\"Média & texte\";s:8:\"category\";s:5:\"media\";}i:74;a:4:{s:4:\"name\";s:20:\"core/latest-comments\";s:4:\"icon\";s:290:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18 4H6c-1.1 0-2 .9-2 2v12.9c0 .6.5 1.1 1.1 1.1.3 0 .5-.1.8-.3L8.5 17H18c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm.5 11c0 .3-.2.5-.5.5H7.9l-2.4 2.4V6c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v9z\"></path></svg>\";s:5:\"title\";s:21:\"Derniers commentaires\";s:8:\"category\";s:7:\"widgets\";}i:75;a:4:{s:4:\"name\";s:17:\"core/latest-posts\";s:4:\"icon\";s:326:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18 4H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm.5 14c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v12zM7 11h2V9H7v2zm0 4h2v-2H7v2zm3-4h7V9h-7v2zm0 4h7v-2h-7v2z\"></path></svg>\";s:5:\"title\";s:17:\"Derniers articles\";s:8:\"category\";s:7:\"widgets\";}i:76;a:4:{s:4:\"name\";s:12:\"core/missing\";s:4:\"icon\";s:288:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 8h-1V6h-5v2h-2V6H6v2H5c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-8c0-1.1-.9-2-2-2zm.5 10c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5v-8c0-.3.2-.5.5-.5h14c.3 0 .5.2.5.5v8z\"></path></svg>\";s:5:\"title\";s:18:\"Non pris en charge\";s:8:\"category\";s:4:\"text\";}i:77;a:4:{s:4:\"name\";s:9:\"core/more\";s:4:\"icon\";s:185:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M4 9v1.5h16V9H4zm12 5.5h4V13h-4v1.5zm-6 0h4V13h-4v1.5zm-6 0h4V13H4v1.5z\"></path></svg>\";s:5:\"title\";s:13:\"Lire la suite\";s:8:\"category\";s:6:\"design\";}i:78;a:5:{s:4:\"name\";s:13:\"core/nextpage\";s:4:\"icon\";s:355:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M7.8 6c0-.7.6-1.2 1.2-1.2h6c.7 0 1.2.6 1.2 1.2v3h1.5V6c0-1.5-1.2-2.8-2.8-2.8H9C7.5 3.2 6.2 4.5 6.2 6v3h1.5V6zm8.4 11c0 .7-.6 1.2-1.2 1.2H9c-.7 0-1.2-.6-1.2-1.2v-3H6.2v3c0 1.5 1.2 2.8 2.8 2.8h6c1.5 0 2.8-1.2 2.8-2.8v-3h-1.5v3zM4 11v1h16v-1H4z\"></path></svg>\";s:5:\"title\";s:12:\"Saut de page\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:17:\"core/post-content\";}}i:79;a:4:{s:4:\"name\";s:14:\"core/page-list\";s:4:\"icon\";s:398:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M7 13.8h6v-1.5H7v1.5zM18 16V4c0-1.1-.9-2-2-2H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h10c1.1 0 2-.9 2-2zM5.5 16V4c0-.3.2-.5.5-.5h10c.3 0 .5.2.5.5v12c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5zM7 10.5h8V9H7v1.5zm0-3.3h8V5.8H7v1.4zM20.2 6v13c0 .7-.6 1.2-1.2 1.2H8v1.5h11c1.5 0 2.7-1.2 2.7-2.8V6h-1.5z\"></path></svg>\";s:5:\"title\";s:15:\"Liste des pages\";s:8:\"category\";s:7:\"widgets\";}i:80;a:4:{s:4:\"name\";s:17:\"core/preformatted\";s:4:\"icon\";s:341:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18 4H6c-1.1 0-2 .9-2 2v12c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm.5 14c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5V6c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v12zM7 16.5h6V15H7v1.5zm4-4h6V11h-6v1.5zM9 11H7v1.5h2V11zm6 5.5h2V15h-2v1.5z\"></path></svg>\";s:5:\"title\";s:12:\"Préformaté\";s:8:\"category\";s:4:\"text\";}i:81;a:4:{s:4:\"name\";s:14:\"core/pullquote\";s:4:\"icon\";s:303:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18 8H6c-1.1 0-2 .9-2 2v4c0 1.1.9 2 2 2h12c1.1 0 2-.9 2-2v-4c0-1.1-.9-2-2-2zm.5 6c0 .3-.2.5-.5.5H6c-.3 0-.5-.2-.5-.5v-4c0-.3.2-.5.5-.5h12c.3 0 .5.2.5.5v4zM4 4v1.5h16V4H4zm0 16h16v-1.5H4V20z\"></path></svg>\";s:5:\"title\";s:19:\"Citation en exergue\";s:8:\"category\";s:4:\"text\";}i:82;a:4:{s:4:\"name\";s:8:\"core/rss\";s:4:\"icon\";s:360:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M5 10.2h-.8v1.5H5c1.9 0 3.8.8 5.1 2.1 1.4 1.4 2.1 3.2 2.1 5.1v.8h1.5V19c0-2.3-.9-4.5-2.6-6.2-1.6-1.6-3.8-2.6-6.1-2.6zm10.4-1.6C12.6 5.8 8.9 4.2 5 4.2h-.8v1.5H5c3.5 0 6.9 1.4 9.4 3.9s3.9 5.8 3.9 9.4v.8h1.5V19c0-3.9-1.6-7.6-4.4-10.4zM4 20h3v-3H4v3z\"></path></svg>\";s:5:\"title\";s:3:\"RSS\";s:8:\"category\";s:7:\"widgets\";}i:83;a:4:{s:4:\"name\";s:11:\"core/search\";s:4:\"icon\";s:295:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M13.5 6C10.5 6 8 8.5 8 11.5c0 1.1.3 2.1.9 3l-3.4 3 1 1.1 3.4-2.9c1 .9 2.2 1.4 3.6 1.4 3 0 5.5-2.5 5.5-5.5C19 8.5 16.5 6 13.5 6zm0 9.5c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4-1.8 4-4 4z\"></path></svg>\";s:5:\"title\";s:9:\"Recherche\";s:8:\"category\";s:7:\"widgets\";}i:84;a:4:{s:4:\"name\";s:14:\"core/separator\";s:4:\"icon\";s:159:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M20.2 7v4H3.8V7H2.2v9h1.6v-3.5h16.4V16h1.6V7z\"></path></svg>\";s:5:\"title\";s:11:\"Séparateur\";s:8:\"category\";s:6:\"design\";}i:85;a:4:{s:4:\"name\";s:10:\"core/block\";s:4:\"icon\";s:288:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 8h-1V6h-5v2h-2V6H6v2H5c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-8c0-1.1-.9-2-2-2zm.5 10c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5v-8c0-.3.2-.5.5-.5h14c.3 0 .5.2.5.5v8z\"></path></svg>\";s:5:\"title\";s:18:\"Bloc réutilisable\";s:8:\"category\";s:8:\"reusable\";}i:86;a:4:{s:4:\"name\";s:17:\"core/social-links\";s:4:\"icon\";s:361:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M9 11.8l6.1-4.5c.1.4.4.7.9.7h2c.6 0 1-.4 1-1V5c0-.6-.4-1-1-1h-2c-.6 0-1 .4-1 1v.4l-6.4 4.8c-.2-.1-.4-.2-.6-.2H6c-.6 0-1 .4-1 1v2c0 .6.4 1 1 1h2c.2 0 .4-.1.6-.2l6.4 4.8v.4c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2c0-.6-.4-1-1-1h-2c-.5 0-.8.3-.9.7L9 12.2v-.4z\"></path></svg>\";s:5:\"title\";s:27:\"Icônes de réseaux sociaux\";s:8:\"category\";s:7:\"widgets\";}i:87;a:5:{s:4:\"name\";s:16:\"core/social-link\";s:4:\"icon\";s:361:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M9 11.8l6.1-4.5c.1.4.4.7.9.7h2c.6 0 1-.4 1-1V5c0-.6-.4-1-1-1h-2c-.6 0-1 .4-1 1v.4l-6.4 4.8c-.2-.1-.4-.2-.6-.2H6c-.6 0-1 .4-1 1v2c0 .6.4 1 1 1h2c.2 0 .4-.1.6-.2l6.4 4.8v.4c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2c0-.6-.4-1-1-1h-2c-.5 0-.8.3-.9.7L9 12.2v-.4z\"></path></svg>\";s:5:\"title\";s:24:\"Icône de réseau social\";s:8:\"category\";s:7:\"widgets\";s:6:\"parent\";a:1:{i:0;s:17:\"core/social-links\";}}i:88;a:4:{s:4:\"name\";s:11:\"core/spacer\";s:4:\"icon\";s:185:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M12.5 4.2v1.6h4.7L5.8 17.2V12H4.2v7.8H12v-1.6H6.8L18.2 6.8v4.7h1.6V4.2z\"></path></svg>\";s:5:\"title\";s:10:\"Espacement\";s:8:\"category\";s:6:\"design\";}i:89;a:4:{s:4:\"name\";s:10:\"core/table\";s:4:\"icon\";s:354:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 3H5c-1.1 0-2 .9-2 2v14c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zM5 4.5h14c.3 0 .5.2.5.5v3.5h-15V5c0-.3.2-.5.5-.5zm8 5.5h6.5v3.5H13V10zm-1.5 3.5h-7V10h7v3.5zm-7 5.5v-4h7v4.5H5c-.3 0-.5-.2-.5-.5zm14.5.5h-6V15h6.5v4c0 .3-.2.5-.5.5z\"></path></svg>\";s:5:\"title\";s:7:\"Tableau\";s:8:\"category\";s:4:\"text\";}i:90;a:4:{s:4:\"name\";s:14:\"core/tag-cloud\";s:4:\"icon\";s:459:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M20.1 11.2l-6.7-6.7c-.1-.1-.3-.2-.5-.2H5c-.4-.1-.8.3-.8.7v7.8c0 .2.1.4.2.5l6.7 6.7c.2.2.5.4.7.5s.6.2.9.2c.3 0 .6-.1.9-.2.3-.1.5-.3.8-.5l5.6-5.6c.4-.4.7-1 .7-1.6.1-.6-.2-1.2-.6-1.6zM19 13.4L13.4 19c-.1.1-.2.1-.3.2-.2.1-.4.1-.6 0-.1 0-.2-.1-.3-.2l-6.5-6.5V5.8h6.8l6.5 6.5c.2.2.2.4.2.6 0 .1 0 .3-.2.5zM9 8c-.6 0-1 .4-1 1s.4 1 1 1 1-.4 1-1-.4-1-1-1z\"></path></svg>\";s:5:\"title\";s:21:\"Nuage d’étiquettes\";s:8:\"category\";s:7:\"widgets\";}i:91;a:4:{s:4:\"name\";s:17:\"core/text-columns\";s:4:\"icon\";s:58:\"<span class=\"dashicon dashicons dashicons-columns\"></span>\";s:5:\"title\";s:29:\"Colonnes de texte (obsolète)\";s:8:\"category\";s:6:\"design\";}i:92;a:4:{s:4:\"name\";s:10:\"core/verse\";s:4:\"icon\";s:551:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M17.8 2l-.9.3c-.1 0-3.6 1-5.2 2.1C10 5.5 9.3 6.5 8.9 7.1c-.6.9-1.7 4.7-1.7 6.3l-.9 2.3c-.2.4 0 .8.4 1 .1 0 .2.1.3.1.3 0 .6-.2.7-.5l.6-1.5c.3 0 .7-.1 1.2-.2.7-.1 1.4-.3 2.2-.5.8-.2 1.6-.5 2.4-.8.7-.3 1.4-.7 1.9-1.2s.8-1.2 1-1.9c.2-.7.3-1.6.4-2.4.1-.8.1-1.7.2-2.5 0-.8.1-1.5.2-2.1V2zm-1.9 5.6c-.1.8-.2 1.5-.3 2.1-.2.6-.4 1-.6 1.3-.3.3-.8.6-1.4.9-.7.3-1.4.5-2.2.8-.6.2-1.3.3-1.8.4L15 7.5c.3-.3.6-.7 1-1.1 0 .4 0 .8-.1 1.2zM6 20h8v-1.5H6V20z\"></path></svg>\";s:5:\"title\";s:7:\"Couplet\";s:8:\"category\";s:4:\"text\";}i:93;a:4:{s:4:\"name\";s:10:\"core/video\";s:4:\"icon\";s:314:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18.7 3H5.3C4 3 3 4 3 5.3v13.4C3 20 4 21 5.3 21h13.4c1.3 0 2.3-1 2.3-2.3V5.3C21 4 20 3 18.7 3zm.8 15.7c0 .4-.4.8-.8.8H5.3c-.4 0-.8-.4-.8-.8V5.3c0-.4.4-.8.8-.8h13.4c.4 0 .8.4.8.8v13.4zM10 15l5-3-5-3v6z\"></path></svg>\";s:5:\"title\";s:6:\"Vidéo\";s:8:\"category\";s:5:\"media\";}i:94;a:4:{s:4:\"name\";s:14:\"core/site-logo\";s:4:\"icon\";s:425:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M12 3c-5 0-9 4-9 9s4 9 9 9 9-4 9-9-4-9-9-9zm0 1.5c4.1 0 7.5 3.4 7.5 7.5v.1c-1.4-.8-3.3-1.7-3.4-1.8-.2-.1-.5-.1-.8.1l-2.9 2.1L9 11.3c-.2-.1-.4 0-.6.1l-3.7 2.2c-.1-.5-.2-1-.2-1.5 0-4.2 3.4-7.6 7.5-7.6zm0 15c-3.1 0-5.7-1.9-6.9-4.5l3.7-2.2 3.5 1.2c.2.1.5 0 .7-.1l2.9-2.1c.8.4 2.5 1.2 3.5 1.9-.9 3.3-3.9 5.8-7.4 5.8z\"></path></svg>\";s:5:\"title\";s:12:\"Logo du site\";s:8:\"category\";s:6:\"design\";}i:95;a:4:{s:4:\"name\";s:17:\"core/site-tagline\";s:4:\"icon\";s:189:\"<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" role=\"img\" aria-hidden=\"true\"><path fill=\"none\" d=\"M0 0h24v24H0z\"></path><path d=\"M4 9h16v2H4V9zm0 4h10v2H4v-2z\"></path></svg>\";s:5:\"title\";s:19:\"Description du site\";s:8:\"category\";s:6:\"design\";}i:96;a:4:{s:4:\"name\";s:15:\"core/site-title\";s:4:\"icon\";s:519:\"<svg xmlns=\"https://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M12 9c-.8 0-1.5.7-1.5 1.5S11.2 12 12 12s1.5-.7 1.5-1.5S12.8 9 12 9zm0-5c-3.6 0-6.5 2.8-6.5 6.2 0 .8.3 1.8.9 3.1.5 1.1 1.2 2.3 2 3.6.7 1 3 3.8 3.2 3.9l.4.5.4-.5c.2-.2 2.6-2.9 3.2-3.9.8-1.2 1.5-2.5 2-3.6.6-1.3.9-2.3.9-3.1C18.5 6.8 15.6 4 12 4zm4.3 8.7c-.5 1-1.1 2.2-1.9 3.4-.5.7-1.7 2.2-2.4 3-.7-.8-1.9-2.3-2.4-3-.8-1.2-1.4-2.3-1.9-3.3-.6-1.4-.7-2.2-.7-2.5 0-2.6 2.2-4.7 5-4.7s5 2.1 5 4.7c0 .2-.1 1-.7 2.4z\"></path></svg>\";s:5:\"title\";s:13:\"Titre du Site\";s:8:\"category\";s:6:\"design\";}i:97;a:4:{s:4:\"name\";s:10:\"core/query\";s:4:\"icon\";s:1016:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18.1823 11.6392C18.1823 13.0804 17.0139 14.2487 15.5727 14.2487C14.3579 14.2487 13.335 13.4179 13.0453 12.2922L13.0377 12.2625L13.0278 12.2335L12.3985 10.377L12.3942 10.3785C11.8571 8.64997 10.246 7.39405 8.33961 7.39405C5.99509 7.39405 4.09448 9.29465 4.09448 11.6392C4.09448 13.9837 5.99509 15.8843 8.33961 15.8843C8.88499 15.8843 9.40822 15.781 9.88943 15.5923L9.29212 14.0697C8.99812 14.185 8.67729 14.2487 8.33961 14.2487C6.89838 14.2487 5.73003 13.0804 5.73003 11.6392C5.73003 10.1979 6.89838 9.02959 8.33961 9.02959C9.55444 9.02959 10.5773 9.86046 10.867 10.9862L10.8772 10.9836L11.4695 12.7311C11.9515 14.546 13.6048 15.8843 15.5727 15.8843C17.9172 15.8843 19.8178 13.9837 19.8178 11.6392C19.8178 9.29465 17.9172 7.39404 15.5727 7.39404C15.0287 7.39404 14.5066 7.4968 14.0264 7.6847L14.6223 9.20781C14.9158 9.093 15.2358 9.02959 15.5727 9.02959C17.0139 9.02959 18.1823 10.1979 18.1823 11.6392Z\"></path></svg>\";s:5:\"title\";s:18:\"Boucle de requête\";s:8:\"category\";s:5:\"theme\";}i:98;a:5:{s:4:\"name\";s:18:\"core/post-template\";s:4:\"icon\";s:1016:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M18.1823 11.6392C18.1823 13.0804 17.0139 14.2487 15.5727 14.2487C14.3579 14.2487 13.335 13.4179 13.0453 12.2922L13.0377 12.2625L13.0278 12.2335L12.3985 10.377L12.3942 10.3785C11.8571 8.64997 10.246 7.39405 8.33961 7.39405C5.99509 7.39405 4.09448 9.29465 4.09448 11.6392C4.09448 13.9837 5.99509 15.8843 8.33961 15.8843C8.88499 15.8843 9.40822 15.781 9.88943 15.5923L9.29212 14.0697C8.99812 14.185 8.67729 14.2487 8.33961 14.2487C6.89838 14.2487 5.73003 13.0804 5.73003 11.6392C5.73003 10.1979 6.89838 9.02959 8.33961 9.02959C9.55444 9.02959 10.5773 9.86046 10.867 10.9862L10.8772 10.9836L11.4695 12.7311C11.9515 14.546 13.6048 15.8843 15.5727 15.8843C17.9172 15.8843 19.8178 13.9837 19.8178 11.6392C19.8178 9.29465 17.9172 7.39404 15.5727 7.39404C15.0287 7.39404 14.5066 7.4968 14.0264 7.6847L14.6223 9.20781C14.9158 9.093 15.2358 9.02959 15.5727 9.02959C17.0139 9.02959 18.1823 10.1979 18.1823 11.6392Z\"></path></svg>\";s:5:\"title\";s:22:\"Modèle de publication\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:10:\"core/query\";}}i:99;a:4:{s:4:\"name\";s:16:\"core/query-title\";s:4:\"icon\";s:288:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 8h-1V6h-5v2h-2V6H6v2H5c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-8c0-1.1-.9-2-2-2zm.5 10c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5v-8c0-.3.2-.5.5-.5h14c.3 0 .5.2.5.5v8z\"></path></svg>\";s:5:\"title\";s:20:\"Titre de la requête\";s:8:\"category\";s:6:\"design\";}i:100;a:5:{s:4:\"name\";s:21:\"core/query-pagination\";s:4:\"icon\";s:308:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><rect x=\"4\" y=\"10.5\" width=\"6\" height=\"3\" rx=\"1.5\" fill=\"#000\"></rect><rect x=\"12\" y=\"10.5\" width=\"3\" height=\"3\" rx=\"1.5\" fill=\"#000\"></rect><rect x=\"17\" y=\"10.5\" width=\"3\" height=\"3\" rx=\"1.5\" fill=\"#000\"></rect></svg>\";s:5:\"title\";s:25:\"Pagination de la requête\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:10:\"core/query\";}}i:101;a:5:{s:4:\"name\";s:26:\"core/query-pagination-next\";s:4:\"icon\";s:314:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><rect x=\"6\" y=\"10.5\" width=\"3\" height=\"3\" rx=\"1.5\" fill=\"#000\"></rect><rect x=\"11\" y=\"10.5\" width=\"3\" height=\"3\" rx=\"1.5\" fill=\"#000\"></rect><path d=\"M16.5 9.5L19 12l-2.5 2.5\" stroke=\"#1E1E1E\" strokewidth=\"1.5\"></path></svg>\";s:5:\"title\";s:31:\"Pagination suivante de requête\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:21:\"core/query-pagination\";}}i:102;a:5:{s:4:\"name\";s:29:\"core/query-pagination-numbers\";s:4:\"icon\";s:505:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><rect x=\"4\" y=\"10.5\" width=\"6\" height=\"3\" rx=\"1.5\" fill=\"#000\"></rect><path d=\"M13.5 14v-4l-1.5.5\" stroke=\"#1E1E1E\"></path><path d=\"M19.266 9.805c-.473-.611-1.22-.51-1.702-.367a3.854 3.854 0 00-.718.307l.13 1.082c.192-.17.47-.422.782-.515.34-.1.578.025.668.141.21.27-.034.835-.16 1.055-.49.85-.93 1.594-1.45 2.492H19.5v-1h-.914c.277-.574.814-1.443.914-2.106.052-.343.02-.762-.234-1.09z\" fill=\"#1E1E1E\"></path></svg>\";s:5:\"title\";s:34:\"Pagination numérotée de requête\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:21:\"core/query-pagination\";}}i:103;a:5:{s:4:\"name\";s:30:\"core/query-pagination-previous\";s:4:\"icon\";s:379:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><rect x=\"18\" y=\"13.5\" width=\"3\" height=\"3\" rx=\"1.5\" transform=\"rotate(-180 18 13.5)\" fill=\"#000\"></rect><rect x=\"13\" y=\"13.5\" width=\"3\" height=\"3\" rx=\"1.5\" transform=\"rotate(-180 13 13.5)\" fill=\"#000\"></rect><path d=\"M7.5 14.5L5 12l2.5-2.5\" stroke=\"#1E1E1E\" strokewidth=\"1.5\"></path></svg>\";s:5:\"title\";s:35:\"Pagination précédente de requête\";s:8:\"category\";s:6:\"design\";s:6:\"parent\";a:1:{i:0;s:21:\"core/query-pagination\";}}i:104;a:4:{s:4:\"name\";s:15:\"core/post-title\";s:4:\"icon\";s:372:\"<svg viewbox=\"0 0 24 24\" xmlns=\"http://www.w3.org/2000/svg\" role=\"img\" aria-hidden=\"true\"><path d=\"M4 14.5h16V16H4zM4 18.5h9V20H4zM4 4h3c2 0 3 .86 3 2.583 0 .891-.253 1.554-.76 1.988-.505.435-1.24.652-2.204.652H5.542V12H4V4zm2.855 4c.53 0 .924-.114 1.18-.343.266-.228.398-.579.398-1.051 0-.473-.132-.82-.397-1.04-.265-.229-.67-.343-1.217-.343H5.542V8h1.313z\"></path></svg>\";s:5:\"title\";s:23:\"Titre de la publication\";s:8:\"category\";s:5:\"theme\";}i:105;a:4:{s:4:\"name\";s:17:\"core/post-content\";s:4:\"icon\";s:192:\"<svg xmlns=\"https://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M4 20h16v-1.5H4V20zm0-4.8h16v-1.5H4v1.5zm0-6.4v1.5h16V8.8H4zM16 4H4v1.5h12V4z\"></path></svg>\";s:5:\"title\";s:25:\"Contenu de la publication\";s:8:\"category\";s:5:\"theme\";}i:106;a:4:{s:4:\"name\";s:14:\"core/post-date\";s:4:\"icon\";s:639:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M11.696 13.972c.356-.546.599-.958.728-1.235a1.79 1.79 0 00.203-.783c0-.264-.077-.47-.23-.618-.148-.153-.354-.23-.618-.23-.295 0-.569.07-.82.212a3.413 3.413 0 00-.738.571l-.147-1.188c.289-.234.59-.41.903-.526.313-.117.66-.175 1.041-.175.375 0 .695.08.959.24.264.153.46.362.59.626.135.265.203.556.203.876 0 .362-.08.734-.24 1.115-.154.381-.427.87-.82 1.466l-.756 1.152H14v1.106h-4l1.696-2.609z\"></path><path d=\"M19.5 7h-15v12a.5.5 0 00.5.5h14a.5.5 0 00.5-.5V7zM3 7V5a2 2 0 012-2h14a2 2 0 012 2v14a2 2 0 01-2 2H5a2 2 0 01-2-2V7z\"></path></svg>\";s:5:\"title\";s:19:\"Date de publication\";s:8:\"category\";s:5:\"theme\";}i:107;a:4:{s:4:\"name\";s:17:\"core/post-excerpt\";s:4:\"icon\";s:574:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M12.75 9.333c0 .521-.102.977-.327 1.354-.23.386-.555.628-.893.774-.545.234-1.183.227-1.544.222l-.12-.001v-1.5h.123c.414.001.715.002.948-.099a.395.395 0 00.199-.166c.05-.083.114-.253.114-.584V7.2H8.8V4h3.95v5.333zM7.95 9.333c0 .521-.102.977-.327 1.354-.23.386-.555.628-.893.774-.545.234-1.183.227-1.544.222l-.12-.001v-1.5h.123c.414.001.715.002.948-.099a.394.394 0 00.198-.166c.05-.083.115-.253.115-.584V7.2H4V4h3.95v5.333zM13 20H4v-1.5h9V20zM20 16H4v-1.5h16V16z\"></path></svg>\";s:5:\"title\";s:25:\"Extrait de la publication\";s:8:\"category\";s:5:\"theme\";}i:108;a:4:{s:4:\"name\";s:24:\"core/post-featured-image\";s:4:\"icon\";s:365:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 3H5c-.6 0-1 .4-1 1v7c0 .5.4 1 1 1h14c.5 0 1-.4 1-1V4c0-.6-.4-1-1-1zM5.5 10.5v-.4l1.8-1.3 1.3.8c.3.2.7.2.9-.1L11 8.1l2.4 2.4H5.5zm13 0h-2.9l-4-4c-.3-.3-.8-.3-1.1 0L8.9 8l-1.2-.8c-.3-.2-.6-.2-.9 0l-1.3 1V4.5h13v6zM4 20h9v-1.5H4V20zm0-4h16v-1.5H4V16z\"></path></svg>\";s:5:\"title\";s:37:\"Image mise en avant de la publication\";s:8:\"category\";s:5:\"theme\";}i:109;a:4:{s:4:\"name\";s:15:\"core/post-terms\";s:4:\"icon\";s:288:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M19 8h-1V6h-5v2h-2V6H6v2H5c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h14c1.1 0 2-.9 2-2v-8c0-1.1-.9-2-2-2zm.5 10c0 .3-.2.5-.5.5H5c-.3 0-.5-.2-.5-.5v-8c0-.3.2-.5.5-.5h14c.3 0 .5.2.5.5v8z\"></path></svg>\";s:5:\"title\";s:26:\"Étiquettes de publication\";s:8:\"category\";s:6:\"design\";}i:110;a:4:{s:4:\"name\";s:13:\"core/loginout\";s:4:\"icon\";s:348:\"<svg xmlns=\"http://www.w3.org/2000/svg\" viewbox=\"0 0 24 24\" role=\"img\" aria-hidden=\"true\"><path d=\"M11 14.5l1.1 1.1 3-3 .5-.5-.6-.6-3-3-1 1 1.7 1.7H5v1.5h7.7L11 14.5zM16.8 5h-7c-1.1 0-2 .9-2 2v1.5h1.5V7c0-.3.2-.5.5-.5h7c.3 0 .5.2.5.5v10c0 .3-.2.5-.5.5h-7c-.3 0-.5-.2-.5-.5v-1.5H7.8V17c0 1.1.9 2 2 2h7c1.1 0 2-.9 2-2V7c0-1.1-.9-2-2-2z\"></path></svg>\";s:5:\"title\";s:22:\"Connexion/déconnexion\";s:8:\"category\";s:5:\"theme\";}i:111;a:4:{s:4:\"name\";s:18:\"core/legacy-widget\";s:4:\"icon\";s:64:\"<span class=\"dashicon dashicons dashicons-block-default\"></span>\";s:5:\"title\";s:13:\"Legacy Widget\";s:8:\"category\";s:7:\"widgets\";}i:112;a:4:{s:4:\"name\";s:16:\"core/widget-area\";s:4:\"icon\";s:86:\"&lt;span class=&quot;dashicon dashicons dashicons-block-default&quot;&gt;&lt;/span&gt;\";s:5:\"title\";s:11:\"Widget Area\";s:8:\"category\";s:7:\"widgets\";}}", "yes");
INSERT INTO `wp_options` VALUES("2312", "advgb_blocks_user_roles", "a:1:{s:13:\"administrator\";a:1:{s:13:\"active_blocks\";N;}}", "yes");
INSERT INTO `wp_options` VALUES("2340", "_transient_dirsize_cache", "a:683:{s:51:\"/home/orthopa/www/wp-includes/css/dist/edit-widgets\";i:89899;s:52:\"/home/orthopa/www/wp-includes/css/dist/block-library\";i:640961;s:46:\"/home/orthopa/www/wp-includes/css/dist/widgets\";i:23866;s:51:\"/home/orthopa/www/wp-includes/css/dist/block-editor\";i:436575;s:53:\"/home/orthopa/www/wp-includes/css/dist/format-library\";i:11260;s:54:\"/home/orthopa/www/wp-includes/css/dist/reusable-blocks\";i:4288;s:48:\"/home/orthopa/www/wp-includes/css/dist/edit-post\";i:206821;s:59:\"/home/orthopa/www/wp-includes/css/dist/list-reusable-blocks\";i:16478;s:49:\"/home/orthopa/www/wp-includes/css/dist/components\";i:533182;s:56:\"/home/orthopa/www/wp-includes/css/dist/customize-widgets\";i:29568;s:42:\"/home/orthopa/www/wp-includes/css/dist/nux\";i:13786;s:54:\"/home/orthopa/www/wp-includes/css/dist/block-directory\";i:16954;s:45:\"/home/orthopa/www/wp-includes/css/dist/editor\";i:95261;s:38:\"/home/orthopa/www/wp-includes/css/dist\";i:2118899;s:33:\"/home/orthopa/www/wp-includes/css\";i:2765182;s:33:\"/home/orthopa/www/wp-includes/ID3\";i:1134191;s:43:\"/home/orthopa/www/wp-includes/random_compat\";i:40843;s:46:\"/home/orthopa/www/wp-includes/Text/Diff/Engine\";i:31662;s:48:\"/home/orthopa/www/wp-includes/Text/Diff/Renderer\";i:5535;s:39:\"/home/orthopa/www/wp-includes/Text/Diff\";i:44010;s:34:\"/home/orthopa/www/wp-includes/Text\";i:56925;s:36:\"/home/orthopa/www/wp-includes/assets\";i:10499;s:43:\"/home/orthopa/www/wp-includes/blocks/search\";i:13482;s:46:\"/home/orthopa/www/wp-includes/blocks/separator\";i:8212;s:44:\"/home/orthopa/www/wp-includes/blocks/missing\";i:509;s:42:\"/home/orthopa/www/wp-includes/blocks/query\";i:4288;s:42:\"/home/orthopa/www/wp-includes/blocks/video\";i:17816;s:46:\"/home/orthopa/www/wp-includes/blocks/shortcode\";i:7794;s:42:\"/home/orthopa/www/wp-includes/blocks/embed\";i:16808;s:49:\"/home/orthopa/www/wp-includes/blocks/preformatted\";i:3635;s:42:\"/home/orthopa/www/wp-includes/blocks/block\";i:4552;s:47:\"/home/orthopa/www/wp-includes/blocks/post-title\";i:3643;s:49:\"/home/orthopa/www/wp-includes/blocks/latest-posts\";i:16144;s:47:\"/home/orthopa/www/wp-includes/blocks/categories\";i:6592;s:46:\"/home/orthopa/www/wp-includes/blocks/post-date\";i:537;s:49:\"/home/orthopa/www/wp-includes/blocks/post-content\";i:3788;s:53:\"/home/orthopa/www/wp-includes/blocks/query-pagination\";i:11618;s:45:\"/home/orthopa/www/wp-includes/blocks/freeform\";i:41868;s:50:\"/home/orthopa/www/wp-includes/blocks/post-template\";i:16149;s:41:\"/home/orthopa/www/wp-includes/blocks/file\";i:11958;s:43:\"/home/orthopa/www/wp-includes/blocks/button\";i:22207;s:52:\"/home/orthopa/www/wp-includes/blocks/latest-comments\";i:7248;s:41:\"/home/orthopa/www/wp-includes/blocks/list\";i:3908;s:61:\"/home/orthopa/www/wp-includes/blocks/query-pagination-numbers\";i:3898;s:41:\"/home/orthopa/www/wp-includes/blocks/more\";i:6369;s:46:\"/home/orthopa/www/wp-includes/blocks/pullquote\";i:11756;s:62:\"/home/orthopa/www/wp-includes/blocks/query-pagination-previous\";i:526;s:43:\"/home/orthopa/www/wp-includes/blocks/column\";i:542;s:47:\"/home/orthopa/www/wp-includes/blocks/site-title\";i:3796;s:46:\"/home/orthopa/www/wp-includes/blocks/tag-cloud\";i:6848;s:46:\"/home/orthopa/www/wp-includes/blocks/site-logo\";i:13058;s:42:\"/home/orthopa/www/wp-includes/blocks/audio\";i:7013;s:42:\"/home/orthopa/www/wp-includes/blocks/cover\";i:56553;s:49:\"/home/orthopa/www/wp-includes/blocks/social-links\";i:57725;s:47:\"/home/orthopa/www/wp-includes/blocks/media-text\";i:18137;s:56:\"/home/orthopa/www/wp-includes/blocks/post-featured-image\";i:9333;s:41:\"/home/orthopa/www/wp-includes/blocks/code\";i:3363;s:48:\"/home/orthopa/www/wp-includes/blocks/social-link\";i:4460;s:44:\"/home/orthopa/www/wp-includes/blocks/gallery\";i:50134;s:42:\"/home/orthopa/www/wp-includes/blocks/verse\";i:3694;s:41:\"/home/orthopa/www/wp-includes/blocks/html\";i:5448;s:46:\"/home/orthopa/www/wp-includes/blocks/paragraph\";i:9325;s:40:\"/home/orthopa/www/wp-includes/blocks/rss\";i:11021;s:42:\"/home/orthopa/www/wp-includes/blocks/quote\";i:5041;s:48:\"/home/orthopa/www/wp-includes/blocks/query-title\";i:3485;s:42:\"/home/orthopa/www/wp-includes/blocks/table\";i:25114;s:50:\"/home/orthopa/www/wp-includes/blocks/legacy-widget\";i:501;s:49:\"/home/orthopa/www/wp-includes/blocks/text-columns\";i:8291;s:44:\"/home/orthopa/www/wp-includes/blocks/heading\";i:7680;s:42:\"/home/orthopa/www/wp-includes/blocks/image\";i:23825;s:58:\"/home/orthopa/www/wp-includes/blocks/query-pagination-next\";i:514;s:45:\"/home/orthopa/www/wp-includes/blocks/loginout\";i:455;s:45:\"/home/orthopa/www/wp-includes/blocks/calendar\";i:4767;s:43:\"/home/orthopa/www/wp-includes/blocks/spacer\";i:8824;s:45:\"/home/orthopa/www/wp-includes/blocks/nextpage\";i:5644;s:42:\"/home/orthopa/www/wp-includes/blocks/group\";i:7376;s:46:\"/home/orthopa/www/wp-includes/blocks/page-list\";i:12826;s:45:\"/home/orthopa/www/wp-includes/blocks/archives\";i:3230;s:49:\"/home/orthopa/www/wp-includes/blocks/post-excerpt\";i:6465;s:47:\"/home/orthopa/www/wp-includes/blocks/post-terms\";i:451;s:44:\"/home/orthopa/www/wp-includes/blocks/buttons\";i:18381;s:44:\"/home/orthopa/www/wp-includes/blocks/columns\";i:13242;s:49:\"/home/orthopa/www/wp-includes/blocks/site-tagline\";i:3650;s:36:\"/home/orthopa/www/wp-includes/blocks\";i:803053;s:45:\"/home/orthopa/www/wp-includes/SimplePie/Cache\";i:39593;s:45:\"/home/orthopa/www/wp-includes/SimplePie/Parse\";i:20551;s:44:\"/home/orthopa/www/wp-includes/SimplePie/HTTP\";i:11515;s:55:\"/home/orthopa/www/wp-includes/SimplePie/XML/Declaration\";i:7098;s:43:\"/home/orthopa/www/wp-includes/SimplePie/XML\";i:7098;s:52:\"/home/orthopa/www/wp-includes/SimplePie/Content/Type\";i:8015;s:47:\"/home/orthopa/www/wp-includes/SimplePie/Content\";i:8015;s:51:\"/home/orthopa/www/wp-includes/SimplePie/Decode/HTML\";i:17241;s:46:\"/home/orthopa/www/wp-includes/SimplePie/Decode\";i:17241;s:43:\"/home/orthopa/www/wp-includes/SimplePie/Net\";i:7493;s:39:\"/home/orthopa/www/wp-includes/SimplePie\";i:455756;s:35:\"/home/orthopa/www/wp-includes/fonts\";i:289826;s:42:\"/home/orthopa/www/wp-includes/certificates\";i:234459;s:39:\"/home/orthopa/www/wp-includes/customize\";i:170868;s:47:\"/home/orthopa/www/wp-includes/sodium_compat/lib\";i:84845;s:68:\"/home/orthopa/www/wp-includes/sodium_compat/namespaced/Core/ChaCha20\";i:224;s:73:\"/home/orthopa/www/wp-includes/sodium_compat/namespaced/Core/Curve25519/Ge\";i:602;s:70:\"/home/orthopa/www/wp-includes/sodium_compat/namespaced/Core/Curve25519\";i:820;s:68:\"/home/orthopa/www/wp-includes/sodium_compat/namespaced/Core/Poly1305\";i:112;s:59:\"/home/orthopa/www/wp-includes/sodium_compat/namespaced/Core\";i:2444;s:54:\"/home/orthopa/www/wp-includes/sodium_compat/namespaced\";i:2698;s:53:\"/home/orthopa/www/wp-includes/sodium_compat/src/PHP52\";i:4116;s:63:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core32/Poly1305\";i:15980;s:67:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core32/SecretStream\";i:3656;s:68:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core32/Curve25519/Ge\";i:8177;s:65:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core32/Curve25519\";i:122399;s:63:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core32/ChaCha20\";i:6295;s:54:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core32\";i:437583;s:61:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core/Poly1305\";i:12912;s:66:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core/Curve25519/Ge\";i:7881;s:63:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core/Curve25519\";i:121533;s:59:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core/Base64\";i:22135;s:65:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core/SecretStream\";i:3624;s:61:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core/ChaCha20\";i:5152;s:52:\"/home/orthopa/www/wp-includes/sodium_compat/src/Core\";i:459958;s:47:\"/home/orthopa/www/wp-includes/sodium_compat/src\";i:1212803;s:43:\"/home/orthopa/www/wp-includes/sodium_compat\";i:1306435;s:48:\"/home/orthopa/www/wp-includes/sitemaps/providers\";i:15133;s:38:\"/home/orthopa/www/wp-includes/sitemaps\";i:45055;s:34:\"/home/orthopa/www/wp-includes/pomo\";i:52248;s:44:\"/home/orthopa/www/wp-includes/block-patterns\";i:9046;s:33:\"/home/orthopa/www/wp-includes/IXR\";i:33914;s:40:\"/home/orthopa/www/wp-includes/images/wlw\";i:4413;s:44:\"/home/orthopa/www/wp-includes/images/crystal\";i:15541;s:44:\"/home/orthopa/www/wp-includes/images/smilies\";i:10082;s:42:\"/home/orthopa/www/wp-includes/images/media\";i:2419;s:36:\"/home/orthopa/www/wp-includes/images\";i:103747;s:39:\"/home/orthopa/www/wp-includes/PHPMailer\";i:221082;s:45:\"/home/orthopa/www/wp-includes/rest-api/search\";i:15180;s:45:\"/home/orthopa/www/wp-includes/rest-api/fields\";i:22314;s:48:\"/home/orthopa/www/wp-includes/rest-api/endpoints\";i:583613;s:38:\"/home/orthopa/www/wp-includes/rest-api\";i:705110;s:45:\"/home/orthopa/www/wp-includes/Requests/Cookie\";i:3865;s:47:\"/home/orthopa/www/wp-includes/Requests/Response\";i:2135;s:53:\"/home/orthopa/www/wp-includes/Requests/Exception/HTTP\";i:14365;s:58:\"/home/orthopa/www/wp-includes/Requests/Exception/Transport\";i:919;s:48:\"/home/orthopa/www/wp-includes/Requests/Exception\";i:16778;s:43:\"/home/orthopa/www/wp-includes/Requests/Auth\";i:1939;s:46:\"/home/orthopa/www/wp-includes/Requests/Utility\";i:3310;s:48:\"/home/orthopa/www/wp-includes/Requests/Transport\";i:30090;s:44:\"/home/orthopa/www/wp-includes/Requests/Proxy\";i:3488;s:38:\"/home/orthopa/www/wp-includes/Requests\";i:139225;s:42:\"/home/orthopa/www/wp-includes/theme-compat\";i:15414;s:37:\"/home/orthopa/www/wp-includes/widgets\";i:155462;s:41:\"/home/orthopa/www/wp-includes/js/thickbox\";i:31185;s:44:\"/home/orthopa/www/wp-includes/js/dist/vendor\";i:2310530;s:37:\"/home/orthopa/www/wp-includes/js/dist\";i:12738262;s:55:\"/home/orthopa/www/wp-includes/js/mediaelement/renderers\";i:18880;s:45:\"/home/orthopa/www/wp-includes/js/mediaelement\";i:719405;s:37:\"/home/orthopa/www/wp-includes/js/crop\";i:20004;s:42:\"/home/orthopa/www/wp-includes/js/swfupload\";i:8715;s:43:\"/home/orthopa/www/wp-includes/js/codemirror\";i:1287141;s:38:\"/home/orthopa/www/wp-includes/js/jcrop\";i:18340;s:42:\"/home/orthopa/www/wp-includes/js/jquery/ui\";i:793444;s:39:\"/home/orthopa/www/wp-includes/js/jquery\";i:1309881;s:60:\"/home/orthopa/www/wp-includes/js/tinymce/skins/lightgray/img\";i:2856;s:62:\"/home/orthopa/www/wp-includes/js/tinymce/skins/lightgray/fonts\";i:155760;s:56:\"/home/orthopa/www/wp-includes/js/tinymce/skins/lightgray\";i:210254;s:63:\"/home/orthopa/www/wp-includes/js/tinymce/skins/wordpress/images\";i:14207;s:56:\"/home/orthopa/www/wp-includes/js/tinymce/skins/wordpress\";i:22831;s:46:\"/home/orthopa/www/wp-includes/js/tinymce/skins\";i:233085;s:46:\"/home/orthopa/www/wp-includes/js/tinymce/utils\";i:18822;s:53:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/link\";i:32949;s:55:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wplink\";i:26476;s:63:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/directionality\";i:2749;s:60:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wpeditimage\";i:37716;s:57:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/tabfocus\";i:5336;s:54:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/media\";i:57914;s:56:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/charmap\";i:31811;s:56:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wpemoji\";i:5099;s:61:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/compat3x/css\";i:8179;s:57:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/compat3x\";i:21758;s:55:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wpview\";i:8994;s:62:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wptextpattern\";i:11927;s:51:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/hr\";i:1347;s:58:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wordpress\";i:50608;s:54:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/lists\";i:97383;s:58:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/textcolor\";i:16237;s:54:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/paste\";i:113193;s:58:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wpdialogs\";i:3761;s:58:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wpgallery\";i:4808;s:61:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/wpautoresize\";i:8332;s:59:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/fullscreen\";i:7779;s:60:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/colorpicker\";i:4910;s:54:\"/home/orthopa/www/wp-includes/js/tinymce/plugins/image\";i:55874;s:48:\"/home/orthopa/www/wp-includes/js/tinymce/plugins\";i:606961;s:54:\"/home/orthopa/www/wp-includes/js/tinymce/themes/modern\";i:446221;s:54:\"/home/orthopa/www/wp-includes/js/tinymce/themes/inlite\";i:452642;s:47:\"/home/orthopa/www/wp-includes/js/tinymce/themes\";i:898863;s:46:\"/home/orthopa/www/wp-includes/js/tinymce/langs\";i:15529;s:40:\"/home/orthopa/www/wp-includes/js/tinymce\";i:2853651;s:41:\"/home/orthopa/www/wp-includes/js/plupload\";i:490247;s:46:\"/home/orthopa/www/wp-includes/js/imgareaselect\";i:49035;s:32:\"/home/orthopa/www/wp-includes/js\";i:21947559;s:44:\"/home/orthopa/www/wp-includes/block-supports\";i:45726;s:29:\"/home/orthopa/www/wp-includes\";i:37063598;s:36:\"/home/orthopa/www/wp-content/upgrade\";i:0;s:42:\"/home/orthopa/www/wp-content/ai1wm-backups\";i:129408513;s:46:\"/home/orthopa/www/wp-content/languages/plugins\";i:718531;s:45:\"/home/orthopa/www/wp-content/languages/themes\";i:130765;s:38:\"/home/orthopa/www/wp-content/languages\";i:3519711;s:28:\"/home/orthopa/www/wp-content\";i:132928252;s:32:\"/home/orthopa/www/wp-admin/maint\";i:7260;s:33:\"/home/orthopa/www/wp-admin/images\";i:389513;s:35:\"/home/orthopa/www/wp-admin/includes\";i:2861430;s:37:\"/home/orthopa/www/wp-admin/js/widgets\";i:139408;s:29:\"/home/orthopa/www/wp-admin/js\";i:1897212;s:34:\"/home/orthopa/www/wp-admin/network\";i:123822;s:44:\"/home/orthopa/www/wp-admin/css/colors/coffee\";i:74748;s:47:\"/home/orthopa/www/wp-admin/css/colors/ectoplasm\";i:77279;s:44:\"/home/orthopa/www/wp-admin/css/colors/modern\";i:77352;s:43:\"/home/orthopa/www/wp-admin/css/colors/ocean\";i:74770;s:43:\"/home/orthopa/www/wp-admin/css/colors/light\";i:77861;s:45:\"/home/orthopa/www/wp-admin/css/colors/sunrise\";i:77298;s:42:\"/home/orthopa/www/wp-admin/css/colors/blue\";i:77273;s:46:\"/home/orthopa/www/wp-admin/css/colors/midnight\";i:77238;s:37:\"/home/orthopa/www/wp-admin/css/colors\";i:636927;s:30:\"/home/orthopa/www/wp-admin/css\";i:2463608;s:31:\"/home/orthopa/www/wp-admin/user\";i:3418;s:26:\"/home/orthopa/www/wp-admin\";i:8605097;s:17:\"/home/orthopa/www\";i:178770554;s:64:\"/home/orthopa/www/wp-content/themes/virtue/templates/mobile_home\";i:3040;s:57:\"/home/orthopa/www/wp-content/themes/virtue/templates/home\";i:29830;s:52:\"/home/orthopa/www/wp-content/themes/virtue/templates\";i:99556;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/themecheck/js\";i:405;s:74:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/themecheck/css\";i:139;s:77:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/themecheck/checks\";i:5039;s:75:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/themecheck/lang\";i:945;s:70:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/themecheck\";i:14266;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/sorter\";i:20768;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/select\";i:21831;s:74:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/section\";i:6321;s:72:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/color\";i:14867;s:77:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/multi_text\";i:8934;s:74:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/palette\";i:8682;s:77:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/background\";i:46191;s:70:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/raw\";i:39829;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/switch\";i:12922;s:75:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/textarea\";i:3303;s:79:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/image_select\";i:21264;s:91:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/slider/vendor/nouislider\";i:51074;s:80:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/slider/vendor\";i:51074;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/slider\";i:84355;s:71:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/text\";i:5958;s:71:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/info\";i:12120;s:72:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/media\";i:13516;s:77:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields/typography\";i:292492;s:66:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/fields\";i:613353;s:76:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/color\";i:5712;s:78:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/no_html\";i:1364;s:82:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/str_replace\";i:1070;s:84:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/comma_numeric\";i:1491;s:74:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/url\";i:1431;s:75:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/date\";i:1857;s:86:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/email_not_empty\";i:1422;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/js\";i:980;s:88:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/numeric_not_empty\";i:1311;s:78:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/numeric\";i:1360;s:74:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/css\";i:1421;s:75:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/html\";i:990;s:80:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/not_empty\";i:1384;s:76:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/email\";i:1350;s:87:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/no_special_chars\";i:1423;s:81:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/color_rgba\";i:2353;s:83:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/preg_replace\";i:1092;s:82:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/html_custom\";i:1109;s:80:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation/colorrgba\";i:2627;s:70:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/validation\";i:31747;s:85:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions/customizer/inc\";i:18128;s:81:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions/customizer\";i:106204;s:100:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions/options_object/options_object\";i:8538;s:85:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions/options_object\";i:12318;s:98:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions/import_export/import_export\";i:21960;s:84:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions/import_export\";i:30279;s:70:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc/extensions\";i:148865;s:59:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/inc\";i:925867;s:71:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/templates/panel\";i:13575;s:65:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/templates\";i:13575;s:67:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/css\";i:67082;s:67:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/img\";i:43921;s:100:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/kad_slides/kad_slides/min\";i:2974;s:96:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/kad_slides/kad_slides\";i:31232;s:85:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/kad_slides\";i:33725;s:94:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/kad_icons/kad_icons\";i:61343;s:84:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/kad_icons\";i:63832;s:104:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/vendor_support/vendor/select2\";i:287416;s:96:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/vendor_support/vendor\";i:287416;s:89:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions/vendor_support\";i:290566;s:74:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options/extensions\";i:388123;s:63:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/options\";i:500706;s:66:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/img\";i:24544;s:80:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/import_export\";i:165;s:78:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/qtip\";i:21431;s:82:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/spectrum\";i:26512;s:93:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/elusive-icons/fonts\";i:337172;s:92:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/elusive-icons/scss\";i:68413;s:87:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/elusive-icons\";i:426762;s:100:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/jquery-ui-bootstrap/images\";i:36055;s:93:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor/jquery-ui-bootstrap\";i:196590;s:73:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/vendor\";i:671295;s:79:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/color-picker\";i:3607;s:72:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css/media\";i:2198;s:66:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/css\";i:955965;s:71:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/js/media\";i:10897;s:81:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/js/vendor/spectrum\";i:95861;s:77:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/js/vendor/qtip\";i:186798;s:72:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/js/vendor\";i:346514;s:65:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets/js\";i:481217;s:62:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/assets\";i:1461726;s:65:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/languages\";i:510046;s:60:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions/core\";i:37709;s:55:\"/home/orthopa/www/wp-content/themes/virtue/themeoptions\";i:3728423;s:55:\"/home/orthopa/www/wp-content/themes/virtue/lib/icons/js\";i:70445;s:56:\"/home/orthopa/www/wp-content/themes/virtue/lib/icons/css\";i:42912;s:56:\"/home/orthopa/www/wp-content/themes/virtue/lib/icons/img\";i:2245;s:52:\"/home/orthopa/www/wp-content/themes/virtue/lib/icons\";i:116624;s:58:\"/home/orthopa/www/wp-content/themes/virtue/lib/woocommerce\";i:21149;s:54:\"/home/orthopa/www/wp-content/themes/virtue/lib/classes\";i:13903;s:61:\"/home/orthopa/www/wp-content/themes/virtue/lib/template_hooks\";i:6978;s:56:\"/home/orthopa/www/wp-content/themes/virtue/lib/elementor\";i:3050;s:46:\"/home/orthopa/www/wp-content/themes/virtue/lib\";i:2080254;s:81:\"/home/orthopa/www/wp-content/themes/virtue/woocommerce/single-product/add-to-cart\";i:12142;s:69:\"/home/orthopa/www/wp-content/themes/virtue/woocommerce/single-product\";i:19824;s:59:\"/home/orthopa/www/wp-content/themes/virtue/woocommerce/loop\";i:2385;s:54:\"/home/orthopa/www/wp-content/themes/virtue/woocommerce\";i:32962;s:65:\"/home/orthopa/www/wp-content/themes/virtue/assets/css/virtue_less\";i:314815;s:67:\"/home/orthopa/www/wp-content/themes/virtue/assets/css/kad_framework\";i:120156;s:59:\"/home/orthopa/www/wp-content/themes/virtue/assets/css/fonts\";i:1203279;s:59:\"/home/orthopa/www/wp-content/themes/virtue/assets/css/skins\";i:12437;s:53:\"/home/orthopa/www/wp-content/themes/virtue/assets/css\";i:2282084;s:59:\"/home/orthopa/www/wp-content/themes/virtue/assets/img/icons\";i:31668;s:66:\"/home/orthopa/www/wp-content/themes/virtue/assets/img/credit-cards\";i:68911;s:58:\"/home/orthopa/www/wp-content/themes/virtue/assets/img/skin\";i:55082;s:53:\"/home/orthopa/www/wp-content/themes/virtue/assets/img\";i:890631;s:56:\"/home/orthopa/www/wp-content/themes/virtue/assets/js/min\";i:178914;s:59:\"/home/orthopa/www/wp-content/themes/virtue/assets/js/vendor\";i:60175;s:52:\"/home/orthopa/www/wp-content/themes/virtue/assets/js\";i:608859;s:49:\"/home/orthopa/www/wp-content/themes/virtue/assets\";i:3781574;s:52:\"/home/orthopa/www/wp-content/themes/virtue/languages\";i:2633313;s:42:\"/home/orthopa/www/wp-content/themes/virtue\";i:12830023;s:73:\"/home/orthopa/www/wp-content/themes/twentyseventeen/template-parts/header\";i:1627;s:73:\"/home/orthopa/www/wp-content/themes/twentyseventeen/template-parts/footer\";i:1343;s:71:\"/home/orthopa/www/wp-content/themes/twentyseventeen/template-parts/post\";i:14277;s:77:\"/home/orthopa/www/wp-content/themes/twentyseventeen/template-parts/navigation\";i:1039;s:71:\"/home/orthopa/www/wp-content/themes/twentyseventeen/template-parts/page\";i:4622;s:66:\"/home/orthopa/www/wp-content/themes/twentyseventeen/template-parts\";i:22908;s:55:\"/home/orthopa/www/wp-content/themes/twentyseventeen/inc\";i:64930;s:61:\"/home/orthopa/www/wp-content/themes/twentyseventeen/assets/js\";i:34061;s:65:\"/home/orthopa/www/wp-content/themes/twentyseventeen/assets/images\";i:1264875;s:62:\"/home/orthopa/www/wp-content/themes/twentyseventeen/assets/css\";i:63897;s:58:\"/home/orthopa/www/wp-content/themes/twentyseventeen/assets\";i:1362833;s:51:\"/home/orthopa/www/wp-content/themes/twentyseventeen\";i:1952773;s:35:\"/home/orthopa/www/wp-content/themes\";i:14782824;s:62:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/review\";i:14277;s:65:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/languages\";i:1470375;s:88:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/recent-posts/icons\";i:7833;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/recent-posts\";i:50336;s:77:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/infobox\";i:0;s:78:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advimage\";i:1441;s:87:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/count-up/frontend\";i:0;s:78:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/count-up\";i:0;s:77:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advtabs\";i:2466;s:81:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/testimonial\";i:12209;s:83:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/images-slider\";i:612;s:80:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/login-form\";i:4860;s:77:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/summary\";i:238;s:77:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advicon\";i:0;s:73:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/map\";i:2123;s:80:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/newsletter\";i:3304;s:79:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/accordion\";i:0;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/woo-products\";i:1922;s:78:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advtable\";i:0;s:84:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/editor-sidebar\";i:0;s:80:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/search-bar\";i:0;s:79:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advbutton\";i:0;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/contact-form\";i:2461;s:86:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/0-adv-components\";i:0;s:77:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advlist\";i:0;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/customstyles\";i:2614;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/social-links\";i:0;s:79:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/container\";i:0;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advaccordion\";i:0;s:74:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/tabs\";i:0;s:83:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/columns/icons\";i:3818;s:77:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/columns\";i:3818;s:78:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks/advvideo\";i:1071;s:69:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/blocks\";i:1951827;s:72:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/css/fonts\";i:747252;s:66:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/css\";i:1079315;s:69:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/images\";i:531105;s:80:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js/codemirror/lib\";i:356466;s:87:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js/codemirror/addon/hint\";i:18904;s:82:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js/codemirror/addon\";i:18904;s:85:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js/codemirror/mode/css\";i:31656;s:81:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js/codemirror/mode\";i:31656;s:76:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js/codemirror\";i:407026;s:65:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets/js\";i:779382;s:62:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/assets\";i:4341629;s:65:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/incl/view\";i:70690;s:60:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg/incl\";i:354270;s:55:\"/home/orthopa/www/wp-content/plugins/advanced-gutenberg\";i:6249348;s:63:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/plugin\";i:1032076;s:70:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/assets/js/src\";i:163141;s:66:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/assets/js\";i:243249;s:70:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/assets/images\";i:178857;s:71:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/assets/css/src\";i:13150;s:67:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/assets/css\";i:22888;s:63:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/assets\";i:444994;s:63:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/blocks\";i:156677;s:70:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/build/vendors\";i:953106;s:62:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/build\";i:3321607;s:69:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/settings/img\";i:279360;s:65:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/settings\";i:368148;s:66:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/templates\";i:22096;s:63:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist/vendor\";i:55478;s:56:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/dist\";i:7675664;s:61:\"/home/orthopa/www/wp-content/plugins/kadence-blocks/languages\";i:104606;s:51:\"/home/orthopa/www/wp-content/plugins/kadence-blocks\";i:7833072;s:70:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/surfaces/values\";i:10615;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/surfaces\";i:28185;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/exceptions/oauth\";i:736;s:84:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/exceptions/addon-installation\";i:1638;s:80:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/exceptions/semrush/tokens\";i:1342;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/exceptions/semrush\";i:1342;s:75:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/exceptions/indexable\";i:1966;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/exceptions\";i:6379;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/context\";i:15963;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/generated/assets\";i:15799;s:64:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/generated\";i:343148;s:78:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/schema-templates/assets\";i:11060;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/schema-templates\";i:20226;s:84:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/generators/schema/third-party\";i:6653;s:72:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/generators/schema\";i:48422;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/generators\";i:85734;s:69:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/inc\";i:2370;s:86:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/presenters/admin\";i:5973;s:91:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/presenters/open-graph\";i:753;s:80:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/presenters\";i:6726;s:94:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/integrations/third-party\";i:1509;s:88:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/integrations/admin\";i:9656;s:82:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/integrations\";i:11165;s:82:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/conditionals\";i:1180;s:88:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/actions/indexation\";i:3536;s:86:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/actions/indexing\";i:298;s:77:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src/actions\";i:3834;s:69:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/src\";i:22905;s:81:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/frontend/schema\";i:30661;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/frontend\";i:57740;s:81:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/notifiers\";i:844;s:80:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/taxonomy\";i:1512;s:83:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/recalculate\";i:3897;s:78:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/onpage\";i:2756;s:76:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/ajax\";i:1862;s:81:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/endpoints\";i:1313;s:77:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin/links\";i:1810;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated/admin\";i:33401;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/deprecated\";i:116454;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/repositories\";i:23909;s:64:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/memoizers\";i:7216;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/routes\";i:32603;s:64:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/wordpress\";i:1307;s:70:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/helpers/twitter\";i:1152;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/helpers/open-graph\";i:5565;s:69:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/helpers/schema\";i:12989;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/helpers\";i:119481;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/commands\";i:9350;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/models\";i:8943;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/wrappers\";i:3025;s:75:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters/webmaster\";i:2983;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters/debug\";i:2443;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters/twitter\";i:5959;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters/slack\";i:2032;s:76:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters/open-graph\";i:12658;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters/admin\";i:31659;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presenters\";i:82596;s:72:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/config/migrations\";i:33075;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/config\";i:53644;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/builders\";i:75642;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/loggers\";i:1094;s:70:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/actions/semrush\";i:4582;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/actions/indexing\";i:37860;s:81:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/actions/addon-installation\";i:6340;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/actions/indexables\";i:3723;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/actions\";i:57998;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/initializers\";i:7421;s:77:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/front-end\";i:38578;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/alerts\";i:933;s:76:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/watchers\";i:78037;s:92:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/admin/addon-installation\";i:9292;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/admin\";i:73614;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/blocks\";i:8304;s:79:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations/third-party\";i:52131;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/integrations\";i:291469;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/services/indexables\";i:2336;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/services\";i:2336;s:68:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/presentations\";i:53296;s:72:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/values/open-graph\";i:1157;s:69:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/values/semrush\";i:2902;s:72:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/values/indexables\";i:1597;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/values\";i:8488;s:79:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/conditionals/third-party\";i:2990;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/conditionals/admin\";i:4625;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src/conditionals\";i:23276;s:54:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/src\";i:1487105;s:60:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/languages\";i:2991086;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/inc/exceptions\";i:402;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/inc/options\";i:131915;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/inc/sitemaps\";i:97374;s:54:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/inc\";i:533596;s:68:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/js/dist/languages\";i:2361766;s:68:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/js/dist/externals\";i:1641748;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/js/dist/select2/i18n\";i:55917;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/js/dist/select2\";i:135089;s:58:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/js/dist\";i:5402484;s:53:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/js\";i:5402484;s:57:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/images\";i:296595;s:69:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/packages/js/images\";i:13044;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/packages/js\";i:13044;s:59:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/packages\";i:13044;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor/composer\";i:270526;s:79:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor/yoast/i18n-module/src\";i:13505;s:75:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor/yoast/i18n-module\";i:14948;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor/yoast\";i:14948;s:57:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor\";i:285652;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/lib/migrations\";i:42035;s:75:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/lib/dependency-injection\";i:2133;s:54:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/lib\";i:138812;s:104:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/symfony/dependency-injection/Argument\";i:907;s:105:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/symfony/dependency-injection/Exception\";i:7089;s:108:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/symfony/dependency-injection/ParameterBag\";i:18515;s:95:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/symfony/dependency-injection\";i:50999;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/symfony\";i:50999;s:84:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/container/src\";i:1680;s:80:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/container\";i:1680;s:87:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/http-message/src\";i:46661;s:83:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/http-message\";i:46661;s:82:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/log/Psr/Log\";i:11844;s:78:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/log/Psr\";i:11844;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr/log\";i:11844;s:70:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/psr\";i:60185;s:86:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/psr7/src\";i:143415;s:82:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/psr7\";i:143415;s:95:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/guzzle/src/Cookie\";i:27297;s:96:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/guzzle/src/Handler\";i:57020;s:98:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/guzzle/src/Exception\";i:9318;s:88:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/guzzle/src\";i:188187;s:84:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/guzzle\";i:188187;s:90:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/promises/src\";i:44572;s:86:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp/promises\";i:44572;s:77:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/guzzlehttp\";i:376174;s:110:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/Provider/Exception\";i:1225;s:100:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/Provider\";i:33740;s:106:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/OptionProvider\";i:3990;s:97:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/Token\";i:7954;s:107:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/Grant/Exception\";i:804;s:97:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/Grant\";i:10346;s:96:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src/Tool\";i:15112;s:91:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client/src\";i:71142;s:87:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league/oauth2-client\";i:71142;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed/league\";i:71142;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/vendor_prefixed\";i:558500;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/ryte\";i:11416;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/roles\";i:8038;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/statistics\";i:7966;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/ajax\";i:5803;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/endpoints\";i:3824;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/pages\";i:6707;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/tracking\";i:16818;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/listeners\";i:304;s:61:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/menu\";i:26352;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/watchers\";i:6817;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/exceptions\";i:1090;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/form\";i:1101;s:77:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/dashboard\";i:10292;s:74:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/social\";i:8355;s:84:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/metas/taxonomies\";i:820;s:82:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/metas/archives\";i:1702;s:97:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/metas/paper-content/post_type\";i:4470;s:95:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/metas/paper-content/general\";i:5380;s:87:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/metas/paper-content\";i:32548;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/metas\";i:47414;s:72:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/tool\";i:6910;s:75:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs/network\";i:7332;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views/tabs\";i:80303;s:62:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/views\";i:161279;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/taxonomy\";i:36019;s:64:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/metabox\";i:59343;s:69:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/capabilities\";i:14794;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/notifiers\";i:8270;s:73:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/config-ui/fields\";i:34317;s:77:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/config-ui/components\";i:6345;s:76:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/config-ui/factories\";i:2151;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/config-ui\";i:72560;s:64:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/filters\";i:8521;s:65:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/services\";i:2475;s:71:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/import/plugins\";i:59041;s:63:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/import\";i:66729;s:66:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/formatter\";i:26125;s:84:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/google_search_console/views\";i:3365;s:78:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin/google_search_console\";i:3800;s:56:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/admin\";i:919475;s:67:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/css/dist/select2\";i:29944;s:59:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/css/dist\";i:440365;s:54:\"/home/orthopa/www/wp-content/plugins/wordpress-seo/css\";i:444632;s:50:\"/home/orthopa/www/wp-content/plugins/wordpress-seo\";i:13144160;s:66:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/welcome/images\";i:225586;s:59:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/welcome\";i:242164;s:58:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/assets\";i:182594;s:58:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/images\";i:1093;s:59:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/widgets\";i:19670;s:72:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/icons/img\";i:1822;s:68:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/icons\";i:17658;s:74:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/youtube/img\";i:1906;s:70:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/youtube\";i:6618;s:74:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/columns/img\";i:1728;s:70:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/columns\";i:14438;s:72:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/vimeo/img\";i:1598;s:68:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/vimeo\";i:6258;s:71:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/btns/img\";i:1673;s:67:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/btns\";i:15448;s:76:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/pullquote/img\";i:1688;s:72:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/pullquote\";i:6072;s:76:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/accordion/img\";i:1521;s:72:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/accordion\";i:5673;s:74:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/divider/img\";i:1245;s:70:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes/divider\";i:5415;s:62:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/shortcodes\";i:77580;s:73:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/includes/rest-api\";i:55590;s:70:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/includes/types\";i:56635;s:69:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/includes/shim\";i:15838;s:64:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/includes\";i:391460;s:58:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/js\";i:143114;s:65:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/languages\";i:1792844;s:73:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/css/sass/partials\";i:25693;s:64:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/css/sass\";i:26403;s:59:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/css\";i:362258;s:62:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb/images\";i:24597;s:55:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/cmb\";i:2720699;s:61:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit/languages\";i:750689;s:51:\"/home/orthopa/www/wp-content/plugins/virtue-toolkit\";i:4200815;s:68:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/storage\";i:52;s:75:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/controller\";i:79488;s:76:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/import\";i:54979;s:76:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/common\";i:12990;s:76:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/export\";i:51151;s:77:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/updater\";i:9474;s:74:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/main\";i:34493;s:80:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/assets/img\";i:11568;s:80:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/assets/css\";i:143679;s:87:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/assets/javascript\";i:151166;s:81:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/assets/font\";i:37850;s:76:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/assets\";i:344263;s:77:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view/backups\";i:12184;s:69:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/view\";i:519534;s:77:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/model/export\";i:85674;s:77:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/model/import\";i:114446;s:70:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/model\";i:249940;s:89:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/iterator\";i:4791;s:91:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/filesystem\";i:13839;s:88:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/command\";i:1522;s:87:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/filter\";i:5729;s:89:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/database\";i:66476;s:85:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/cron\";i:3831;s:89:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask/archiver\";i:36864;s:80:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/servmask\";i:133052;s:100:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/bandar/bandar/lib/Exceptions\";i:1996;s:89:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/bandar/bandar/lib\";i:7938;s:85:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/bandar/bandar\";i:9015;s:78:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor/bandar\";i:9015;s:71:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib/vendor\";i:142067;s:64:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration/lib\";i:991029;s:60:\"/home/orthopa/www/wp-content/plugins/all-in-one-wp-migration\";i:1158760;s:36:\"/home/orthopa/www/wp-content/plugins\";i:32586183;s:44:\"/home/orthopa/www/wp-content/uploads/2021/09\";i:3875131;s:44:\"/home/orthopa/www/wp-content/uploads/2021/10\";i:2600830;s:44:\"/home/orthopa/www/wp-content/uploads/2021/08\";i:0;s:41:\"/home/orthopa/www/wp-content/uploads/2021\";i:6475961;s:42:\"/home/orthopa/www/wp-content/uploads/redux\";i:0;s:36:\"/home/orthopa/www/wp-content/uploads\";i:6475961;}", "yes");
INSERT INTO `wp_options` VALUES("2490", "_wp_suggested_policy_text_has_changed", "changed", "yes");
INSERT INTO `wp_options` VALUES("2617", "advanced-gutenberg_wp_reviews_installed_on", "2021-10-28 08:31:47", "yes");
INSERT INTO `wp_options` VALUES("2647", "wp_maintenance_settings", "a:69:{s:8:\"color_bg\";s:7:\"#f1f1f1\";s:9:\"color_txt\";s:7:\"#888888\";s:15:\"color_bg_bottom\";s:7:\"#333333\";s:17:\"color_text_bottom\";s:7:\"#FFFFFF\";s:17:\"titre_maintenance\";s:61:\"Le site du cabinet d\\\'Orthopédie Anthoard est en maintenance\";s:16:\"text_maintenance\";s:120:\"désolé, mais le site d\\\'Orthopédie et de Podologie du Cabinet l\\\'ANTHOARD à Grenoble est momentanément indisponible\";s:9:\"userlimit\";s:13:\"administrator\";s:5:\"image\";s:108:\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/plugins/wp-maintenance/images/default2.png\";s:11:\"image_width\";i:450;s:12:\"image_height\";i:450;s:10:\"font_title\";s:7:\"PT Sans\";s:15:\"font_title_size\";i:40;s:17:\"font_title_weigth\";s:6:\"normal\";s:16:\"font_title_style\";s:0:\"\";s:15:\"font_text_style\";s:0:\"\";s:9:\"font_text\";s:11:\"Metrophobic\";s:14:\"font_text_size\";i:18;s:16:\"font_text_bottom\";s:7:\"PT Sans\";s:16:\"font_text_weigth\";s:6:\"normal\";s:16:\"font_bottom_size\";i:12;s:18:\"font_bottom_weigth\";s:6:\"normal\";s:17:\"font_bottom_style\";s:0:\"\";s:8:\"font_cpt\";s:7:\"PT Sans\";s:9:\"color_cpt\";s:7:\"#333333\";s:11:\"enable_demo\";i:0;s:16:\"color_field_text\";s:7:\"#333333\";s:17:\"color_text_button\";s:7:\"#ffffff\";s:22:\"color_field_background\";s:7:\"#F1F1F1\";s:18:\"color_field_border\";s:7:\"#333333\";s:20:\"color_button_onclick\";s:7:\"#333333\";s:18:\"color_button_hover\";s:7:\"#cccccc\";s:12:\"color_button\";s:7:\"#1e73be\";s:9:\"newletter\";i:0;s:10:\"active_cpt\";i:0;s:19:\"newletter_font_text\";s:7:\"PT Sans\";s:14:\"newletter_size\";i:18;s:20:\"newletter_font_style\";s:0:\"\";s:21:\"newletter_font_weigth\";s:6:\"normal\";s:14:\"type_newletter\";s:9:\"shortcode\";s:15:\"title_newletter\";s:0:\"\";s:14:\"code_newletter\";s:0:\"\";s:14:\"code_analytics\";s:0:\"\";s:16:\"domain_analytics\";s:46:\"www.orthopedie-podologie-anthoard-grenoble.com\";s:19:\"text_bt_maintenance\";s:0:\"\";s:11:\"add_wplogin\";i:0;s:14:\"b_enable_image\";i:0;s:15:\"b_opacity_image\";s:3:\"0.2\";s:7:\"disable\";i:0;s:9:\"pageperso\";i:0;s:13:\"date_cpt_size\";i:6;s:15:\"color_bg_header\";s:7:\"#ffffff\";s:17:\"add_wplogin_title\";s:0:\"\";s:10:\"headercode\";s:0:\"\";s:15:\"message_cpt_fin\";s:0:\"\";s:14:\"b_repeat_image\";s:0:\"\";s:12:\"color_cpt_bg\";s:0:\"\";s:12:\"font_end_cpt\";s:7:\"PT Sans\";s:12:\"cpt_end_size\";i:3;s:13:\"enable_slider\";i:0;s:11:\"slider_auto\";s:5:\"false\";s:10:\"slider_nav\";s:5:\"false\";s:16:\"container_active\";i:0;s:15:\"container_color\";s:7:\"#ffffff\";s:17:\"container_opacity\";s:3:\"0.5\";s:15:\"container_width\";i:80;s:19:\"dashboard_delete_db\";i:1;s:9:\"error_503\";i:1;s:13:\"enable_footer\";i:0;s:16:\"iframe_newletter\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("2648", "wp_maintenance_active", "0", "yes");
INSERT INTO `wp_options` VALUES("2649", "wp_maintenance_style", "#logo {text-align: center;max-width: 100%;height: auto;text-align: center;}\r\n\r\na:link {color: #_COLORTXT;text-decoration: none;}\r\na:visited {color: #_COLORTXT;text-decoration: none;}\r\na:hover, a:focus, a:active {color: #_COLORTXT;text-decoration: none;}\r\n\r\n.cptR-rec_countdown {\r\n    position: relative;\r\n    background: #_COLORCPTBG;\r\n    display: inline-block;\r\n    line-height: 100%;\r\n    min-height: 60px;\r\n    text-transform: uppercase;\r\n    text-align:center;\r\n    margin: 0.5em auto;\r\n}\r\n.wpm_ctp_sep {margin-top:1vw;}\r\n\r\nheader {background: #_COLORHEAD;}\r\n\r\n#wpm-cpt-day, #wpm-cpt-hours, #wpm-cpt-minutes, #wpm-cpt-seconds {\r\n    color: #_COLORCPT;\r\n    display: block;\r\n    font-size: #_DATESIZE;\r\n    height: 40px;\r\n    line-height: 18px;\r\n    text-align: center;\r\n    float:left;\r\n    margin:0.3em;\r\n    padding:0px;\r\n}\r\n#wpm-cpt-days-span, #wpm-cpt-hours-span, #wpm-cpt-minutes-span, #wpm-cpt-seconds-span {\r\n    color: #_COLORCPT;\r\n    font-size: 10px;\r\n    padding: 25px 5px 0 2px;\r\n}\r\n.wpm_social ul, li { background:none!important; }\r\n.wpm_horizontal li {display: inline-block;list-style: none;margin:5px;opacity:1;}\r\n.wpm_horizontal li:hover {opacity:0.5;}\r\n\r\n.wpm_social {padding: 0 45px;text-align: center;}\r\n.wpm_newletter {text-align:center;}\r\n#countdown {clear:both;margin-left:auto;margin-right:auto;text-align: center;}\r\n\r\n    ", "yes");
INSERT INTO `wp_options` VALUES("2650", "wp_maintenance_social_options", "a:7:{s:6:\"enable\";i:0;s:5:\"texte\";s:12:\"Follow me on\";s:5:\"style\";s:6:\"style1\";s:4:\"size\";i:64;s:8:\"position\";s:6:\"bottom\";s:5:\"align\";s:6:\"center\";s:5:\"theme\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("2651", "wp_maintenance_version", "6.1.2", "yes");
INSERT INTO `wp_options` VALUES("5553", "db_upgraded", "", "yes");
INSERT INTO `wp_options` VALUES("18823", "rewrite_rules", "a:120:{s:19:\"sitemap_index\\.xml$\";s:19:\"index.php?sitemap=1\";s:31:\"([^/]+?)-sitemap([0-9]+)?\\.xml$\";s:51:\"index.php?sitemap=$matches[1]&sitemap_n=$matches[2]\";s:24:\"([a-z]+)?-?sitemap\\.xsl$\";s:39:\"index.php?yoast-sitemap-xsl=$matches[1]\";s:11:\"^wp-json/?$\";s:22:\"index.php?rest_route=/\";s:14:\"^wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:21:\"^index.php/wp-json/?$\";s:22:\"index.php?rest_route=/\";s:24:\"^index.php/wp-json/(.*)?\";s:33:\"index.php?rest_route=/$matches[1]\";s:17:\"^wp-sitemap\\.xml$\";s:23:\"index.php?sitemap=index\";s:17:\"^wp-sitemap\\.xsl$\";s:36:\"index.php?sitemap-stylesheet=sitemap\";s:23:\"^wp-sitemap-index\\.xsl$\";s:34:\"index.php?sitemap-stylesheet=index\";s:48:\"^wp-sitemap-([a-z]+?)-([a-z\\d_-]+?)-(\\d+?)\\.xml$\";s:75:\"index.php?sitemap=$matches[1]&sitemap-subtype=$matches[2]&paged=$matches[3]\";s:34:\"^wp-sitemap-([a-z]+?)-(\\d+?)\\.xml$\";s:47:\"index.php?sitemap=$matches[1]&paged=$matches[2]\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:23:\"category/(.+?)/embed/?$\";s:46:\"index.php?category_name=$matches[1]&embed=true\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:20:\"tag/([^/]+)/embed/?$\";s:36:\"index.php?tag=$matches[1]&embed=true\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:21:\"type/([^/]+)/embed/?$\";s:44:\"index.php?post_format=$matches[1]&embed=true\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:55:\"portfolio-type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:53:\"index.php?portfolio-type=$matches[1]&feed=$matches[2]\";s:50:\"portfolio-type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:53:\"index.php?portfolio-type=$matches[1]&feed=$matches[2]\";s:31:\"portfolio-type/([^/]+)/embed/?$\";s:47:\"index.php?portfolio-type=$matches[1]&embed=true\";s:43:\"portfolio-type/([^/]+)/page/?([0-9]{1,})/?$\";s:54:\"index.php?portfolio-type=$matches[1]&paged=$matches[2]\";s:25:\"portfolio-type/([^/]+)/?$\";s:36:\"index.php?portfolio-type=$matches[1]\";s:37:\"portfolio/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:47:\"portfolio/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:67:\"portfolio/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"portfolio/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:62:\"portfolio/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:43:\"portfolio/[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:26:\"portfolio/([^/]+)/embed/?$\";s:42:\"index.php?portfolio=$matches[1]&embed=true\";s:30:\"portfolio/([^/]+)/trackback/?$\";s:36:\"index.php?portfolio=$matches[1]&tb=1\";s:50:\"portfolio/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?portfolio=$matches[1]&feed=$matches[2]\";s:45:\"portfolio/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:48:\"index.php?portfolio=$matches[1]&feed=$matches[2]\";s:38:\"portfolio/([^/]+)/page/?([0-9]{1,})/?$\";s:49:\"index.php?portfolio=$matches[1]&paged=$matches[2]\";s:34:\"portfolio/([^/]+)(?:/([0-9]+))?/?$\";s:48:\"index.php?portfolio=$matches[1]&page=$matches[2]\";s:26:\"portfolio/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:36:\"portfolio/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:56:\"portfolio/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"portfolio/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:51:\"portfolio/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:32:\"portfolio/[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:12:\"robots\\.txt$\";s:18:\"index.php?robots=1\";s:13:\"favicon\\.ico$\";s:19:\"index.php?favicon=1\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:8:\"embed/?$\";s:21:\"index.php?&embed=true\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:27:\"comment-page-([0-9]{1,})/?$\";s:38:\"index.php?&page_id=8&cpage=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:17:\"comments/embed/?$\";s:21:\"index.php?&embed=true\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:20:\"search/(.+)/embed/?$\";s:34:\"index.php?s=$matches[1]&embed=true\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:23:\"author/([^/]+)/embed/?$\";s:44:\"index.php?author_name=$matches[1]&embed=true\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:45:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/embed/?$\";s:74:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&embed=true\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:32:\"([0-9]{4})/([0-9]{1,2})/embed/?$\";s:58:\"index.php?year=$matches[1]&monthnum=$matches[2]&embed=true\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:19:\"([0-9]{4})/embed/?$\";s:37:\"index.php?year=$matches[1]&embed=true\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\".?.+?/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"(.?.+?)/embed/?$\";s:41:\"index.php?pagename=$matches[1]&embed=true\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:24:\"(.?.+?)(?:/([0-9]+))?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:27:\"[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\"[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\"[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\"[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:33:\"[^/]+/attachment/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";s:16:\"([^/]+)/embed/?$\";s:37:\"index.php?name=$matches[1]&embed=true\";s:20:\"([^/]+)/trackback/?$\";s:31:\"index.php?name=$matches[1]&tb=1\";s:40:\"([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:35:\"([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?name=$matches[1]&feed=$matches[2]\";s:28:\"([^/]+)/page/?([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&paged=$matches[2]\";s:35:\"([^/]+)/comment-page-([0-9]{1,})/?$\";s:44:\"index.php?name=$matches[1]&cpage=$matches[2]\";s:24:\"([^/]+)(?:/([0-9]+))?/?$\";s:43:\"index.php?name=$matches[1]&page=$matches[2]\";s:16:\"[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:26:\"[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:46:\"[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:41:\"[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:22:\"[^/]+/([^/]+)/embed/?$\";s:43:\"index.php?attachment=$matches[1]&embed=true\";}", "yes");
INSERT INTO `wp_options` VALUES("27956", "user_count", "1", "no");
INSERT INTO `wp_options` VALUES("50656", "can_compress_scripts", "0", "no");
INSERT INTO `wp_options` VALUES("50676", "wp_maintenance_settings_css", "#logo {text-align: center;max-width: 100%;height: auto;text-align: center;}\r\n\r\na:link {color: #_COLORTXT;text-decoration: none;}\r\na:visited {color: #_COLORTXT;text-decoration: none;}\r\na:hover, a:focus, a:active {color: #_COLORTXT;text-decoration: none;}\r\n\r\n.cptR-rec_countdown {\r\n    position: relative;\r\n    background: #_COLORCPTBG;\r\n    display: inline-block;\r\n    line-height: 100%;\r\n    min-height: 60px;\r\n    text-transform: uppercase;\r\n    text-align:center;\r\n    margin: 0.5em auto;\r\n}\r\n.wpm_ctp_sep {margin-top:1vw;}\r\n\r\nheader {background: #_COLORHEAD;}\r\n\r\n#wpm-cpt-day, #wpm-cpt-hours, #wpm-cpt-minutes, #wpm-cpt-seconds {\r\n    color: #_COLORCPT;\r\n    display: block;\r\n    font-size: #_DATESIZE;\r\n    height: 40px;\r\n    line-height: 18px;\r\n    text-align: center;\r\n    float:left;\r\n    margin:0.3em;\r\n    padding:0px;\r\n}\r\n#wpm-cpt-days-span, #wpm-cpt-hours-span, #wpm-cpt-minutes-span, #wpm-cpt-seconds-span {\r\n    color: #_COLORCPT;\r\n    font-size: 10px;\r\n    padding: 25px 5px 0 2px;\r\n}\r\n.wpm_social ul, li { background:none!important; }\r\n.wpm_horizontal li {display: inline-block;list-style: none;margin:5px;opacity:1;}\r\n.wpm_horizontal li:hover {opacity:0.5;}\r\n\r\n.wpm_social {padding: 0 45px;text-align: center;}\r\n.wpm_newletter {text-align:center;}\r\n#countdown {clear:both;margin-left:auto;margin-right:auto;text-align: center;}\r\n\r\n.footer-basic p a {\r\ncolor:#_COLOR_TXT_BT;\r\ntext-decoration:none;\r\n}\r\n.footer-basic .copyright {\r\nmargin-top:15px;\r\ntext-align:center;\r\nfont-size:13px;\r\ncolor:#aaa;\r\nmargin-bottom:0;\r\n}\r\n    ", "yes");
INSERT INTO `wp_options` VALUES("50677", "wp_maintenance_settings_colors", "a:40:{s:8:\"color_bg\";s:7:\"#f1f1f1\";s:15:\"color_bg_header\";s:7:\"#ffffff\";s:11:\"color_title\";s:7:\"#333333\";s:10:\"font_title\";s:5:\"Anton\";s:15:\"font_title_size\";s:2:\"16\";s:17:\"font_title_weigth\";s:0:\"\";s:16:\"font_title_style\";s:0:\"\";s:9:\"color_txt\";s:7:\"#333333\";s:9:\"font_text\";s:5:\"Anton\";s:14:\"font_text_size\";s:2:\"16\";s:16:\"font_text_weigth\";s:0:\"\";s:15:\"font_text_style\";s:0:\"\";s:16:\"container_active\";i:0;s:32:\"container_colorcontainer_opacity\";s:3:\"0.5\";s:15:\"container_width\";s:2:\"80\";s:9:\"color_cpt\";s:7:\"#333333\";s:12:\"color_cpt_bg\";s:7:\"#ffffff\";s:8:\"font_cpt\";s:8:\"Pacifico\";s:13:\"date_cpt_size\";s:1:\"6\";s:12:\"font_end_cpt\";s:8:\"Pacifico\";s:12:\"cpt_end_size\";s:1:\"2\";s:17:\"color_text_bottom\";s:7:\"#ffffff\";s:15:\"color_bg_bottom\";s:7:\"#333333\";s:16:\"font_text_bottom\";s:7:\"PT+Sans\";s:16:\"font_bottom_size\";s:2:\"12\";s:18:\"font_bottom_weigth\";s:0:\"\";s:17:\"font_bottom_style\";s:0:\"\";s:9:\"newletter\";i:0;s:19:\"newletter_font_text\";s:7:\"PT+Sans\";s:14:\"newletter_size\";s:2:\"14\";s:21:\"newletter_font_weigth\";s:0:\"\";s:20:\"newletter_font_style\";s:0:\"\";s:16:\"color_field_text\";s:7:\"#333333\";s:18:\"color_field_border\";s:7:\"#333333\";s:22:\"color_field_background\";s:7:\"#CCCCCC\";s:17:\"color_text_button\";s:7:\"#ffffff\";s:12:\"color_button\";s:7:\"#1e73be\";s:18:\"color_button_hover\";s:7:\"#ffffff\";s:20:\"color_button_onclick\";s:7:\"#ffffff\";s:18:\"remove_googlefonts\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("50678", "wp_maintenance_settings_picture", "a:9:{s:5:\"image\";s:108:\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/plugins/wp-maintenance/images/default2.png\";s:11:\"image_width\";i:450;s:12:\"image_height\";i:450;s:14:\"b_enable_image\";i:0;s:7:\"b_image\";s:0:\"\";s:15:\"b_opacity_image\";s:3:\"0.2\";s:14:\"b_repeat_image\";s:6:\"repeat\";s:13:\"b_fixed_image\";i:1;s:9:\"b_pattern\";i:0;}", "yes");
INSERT INTO `wp_options` VALUES("50679", "wp_maintenance_settings_countdown", "a:7:{s:10:\"active_cpt\";i:0;s:11:\"date_cpt_hh\";s:0:\"\";s:7:\"cptdate\";s:0:\"\";s:7:\"cpttime\";s:0:\"\";s:12:\"active_cpt_s\";s:0:\"\";s:7:\"disable\";s:0:\"\";s:15:\"message_cpt_fin\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("50680", "wp_maintenance_settings_seo", "a:4:{s:10:\"enable_seo\";i:0;s:9:\"seo_title\";s:0:\"\";s:15:\"seo_description\";s:0:\"\";s:7:\"favicon\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("50681", "wp_maintenance_settings_socialnetworks", "a:7:{s:6:\"enable\";i:0;s:5:\"texte\";s:14:\"Suivez-moi sur\";s:4:\"size\";i:64;s:5:\"style\";s:6:\"style1\";s:8:\"position\";s:6:\"bottom\";s:5:\"align\";s:6:\"center\";s:5:\"theme\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("50682", "wp_maintenance_list_socialnetworks", "a:15:{s:8:\"facebook\";s:0:\"\";s:7:\"twitter\";s:0:\"\";s:8:\"linkedin\";s:0:\"\";s:6:\"flickr\";s:0:\"\";s:7:\"youtube\";s:0:\"\";s:9:\"pinterest\";s:0:\"\";s:5:\"vimeo\";s:0:\"\";s:9:\"instagram\";s:0:\"\";s:8:\"about_me\";s:0:\"\";s:10:\"soundcloud\";s:0:\"\";s:5:\"skype\";s:0:\"\";s:6:\"tumblr\";s:0:\"\";s:7:\"blogger\";s:0:\"\";s:6:\"paypal\";s:0:\"\";s:5:\"email\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("50683", "wp_maintenance_settings_footer", "a:4:{s:13:\"enable_footer\";i:0;s:19:\"text_bt_maintenance\";s:0:\"\";s:11:\"add_wplogin\";i:0;s:17:\"add_wplogin_title\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("50684", "wp_maintenance_settings_options", "a:5:{s:9:\"pageperso\";i:0;s:19:\"dashboard_delete_db\";i:0;s:9:\"error_503\";i:1;s:8:\"id_pages\";s:0:\"\";s:10:\"headercode\";s:0:\"\";}", "yes");
INSERT INTO `wp_options` VALUES("56349", "_site_transient_timeout_php_check_3a6f2a803f99347534e67553ed67d1ad", "1674629513", "no");
INSERT INTO `wp_options` VALUES("56350", "_site_transient_php_check_3a6f2a803f99347534e67553ed67d1ad", "a:5:{s:19:\"recommended_version\";s:3:\"7.4\";s:15:\"minimum_version\";s:6:\"5.6.20\";s:12:\"is_supported\";b:1;s:9:\"is_secure\";b:1;s:13:\"is_acceptable\";b:1;}", "no");
INSERT INTO `wp_options` VALUES("56464", "_site_transient_timeout_available_translations", "1674107215", "no");
INSERT INTO `wp_options` VALUES("56465", "_site_transient_available_translations", "a:130:{s:2:\"af\";a:8:{s:8:\"language\";s:2:\"af\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-05-13 15:59:22\";s:12:\"english_name\";s:9:\"Afrikaans\";s:11:\"native_name\";s:9:\"Afrikaans\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8-beta/af.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"af\";i:2;s:3:\"afr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Gaan voort\";}}s:2:\"am\";a:8:{s:8:\"language\";s:2:\"am\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2022-09-29 20:43:49\";s:12:\"english_name\";s:7:\"Amharic\";s:11:\"native_name\";s:12:\"አማርኛ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.0.3/am.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"am\";i:2;s:3:\"amh\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"ቀጥል\";}}s:3:\"arg\";a:8:{s:8:\"language\";s:3:\"arg\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-09-22 16:46:56\";s:12:\"english_name\";s:9:\"Aragonese\";s:11:\"native_name\";s:9:\"Aragonés\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.1.1/arg.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"an\";i:2;s:3:\"arg\";i:3;s:3:\"arg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continar\";}}s:2:\"ar\";a:8:{s:8:\"language\";s:2:\"ar\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-04 13:58:35\";s:12:\"english_name\";s:6:\"Arabic\";s:11:\"native_name\";s:14:\"العربية\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/ar.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:2;s:3:\"ara\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:3:\"ary\";a:8:{s:8:\"language\";s:3:\"ary\";s:7:\"version\";s:6:\"4.8.21\";s:7:\"updated\";s:19:\"2017-01-26 15:42:35\";s:12:\"english_name\";s:15:\"Moroccan Arabic\";s:11:\"native_name\";s:31:\"العربية المغربية\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.8.21/ary.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ar\";i:3;s:3:\"ary\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"المتابعة\";}}s:2:\"as\";a:8:{s:8:\"language\";s:2:\"as\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-18 12:06:43\";s:12:\"english_name\";s:8:\"Assamese\";s:11:\"native_name\";s:21:\"অসমীয়া\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/as.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"as\";i:2;s:3:\"asm\";i:3;s:3:\"asm\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:3:\"azb\";a:8:{s:8:\"language\";s:3:\"azb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-12 20:34:31\";s:12:\"english_name\";s:17:\"South Azerbaijani\";s:11:\"native_name\";s:29:\"گؤنئی آذربایجان\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/azb.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:3;s:3:\"azb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"az\";a:8:{s:8:\"language\";s:2:\"az\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-06 00:09:27\";s:12:\"english_name\";s:11:\"Azerbaijani\";s:11:\"native_name\";s:16:\"Azərbaycan dili\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/az.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"az\";i:2;s:3:\"aze\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Davam\";}}s:3:\"bel\";a:8:{s:8:\"language\";s:3:\"bel\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2019-10-29 07:54:22\";s:12:\"english_name\";s:10:\"Belarusian\";s:11:\"native_name\";s:29:\"Беларуская мова\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.9.22/bel.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"be\";i:2;s:3:\"bel\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Працягнуць\";}}s:5:\"bg_BG\";a:8:{s:8:\"language\";s:5:\"bg_BG\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-16 13:00:35\";s:12:\"english_name\";s:9:\"Bulgarian\";s:11:\"native_name\";s:18:\"Български\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/bg_BG.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bg\";i:2;s:3:\"bul\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Напред\";}}s:5:\"bn_BD\";a:8:{s:8:\"language\";s:5:\"bn_BD\";s:7:\"version\";s:6:\"5.4.12\";s:7:\"updated\";s:19:\"2020-10-31 08:48:37\";s:12:\"english_name\";s:20:\"Bengali (Bangladesh)\";s:11:\"native_name\";s:15:\"বাংলা\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.4.12/bn_BD.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"bn\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:23:\"এগিয়ে চল.\";}}s:2:\"bo\";a:8:{s:8:\"language\";s:2:\"bo\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2020-10-30 03:24:38\";s:12:\"english_name\";s:7:\"Tibetan\";s:11:\"native_name\";s:21:\"བོད་ཡིག\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8-beta/bo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bo\";i:2;s:3:\"tib\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:33:\"མུ་མཐུད་དུ།\";}}s:5:\"bs_BA\";a:8:{s:8:\"language\";s:5:\"bs_BA\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-24 12:03:10\";s:12:\"english_name\";s:7:\"Bosnian\";s:11:\"native_name\";s:8:\"Bosanski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/bs_BA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"bs\";i:2;s:3:\"bos\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:2:\"ca\";a:8:{s:8:\"language\";s:2:\"ca\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-13 14:46:37\";s:12:\"english_name\";s:7:\"Catalan\";s:11:\"native_name\";s:7:\"Català\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/ca.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ca\";i:2;s:3:\"cat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:3:\"ceb\";a:8:{s:8:\"language\";s:3:\"ceb\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-02 17:25:51\";s:12:\"english_name\";s:7:\"Cebuano\";s:11:\"native_name\";s:7:\"Cebuano\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/ceb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"ceb\";i:3;s:3:\"ceb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Padayun\";}}s:5:\"cs_CZ\";a:8:{s:8:\"language\";s:5:\"cs_CZ\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-25 20:56:45\";s:12:\"english_name\";s:5:\"Czech\";s:11:\"native_name\";s:9:\"Čeština\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/cs_CZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cs\";i:2;s:3:\"ces\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:11:\"Pokračovat\";}}s:2:\"cy\";a:8:{s:8:\"language\";s:2:\"cy\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-14 15:48:08\";s:12:\"english_name\";s:5:\"Welsh\";s:11:\"native_name\";s:7:\"Cymraeg\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/cy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"cy\";i:2;s:3:\"cym\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Parhau\";}}s:5:\"da_DK\";a:8:{s:8:\"language\";s:5:\"da_DK\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-10 08:19:28\";s:12:\"english_name\";s:6:\"Danish\";s:11:\"native_name\";s:5:\"Dansk\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/da_DK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"da\";i:2;s:3:\"dan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsæt\";}}s:5:\"de_CH\";a:8:{s:8:\"language\";s:5:\"de_CH\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-16 12:27:22\";s:12:\"english_name\";s:20:\"German (Switzerland)\";s:11:\"native_name\";s:17:\"Deutsch (Schweiz)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/de_CH.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:5:\"de_DE\";a:8:{s:8:\"language\";s:5:\"de_DE\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-17 17:06:48\";s:12:\"english_name\";s:6:\"German\";s:11:\"native_name\";s:7:\"Deutsch\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/de_DE.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:12:\"de_DE_formal\";a:8:{s:8:\"language\";s:12:\"de_DE_formal\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-17 17:02:15\";s:12:\"english_name\";s:15:\"German (Formal)\";s:11:\"native_name\";s:13:\"Deutsch (Sie)\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/translation/core/6.1.1/de_DE_formal.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:14:\"de_CH_informal\";a:8:{s:8:\"language\";s:14:\"de_CH_informal\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-16 12:27:34\";s:12:\"english_name\";s:30:\"German (Switzerland, Informal)\";s:11:\"native_name\";s:21:\"Deutsch (Schweiz, Du)\";s:7:\"package\";s:73:\"https://downloads.wordpress.org/translation/core/6.1.1/de_CH_informal.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:5:\"de_AT\";a:8:{s:8:\"language\";s:5:\"de_AT\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2022-03-17 12:58:14\";s:12:\"english_name\";s:16:\"German (Austria)\";s:11:\"native_name\";s:21:\"Deutsch (Österreich)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.3/de_AT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"de\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Weiter\";}}s:3:\"dsb\";a:8:{s:8:\"language\";s:3:\"dsb\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-07-16 12:13:09\";s:12:\"english_name\";s:13:\"Lower Sorbian\";s:11:\"native_name\";s:16:\"Dolnoserbšćina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.1.1/dsb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"dsb\";i:3;s:3:\"dsb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Dalej\";}}s:3:\"dzo\";a:8:{s:8:\"language\";s:3:\"dzo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-06-29 08:59:03\";s:12:\"english_name\";s:8:\"Dzongkha\";s:11:\"native_name\";s:18:\"རྫོང་ཁ\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/dzo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"dz\";i:2;s:3:\"dzo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"el\";a:8:{s:8:\"language\";s:2:\"el\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-11 11:55:57\";s:12:\"english_name\";s:5:\"Greek\";s:11:\"native_name\";s:16:\"Ελληνικά\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/el.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"el\";i:2;s:3:\"ell\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Συνέχεια\";}}s:5:\"en_CA\";a:8:{s:8:\"language\";s:5:\"en_CA\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-09 10:47:19\";s:12:\"english_name\";s:16:\"English (Canada)\";s:11:\"native_name\";s:16:\"English (Canada)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/en_CA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_ZA\";a:8:{s:8:\"language\";s:5:\"en_ZA\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2021-12-24 12:36:39\";s:12:\"english_name\";s:22:\"English (South Africa)\";s:11:\"native_name\";s:22:\"English (South Africa)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.3/en_ZA.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_AU\";a:8:{s:8:\"language\";s:5:\"en_AU\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-16 06:36:35\";s:12:\"english_name\";s:19:\"English (Australia)\";s:11:\"native_name\";s:19:\"English (Australia)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/en_AU.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_GB\";a:8:{s:8:\"language\";s:5:\"en_GB\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-10 21:58:00\";s:12:\"english_name\";s:12:\"English (UK)\";s:11:\"native_name\";s:12:\"English (UK)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/en_GB.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"en_NZ\";a:8:{s:8:\"language\";s:5:\"en_NZ\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2022-04-01 22:35:34\";s:12:\"english_name\";s:21:\"English (New Zealand)\";s:11:\"native_name\";s:21:\"English (New Zealand)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.3/en_NZ.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"en\";i:2;s:3:\"eng\";i:3;s:3:\"eng\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"eo\";a:8:{s:8:\"language\";s:2:\"eo\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-18 21:56:09\";s:12:\"english_name\";s:9:\"Esperanto\";s:11:\"native_name\";s:9:\"Esperanto\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/eo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eo\";i:2;s:3:\"epo\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Daŭrigi\";}}s:5:\"es_EC\";a:8:{s:8:\"language\";s:5:\"es_EC\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-11 23:25:26\";s:12:\"english_name\";s:17:\"Spanish (Ecuador)\";s:11:\"native_name\";s:19:\"Español de Ecuador\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_EC.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CO\";a:8:{s:8:\"language\";s:5:\"es_CO\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-07-22 14:08:10\";s:12:\"english_name\";s:18:\"Spanish (Colombia)\";s:11:\"native_name\";s:20:\"Español de Colombia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_CO.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_MX\";a:8:{s:8:\"language\";s:5:\"es_MX\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-10 19:19:07\";s:12:\"english_name\";s:16:\"Spanish (Mexico)\";s:11:\"native_name\";s:19:\"Español de México\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_MX.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_ES\";a:8:{s:8:\"language\";s:5:\"es_ES\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-10 18:26:21\";s:12:\"english_name\";s:15:\"Spanish (Spain)\";s:11:\"native_name\";s:8:\"Español\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_ES.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_PE\";a:8:{s:8:\"language\";s:5:\"es_PE\";s:7:\"version\";s:5:\"5.8.6\";s:7:\"updated\";s:19:\"2021-10-04 20:53:18\";s:12:\"english_name\";s:14:\"Spanish (Peru)\";s:11:\"native_name\";s:17:\"Español de Perú\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8.6/es_PE.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_DO\";a:8:{s:8:\"language\";s:5:\"es_DO\";s:7:\"version\";s:5:\"5.8.6\";s:7:\"updated\";s:19:\"2021-10-08 14:32:50\";s:12:\"english_name\";s:28:\"Spanish (Dominican Republic)\";s:11:\"native_name\";s:33:\"Español de República Dominicana\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8.6/es_DO.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CL\";a:8:{s:8:\"language\";s:5:\"es_CL\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-06-14 16:02:22\";s:12:\"english_name\";s:15:\"Spanish (Chile)\";s:11:\"native_name\";s:17:\"Español de Chile\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/es_CL.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_UY\";a:8:{s:8:\"language\";s:5:\"es_UY\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-03-31 18:33:26\";s:12:\"english_name\";s:17:\"Spanish (Uruguay)\";s:11:\"native_name\";s:19:\"Español de Uruguay\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/es_UY.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_PR\";a:8:{s:8:\"language\";s:5:\"es_PR\";s:7:\"version\";s:6:\"5.4.12\";s:7:\"updated\";s:19:\"2020-04-29 15:36:59\";s:12:\"english_name\";s:21:\"Spanish (Puerto Rico)\";s:11:\"native_name\";s:23:\"Español de Puerto Rico\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.4.12/es_PR.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_CR\";a:8:{s:8:\"language\";s:5:\"es_CR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-03 15:35:12\";s:12:\"english_name\";s:20:\"Spanish (Costa Rica)\";s:11:\"native_name\";s:22:\"Español de Costa Rica\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_CR.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_GT\";a:8:{s:8:\"language\";s:5:\"es_GT\";s:7:\"version\";s:6:\"5.2.17\";s:7:\"updated\";s:19:\"2019-03-02 06:35:01\";s:12:\"english_name\";s:19:\"Spanish (Guatemala)\";s:11:\"native_name\";s:21:\"Español de Guatemala\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.2.17/es_GT.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_AR\";a:8:{s:8:\"language\";s:5:\"es_AR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-17 14:28:26\";s:12:\"english_name\";s:19:\"Spanish (Argentina)\";s:11:\"native_name\";s:21:\"Español de Argentina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_AR.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"es_VE\";a:8:{s:8:\"language\";s:5:\"es_VE\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-16 13:13:32\";s:12:\"english_name\";s:19:\"Spanish (Venezuela)\";s:11:\"native_name\";s:21:\"Español de Venezuela\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/es_VE.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"es\";i:2;s:3:\"spa\";i:3;s:3:\"spa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"et\";a:8:{s:8:\"language\";s:2:\"et\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2020-08-12 08:38:59\";s:12:\"english_name\";s:8:\"Estonian\";s:11:\"native_name\";s:5:\"Eesti\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8-beta/et.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"et\";i:2;s:3:\"est\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Jätka\";}}s:2:\"eu\";a:8:{s:8:\"language\";s:2:\"eu\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-15 05:47:03\";s:12:\"english_name\";s:6:\"Basque\";s:11:\"native_name\";s:7:\"Euskara\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/eu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"eu\";i:2;s:3:\"eus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Jarraitu\";}}s:5:\"fa_AF\";a:8:{s:8:\"language\";s:5:\"fa_AF\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-19 05:14:04\";s:12:\"english_name\";s:21:\"Persian (Afghanistan)\";s:11:\"native_name\";s:31:\"(فارسی (افغانستان\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/fa_AF.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"fa_IR\";a:8:{s:8:\"language\";s:5:\"fa_IR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-17 08:19:07\";s:12:\"english_name\";s:7:\"Persian\";s:11:\"native_name\";s:10:\"فارسی\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/fa_IR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fa\";i:2;s:3:\"fas\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:2:\"fi\";a:8:{s:8:\"language\";s:2:\"fi\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-07 05:25:25\";s:12:\"english_name\";s:7:\"Finnish\";s:11:\"native_name\";s:5:\"Suomi\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/fi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fi\";i:2;s:3:\"fin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Jatka\";}}s:5:\"fr_CA\";a:8:{s:8:\"language\";s:5:\"fr_CA\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-12 18:38:54\";s:12:\"english_name\";s:15:\"French (Canada)\";s:11:\"native_name\";s:19:\"Français du Canada\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/fr_CA.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fr\";i:2;s:3:\"fra\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:5:\"fr_FR\";a:8:{s:8:\"language\";s:5:\"fr_FR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-02 09:17:04\";s:12:\"english_name\";s:15:\"French (France)\";s:11:\"native_name\";s:9:\"Français\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/fr_FR.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"fr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:5:\"fr_BE\";a:8:{s:8:\"language\";s:5:\"fr_BE\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-02-22 13:54:46\";s:12:\"english_name\";s:16:\"French (Belgium)\";s:11:\"native_name\";s:21:\"Français de Belgique\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/fr_BE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fr\";i:2;s:3:\"fra\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuer\";}}s:3:\"fur\";a:8:{s:8:\"language\";s:3:\"fur\";s:7:\"version\";s:6:\"4.8.21\";s:7:\"updated\";s:19:\"2018-01-29 17:32:35\";s:12:\"english_name\";s:8:\"Friulian\";s:11:\"native_name\";s:8:\"Friulian\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.8.21/fur.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"fur\";i:3;s:3:\"fur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"fy\";a:8:{s:8:\"language\";s:2:\"fy\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-25 12:53:23\";s:12:\"english_name\";s:7:\"Frisian\";s:11:\"native_name\";s:5:\"Frysk\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/fy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"fy\";i:2;s:3:\"fry\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Trochgean\";}}s:2:\"gd\";a:8:{s:8:\"language\";s:2:\"gd\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-08-23 17:41:37\";s:12:\"english_name\";s:15:\"Scottish Gaelic\";s:11:\"native_name\";s:9:\"Gàidhlig\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/gd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"gd\";i:2;s:3:\"gla\";i:3;s:3:\"gla\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"Lean air adhart\";}}s:5:\"gl_ES\";a:8:{s:8:\"language\";s:5:\"gl_ES\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-03 10:28:43\";s:12:\"english_name\";s:8:\"Galician\";s:11:\"native_name\";s:6:\"Galego\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/gl_ES.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gl\";i:2;s:3:\"glg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:2:\"gu\";a:8:{s:8:\"language\";s:2:\"gu\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2018-09-14 12:33:48\";s:12:\"english_name\";s:8:\"Gujarati\";s:11:\"native_name\";s:21:\"ગુજરાતી\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.9.22/gu.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"gu\";i:2;s:3:\"guj\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:31:\"ચાલુ રાખવું\";}}s:3:\"haz\";a:8:{s:8:\"language\";s:3:\"haz\";s:7:\"version\";s:6:\"4.4.29\";s:7:\"updated\";s:19:\"2015-12-05 00:59:09\";s:12:\"english_name\";s:8:\"Hazaragi\";s:11:\"native_name\";s:15:\"هزاره گی\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.4.29/haz.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"haz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"ادامه\";}}s:5:\"he_IL\";a:8:{s:8:\"language\";s:5:\"he_IL\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-02 09:16:06\";s:12:\"english_name\";s:6:\"Hebrew\";s:11:\"native_name\";s:16:\"עִבְרִית\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/he_IL.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"he\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"המשך\";}}s:5:\"hi_IN\";a:8:{s:8:\"language\";s:5:\"hi_IN\";s:7:\"version\";s:6:\"5.4.12\";s:7:\"updated\";s:19:\"2020-11-06 12:34:38\";s:12:\"english_name\";s:5:\"Hindi\";s:11:\"native_name\";s:18:\"हिन्दी\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.4.12/hi_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hi\";i:2;s:3:\"hin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"जारी रखें\";}}s:2:\"hr\";a:8:{s:8:\"language\";s:2:\"hr\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-15 19:56:23\";s:12:\"english_name\";s:8:\"Croatian\";s:11:\"native_name\";s:8:\"Hrvatski\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/hr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hr\";i:2;s:3:\"hrv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Nastavi\";}}s:3:\"hsb\";a:8:{s:8:\"language\";s:3:\"hsb\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-07-18 19:40:10\";s:12:\"english_name\";s:13:\"Upper Sorbian\";s:11:\"native_name\";s:17:\"Hornjoserbšćina\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.1.1/hsb.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"hsb\";i:3;s:3:\"hsb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:4:\"Dale\";}}s:5:\"hu_HU\";a:8:{s:8:\"language\";s:5:\"hu_HU\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-09 10:37:58\";s:12:\"english_name\";s:9:\"Hungarian\";s:11:\"native_name\";s:6:\"Magyar\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/hu_HU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hu\";i:2;s:3:\"hun\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Folytatás\";}}s:2:\"hy\";a:8:{s:8:\"language\";s:2:\"hy\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-12-03 16:21:10\";s:12:\"english_name\";s:8:\"Armenian\";s:11:\"native_name\";s:14:\"Հայերեն\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/hy.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"hy\";i:2;s:3:\"hye\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Շարունակել\";}}s:5:\"id_ID\";a:8:{s:8:\"language\";s:5:\"id_ID\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-29 15:17:58\";s:12:\"english_name\";s:10:\"Indonesian\";s:11:\"native_name\";s:16:\"Bahasa Indonesia\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/id_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"id\";i:2;s:3:\"ind\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Lanjutkan\";}}s:5:\"is_IS\";a:8:{s:8:\"language\";s:5:\"is_IS\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2018-12-11 10:40:02\";s:12:\"english_name\";s:9:\"Icelandic\";s:11:\"native_name\";s:9:\"Íslenska\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.9.22/is_IS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"is\";i:2;s:3:\"isl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Áfram\";}}s:5:\"it_IT\";a:8:{s:8:\"language\";s:5:\"it_IT\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-23 17:14:53\";s:12:\"english_name\";s:7:\"Italian\";s:11:\"native_name\";s:8:\"Italiano\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/it_IT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"it\";i:2;s:3:\"ita\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continua\";}}s:2:\"ja\";a:8:{s:8:\"language\";s:2:\"ja\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-06 07:11:58\";s:12:\"english_name\";s:8:\"Japanese\";s:11:\"native_name\";s:9:\"日本語\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/ja.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"ja\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"次へ\";}}s:5:\"jv_ID\";a:8:{s:8:\"language\";s:5:\"jv_ID\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2019-02-16 23:58:56\";s:12:\"english_name\";s:8:\"Javanese\";s:11:\"native_name\";s:9:\"Basa Jawa\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.9.22/jv_ID.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"jv\";i:2;s:3:\"jav\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Nerusaké\";}}s:5:\"ka_GE\";a:8:{s:8:\"language\";s:5:\"ka_GE\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2022-10-24 08:01:09\";s:12:\"english_name\";s:8:\"Georgian\";s:11:\"native_name\";s:21:\"ქართული\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.3/ka_GE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ka\";i:2;s:3:\"kat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"გაგრძელება\";}}s:3:\"kab\";a:8:{s:8:\"language\";s:3:\"kab\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-04 12:58:16\";s:12:\"english_name\";s:6:\"Kabyle\";s:11:\"native_name\";s:9:\"Taqbaylit\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.1.1/kab.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"kab\";i:3;s:3:\"kab\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Kemmel\";}}s:2:\"kk\";a:8:{s:8:\"language\";s:2:\"kk\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2018-07-10 11:35:44\";s:12:\"english_name\";s:6:\"Kazakh\";s:11:\"native_name\";s:19:\"Қазақ тілі\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.9.22/kk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"kk\";i:2;s:3:\"kaz\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Жалғастыру\";}}s:2:\"km\";a:8:{s:8:\"language\";s:2:\"km\";s:7:\"version\";s:6:\"5.2.17\";s:7:\"updated\";s:19:\"2019-06-10 16:18:28\";s:12:\"english_name\";s:5:\"Khmer\";s:11:\"native_name\";s:27:\"ភាសាខ្មែរ\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.2.17/km.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"km\";i:2;s:3:\"khm\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"បន្ត\";}}s:2:\"kn\";a:8:{s:8:\"language\";s:2:\"kn\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-10-20 17:15:28\";s:12:\"english_name\";s:7:\"Kannada\";s:11:\"native_name\";s:15:\"ಕನ್ನಡ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/kn.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"kn\";i:2;s:3:\"kan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"ಮುಂದುವರಿಸು\";}}s:5:\"ko_KR\";a:8:{s:8:\"language\";s:5:\"ko_KR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-21 23:01:12\";s:12:\"english_name\";s:6:\"Korean\";s:11:\"native_name\";s:9:\"한국어\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/ko_KR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ko\";i:2;s:3:\"kor\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"계속\";}}s:3:\"ckb\";a:8:{s:8:\"language\";s:3:\"ckb\";s:7:\"version\";s:5:\"5.8.6\";s:7:\"updated\";s:19:\"2021-12-07 16:32:30\";s:12:\"english_name\";s:16:\"Kurdish (Sorani)\";s:11:\"native_name\";s:13:\"كوردی‎\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.8.6/ckb.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ku\";i:3;s:3:\"ckb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"به‌رده‌وام به‌\";}}s:2:\"lo\";a:8:{s:8:\"language\";s:2:\"lo\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-12 09:59:23\";s:12:\"english_name\";s:3:\"Lao\";s:11:\"native_name\";s:21:\"ພາສາລາວ\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/lo.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lo\";i:2;s:3:\"lao\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"ຕໍ່​ໄປ\";}}s:5:\"lt_LT\";a:8:{s:8:\"language\";s:5:\"lt_LT\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-24 03:51:58\";s:12:\"english_name\";s:10:\"Lithuanian\";s:11:\"native_name\";s:15:\"Lietuvių kalba\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/lt_LT.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lt\";i:2;s:3:\"lit\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Tęsti\";}}s:2:\"lv\";a:8:{s:8:\"language\";s:2:\"lv\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-06 16:38:45\";s:12:\"english_name\";s:7:\"Latvian\";s:11:\"native_name\";s:16:\"Latviešu valoda\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/lv.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"lv\";i:2;s:3:\"lav\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Turpināt\";}}s:5:\"mk_MK\";a:8:{s:8:\"language\";s:5:\"mk_MK\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2022-10-01 09:23:52\";s:12:\"english_name\";s:10:\"Macedonian\";s:11:\"native_name\";s:31:\"Македонски јазик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.0.3/mk_MK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mk\";i:2;s:3:\"mkd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:16:\"Продолжи\";}}s:5:\"ml_IN\";a:8:{s:8:\"language\";s:5:\"ml_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-27 03:43:32\";s:12:\"english_name\";s:9:\"Malayalam\";s:11:\"native_name\";s:18:\"മലയാളം\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/ml_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ml\";i:2;s:3:\"mal\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"തുടരുക\";}}s:2:\"mn\";a:8:{s:8:\"language\";s:2:\"mn\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-02 15:24:05\";s:12:\"english_name\";s:9:\"Mongolian\";s:11:\"native_name\";s:12:\"Монгол\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/mn.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mn\";i:2;s:3:\"mon\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:2:\"mr\";a:8:{s:8:\"language\";s:2:\"mr\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2019-11-22 15:32:08\";s:12:\"english_name\";s:7:\"Marathi\";s:11:\"native_name\";s:15:\"मराठी\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.9.22/mr.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"mr\";i:2;s:3:\"mar\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"सुरु ठेवा\";}}s:5:\"ms_MY\";a:8:{s:8:\"language\";s:5:\"ms_MY\";s:7:\"version\";s:6:\"5.5.11\";s:7:\"updated\";s:19:\"2022-03-11 13:52:22\";s:12:\"english_name\";s:5:\"Malay\";s:11:\"native_name\";s:13:\"Bahasa Melayu\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/5.5.11/ms_MY.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ms\";i:2;s:3:\"msa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Teruskan\";}}s:5:\"my_MM\";a:8:{s:8:\"language\";s:5:\"my_MM\";s:7:\"version\";s:6:\"4.2.34\";s:7:\"updated\";s:19:\"2017-12-26 11:57:10\";s:12:\"english_name\";s:17:\"Myanmar (Burmese)\";s:11:\"native_name\";s:15:\"ဗမာစာ\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.2.34/my_MM.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"my\";i:2;s:3:\"mya\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:54:\"ဆက်လက်လုပ်ဆောင်ပါ။\";}}s:5:\"nb_NO\";a:8:{s:8:\"language\";s:5:\"nb_NO\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-11 01:42:08\";s:12:\"english_name\";s:19:\"Norwegian (Bokmål)\";s:11:\"native_name\";s:13:\"Norsk bokmål\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/nb_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nb\";i:2;s:3:\"nob\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Fortsett\";}}s:5:\"ne_NP\";a:8:{s:8:\"language\";s:5:\"ne_NP\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-25 15:38:17\";s:12:\"english_name\";s:6:\"Nepali\";s:11:\"native_name\";s:18:\"नेपाली\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/ne_NP.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ne\";i:2;s:3:\"nep\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:43:\"जारी राख्नुहोस्\";}}s:12:\"nl_NL_formal\";a:8:{s:8:\"language\";s:12:\"nl_NL_formal\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-05 12:28:58\";s:12:\"english_name\";s:14:\"Dutch (Formal)\";s:11:\"native_name\";s:20:\"Nederlands (Formeel)\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/translation/core/6.1.1/nl_NL_formal.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nl_BE\";a:8:{s:8:\"language\";s:5:\"nl_BE\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-18 13:56:03\";s:12:\"english_name\";s:15:\"Dutch (Belgium)\";s:11:\"native_name\";s:20:\"Nederlands (België)\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/nl_BE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nl_NL\";a:8:{s:8:\"language\";s:5:\"nl_NL\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-17 10:38:45\";s:12:\"english_name\";s:5:\"Dutch\";s:11:\"native_name\";s:10:\"Nederlands\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/nl_NL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nl\";i:2;s:3:\"nld\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Doorgaan\";}}s:5:\"nn_NO\";a:8:{s:8:\"language\";s:5:\"nn_NO\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-03-18 10:59:16\";s:12:\"english_name\";s:19:\"Norwegian (Nynorsk)\";s:11:\"native_name\";s:13:\"Norsk nynorsk\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/nn_NO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"nn\";i:2;s:3:\"nno\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Hald fram\";}}s:3:\"oci\";a:8:{s:8:\"language\";s:3:\"oci\";s:7:\"version\";s:6:\"4.8.21\";s:7:\"updated\";s:19:\"2017-08-25 10:03:08\";s:12:\"english_name\";s:7:\"Occitan\";s:11:\"native_name\";s:7:\"Occitan\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/4.8.21/oci.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"oc\";i:2;s:3:\"oci\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Contunhar\";}}s:5:\"pa_IN\";a:8:{s:8:\"language\";s:5:\"pa_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-16 05:19:43\";s:12:\"english_name\";s:15:\"Panjabi (India)\";s:11:\"native_name\";s:18:\"ਪੰਜਾਬੀ\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/pa_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pa\";i:2;s:3:\"pan\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:25:\"ਜਾਰੀ ਰੱਖੋ\";}}s:5:\"pl_PL\";a:8:{s:8:\"language\";s:5:\"pl_PL\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-27 05:43:37\";s:12:\"english_name\";s:6:\"Polish\";s:11:\"native_name\";s:6:\"Polski\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/pl_PL.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pl\";i:2;s:3:\"pol\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Kontynuuj\";}}s:2:\"ps\";a:8:{s:8:\"language\";s:2:\"ps\";s:7:\"version\";s:6:\"4.3.30\";s:7:\"updated\";s:19:\"2015-12-02 21:41:29\";s:12:\"english_name\";s:6:\"Pashto\";s:11:\"native_name\";s:8:\"پښتو\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.3.30/ps.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ps\";i:2;s:3:\"pus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:19:\"دوام ورکړه\";}}s:10:\"pt_PT_ao90\";a:8:{s:8:\"language\";s:10:\"pt_PT_ao90\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-08-09 12:26:21\";s:12:\"english_name\";s:27:\"Portuguese (Portugal, AO90)\";s:11:\"native_name\";s:17:\"Português (AO90)\";s:7:\"package\";s:69:\"https://downloads.wordpress.org/translation/core/6.1.1/pt_PT_ao90.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_AO\";a:8:{s:8:\"language\";s:5:\"pt_AO\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-10-01 12:16:29\";s:12:\"english_name\";s:19:\"Portuguese (Angola)\";s:11:\"native_name\";s:20:\"Português de Angola\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/pt_AO.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_BR\";a:8:{s:8:\"language\";s:5:\"pt_BR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-08 13:50:14\";s:12:\"english_name\";s:19:\"Portuguese (Brazil)\";s:11:\"native_name\";s:20:\"Português do Brasil\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/pt_BR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"pt\";i:2;s:3:\"por\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:5:\"pt_PT\";a:8:{s:8:\"language\";s:5:\"pt_PT\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-09 08:47:14\";s:12:\"english_name\";s:21:\"Portuguese (Portugal)\";s:11:\"native_name\";s:10:\"Português\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/pt_PT.zip\";s:3:\"iso\";a:1:{i:1;s:2:\"pt\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuar\";}}s:3:\"rhg\";a:8:{s:8:\"language\";s:3:\"rhg\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-16 13:03:18\";s:12:\"english_name\";s:8:\"Rohingya\";s:11:\"native_name\";s:8:\"Ruáinga\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/rhg.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"rhg\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"ro_RO\";a:8:{s:8:\"language\";s:5:\"ro_RO\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-05 04:37:02\";s:12:\"english_name\";s:8:\"Romanian\";s:11:\"native_name\";s:8:\"Română\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/ro_RO.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ro\";i:2;s:3:\"ron\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Continuă\";}}s:5:\"ru_RU\";a:8:{s:8:\"language\";s:5:\"ru_RU\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-24 05:36:29\";s:12:\"english_name\";s:7:\"Russian\";s:11:\"native_name\";s:14:\"Русский\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/ru_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ru\";i:2;s:3:\"rus\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продолжить\";}}s:3:\"sah\";a:8:{s:8:\"language\";s:3:\"sah\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-21 02:06:41\";s:12:\"english_name\";s:5:\"Sakha\";s:11:\"native_name\";s:14:\"Сахалыы\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/sah.zip\";s:3:\"iso\";a:2:{i:2;s:3:\"sah\";i:3;s:3:\"sah\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Салҕаа\";}}s:3:\"snd\";a:8:{s:8:\"language\";s:3:\"snd\";s:7:\"version\";s:6:\"5.4.12\";s:7:\"updated\";s:19:\"2020-07-07 01:53:37\";s:12:\"english_name\";s:6:\"Sindhi\";s:11:\"native_name\";s:8:\"سنڌي\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/translation/core/5.4.12/snd.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"sd\";i:2;s:3:\"snd\";i:3;s:3:\"snd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"اڳتي هلو\";}}s:5:\"si_LK\";a:8:{s:8:\"language\";s:5:\"si_LK\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-12 06:00:52\";s:12:\"english_name\";s:7:\"Sinhala\";s:11:\"native_name\";s:15:\"සිංහල\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/si_LK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"si\";i:2;s:3:\"sin\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:44:\"දිගටම කරගෙන යන්න\";}}s:5:\"sk_SK\";a:8:{s:8:\"language\";s:5:\"sk_SK\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-18 08:25:36\";s:12:\"english_name\";s:6:\"Slovak\";s:11:\"native_name\";s:11:\"Slovenčina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/sk_SK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sk\";i:2;s:3:\"slk\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Pokračovať\";}}s:3:\"skr\";a:8:{s:8:\"language\";s:3:\"skr\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-06 09:43:42\";s:12:\"english_name\";s:7:\"Saraiki\";s:11:\"native_name\";s:14:\"سرائیکی\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/6.1.1/skr.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"skr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:17:\"جاری رکھو\";}}s:5:\"sl_SI\";a:8:{s:8:\"language\";s:5:\"sl_SI\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-11 12:48:55\";s:12:\"english_name\";s:9:\"Slovenian\";s:11:\"native_name\";s:13:\"Slovenščina\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/sl_SI.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sl\";i:2;s:3:\"slv\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Nadaljuj\";}}s:2:\"sq\";a:8:{s:8:\"language\";s:2:\"sq\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-18 19:47:58\";s:12:\"english_name\";s:8:\"Albanian\";s:11:\"native_name\";s:5:\"Shqip\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/sq.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sq\";i:2;s:3:\"sqi\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"Vazhdo\";}}s:5:\"sr_RS\";a:8:{s:8:\"language\";s:5:\"sr_RS\";s:7:\"version\";s:5:\"5.8.6\";s:7:\"updated\";s:19:\"2021-08-01 21:21:06\";s:12:\"english_name\";s:7:\"Serbian\";s:11:\"native_name\";s:23:\"Српски језик\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/5.8.6/sr_RS.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sr\";i:2;s:3:\"srp\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:14:\"Настави\";}}s:5:\"sv_SE\";a:8:{s:8:\"language\";s:5:\"sv_SE\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-10 22:13:59\";s:12:\"english_name\";s:7:\"Swedish\";s:11:\"native_name\";s:7:\"Svenska\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/sv_SE.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sv\";i:2;s:3:\"swe\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:9:\"Fortsätt\";}}s:2:\"sw\";a:8:{s:8:\"language\";s:2:\"sw\";s:7:\"version\";s:6:\"5.3.14\";s:7:\"updated\";s:19:\"2019-10-13 15:35:35\";s:12:\"english_name\";s:7:\"Swahili\";s:11:\"native_name\";s:9:\"Kiswahili\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.3.14/sw.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"sw\";i:2;s:3:\"swa\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:7:\"Endelea\";}}s:3:\"szl\";a:8:{s:8:\"language\";s:3:\"szl\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-09-24 19:58:14\";s:12:\"english_name\";s:8:\"Silesian\";s:11:\"native_name\";s:17:\"Ślōnskŏ gŏdka\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/szl.zip\";s:3:\"iso\";a:1:{i:3;s:3:\"szl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:13:\"Kōntynuować\";}}s:5:\"ta_IN\";a:8:{s:8:\"language\";s:5:\"ta_IN\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-27 03:22:47\";s:12:\"english_name\";s:5:\"Tamil\";s:11:\"native_name\";s:15:\"தமிழ்\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/ta_IN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ta\";i:2;s:3:\"tam\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:24:\"தொடரவும்\";}}s:5:\"ta_LK\";a:8:{s:8:\"language\";s:5:\"ta_LK\";s:7:\"version\";s:6:\"4.2.34\";s:7:\"updated\";s:19:\"2015-12-03 01:07:44\";s:12:\"english_name\";s:17:\"Tamil (Sri Lanka)\";s:11:\"native_name\";s:15:\"தமிழ்\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.2.34/ta_LK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ta\";i:2;s:3:\"tam\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:18:\"தொடர்க\";}}s:2:\"te\";a:8:{s:8:\"language\";s:2:\"te\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2017-01-26 15:47:39\";s:12:\"english_name\";s:6:\"Telugu\";s:11:\"native_name\";s:18:\"తెలుగు\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/4.7.2/te.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"te\";i:2;s:3:\"tel\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:30:\"కొనసాగించు\";}}s:2:\"th\";a:8:{s:8:\"language\";s:2:\"th\";s:7:\"version\";s:5:\"5.8.6\";s:7:\"updated\";s:19:\"2022-06-08 04:30:30\";s:12:\"english_name\";s:4:\"Thai\";s:11:\"native_name\";s:9:\"ไทย\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/5.8.6/th.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"th\";i:2;s:3:\"tha\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:15:\"ต่อไป\";}}s:2:\"tl\";a:8:{s:8:\"language\";s:2:\"tl\";s:7:\"version\";s:6:\"4.8.21\";s:7:\"updated\";s:19:\"2017-09-30 09:04:29\";s:12:\"english_name\";s:7:\"Tagalog\";s:11:\"native_name\";s:7:\"Tagalog\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.8.21/tl.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tl\";i:2;s:3:\"tgl\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:10:\"Magpatuloy\";}}s:5:\"tr_TR\";a:8:{s:8:\"language\";s:5:\"tr_TR\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2023-01-04 13:32:22\";s:12:\"english_name\";s:7:\"Turkish\";s:11:\"native_name\";s:8:\"Türkçe\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/tr_TR.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tr\";i:2;s:3:\"tur\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:5:\"Devam\";}}s:5:\"tt_RU\";a:8:{s:8:\"language\";s:5:\"tt_RU\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-11-20 20:20:50\";s:12:\"english_name\";s:5:\"Tatar\";s:11:\"native_name\";s:19:\"Татар теле\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/4.7.2/tt_RU.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"tt\";i:2;s:3:\"tat\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:17:\"дәвам итү\";}}s:3:\"tah\";a:8:{s:8:\"language\";s:3:\"tah\";s:7:\"version\";s:5:\"4.7.2\";s:7:\"updated\";s:19:\"2016-03-06 18:39:39\";s:12:\"english_name\";s:8:\"Tahitian\";s:11:\"native_name\";s:10:\"Reo Tahiti\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/4.7.2/tah.zip\";s:3:\"iso\";a:3:{i:1;s:2:\"ty\";i:2;s:3:\"tah\";i:3;s:3:\"tah\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:8:\"Continue\";}}s:5:\"ug_CN\";a:8:{s:8:\"language\";s:5:\"ug_CN\";s:7:\"version\";s:6:\"4.9.22\";s:7:\"updated\";s:19:\"2021-07-03 18:41:33\";s:12:\"english_name\";s:6:\"Uighur\";s:11:\"native_name\";s:16:\"ئۇيغۇرچە\";s:7:\"package\";s:65:\"https://downloads.wordpress.org/translation/core/4.9.22/ug_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ug\";i:2;s:3:\"uig\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:26:\"داۋاملاشتۇرۇش\";}}s:2:\"uk\";a:8:{s:8:\"language\";s:2:\"uk\";s:7:\"version\";s:5:\"6.0.3\";s:7:\"updated\";s:19:\"2022-09-11 15:51:48\";s:12:\"english_name\";s:9:\"Ukrainian\";s:11:\"native_name\";s:20:\"Українська\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.0.3/uk.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uk\";i:2;s:3:\"ukr\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:20:\"Продовжити\";}}s:2:\"ur\";a:8:{s:8:\"language\";s:2:\"ur\";s:7:\"version\";s:6:\"5.4.12\";s:7:\"updated\";s:19:\"2020-04-09 11:17:33\";s:12:\"english_name\";s:4:\"Urdu\";s:11:\"native_name\";s:8:\"اردو\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/translation/core/5.4.12/ur.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"ur\";i:2;s:3:\"urd\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:19:\"جاری رکھیں\";}}s:5:\"uz_UZ\";a:8:{s:8:\"language\";s:5:\"uz_UZ\";s:7:\"version\";s:8:\"5.8-beta\";s:7:\"updated\";s:19:\"2021-02-28 12:02:22\";s:12:\"english_name\";s:5:\"Uzbek\";s:11:\"native_name\";s:11:\"O‘zbekcha\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/translation/core/5.8-beta/uz_UZ.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"uz\";i:2;s:3:\"uzb\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:11:\"Davom etish\";}}s:2:\"vi\";a:8:{s:8:\"language\";s:2:\"vi\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-17 10:13:02\";s:12:\"english_name\";s:10:\"Vietnamese\";s:11:\"native_name\";s:14:\"Tiếng Việt\";s:7:\"package\";s:61:\"https://downloads.wordpress.org/translation/core/6.1.1/vi.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"vi\";i:2;s:3:\"vie\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:12:\"Tiếp tục\";}}s:5:\"zh_HK\";a:8:{s:8:\"language\";s:5:\"zh_HK\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-07-15 15:25:03\";s:12:\"english_name\";s:19:\"Chinese (Hong Kong)\";s:11:\"native_name\";s:12:\"香港中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/zh_HK.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_TW\";a:8:{s:8:\"language\";s:5:\"zh_TW\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-11-15 22:21:52\";s:12:\"english_name\";s:16:\"Chinese (Taiwan)\";s:11:\"native_name\";s:12:\"繁體中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/zh_TW.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"繼續\";}}s:5:\"zh_CN\";a:8:{s:8:\"language\";s:5:\"zh_CN\";s:7:\"version\";s:5:\"6.1.1\";s:7:\"updated\";s:19:\"2022-12-18 06:20:30\";s:12:\"english_name\";s:15:\"Chinese (China)\";s:11:\"native_name\";s:12:\"简体中文\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/translation/core/6.1.1/zh_CN.zip\";s:3:\"iso\";a:2:{i:1;s:2:\"zh\";i:2;s:3:\"zho\";}s:7:\"strings\";a:1:{s:8:\"continue\";s:6:\"继续\";}}}", "no");
INSERT INTO `wp_options` VALUES("56487", "_transient_timeout_wpseo_total_unindexed_post_type_archives", "1674187617", "no");
INSERT INTO `wp_options` VALUES("56488", "_transient_wpseo_total_unindexed_post_type_archives", "0", "no");
INSERT INTO `wp_options` VALUES("56489", "_transient_timeout_wpseo_total_unindexed_general_items", "1674187617", "no");
INSERT INTO `wp_options` VALUES("56490", "_transient_wpseo_total_unindexed_general_items", "0", "no");
INSERT INTO `wp_options` VALUES("56491", "_transient_timeout_wpseo_unindexed_post_link_count", "1674187617", "no");
INSERT INTO `wp_options` VALUES("56492", "_transient_wpseo_unindexed_post_link_count", "0", "no");
INSERT INTO `wp_options` VALUES("56493", "_transient_timeout_wpseo_unindexed_term_link_count", "1674187617", "no");
INSERT INTO `wp_options` VALUES("56494", "_transient_wpseo_unindexed_term_link_count", "0", "no");
INSERT INTO `wp_options` VALUES("56495", "_site_transient_timeout_browser_74d5eb630041ee79001b13f406ccf23b", "1674706017", "no");
INSERT INTO `wp_options` VALUES("56496", "_site_transient_browser_74d5eb630041ee79001b13f406ccf23b", "a:10:{s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"96.0.4664.174\";s:8:\"platform\";s:7:\"Windows\";s:10:\"update_url\";s:29:\"https://www.google.com/chrome\";s:7:\"img_src\";s:43:\"http://s.w.org/images/browsers/chrome.png?1\";s:11:\"img_src_ssl\";s:44:\"https://s.w.org/images/browsers/chrome.png?1\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;s:6:\"mobile\";b:0;}", "no");
INSERT INTO `wp_options` VALUES("56499", "_site_transient_timeout_theme_roots", "1674104319", "no");
INSERT INTO `wp_options` VALUES("56500", "_site_transient_theme_roots", "a:2:{s:17:\"twentytwentythree\";s:7:\"/themes\";s:6:\"virtue\";s:7:\"/themes\";}", "no");
INSERT INTO `wp_options` VALUES("56501", "_site_transient_timeout_wp_remote_block_patterns_3836d69e75c3590c57e721b58798e919", "1674104878", "no");
INSERT INTO `wp_options` VALUES("56502", "_site_transient_wp_remote_block_patterns_3836d69e75c3590c57e721b58798e919", "a:44:{i:0;O:8:\"stdClass\":7:{s:2:\"id\";i:231639;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:22:\"Header with hero image\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1343:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-group alignfull is-content-justification-space-between is-layout-flex wp-container-3\" style=\"padding-top:1em;padding-right:1em;padding-bottom:0em;padding-left:1em\">\n<div class=\"wp-block-group is-layout-flex\"><div class=\"wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n<h1 class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n\n\n</div>\n\n\n\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:490px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-0 has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-19-fog-lifts-up-after-raind.jpg?w=1200&amp;h=1200&amp;fit=clip&amp;crop=default&amp;dpr=1&amp;q=75&amp;vib=3&amp;con=3&amp;usm=15&amp;cs=srgb&amp;bg=F4F4F3&amp;ixlib=js-2.2.1&amp;s=f60b088dac6c7cc04eeebf67f600e079\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<p class=\"has-text-align-center has-large-font-size\"></p>\n</div></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:65:\"Header on a white background followed by a full-width hero image.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:83:\"core/cover,core/group,core/navigation,core/paragraph,core/site-logo,core/site-title\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"header\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1969:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"0em\",\"top\":\"1em\",\"right\":\"1em\",\"left\":\"1em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:1em;padding-right:1em;padding-bottom:0em;padding-left:1em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-logo {\"width\":60} /-->\n\n<!-- wp:site-title {\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:cover {\"url\":\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-19-fog-lifts-up-after-raind.jpg?w=1200&h=1200&fit=clip&crop=default&dpr=1&q=75&vib=3&con=3&usm=15&cs=srgb&bg=F4F4F3&ixlib=js-2.2.1&s=f60b088dac6c7cc04eeebf67f600e079\",\"id\":null,\"dimRatio\":0,\"minHeight\":490,\"minHeightUnit\":\"px\",\"isDark\":false,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:490px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-0 has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-19-fog-lifts-up-after-raind.jpg?w=1200&amp;h=1200&amp;fit=clip&amp;crop=default&amp;dpr=1&amp;q=75&amp;vib=3&amp;con=3&amp;usm=15&amp;cs=srgb&amp;bg=F4F4F3&amp;ixlib=js-2.2.1&amp;s=f60b088dac6c7cc04eeebf67f600e079\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:paragraph {\"align\":\"center\",\"placeholder\":\"Saisissez un titre...\",\"fontSize\":\"large\"} -->\n<p class=\"has-text-align-center has-large-font-size\"></p>\n<!-- /wp:paragraph --></div></div>\n<!-- /wp:cover --></div>\n<!-- /wp:group -->\";}i:1;O:8:\"stdClass\":7:{s:2:\"id\";i:4952;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:41:\"Trois colonnes avec des images décalées\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1179:\"\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-8\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:25%\">\n<figure class=\"wp-block-image size-large is-style-default\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-01.jpg\" alt=\"Vue de près d’un détail architectural.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:25%\">\n<div style=\"height:500px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div style=\"height:150px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-02.jpg\" alt=\"Détail d’une fenêtre d’un immeuble blanc.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:45%\">\n<figure class=\"wp-block-image size-large is-style-default\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-03.jpg\" alt=\"Détail du coin d’un immeuble blanc avec des points saillants et des coins arrondis.\" /></figure>\n\n\n\n<div style=\"height:285px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:50:\"Trois colonnes avec des images ayant un décalage.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:47:\"core/column,core/columns,core/image,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"gallery\";i:1;s:6:\"images\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1729:\"<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"25%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:25%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-large is-style-default\"><img src=\"https://s.w.org/images/core/5.8/architecture-01.jpg\" alt=\"Vue de près d’un détail architectural.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"25%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:25%\"><!-- wp:spacer {\"height\":500} -->\n<div style=\"height:500px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:spacer {\"height\":150} -->\n<div style=\"height:150px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/architecture-02.jpg\" alt=\"Détail d’une fenêtre d’un immeuble blanc.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"45%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:45%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-large is-style-default\"><img src=\"https://s.w.org/images/core/5.8/architecture-03.jpg\" alt=\"Détail du coin d’un immeuble blanc avec des points saillants et des coins arrondis.\" /></figure>\n<!-- /wp:image -->\n\n<!-- wp:spacer {\"height\":285} -->\n<div style=\"height:285px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:2;O:8:\"stdClass\":7:{s:2:\"id\";i:1320;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:23:\"Trois colonnes de texte\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1020:\"\n<div class=\"wp-block-columns alignfull has-text-color has-background is-layout-flex wp-container-12\" style=\"background-color:#ffffff;color:#000000\">\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Visite virtuelle ↗</a></strong></h3>\n\n\n\n<p>Parcourez le musée depuis votre ordinateur. Idéal pour les écoles et les événements.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Expos actuelles ↗</a></strong></h3>\n\n\n\n<p>Suivez nos actualités et parcourez nos expositions en cours ici.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Infos utiles ↗</a></strong></h3>\n\n\n\n<p>Découvrez nos horaires d’ouverture, les prix des billets et les réductions.</p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:24:\"Trois colonnes de texte.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:52:\"core/column,core/columns,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1564:\"<!-- wp:columns {\"align\":\"full\",\"style\":{\"color\":{\"text\":\"#000000\",\"background\":\"#ffffff\"}}} -->\n<div class=\"wp-block-columns alignfull has-text-color has-background\" style=\"background-color:#ffffff;color:#000000\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Visite virtuelle ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Parcourez le musée depuis votre ordinateur. Idéal pour les écoles et les événements.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Expos actuelles ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Suivez nos actualités et parcourez nos expositions en cours ici.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Infos utiles ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Découvrez nos horaires d’ouverture, les prix des billets et les réductions.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:3;O:8:\"stdClass\":7:{s:2:\"id\";i:1321;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:35:\"Trois colonnes avec images et texte\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:3028:\"\n<div class=\"wp-block-group alignfull has-background is-layout-flow\" style=\"background-color:#f8f4e4\">\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-14\">\n<div class=\"wp-block-column is-layout-flow\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h6 class=\"has-text-color wp-block-heading\" id=\"ecosystem\" style=\"color:#000000\">ÉCOSYSTÈME</h6>\n\n\n\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Croissance positive.</strong></p>\n\n\n\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-18\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.38%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>La Nature</em>, dans le sens courant, désigne les essences inchangées par l’homme ; l’espace, l’air, le fleuve, la feuille.&nbsp;<em>L’Art</em>&nbsp;s’applique au mélange de sa volonté avec les mêmes choses, comme dans une maison, un canal, une statue, un tableau. Mais ses opérations prises ensemble sont si insignifiantes, un peu d’écaillage, de cuisson, de rapiéçage, de lavage, que dans une impression aussi grandiose que celle du monde sur l’esprit humain, elles ne changent pas le résultat.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33%\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"Le soleil se couchant derrière une forêt dense.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.62%\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Des éoliennes se tiennent sur une plaine herbeuse, avec un ciel bleu en arrière-plan.\" /></figure>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-21\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:67%\">\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"Le soleil brille au dessus d’une crête donnant sur le bord de mer. Plus loin, une voiture est visible.\" /></figure></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\" style=\"flex-basis:33%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Sans doute n’avons-nous pas de questions à poser qui soient sans réponse. Nous devons faire confiance à la perfection de la création au point de croire que, quelle que soit la curiosité que l’ordre des choses a éveillée dans notre esprit, l’ordre des choses peut la satisfaire. La condition de chaque homme est une solution en hiéroglyphes aux questions qu’il poserait.</p>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:96:\"Trois colonnes avec des images et du texte, avec un espacement vertical pour un aspect décalé.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:86:\"core/column,core/columns,core/group,core/heading,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:4184:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#f8f4e4\"}}} -->\n<div class=\"wp-block-group alignfull has-background\" style=\"background-color:#f8f4e4\"><!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:heading {\"level\":6,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h6 class=\"has-text-color\" id=\"ecosystem\" style=\"color:#000000\">ÉCOSYSTÈME</h6>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"5vw\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Croissance positive.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:spacer {\"height\":\"5px\"} -->\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"33.38%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.38%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>La Nature</em>, dans le sens courant, désigne les essences inchangées par l’homme ; l’espace, l’air, le fleuve, la feuille.&nbsp;<em>L’Art</em>&nbsp;s’applique au mélange de sa volonté avec les mêmes choses, comme dans une maison, un canal, une statue, un tableau. Mais ses opérations prises ensemble sont si insignifiantes, un peu d’écaillage, de cuisson, de rapiéçage, de lavage, que dans une impression aussi grandiose que celle du monde sur l’esprit humain, elles ne changent pas le résultat.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33%\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"Le soleil se couchant derrière une forêt dense.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33.62%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.62%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Des éoliennes se tiennent sur une plaine herbeuse, avec un ciel bleu en arrière-plan.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"67%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:67%\"><!-- wp:image {\"align\":\"right\",\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"Le soleil brille au dessus d’une crête donnant sur le bord de mer. Plus loin, une voiture est visible.\" /></figure></div>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"width\":\"33%\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\" style=\"flex-basis:33%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Sans doute n’avons-nous pas de questions à poser qui soient sans réponse. Nous devons faire confiance à la perfection de la création au point de croire que, quelle que soit la curiosité que l’ordre des choses a éveillée dans notre esprit, l’ordre des choses peut la satisfaire. La condition de chaque homme est une solution en hiéroglyphes aux questions qu’il poserait.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:group -->\";}i:4;O:8:\"stdClass\":7:{s:2:\"id\";i:1322;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:48:\"Deux colonnes de texte avec des titres décalés\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:2188:\"\n<div class=\"wp-block-group alignfull has-background is-layout-flow\" style=\"background-color:#f2f0e9\">\n<div style=\"height:70px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center is-layout-flex wp-container-25\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\">\n<p class=\"has-text-color\" style=\"color:#000000;font-size:30px;line-height:1.1\"><strong>Inspiration océanique</strong></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\">\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-29\">\n<div class=\"wp-block-column is-layout-flow\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Enroulant des voiles autour de leurs têtes, les femmes marchèrent sur le pont. Ils descendaient maintenant progressivement le fleuve, dépassant les formes sombres des navires à l’ancre, et Londres était un fourmillement de lumières avec une voûte jaune pâle qui tombait au-dessus. Il y avait les lumières des grands théâtres, les lumières des longues rues, les lumières qui indiquaient d’immenses espaces de confort domestique, les lumières qui pendaient haut dans l’air.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Aucune obscurité ne s’installerait jamais sur ces lampes, comme aucune obscurité ne s’était installée sur elles depuis des centaines d’années. Il semblait effrayant que la ville flambât à jamais au même endroit ; effrayant du moins pour les gens qui partaient à l’aventure sur la mer, et qui la voyaient comme un monticule circonscrit, éternellement brûlé, éternellement balafré. Du pont du navire, la grande ville apparaissait comme une figure recroquevillée et frêle, un miséreux sédentaire.</p>\n</div>\n</div>\n\n\n\n<div style=\"height:40px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:46:\"Deux colonnes de texte avec un titre décalé.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:77:\"core/column,core/columns,core/group,core/paragraph,core/separator,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:3036:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#f2f0e9\"}}} -->\n<div class=\"wp-block-group alignfull has-background\" style=\"background-color:#f2f0e9\"><!-- wp:spacer {\"height\":70} -->\n<div style=\"height:70px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"verticalAlignment\":\"center\",\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center\"><!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"30px\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:30px;line-height:1.1\"><strong>Inspiration océanique</strong></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:separator {\"customColor\":\"#000000\",\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n<!-- /wp:separator --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Enroulant des voiles autour de leurs têtes, les femmes marchèrent sur le pont. Ils descendaient maintenant progressivement le fleuve, dépassant les formes sombres des navires à l’ancre, et Londres était un fourmillement de lumières avec une voûte jaune pâle qui tombait au-dessus. Il y avait les lumières des grands théâtres, les lumières des longues rues, les lumières qui indiquaient d’immenses espaces de confort domestique, les lumières qui pendaient haut dans l’air.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Aucune obscurité ne s’installerait jamais sur ces lampes, comme aucune obscurité ne s’était installée sur elles depuis des centaines d’années. Il semblait effrayant que la ville flambât à jamais au même endroit ; effrayant du moins pour les gens qui partaient à l’aventure sur la mer, et qui la voyaient comme un monticule circonscrit, éternellement brûlé, éternellement balafré. Du pont du navire, la grande ville apparaissait comme une figure recroquevillée et frêle, un miséreux sédentaire.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":40} -->\n<div style=\"height:40px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:group -->\";}i:5;O:8:\"stdClass\":7:{s:2:\"id\";i:1323;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:82:\"Média et texte dans un conteneur prenant la totalité de la hauteur de l’écran\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1479:\"\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-100 has-background-dim\" style=\"background-color:#ffffff\"></span><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center is-image-fill\" style=\"grid-template-columns:56% auto\"><figure class=\"wp-block-media-text__media\" style=\"background-image:url(https://s.w.org/images/core/5.8/soil.jpg);background-position:50% 50%\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/soil.jpg\" alt=\"Détail d’une terre sèche, craquelée.\" /></figure><div class=\"wp-block-media-text__content\">\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000;font-size:32px\"><strong>Quel est le problème ?</strong></h2>\n\n\n\n<p class=\"has-text-color\" style=\"color:#000000;font-size:17px\">Les arbres sont aujourd’hui plus importants que jamais. Plus de 10 000 produits seraient fabriqués à partir d’arbres. Les procédés chimiques permettent à l’humble tas de bois de produire des substances synthétiques, des plastiques et des tissus qui dépassaient l’entendement lorsqu’une hache a abattu pour la première fois un arbre du Texas.</p>\n\n\n\n<div class=\"wp-block-buttons is-layout-flex\">\n<div class=\"wp-block-button is-style-fill\"><a class=\"wp-block-button__link wp-element-button\">EN SAVOIR PLUS</a></div>\n</div>\n</div></div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:90:\"Bloc média et bloc texte, avec l’image à gauche et le texte à droite, dont un bouton.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:79:\"core/button,core/buttons,core/cover,core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"banner\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:2132:\"<!-- wp:cover {\"customOverlayColor\":\"#ffffff\",\"minHeight\":100,\"minHeightUnit\":\"vh\",\"contentPosition\":\"center center\",\"isDark\":false,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-100 has-background-dim\" style=\"background-color:#ffffff\"></span><div class=\"wp-block-cover__inner-container\"><!-- wp:media-text {\"mediaLink\":\"https://s.w.org/images/core/5.8/soil.jpg\",\"mediaType\":\"image\",\"mediaWidth\":56,\"verticalAlignment\":\"center\",\"imageFill\":true} -->\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center is-image-fill\" style=\"grid-template-columns:56% auto\"><figure class=\"wp-block-media-text__media\" style=\"background-image:url(https://s.w.org/images/core/5.8/soil.jpg);background-position:50% 50%\"><img src=\"https://s.w.org/images/core/5.8/soil.jpg\" alt=\"Détail d’une terre sèche, craquelée.\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"32px\"},\"color\":{\"text\":\"#000000\"}}} -->\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000;font-size:32px\"><strong>Quel est le problème ?</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"17px\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:17px\">Les arbres sont aujourd’hui plus importants que jamais. Plus de 10 000 produits seraient fabriqués à partir d’arbres. Les procédés chimiques permettent à l’humble tas de bois de produire des substances synthétiques, des plastiques et des tissus qui dépassaient l’entendement lorsqu’une hache a abattu pour la première fois un arbre du Texas.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:buttons -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"className\":\"is-style-fill\"} -->\n<div class=\"wp-block-button is-style-fill\"><a class=\"wp-block-button__link wp-element-button\">EN SAVOIR PLUS</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div></div>\n<!-- /wp:media-text --></div></div>\n<!-- /wp:cover -->\";}i:6;O:8:\"stdClass\":7:{s:2:\"id\";i:1803;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:40:\"Média et texte avec image sur la droite\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:734:\"\n<div class=\"wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center is-style-default\" style=\"grid-template-columns:auto 56%\"><div class=\"wp-block-media-text__content\">\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000\"><strong>Rivage avec une mer bleue</strong></h2>\n\n\n\n<p class=\"has-text-color\" style=\"color:#636363;font-size:17px;line-height:1.1\">Eleanor Harris (Américaine, 1901-1942)</p>\n</div><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/art-02.jpg\" alt=\"Un paysage vert et marron avec un océan bleu brillant et un ciel plutôt nuageux, réalisé à la peinture à l’huile.\" /></figure></div>\n\n\n\n<p></p>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:74:\"Bloc média et bloc texte, avec l’image à droite et le texte à gauche.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:43:\"core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"banner\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1170:\"<!-- wp:media-text {\"align\":\"full\",\"mediaPosition\":\"right\",\"mediaLink\":\"#\",\"mediaType\":\"image\",\"mediaWidth\":56,\"verticalAlignment\":\"center\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center is-style-default\" style=\"grid-template-columns:auto 56%\"><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000\"><strong>Rivage avec une mer bleue</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"17px\"},\"color\":{\"text\":\"#636363\"}}} -->\n<p class=\"has-text-color\" style=\"color:#636363;font-size:17px;line-height:1.1\">Eleanor Harris (Américaine, 1901-1942)</p>\n<!-- /wp:paragraph --></div><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/images/core/5.8/art-02.jpg\" alt=\"Un paysage vert et marron avec un océan bleu brillant et un ciel plutôt nuageux, réalisé à la peinture à l’huile.\" /></figure></div>\n<!-- /wp:media-text -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\";}i:7;O:8:\"stdClass\":7:{s:2:\"id\";i:1355;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:40:\"Média et texte avec image sur la gauche\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:568:\"\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Vue de près d’un détail architectural.\" /></figure><div class=\"wp-block-media-text__content\">\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Espaces ouverts</strong></h3>\n\n\n\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">Voir l’étude de cas ↗</a></p>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:74:\"Bloc média et bloc texte, avec l’image à gauche et le texte à droite.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:43:\"core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:858:\"<!-- wp:media-text {\"align\":\"full\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Vue de près d’un détail architectural.\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"textAlign\":\"center\",\"level\":3,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Espaces ouverts</strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">Voir l’étude de cas ↗</a></p>\n<!-- /wp:paragraph --></div></div>\n<!-- /wp:media-text -->\";}i:8;O:8:\"stdClass\":7:{s:2:\"id\";i:1324;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:35:\"Large en-tête avec texte et bouton\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1368:\"\n<div class=\"wp-block-cover alignfull has-parallax\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-40 has-background-dim\" style=\"background-color:#000000\"></span><div role=\"img\" class=\"wp-block-cover__image-background has-parallax\" style=\"background-position:50% 50%;background-image:url(https://s.w.org/images/core/5.8/art-01.jpg)\"></div><div class=\"wp-block-cover__inner-container\">\n<h2 class=\"wp-block-heading alignwide has-white-color has-text-color\" style=\"font-size:48px;line-height:1.2\"><strong><em>Outre-mer :</em></strong><br><strong><em>de 1500 à 1960</em></strong></h2>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-35\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:60%\">\n<p class=\"has-text-color\" style=\"color:#ffffff\">Une exposition sur les différentes représentations de l’océan à travers le temps, entre le seizième et le vingtième siècle. Elle se déroule dans notre salle ouverte au <em>deuxième étage</em>.</p>\n\n\n\n<div class=\"wp-block-buttons is-layout-flex\">\n<div class=\"wp-block-button is-style-outline\"><a class=\"wp-block-button__link has-text-color has-background wp-element-button\" style=\"color:#ffffff;background-color:#000000\">Visitez</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:84:\"Une grande en-tête avec une image d’arrière-plan, un texte et un bouton en haut.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:88:\"core/button,core/buttons,core/column,core/columns,core/cover,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"banner\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:2085:\"<!-- wp:cover {\"url\":\"https://s.w.org/images/core/5.8/art-01.jpg\",\"hasParallax\":true,\"dimRatio\":40,\"customOverlayColor\":\"#000000\",\"minHeight\":100,\"minHeightUnit\":\"vh\",\"contentPosition\":\"center center\",\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull has-parallax\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-40 has-background-dim\" style=\"background-color:#000000\"></span><div role=\"img\" class=\"wp-block-cover__image-background has-parallax\" style=\"background-position:50% 50%;background-image:url(https://s.w.org/images/core/5.8/art-01.jpg)\"></div><div class=\"wp-block-cover__inner-container\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"48px\",\"lineHeight\":\"1.2\"}},\"className\":\"alignwide has-white-color has-text-color\"} -->\n<h2 class=\"wp-block-heading alignwide has-white-color has-text-color\" style=\"font-size:48px;line-height:1.2\"><strong><em>Outre-mer :</em></strong><br><strong><em>de 1500 à 1960</em></strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"60%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:60%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#ffffff\"}}} -->\n<p class=\"has-text-color\" style=\"color:#ffffff\">Une exposition sur les différentes représentations de l’océan à travers le temps, entre le seizième et le vingtième siècle. Elle se déroule dans notre salle ouverte au <em>deuxième étage</em>.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:buttons -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"style\":{\"color\":{\"text\":\"#ffffff\",\"background\":\"#000000\"}},\"className\":\"is-style-outline\"} -->\n<div class=\"wp-block-button is-style-outline\"><a class=\"wp-block-button__link has-text-color has-background wp-element-button\" style=\"color:#ffffff;background-color:#000000\">Visitez</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div></div>\n<!-- /wp:cover -->\";}i:9;O:8:\"stdClass\":7:{s:2:\"id\";i:1325;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:44:\"Large en-tête avec texte aligné à gauche.\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1260:\"\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forêt.</h2>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-38\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:55%\">\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Même un enfant sait combien la forêt est précieuse. L’odeur fraîche des arbres, à vous couper le souffle. L’écho des oiseaux volant au-dessus de cette magnitude dense. Un climat stable, une vie durable et diversifiée et une source de culture. Pourtant, les forêts et d’autres écosystèmes sont en péril, menacés de devenir des terres de culture, des pâturages ou des plantations.</em></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:35:\"Bannière avec une citation en haut\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/column,core/columns,core/cover,core/heading,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1777:\"<!-- wp:cover {\"url\":\"https://s.w.org/images/core/5.8/forest.jpg\",\"dimRatio\":60,\"minHeight\":800,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:heading {\"align\":\"wide\",\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"fontSize\":\"64px\"}}} -->\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forêt.</h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"55%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:55%\"><!-- wp:spacer {\"height\":\"330px\"} -->\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"lineHeight\":\"1.3\",\"fontSize\":\"12px\"}}} -->\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Même un enfant sait combien la forêt est précieuse. L’odeur fraîche des arbres, à vous couper le souffle. L’écho des oiseaux volant au-dessus de cette magnitude dense. Un climat stable, une vie durable et diversifiée et une source de culture. Pourtant, les forêts et d’autres écosystèmes sont en péril, menacés de devenir des terres de culture, des pâturages ou des plantations.</em></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div></div>\n<!-- /wp:cover -->\";}i:10;O:8:\"stdClass\":7:{s:2:\"id\";i:1326;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:5:\"Titre\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:608:\"\n<h2 class=\"alignwide wp-block-heading\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">Nous sommes un studio situé à Berlin, avec une forte expérience internationale dans les domaines de l’architecture, de l’urbanisme et de l’aménagement intérieur. Nous croyons au partage des connaissances et à la promotion du dialogue pour accroître le potentiel créatif de la collaboration.</h2>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:18:\"grand texte, titre\";s:16:\"wpop_description\";s:14:\"Texte du titre\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:12:\"core/heading\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:12:\"core/heading\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:709:\"<!-- wp:heading {\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"48px\",\"lineHeight\":\"1.1\"}}} -->\n<h2 class=\"alignwide\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">Nous sommes un studio situé à Berlin, avec une forte expérience internationale dans les domaines de l’architecture, de l’urbanisme et de l’aménagement intérieur. Nous croyons au partage des connaissances et à la promotion du dialogue pour accroître le potentiel créatif de la collaboration.</h2>\n<!-- /wp:heading -->\";}i:11;O:8:\"stdClass\":7:{s:2:\"id\";i:1332;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:8:\"citation\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:688:\"\n<hr class=\"wp-block-separator is-style-default\" />\n\n\n\n<div class=\"wp-block-image is-style-rounded\"><figure class=\"aligncenter size-large is-resized\"><img decoding=\"async\" loading=\"lazy\" src=\"https://s.w.org/images/core/5.8/portrait.jpg\" alt=\"Un portrait de profil d’une femme portant un pull à col roulé ocre et un sac blanc. Elle regarde en l’air et ferme les yeux.\" width=\"150\" height=\"150\" /></figure></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center is-style-large\"><p>« Contribuer me donne l’impression d’être utile à la planète »</p><cite>— Anna Wong, <em>Bénévole</em></cite></blockquote>\n\n\n\n<hr class=\"wp-block-separator is-style-default\" />\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:10:\"core/quote\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:36:\"core/image,core/quote,core/separator\";}s:14:\"category_slugs\";a:1:{i:0;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1045:\"<!-- wp:separator {\"className\":\"is-style-default\"} -->\n<hr class=\"wp-block-separator is-style-default\" />\n<!-- /wp:separator -->\n\n<!-- wp:image {\"align\":\"center\",\"width\":150,\"height\":150,\"sizeSlug\":\"large\",\"linkDestination\":\"none\",\"className\":\"is-style-rounded\"} -->\n<div class=\"wp-block-image is-style-rounded\"><figure class=\"aligncenter size-large is-resized\"><img src=\"https://s.w.org/images/core/5.8/portrait.jpg\" alt=\"Un portrait de profil d’une femme portant un pull à col roulé ocre et un sac blanc. Elle regarde en l’air et ferme les yeux.\" width=\"150\" height=\"150\" /></figure></div>\n<!-- /wp:image -->\n\n<!-- wp:quote {\"align\":\"center\",\"className\":\"is-style-large\"} -->\n<blockquote class=\"wp-block-quote has-text-align-center is-style-large\"><p>« Contribuer me donne l’impression d’être utile à la planète »</p><cite>— Anna Wong, <em>Bénévole</em></cite></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:separator {\"className\":\"is-style-default\"} -->\n<hr class=\"wp-block-separator is-style-default\" />\n<!-- /wp:separator -->\";}i:12;O:8:\"stdClass\":7:{s:2:\"id\";i:1334;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:31:\"Deux colonnes de texte et titre\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1595:\"\n<h2 class=\"wp-block-heading\" style=\"font-size:38px;line-height:1.4\"><strong>Le voyage avait commencé, et avait commencé heureusement avec un ciel bleu doux, et une mer calme.</strong></h2>\n\n\n\n<div class=\"wp-block-columns is-layout-flex wp-container-41\">\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:18px\">Ils la suivirent sur le pont. Toute la fumée et les maisons avaient disparu, et le navire se trouvait dans un large espace de mer très frais et clair, bien que pâle dans la lumière du matin. Ils avaient laissé Londres assise dans sa boue. Une ligne d’ombre très mince s’effilait à l’horizon, à peine assez épaisse pour soutenir le poids de Paris, qui pourtant reposait dessus. Ils étaient libres des routes, libres des hommes, et la même exaltation de leur liberté les traversait tous.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:18px\">Le navire avançait tranquillement à travers de petites vagues qui le giflaient puis pétillaient comme de l’eau effervescente, laissant une petite bordure de bulles et d’écume de chaque côté. Au-dessus, le ciel incolore d’octobre était finement voilé comme par la traînée de fumée d’un feu de bois, et l’air était merveilleusement salé et vivifiant. En effet, il faisait trop froid pour rester immobile. Mme Ambrose avait glissé son bras dans celui de son mari, et tandis qu’ils s’éloignaient, on pouvait voir à la façon dont sa joue inclinée se tournait vers la sienne qu’elle avait quelque chose de personnel à lui confier.</p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:54:\"Deux colonnes de texte précédées par un long titre.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:52:\"core/column,core/columns,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1889:\"<!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":38,\"lineHeight\":\"1.4\"}}} -->\n<h2 style=\"font-size:38px;line-height:1.4\"><strong>Le voyage avait commencé, et avait commencé heureusement avec un ciel bleu doux, et une mer calme.</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":18}}} -->\n<p style=\"font-size:18px\">Ils la suivirent sur le pont. Toute la fumée et les maisons avaient disparu, et le navire se trouvait dans un large espace de mer très frais et clair, bien que pâle dans la lumière du matin. Ils avaient laissé Londres assise dans sa boue. Une ligne d’ombre très mince s’effilait à l’horizon, à peine assez épaisse pour soutenir le poids de Paris, qui pourtant reposait dessus. Ils étaient libres des routes, libres des hommes, et la même exaltation de leur liberté les traversait tous.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":18}}} -->\n<p style=\"font-size:18px\">Le navire avançait tranquillement à travers de petites vagues qui le giflaient puis pétillaient comme de l’eau effervescente, laissant une petite bordure de bulles et d’écume de chaque côté. Au-dessus, le ciel incolore d’octobre était finement voilé comme par la traînée de fumée d’un feu de bois, et l’air était merveilleusement salé et vivifiant. En effet, il faisait trop froid pour rester immobile. Mme Ambrose avait glissé son bras dans celui de son mari, et tandis qu’ils s’éloignaient, on pouvait voir à la façon dont sa joue inclinée se tournait vers la sienne qu’elle avait quelque chose de personnel à lui confier.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:13;O:8:\"stdClass\":7:{s:2:\"id\";i:1272;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:26:\"Deux images côte à côte\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:743:\"\n<figure class=\"wp-block-gallery alignwide columns-2 is-cropped wp-block-gallery-42 is-layout-flex\"><ul class=\"blocks-gallery-grid\"><li class=\"blocks-gallery-item\"><figure><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" alt=\"Une vue aérienne de vagues s’écrasant sur le bord de mer.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" data-link=\"#\" /></figure></li><li class=\"blocks-gallery-item\"><figure><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" alt=\"Une vue aérienne d’un champ. Une route est visible dans le coin en haut à droite.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" data-link=\"#\" /></figure></li></ul></figure>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:52:\"Une galerie d’images avec deux images d’exemple.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:12:\"core/gallery\";}s:14:\"category_slugs\";a:1:{i:0;s:7:\"gallery\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:764:\"<!-- wp:gallery {\"ids\":[null,null],\"linkTo\":\"none\",\"align\":\"wide\"} -->\n<figure class=\"wp-block-gallery alignwide columns-2 is-cropped\"><ul class=\"blocks-gallery-grid\"><li class=\"blocks-gallery-item\"><figure><img src=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" alt=\"Une vue aérienne de vagues s’écrasant sur le bord de mer.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" data-link=\"#\" /></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" alt=\"Une vue aérienne d’un champ. Une route est visible dans le coin en haut à droite.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" data-link=\"#\" /></figure></li></ul></figure>\n<!-- /wp:gallery -->\";}i:14;O:8:\"stdClass\":7:{s:2:\"id\";i:229105;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:26:\"Simple header with tagline\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:826:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-47\" style=\"padding-top:2em;padding-bottom:4em\">\n<div class=\"wp-block-group is-layout-flex\"><div class=\"wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n\n<div class=\"wp-block-group is-layout-flow wp-container-44\"><h1 class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n<p style=\"margin-top:0px;\" class=\"wp-block-site-tagline has-small-font-size\">Beautifully designed patterns ready to go with a simple copy/paste</p></div>\n</div>\n\n\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:92:\"Header with site logo, title and tagline on the left and with navigation links on the right.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:75:\"core/group,core/navigation,core/site-logo,core/site-tagline,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:944:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"4em\",\"top\":\"2em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:2em;padding-bottom:4em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-logo {\"width\":60} /-->\n\n<!-- wp:group {\"style\":{\"spacing\":{\"blockGap\":\"var:preset|spacing|30\"}}} -->\n<div class=\"wp-block-group\"><!-- wp:site-title {\"fontSize\":\"medium\"} /-->\n\n<!-- wp:site-tagline {\"style\":{\"spacing\":{\"margin\":{\"top\":\"0px\"}}},\"fontSize\":\"small\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:15;O:8:\"stdClass\":7:{s:2:\"id\";i:229111;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:26:\"Site title and menu button\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:468:\"\n<div class=\"wp-block-group alignfull is-layout-flow\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-51\" style=\"padding-top:2em;padding-bottom:4em\">\n<div class=\"wp-block-group is-layout-flex\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n\n\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:51:\"Header with site title and a hamburger menu button.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:42:\"core/group,core/navigation,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:753:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"type\":\"default\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"4em\",\"top\":\"2em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:2em;padding-bottom:4em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-title {\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"overlayMenu\":\"always\",\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:16;O:8:\"stdClass\":7:{s:2:\"id\";i:229116;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:22:\"Header with hero image\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1344:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-group alignfull is-content-justification-space-between is-layout-flex wp-container-55\" style=\"padding-top:1em;padding-right:1em;padding-bottom:0em;padding-left:1em\">\n<div class=\"wp-block-group is-layout-flex\"><div class=\"wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n<h1 class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n\n\n</div>\n\n\n\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:490px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-0 has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-19-fog-lifts-up-after-raind.jpg?w=1200&amp;h=1200&amp;fit=clip&amp;crop=default&amp;dpr=1&amp;q=75&amp;vib=3&amp;con=3&amp;usm=15&amp;cs=srgb&amp;bg=F4F4F3&amp;ixlib=js-2.2.1&amp;s=f60b088dac6c7cc04eeebf67f600e079\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<p class=\"has-text-align-center has-large-font-size\"></p>\n</div></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:65:\"Header on a white background followed by a full-width hero image.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:83:\"core/cover,core/group,core/navigation,core/paragraph,core/site-logo,core/site-title\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"header\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1962:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"0em\",\"top\":\"1em\",\"right\":\"1em\",\"left\":\"1em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:1em;padding-right:1em;padding-bottom:0em;padding-left:1em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-logo {\"width\":60} /-->\n\n<!-- wp:site-title {\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:cover {\"url\":\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-19-fog-lifts-up-after-raind.jpg?w=1200&h=1200&fit=clip&crop=default&dpr=1&q=75&vib=3&con=3&usm=15&cs=srgb&bg=F4F4F3&ixlib=js-2.2.1&s=f60b088dac6c7cc04eeebf67f600e079\",\"id\":null,\"dimRatio\":0,\"minHeight\":490,\"minHeightUnit\":\"px\",\"isDark\":false,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:490px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-0 has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-19-fog-lifts-up-after-raind.jpg?w=1200&amp;h=1200&amp;fit=clip&amp;crop=default&amp;dpr=1&amp;q=75&amp;vib=3&amp;con=3&amp;usm=15&amp;cs=srgb&amp;bg=F4F4F3&amp;ixlib=js-2.2.1&amp;s=f60b088dac6c7cc04eeebf67f600e079\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:paragraph {\"align\":\"center\",\"placeholder\":\"Write title…\",\"fontSize\":\"large\"} -->\n<p class=\"has-text-align-center has-large-font-size\"></p>\n<!-- /wp:paragraph --></div></div>\n<!-- /wp:cover --></div>\n<!-- /wp:group -->\";}i:17;O:8:\"stdClass\":7:{s:2:\"id\";i:229092;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:41:\"Header inside full-width background image\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1421:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:680px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-black-background-color has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-cco-the-after-rain.jpg?w=1200&amp;h=1200&amp;fit=clip&amp;crop=default&amp;dpr=1&amp;q=75&amp;vib=3&amp;con=3&amp;usm=15&amp;cs=srgb&amp;bg=F4F4F3&amp;ixlib=js-2.2.1&amp;s=e7b4ca0a0edcc84ba48c1f7ebf02dd5a\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-columns is-not-stacked-on-mobile is-layout-flex wp-container-61\">\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<div class=\"wp-block-group is-layout-flex\"><div class=\"wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n<h1 class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\"></div>\n</div>\n\n\n\n<div style=\"height:480px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:100:\"Simple header with logo, site title, navigation and a full-width background image with dark overlay.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:105:\"core/column,core/columns,core/cover,core/group,core/navigation,core/site-logo,core/site-title,core/spacer\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"header\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:2028:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:cover {\"url\":\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-cco-the-after-rain.jpg?w=1200&h=1200&fit=clip&crop=default&dpr=1&q=75&vib=3&con=3&usm=15&cs=srgb&bg=F4F4F3&ixlib=js-2.2.1&s=e7b4ca0a0edcc84ba48c1f7ebf02dd5a\",\"dimRatio\":50,\"overlayColor\":\"black\",\"minHeight\":680,\"contentPosition\":\"center center\",\"isDark\":false,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:680px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-black-background-color has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://img.rawpixel.com/s3fs-private/rawpixel_images/website_content/a017-eberhard-cco-the-after-rain.jpg?w=1200&amp;h=1200&amp;fit=clip&amp;crop=default&amp;dpr=1&amp;q=75&amp;vib=3&amp;con=3&amp;usm=15&amp;cs=srgb&amp;bg=F4F4F3&amp;ixlib=js-2.2.1&amp;s=e7b4ca0a0edcc84ba48c1f7ebf02dd5a\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:columns {\"isStackedOnMobile\":false} -->\n<div class=\"wp-block-columns is-not-stacked-on-mobile\"><!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-logo {\"width\":60} /-->\n\n<!-- wp:site-title {\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"layout\":{\"type\":\"default\"}} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":\"480px\"} -->\n<div style=\"height:480px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div></div>\n<!-- /wp:cover --></div>\n<!-- /wp:group -->\";}i:18;O:8:\"stdClass\":7:{s:2:\"id\";i:229097;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:34:\"Simple header with dark background\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:788:\"\n<div class=\"wp-elements-89b1d0b7c3b99256e438e69463efaa91 wp-block-group alignfull has-white-color has-black-background-color has-text-color has-background has-link-color is-layout-constrained\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-65\" style=\"padding-top:1em;padding-bottom:1em\">\n<div class=\"wp-block-group is-layout-flex\"><div class=\"wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n<h1 class=\"wp-elements-d3cc6515209f0de8407b215e27b6ee7c wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n\n\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:76:\"Simple header with logo, site title, navigation links and a dark background.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:57:\"core/group,core/navigation,core/site-logo,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1008:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"elements\":{\"link\":{\"color\":{\"text\":\"var:preset|color|white\"}}}},\"backgroundColor\":\"black\",\"textColor\":\"white\",\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull has-white-color has-black-background-color has-text-color has-background has-link-color\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"1em\",\"top\":\"1em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:1em;padding-bottom:1em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-logo {\"width\":60} /-->\n\n<!-- wp:site-title {\"style\":{\"elements\":{\"link\":{\"color\":{\"text\":\"var:preset|color|background\"}}}},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:19;O:8:\"stdClass\":7:{s:2:\"id\";i:229101;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:29:\"Text-only header with tagline\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:594:\"\n<div class=\"wp-block-group alignfull is-layout-flow\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-69\" style=\"padding-top:2em;padding-bottom:2em\">\n<div class=\"wp-block-group is-layout-flex\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n<p class=\"wp-block-site-tagline has-medium-font-size\">Beautifully designed patterns ready to go with a simple copy/paste</p></div>\n\n\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:53:\"Header with site title, tagline and navigation links.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:60:\"core/group,core/navigation,core/site-tagline,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:779:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"type\":\"default\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"2em\",\"top\":\"2em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:2em;padding-bottom:2em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-title {\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /-->\n\n<!-- wp:site-tagline {\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:20;O:8:\"stdClass\":7:{s:2:\"id\";i:229080;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:25:\"Centered header with logo\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:485:\"\n<div class=\"wp-block-group alignfull is-layout-flow\" style=\"padding-top:2em;padding-bottom:4em\"><div class=\"is-default-size aligncenter wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n<h1 class=\"has-text-align-center wp-block-site-title has-large-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:65:\"Center aligned header with logo, site title and navigation links.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:57:\"core/group,core/navigation,core/site-logo,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:397:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"bottom\":\"4em\"}}}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:2em;padding-bottom:4em\"><!-- wp:site-logo {\"align\":\"center\"} /-->\n\n<!-- wp:site-title {\"textAlign\":\"center\",\"fontSize\":\"large\"} /-->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\"}} /--></div>\n<!-- /wp:group -->\";}i:21;O:8:\"stdClass\":7:{s:2:\"id\";i:229084;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:27:\"Header with large font size\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:404:\"\n<div class=\"wp-block-group alignfull is-content-justification-space-between is-nowrap is-layout-flex wp-container-74\" style=\"padding-top:30px;padding-right:30px;padding-bottom:30px;padding-left:30px\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"wp-block-site-title has-large-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:80:\"Header with a large site title and navigation links in the same large font size.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:42:\"core/group,core/navigation,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:612:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"30px\",\"right\":\"30px\",\"bottom\":\"30px\",\"left\":\"30px\"}}},\"layout\":{\"type\":\"flex\",\"flexWrap\":\"nowrap\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:30px;padding-right:30px;padding-bottom:30px;padding-left:30px\"><!-- wp:site-title {\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"large\"} /-->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"},\"style\":{\"spacing\":{\"blockGap\":\"30px\"}},\"fontSize\":\"large\"} /--></div>\n<!-- /wp:group -->\";}i:22;O:8:\"stdClass\":7:{s:2:\"id\";i:229088;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:13:\"Simple header\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:610:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-group alignfull is-content-justification-space-between is-layout-flex wp-container-77\" style=\"padding-top:1em;padding-bottom:1em\">\n<div class=\"wp-block-group is-layout-flex\"><div class=\"wp-block-site-logo\"><span class=\"custom-logo-link\"><img decoding=\"async\" src=\"https://s.w.org/images/wmark.png\" class=\"custom-logo\" alt=\"Logo du site\"></span></div>\n\n<h1 class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n\n\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:51:\"Simple header with logo, site title and navigation.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:57:\"core/group,core/navigation,core/site-logo,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"header\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:721:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"1em\",\"top\":\"1em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:1em;padding-bottom:1em\"><!-- wp:group {\"layout\":{\"type\":\"flex\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-logo {\"width\":60} /-->\n\n<!-- wp:site-title {\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:23;O:8:\"stdClass\":7:{s:2:\"id\";i:229123;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:15:\"Centered footer\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:288:\"\n<div class=\"wp-block-group alignfull is-layout-flow\">\n<div class=\"wp-block-group alignfull is-layout-flow\" style=\"padding-top:4em;padding-bottom:2em\">\n<p class=\"has-text-align-center has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:65:\"Centered footer with the sentence \"Proudly powered by WordPress\".\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:25:\"core/group,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:531:\"<!-- wp:group {\"align\":\"full\"} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"4em\",\"bottom\":\"2em\"}}},\"layout\":{\"inherit\":false}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:paragraph {\"align\":\"center\",\"fontSize\":\"small\"} -->\n<p class=\"has-text-align-center has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:24;O:8:\"stdClass\":7:{s:2:\"id\";i:229127;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:47:\"Footer with search, site title, and credit line\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:2016:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\" style=\"padding-top:4em;padding-bottom:2em\">\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-85\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:100%\">\n<div class=\"wp-block-group alignwide is-layout-flow\"><form role=\"search\" method=\"get\" action=\"https://wordpress.org/patterns/\" class=\"wp-block-search__button-outside wp-block-search__icon-button wp-block-search\"><label for=\"wp-block-search__input-81\" class=\"wp-block-search__label screen-reader-text\">Search</label><div class=\"wp-block-search__inside-wrapper \"  style=\"width: 100%\"><input type=\"search\" id=\"wp-block-search__input-81\" class=\"wp-block-search__input wp-block-search__input\" name=\"s\" value=\"\" placeholder=\"\"  style=\"border-width: 1px\" required /><button type=\"submit\" class=\"wp-block-search__button has-icon wp-element-button\"  style=\"border-width: 1px\" aria-label=\"Search\"><svg class=\"search-icon\" viewBox=\"0 0 24 24\" width=\"24\" height=\"24\">\n					<path d=\"M13.5 6C10.5 6 8 8.5 8 11.5c0 1.1.3 2.1.9 3l-3.4 3 1 1.1 3.4-2.9c1 .9 2.2 1.4 3.6 1.4 3 0 5.5-2.5 5.5-5.5C19 8.5 16.5 6 13.5 6zm0 9.5c-2.2 0-4-1.8-4-4s1.8-4 4-4 4 1.8 4 4-1.8 4-4 4z\"></path>\n				</svg></button></div></form></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:100%\"></div>\n</div>\n\n\n\n<div style=\"height:140px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide are-vertically-aligned-bottom is-layout-flex wp-container-88\">\n<div class=\"wp-block-column is-vertically-aligned-bottom is-layout-flow\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1></div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-bottom is-layout-flow\">\n<p class=\"has-text-align-right has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:88:\"Footer with search field and site title on the left, and small credit line on the right.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:90:\"core/column,core/columns,core/group,core/paragraph,core/search,core/site-title,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1727:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"4em\",\"bottom\":\"2em\"}}},\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"100%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:100%\"><!-- wp:group {\"align\":\"wide\"} -->\n<div class=\"wp-block-group alignwide\"><!-- wp:search {\"label\":\"Search\",\"showLabel\":false,\"width\":100,\"widthUnit\":\"%\",\"buttonText\":\"Search\",\"buttonUseIcon\":true,\"style\":{\"border\":{\"width\":\"1px\"}}} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"100%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:100%\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":\"140px\"} -->\n<div style=\"height:140px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"verticalAlignment\":\"bottom\",\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide are-vertically-aligned-bottom\"><!-- wp:column {\"verticalAlignment\":\"bottom\"} -->\n<div class=\"wp-block-column is-vertically-aligned-bottom\"><!-- wp:site-title {\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"bottom\"} -->\n<div class=\"wp-block-column is-vertically-aligned-bottom\"><!-- wp:paragraph {\"align\":\"right\",\"fontSize\":\"small\"} -->\n<p class=\"has-text-align-right has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:group -->\";}i:25;O:8:\"stdClass\":7:{s:2:\"id\";i:229131;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:38:\"Footer with site title and credit line\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:518:\"\n<div class=\"wp-block-group alignfull is-layout-flow\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-90\" style=\"padding-top:4em;padding-bottom:2em\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n\n<p class=\"has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:64:\"Footer with site title on the left and credit line on the right.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:41:\"core/group,core/paragraph,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:692:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"type\":\"default\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"2em\",\"top\":\"4em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\",\"verticalAlignment\":\"bottom\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:site-title {\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /-->\n\n<!-- wp:paragraph {\"fontSize\":\"small\"} -->\n<p class=\"has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:26;O:8:\"stdClass\":7:{s:2:\"id\";i:229135;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:38:\"Footer with navigation and credit line\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:330:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-93\" style=\"padding-top:4em;padding-bottom:2em\">\n\n\n<p class=\"has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:64:\"Footer with navigation on the left and credit line on the right.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:41:\"core/group,core/navigation,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:719:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"2em\",\"top\":\"4em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\",\"verticalAlignment\":\"bottom\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"left\"},\"fontSize\":\"medium\"} /-->\n\n<!-- wp:paragraph {\"fontSize\":\"small\"} -->\n<p class=\"has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:27;O:8:\"stdClass\":7:{s:2:\"id\";i:229139;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:46:\"Footer with background color and three columns\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1252:\"\n<div class=\"wp-elements-61b879d84aac944553e1bd4d3909d18a wp-block-group alignfull has-white-color has-black-background-color has-text-color has-background has-link-color is-layout-flow\" style=\"padding-top:4em;padding-bottom:2em\">\n<div class=\"wp-block-columns is-layout-flex wp-container-98\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n<p class=\"wp-block-site-tagline has-medium-font-size\">Beautifully designed patterns ready to go with a simple copy/paste</p></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p><strong>Social Media</strong></p>\n\n\n\n<p><a href=\"#\">Facebook</a><br><a href=\"#\">Instagram</a><br><a href=\"#\">Twitter</a></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p><strong>Where We Are</strong></p>\n\n\n\n<p>2020 Lomita Blvd, <br>Torrance, CA 90101<br>United States</p>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-group alignfull is-layout-flow\" style=\"padding-top:4em;padding-bottom:2em\">\n<p class=\"has-text-align-left\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:57:\"Text-only footer with background color and three columns.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:84:\"core/column,core/columns,core/group,core/paragraph,core/site-tagline,core/site-title\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1728:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"4em\",\"bottom\":\"2em\"}},\"elements\":{\"link\":{\"color\":{\"text\":\"var:preset|color|white\"}}}},\"backgroundColor\":\"black\",\"textColor\":\"white\",\"layout\":{\"type\":\"default\"}} -->\n<div class=\"wp-block-group alignfull has-white-color has-black-background-color has-text-color has-background has-link-color\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:site-title {\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /-->\n\n<!-- wp:site-tagline {\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph -->\n<p><strong>Social Media</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p><a href=\"#\">Facebook</a><br><a href=\"#\">Instagram</a><br><a href=\"#\">Twitter</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph -->\n<p><strong>Where We Are</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>2020 Lomita Blvd, <br>Torrance, CA 90101<br>United States</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"4em\",\"bottom\":\"2em\"}}},\"layout\":{\"inherit\":false}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:paragraph {\"align\":\"left\"} -->\n<p class=\"has-text-align-left\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:28;O:8:\"stdClass\":7:{s:2:\"id\";i:229143;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:33:\"Centered footer with social links\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:4343:\"\n<div class=\"wp-block-group alignfull is-layout-flow\" style=\"padding-top:4em;padding-bottom:2em\">\n<div class=\"wp-block-group is-vertical is-layout-flex wp-container-101\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"has-text-align-center wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n<p class=\"has-text-align-center wp-block-site-tagline has-medium-font-size\">Beautifully designed patterns ready to go with a simple copy/paste</p></div>\n\n\n\n<div style=\"height:8px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<ul class=\"wp-block-social-links is-style-logos-only is-content-justification-center is-layout-flex wp-container-102\"><li class=\"wp-social-link wp-social-link-instagram wp-block-social-link\"><a href=\"https://#\" class=\"wp-block-social-link-anchor\"><svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" aria-hidden=\"true\" focusable=\"false\"><path d=\"M12,4.622c2.403,0,2.688,0.009,3.637,0.052c0.877,0.04,1.354,0.187,1.671,0.31c0.42,0.163,0.72,0.358,1.035,0.673 c0.315,0.315,0.51,0.615,0.673,1.035c0.123,0.317,0.27,0.794,0.31,1.671c0.043,0.949,0.052,1.234,0.052,3.637 s-0.009,2.688-0.052,3.637c-0.04,0.877-0.187,1.354-0.31,1.671c-0.163,0.42-0.358,0.72-0.673,1.035 c-0.315,0.315-0.615,0.51-1.035,0.673c-0.317,0.123-0.794,0.27-1.671,0.31c-0.949,0.043-1.233,0.052-3.637,0.052 s-2.688-0.009-3.637-0.052c-0.877-0.04-1.354-0.187-1.671-0.31c-0.42-0.163-0.72-0.358-1.035-0.673 c-0.315-0.315-0.51-0.615-0.673-1.035c-0.123-0.317-0.27-0.794-0.31-1.671C4.631,14.688,4.622,14.403,4.622,12 s0.009-2.688,0.052-3.637c0.04-0.877,0.187-1.354,0.31-1.671c0.163-0.42,0.358-0.72,0.673-1.035 c0.315-0.315,0.615-0.51,1.035-0.673c0.317-0.123,0.794-0.27,1.671-0.31C9.312,4.631,9.597,4.622,12,4.622 M12,3 C9.556,3,9.249,3.01,8.289,3.054C7.331,3.098,6.677,3.25,6.105,3.472C5.513,3.702,5.011,4.01,4.511,4.511 c-0.5,0.5-0.808,1.002-1.038,1.594C3.25,6.677,3.098,7.331,3.054,8.289C3.01,9.249,3,9.556,3,12c0,2.444,0.01,2.751,0.054,3.711 c0.044,0.958,0.196,1.612,0.418,2.185c0.23,0.592,0.538,1.094,1.038,1.594c0.5,0.5,1.002,0.808,1.594,1.038 c0.572,0.222,1.227,0.375,2.185,0.418C9.249,20.99,9.556,21,12,21s2.751-0.01,3.711-0.054c0.958-0.044,1.612-0.196,2.185-0.418 c0.592-0.23,1.094-0.538,1.594-1.038c0.5-0.5,0.808-1.002,1.038-1.594c0.222-0.572,0.375-1.227,0.418-2.185 C20.99,14.751,21,14.444,21,12s-0.01-2.751-0.054-3.711c-0.044-0.958-0.196-1.612-0.418-2.185c-0.23-0.592-0.538-1.094-1.038-1.594 c-0.5-0.5-1.002-0.808-1.594-1.038c-0.572-0.222-1.227-0.375-2.185-0.418C14.751,3.01,14.444,3,12,3L12,3z M12,7.378 c-2.552,0-4.622,2.069-4.622,4.622S9.448,16.622,12,16.622s4.622-2.069,4.622-4.622S14.552,7.378,12,7.378z M12,15 c-1.657,0-3-1.343-3-3s1.343-3,3-3s3,1.343,3,3S13.657,15,12,15z M16.804,6.116c-0.596,0-1.08,0.484-1.08,1.08 s0.484,1.08,1.08,1.08c0.596,0,1.08-0.484,1.08-1.08S17.401,6.116,16.804,6.116z\"></path></svg><span class=\"wp-block-social-link-label screen-reader-text\">Instagram</span></a></li>\n\n<li class=\"wp-social-link wp-social-link-twitter wp-block-social-link\"><a href=\"https://#\" class=\"wp-block-social-link-anchor\"><svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" aria-hidden=\"true\" focusable=\"false\"><path d=\"M22.23,5.924c-0.736,0.326-1.527,0.547-2.357,0.646c0.847-0.508,1.498-1.312,1.804-2.27 c-0.793,0.47-1.671,0.812-2.606,0.996C18.324,4.498,17.257,4,16.077,4c-2.266,0-4.103,1.837-4.103,4.103 c0,0.322,0.036,0.635,0.106,0.935C8.67,8.867,5.647,7.234,3.623,4.751C3.27,5.357,3.067,6.062,3.067,6.814 c0,1.424,0.724,2.679,1.825,3.415c-0.673-0.021-1.305-0.206-1.859-0.513c0,0.017,0,0.034,0,0.052c0,1.988,1.414,3.647,3.292,4.023 c-0.344,0.094-0.707,0.144-1.081,0.144c-0.264,0-0.521-0.026-0.772-0.074c0.522,1.63,2.038,2.816,3.833,2.85 c-1.404,1.1-3.174,1.756-5.096,1.756c-0.331,0-0.658-0.019-0.979-0.057c1.816,1.164,3.973,1.843,6.29,1.843 c7.547,0,11.675-6.252,11.675-11.675c0-0.178-0.004-0.355-0.012-0.531C20.985,7.47,21.68,6.747,22.23,5.924z\"></path></svg><span class=\"wp-block-social-link-label screen-reader-text\">Twitter</span></a></li></ul>\n\n\n\n<div style=\"height:8px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-align-center has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:71:\"Footer with centered site title, tagline, social links and credit line.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:106:\"core/group,core/paragraph,core/site-tagline,core/site-title,core/social-link,core/social-links,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1393:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"4em\",\"bottom\":\"2em\"}}},\"layout\":{\"inherit\":false}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:group {\"style\":{\"spacing\":{\"blockGap\":\"var:preset|spacing|30\"}},\"layout\":{\"type\":\"flex\",\"orientation\":\"vertical\"}} -->\n<div class=\"wp-block-group\"><!-- wp:site-title {\"textAlign\":\"center\",\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /-->\n\n<!-- wp:site-tagline {\"textAlign\":\"center\",\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group -->\n\n<!-- wp:spacer {\"height\":\"8px\"} -->\n<div style=\"height:8px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:social-links {\"className\":\"is-style-logos-only\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\"}} -->\n<ul class=\"wp-block-social-links is-style-logos-only\"><!-- wp:social-link {\"url\":\"#\",\"service\":\"instagram\"} /-->\n\n<!-- wp:social-link {\"url\":\"#\",\"service\":\"twitter\"} /--></ul>\n<!-- /wp:social-links -->\n\n<!-- wp:spacer {\"height\":\"8px\"} -->\n<div style=\"height:8px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"fontSize\":\"small\"} -->\n<p class=\"has-text-align-center has-small-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group -->\";}i:29;O:8:\"stdClass\":7:{s:2:\"id\";i:229147;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:38:\"Footer with credit line and navigation\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:332:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\">\n<div class=\"wp-block-group alignwide is-content-justification-space-between is-layout-flex wp-container-105\" style=\"padding-top:4em;padding-bottom:2em\">\n<p class=\"has-medium-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n\n\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:64:\"Footer with credit line on the left and navigation on the right.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:41:\"core/group,core/navigation,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:708:\"<!-- wp:group {\"align\":\"full\",\"layout\":{\"inherit\":true,\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\"><!-- wp:group {\"align\":\"wide\",\"style\":{\"spacing\":{\"padding\":{\"bottom\":\"2em\",\"top\":\"4em\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"space-between\"}} -->\n<div class=\"wp-block-group alignwide\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:paragraph {\"fontSize\":\"medium\"} -->\n<p class=\"has-medium-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:navigation {\"ref\":80,\"layout\":{\"type\":\"flex\",\"setCascadingProperties\":true,\"justifyContent\":\"right\"},\"fontSize\":\"medium\"} /--></div>\n<!-- /wp:group --></div>\n<!-- /wp:group -->\";}i:30;O:8:\"stdClass\":7:{s:2:\"id\";i:229151;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:19:\"Left-aligned footer\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:455:\"\n<div class=\"wp-block-group alignfull is-layout-constrained\" style=\"padding-top:4em;padding-bottom:2em\">\n<div class=\"wp-block-columns is-layout-flex wp-container-109\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:80%\">\n<p class=\"has-text-align-left has-medium-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:20%\"></div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:44:\"Left-aligned footer with just a credit line.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:50:\"core/column,core/columns,core/group,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"footer\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:741:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"4em\",\"bottom\":\"2em\"}}},\"layout\":{\"type\":\"constrained\"}} -->\n<div class=\"wp-block-group alignfull\" style=\"padding-top:4em;padding-bottom:2em\"><!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column {\"width\":\"80%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:80%\"><!-- wp:paragraph {\"align\":\"left\",\"fontSize\":\"medium\"} -->\n<p class=\"has-text-align-left has-medium-font-size\">Proudly powered by <a href=\"https://wordpress.org\">WordPress</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"20%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:20%\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:group -->\";}i:31;O:8:\"stdClass\":7:{s:2:\"id\";i:201;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:32:\"Three columns with offset images\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1205:\"\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-114\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:25%\">\n<figure class=\"wp-block-image size-large is-style-default\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-01.jpg\" alt=\"Close-up, abstract view of geometric architecture.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:25%\">\n<div style=\"height:500px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div style=\"height:150px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-02.jpg\" alt=\"Close-up, angled view of a window on a white building.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:45%\">\n<figure class=\"wp-block-image size-large is-style-default\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-03.jpg\" alt=\"Close-up of the corner of a white, geometric building with both sharp points and round corners.\" /></figure>\n\n\n\n<div style=\"height:285px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:33:\"Three columns with offset images.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:47:\"core/column,core/columns,core/image,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"gallery\";i:1;s:6:\"images\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1753:\"<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"25%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:25%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-large is-style-default\"><img src=\"https://s.w.org/images/core/5.8/architecture-01.jpg\" alt=\"Close-up, abstract view of geometric architecture.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"25%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:25%\"><!-- wp:spacer {\"height\":500} -->\n<div style=\"height:500px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:spacer {\"height\":150} -->\n<div style=\"height:150px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/architecture-02.jpg\" alt=\"Close-up, angled view of a window on a white building.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"45%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:45%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-large is-style-default\"><img src=\"https://s.w.org/images/core/5.8/architecture-03.jpg\" alt=\"Close-up of the corner of a white, geometric building with both sharp points and round corners.\" /></figure>\n<!-- /wp:image -->\n\n<!-- wp:spacer {\"height\":285} -->\n<div style=\"height:285px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:32;O:8:\"stdClass\":7:{s:2:\"id\";i:200;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:21:\"Three columns of text\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:953:\"\n<div class=\"wp-block-columns alignfull has-text-color has-background is-layout-flex wp-container-118\" style=\"background-color:#ffffff;color:#000000\">\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Virtual Tour ↗</a></strong></h3>\n\n\n\n<p>Get a virtual tour of the museum. Ideal for schools and events.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Current Shows ↗</a></strong></h3>\n\n\n\n<p>Stay updated and see our current exhibitions here.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Useful Info ↗</a></strong></h3>\n\n\n\n<p>Get to know our opening times, ticket prices and discounts.</p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:22:\"Three columns of text.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:52:\"core/column,core/columns,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1496:\"<!-- wp:columns {\"align\":\"full\",\"style\":{\"color\":{\"text\":\"#000000\",\"background\":\"#ffffff\"}}} -->\n<div class=\"wp-block-columns alignfull has-text-color has-background\" style=\"background-color:#ffffff;color:#000000\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Virtual Tour ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Get a virtual tour of the museum. Ideal for schools and events.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Current Shows ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Stay updated and see our current exhibitions here.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Useful Info ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Get to know our opening times, ticket prices and discounts.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:33;O:8:\"stdClass\":7:{s:2:\"id\";i:199;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:34:\"Three columns with images and text\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:2843:\"\n<div class=\"wp-block-group alignfull has-background is-layout-flow\" style=\"background-color:#f8f4e4\">\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-120\">\n<div class=\"wp-block-column is-layout-flow\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h6 class=\"has-text-color wp-block-heading\" id=\"ecosystem\" style=\"color:#000000\">ECOSYSTEM</h6>\n\n\n\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Positive growth.</strong></p>\n\n\n\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-124\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.38%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>Nature</em>, in the common sense, refers to essences unchanged by man; space, the air, the river, the leaf.&nbsp;<em>Art</em>&nbsp;is applied to the mixture of his will with the same things, as in a house, a canal, a statue, a picture. But his operations taken together are so insignificant, a little chipping, baking, patching, and washing, that in an impression so grand as that of the world on the human mind, they do not vary the result.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33%\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"The sun setting through a dense forest.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.62%\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Wind turbines standing on a grassy plain, against a blue sky.\" /></figure>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-127\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:67%\">\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"The sun shining over a ridge leading down into the shore. In the distance, a car drives down a road.\" /></figure></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\" style=\"flex-basis:33%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Undoubtedly we have no questions to ask which are unanswerable. We must trust the perfection of the creation so far, as to believe that whatever curiosity the order of things has awakened in our minds, the order of things can satisfy. Every man&rsquo;s condition is a solution in hieroglyphic to those inquiries he would put.</p>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:77:\"Three columns with images and text, with vertical spacing for an offset look.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:86:\"core/column,core/columns,core/group,core/heading,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:3990:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#f8f4e4\"}}} -->\n<div class=\"wp-block-group alignfull has-background\" style=\"background-color:#f8f4e4\"><!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:heading {\"level\":6,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h6 class=\"has-text-color\" id=\"ecosystem\" style=\"color:#000000\">ECOSYSTEM</h6>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"5vw\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Positive growth.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:spacer {\"height\":\"5px\"} -->\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"33.38%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.38%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>Nature</em>, in the common sense, refers to essences unchanged by man; space, the air, the river, the leaf.&nbsp;<em>Art</em>&nbsp;is applied to the mixture of his will with the same things, as in a house, a canal, a statue, a picture. But his operations taken together are so insignificant, a little chipping, baking, patching, and washing, that in an impression so grand as that of the world on the human mind, they do not vary the result.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33%\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"The sun setting through a dense forest.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33.62%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.62%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Wind turbines standing on a grassy plain, against a blue sky.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"67%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:67%\"><!-- wp:image {\"align\":\"right\",\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"The sun shining over a ridge leading down into the shore. In the distance, a car drives down a road.\" /></figure></div>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"width\":\"33%\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\" style=\"flex-basis:33%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Undoubtedly we have no questions to ask which are unanswerable. We must trust the perfection of the creation so far, as to believe that whatever curiosity the order of things has awakened in our minds, the order of things can satisfy. Every man\'s condition is a solution in hieroglyphic to those inquiries he would put.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:group -->\";}i:34;O:8:\"stdClass\":7:{s:2:\"id\";i:197;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:39:\"Two columns of text with offset heading\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1991:\"\n<div class=\"wp-block-group alignfull has-background is-layout-flow\" style=\"background-color:#f2f0e9\">\n<div style=\"height:70px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center is-layout-flex wp-container-131\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\">\n<p class=\"has-text-color\" style=\"color:#000000;font-size:30px;line-height:1.1\"><strong>Oceanic Inspiration</strong></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\">\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-135\">\n<div class=\"wp-block-column is-layout-flow\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Winding veils round their heads, the women walked on deck. They were now moving steadily down the river, passing the dark shapes of ships at anchor, and London was a swarm of lights with a pale yellow canopy drooping above it. There were the lights of the great theatres, the lights of the long streets, lights that indicated huge squares of domestic comfort, lights that hung high in air.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">No darkness would ever settle upon those lamps, as no darkness had settled upon them for hundreds of years. It seemed dreadful that the town should blaze for ever in the same spot; dreadful at least to people going away to adventure upon the sea, and beholding it as a circumscribed mound, eternally burnt, eternally scarred. From the deck of the ship the great city appeared a crouched and cowardly figure, a sedentary miser.</p>\n</div>\n</div>\n\n\n\n<div style=\"height:40px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:43:\"Two columns of text with an offset heading.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:77:\"core/column,core/columns,core/group,core/paragraph,core/separator,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:2837:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#f2f0e9\"}}} -->\n<div class=\"wp-block-group alignfull has-background\" style=\"background-color:#f2f0e9\"><!-- wp:spacer {\"height\":70} -->\n<div style=\"height:70px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"verticalAlignment\":\"center\",\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center\"><!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"30px\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:30px;line-height:1.1\"><strong>Oceanic Inspiration</strong></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:separator {\"customColor\":\"#000000\",\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n<!-- /wp:separator --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Winding veils round their heads, the women walked on deck. They were now moving steadily down the river, passing the dark shapes of ships at anchor, and London was a swarm of lights with a pale yellow canopy drooping above it. There were the lights of the great theatres, the lights of the long streets, lights that indicated huge squares of domestic comfort, lights that hung high in air.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">No darkness would ever settle upon those lamps, as no darkness had settled upon them for hundreds of years. It seemed dreadful that the town should blaze for ever in the same spot; dreadful at least to people going away to adventure upon the sea, and beholding it as a circumscribed mound, eternally burnt, eternally scarred. From the deck of the ship the great city appeared a crouched and cowardly figure, a sedentary miser.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":40} -->\n<div style=\"height:40px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:group -->\";}i:35;O:8:\"stdClass\":7:{s:2:\"id\";i:196;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:41:\"Media and text in a full height container\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1368:\"\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-100 has-background-dim\" style=\"background-color:#ffffff\"></span><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center is-image-fill\" style=\"grid-template-columns:56% auto\"><figure class=\"wp-block-media-text__media\" style=\"background-image:url(https://s.w.org/images/core/5.8/soil.jpg);background-position:50% 50%\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/soil.jpg\" alt=\"Close-up of dried, cracked earth.\" /></figure><div class=\"wp-block-media-text__content\">\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000;font-size:32px\"><strong>What&rsquo;s the problem?</strong></h2>\n\n\n\n<p class=\"has-text-color\" style=\"color:#000000;font-size:17px\">Trees are more important today than ever before. More than 10,000 products are reportedly made from trees. Through chemistry, the humble woodpile is yielding chemicals, plastics and fabrics that were beyond comprehension when an axe first felled a Texas tree.</p>\n\n\n\n<div class=\"wp-block-buttons is-layout-flex\">\n<div class=\"wp-block-button is-style-fill\"><a class=\"wp-block-button__link wp-element-button\">Learn more</a></div>\n</div>\n</div></div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:77:\"Media and text block with image to the left and text and button to the right.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:79:\"core/button,core/buttons,core/cover,core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"banner\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:2015:\"<!-- wp:cover {\"customOverlayColor\":\"#ffffff\",\"minHeight\":100,\"minHeightUnit\":\"vh\",\"contentPosition\":\"center center\",\"isDark\":false,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull is-light\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-100 has-background-dim\" style=\"background-color:#ffffff\"></span><div class=\"wp-block-cover__inner-container\"><!-- wp:media-text {\"mediaLink\":\"https://s.w.org/images/core/5.8/soil.jpg\",\"mediaType\":\"image\",\"mediaWidth\":56,\"verticalAlignment\":\"center\",\"imageFill\":true} -->\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center is-image-fill\" style=\"grid-template-columns:56% auto\"><figure class=\"wp-block-media-text__media\" style=\"background-image:url(https://s.w.org/images/core/5.8/soil.jpg);background-position:50% 50%\"><img src=\"https://s.w.org/images/core/5.8/soil.jpg\" alt=\"Close-up of dried, cracked earth.\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"32px\"},\"color\":{\"text\":\"#000000\"}}} -->\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000;font-size:32px\"><strong>What\'s the problem?</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"17px\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:17px\">Trees are more important today than ever before. More than 10,000 products are reportedly made from trees. Through chemistry, the humble woodpile is yielding chemicals, plastics and fabrics that were beyond comprehension when an axe first felled a Texas tree.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:buttons -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"className\":\"is-style-fill\"} -->\n<div class=\"wp-block-button is-style-fill\"><a class=\"wp-block-button__link wp-element-button\">Learn more</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div></div>\n<!-- /wp:media-text --></div></div>\n<!-- /wp:cover -->\";}i:36;O:8:\"stdClass\":7:{s:2:\"id\";i:195;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:38:\"Media and text with image on the right\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:719:\"\n<div class=\"wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center is-style-default\" style=\"grid-template-columns:auto 56%\"><div class=\"wp-block-media-text__content\">\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000\"><strong>Shore with Blue Sea</strong></h2>\n\n\n\n<p class=\"has-text-color\" style=\"color:#636363;font-size:17px;line-height:1.1\">Eleanor Harris&nbsp;(American, 1901-1942)</p>\n</div><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/art-02.jpg\" alt=\"A green and brown rural landscape leading into a bright blue ocean and slightly cloudy sky, done in oil paints.\" /></figure></div>\n\n\n\n<p></p>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:66:\"Media and text block with image to the right and text to the left.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:43:\"core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"banner\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1155:\"<!-- wp:media-text {\"align\":\"full\",\"mediaPosition\":\"right\",\"mediaLink\":\"#\",\"mediaType\":\"image\",\"mediaWidth\":56,\"verticalAlignment\":\"center\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center is-style-default\" style=\"grid-template-columns:auto 56%\"><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h2 class=\"wp-block-heading has-text-color\" style=\"color:#000000\"><strong>Shore with Blue Sea</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"17px\"},\"color\":{\"text\":\"#636363\"}}} -->\n<p class=\"has-text-color\" style=\"color:#636363;font-size:17px;line-height:1.1\">Eleanor Harris&nbsp;(American, 1901-1942)</p>\n<!-- /wp:paragraph --></div><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/images/core/5.8/art-02.jpg\" alt=\"A green and brown rural landscape leading into a bright blue ocean and slightly cloudy sky, done in oil paints.\" /></figure></div>\n<!-- /wp:media-text -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\";}i:37;O:8:\"stdClass\":7:{s:2:\"id\";i:192;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:37:\"Media and text with image on the left\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:554:\"\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Close-up, abstract view of architecture.\" /></figure><div class=\"wp-block-media-text__content\">\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Open Spaces</strong></h3>\n\n\n\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">See case study ↗</a></p>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:66:\"Media and text block with image to the left and text to the right.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:43:\"core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:844:\"<!-- wp:media-text {\"align\":\"full\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Close-up, abstract view of architecture.\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"textAlign\":\"center\",\"level\":3,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Open Spaces</strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">See case study ↗</a></p>\n<!-- /wp:paragraph --></div></div>\n<!-- /wp:media-text -->\";}i:38;O:8:\"stdClass\":7:{s:2:\"id\";i:186;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:35:\"Large header with text and a button\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1337:\"\n<div class=\"wp-block-cover alignfull has-parallax\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-40 has-background-dim\" style=\"background-color:#000000\"></span><div role=\"img\" class=\"wp-block-cover__image-background has-parallax\" style=\"background-position:50% 50%;background-image:url(https://s.w.org/images/core/5.8/art-01.jpg)\"></div><div class=\"wp-block-cover__inner-container\">\n<h2 class=\"wp-block-heading alignwide has-white-color has-text-color\" style=\"font-size:48px;line-height:1.2\"><strong><em>Overseas:</em></strong><br><strong><em>1500 — 1960</em></strong></h2>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-141\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:60%\">\n<p class=\"has-text-color\" style=\"color:#ffffff\">An exhibition about the different representations of the ocean throughout time, between the sixteenth and the twentieth century. Taking place in our Open Room in <em>Floor 2</em>.</p>\n\n\n\n<div class=\"wp-block-buttons is-layout-flex\">\n<div class=\"wp-block-button is-style-outline\"><a class=\"wp-block-button__link has-text-color has-background wp-element-button\" style=\"color:#ffffff;background-color:#000000\">Visit</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:62:\"Large header with background image and text and button on top.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:88:\"core/button,core/buttons,core/column,core/columns,core/cover,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:1:{i:0;s:6:\"banner\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:2053:\"<!-- wp:cover {\"url\":\"https://s.w.org/images/core/5.8/art-01.jpg\",\"hasParallax\":true,\"dimRatio\":40,\"customOverlayColor\":\"#000000\",\"minHeight\":100,\"minHeightUnit\":\"vh\",\"contentPosition\":\"center center\",\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull has-parallax\" style=\"min-height:100vh\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-40 has-background-dim\" style=\"background-color:#000000\"></span><div role=\"img\" class=\"wp-block-cover__image-background has-parallax\" style=\"background-position:50% 50%;background-image:url(https://s.w.org/images/core/5.8/art-01.jpg)\"></div><div class=\"wp-block-cover__inner-container\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"48px\",\"lineHeight\":\"1.2\"}},\"className\":\"alignwide has-white-color has-text-color\"} -->\n<h2 class=\"wp-block-heading alignwide has-white-color has-text-color\" style=\"font-size:48px;line-height:1.2\"><strong><em>Overseas:</em></strong><br><strong><em>1500 — 1960</em></strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"60%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:60%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#ffffff\"}}} -->\n<p class=\"has-text-color\" style=\"color:#ffffff\">An exhibition about the different representations of the ocean throughout time, between the sixteenth and the twentieth century. Taking place in our Open Room in <em>Floor 2</em>.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:buttons -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"style\":{\"color\":{\"text\":\"#ffffff\",\"background\":\"#000000\"}},\"className\":\"is-style-outline\"} -->\n<div class=\"wp-block-button is-style-outline\"><a class=\"wp-block-button__link has-text-color has-background wp-element-button\" style=\"color:#ffffff;background-color:#000000\">Visit</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div></div>\n<!-- /wp:cover -->\";}i:39;O:8:\"stdClass\":7:{s:2:\"id\";i:185;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:35:\"Large header with left-aligned text\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1182:\"\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forest.</h2>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-144\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:55%\">\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Even a child knows how valuable the forest is. The fresh, breathtaking smell of trees. Echoing birds flying above that dense magnitude. A stable climate, a sustainable diverse life and a source of culture. Yet, forests and other ecosystems hang in the balance, threatened to become croplands, pasture, and plantations.</em></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:29:\"Cover image with quote on top\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/column,core/columns,core/cover,core/heading,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1698:\"<!-- wp:cover {\"url\":\"https://s.w.org/images/core/5.8/forest.jpg\",\"dimRatio\":60,\"minHeight\":800,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:heading {\"align\":\"wide\",\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"fontSize\":\"64px\"}}} -->\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forest.</h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"55%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:55%\"><!-- wp:spacer {\"height\":\"330px\"} -->\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"lineHeight\":\"1.3\",\"fontSize\":\"12px\"}}} -->\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Even a child knows how valuable the forest is. The fresh, breathtaking smell of trees. Echoing birds flying above that dense magnitude. A stable climate, a sustainable diverse life and a source of culture. Yet, forests and other ecosystems hang in the balance, threatened to become croplands, pasture, and plantations.</em></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div></div>\n<!-- /wp:cover -->\";}i:40;O:8:\"stdClass\":7:{s:2:\"id\";i:184;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:7:\"Heading\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:526:\"\n<h2 class=\"alignwide wp-block-heading\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">We&rsquo;re a studio in Berlin with an international practice in architecture, urban planning and interior design. We believe in sharing knowledge and promoting dialogue to increase the creative potential of collaboration.</h2>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:17:\"large text, title\";s:16:\"wpop_description\";s:12:\"Heading text\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:12:\"core/heading\";}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:12:\"core/heading\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:621:\"<!-- wp:heading {\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"48px\",\"lineHeight\":\"1.1\"}}} -->\n<h2 class=\"alignwide\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">We\'re a studio in Berlin with an international practice in architecture, urban planning and interior design. We believe in sharing knowledge and promoting dialogue to increase the creative potential of collaboration.</h2>\n<!-- /wp:heading -->\";}i:41;O:8:\"stdClass\":7:{s:2:\"id\";i:27;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:5:\"Quote\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:667:\"\n<hr class=\"wp-block-separator is-style-default\" />\n\n\n\n<div class=\"wp-block-image is-style-rounded\"><figure class=\"aligncenter size-large is-resized\"><img decoding=\"async\" loading=\"lazy\" src=\"https://s.w.org/images/core/5.8/portrait.jpg\" alt=\"A side profile of a woman in a russet-colored turtleneck and white bag. She looks up with her eyes closed.\" width=\"150\" height=\"150\" /></figure></div>\n\n\n\n<blockquote class=\"wp-block-quote has-text-align-center is-style-large\"><p>« Contributing makes me feel like I&rsquo;m being useful to the planet. »</p><cite>— Anna Wong, <em>Volunteer</em></cite></blockquote>\n\n\n\n<hr class=\"wp-block-separator is-style-default\" />\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:10:\"core/quote\";}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:36:\"core/image,core/quote,core/separator\";}s:14:\"category_slugs\";a:1:{i:0;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1012:\"<!-- wp:separator {\"className\":\"is-style-default\"} -->\n<hr class=\"wp-block-separator is-style-default\" />\n<!-- /wp:separator -->\n\n<!-- wp:image {\"align\":\"center\",\"width\":150,\"height\":150,\"sizeSlug\":\"large\",\"linkDestination\":\"none\",\"className\":\"is-style-rounded\"} -->\n<div class=\"wp-block-image is-style-rounded\"><figure class=\"aligncenter size-large is-resized\"><img src=\"https://s.w.org/images/core/5.8/portrait.jpg\" alt=\"A side profile of a woman in a russet-colored turtleneck and white bag. She looks up with her eyes closed.\" width=\"150\" height=\"150\" /></figure></div>\n<!-- /wp:image -->\n\n<!-- wp:quote {\"align\":\"center\",\"className\":\"is-style-large\"} -->\n<blockquote class=\"wp-block-quote has-text-align-center is-style-large\"><p>\"Contributing makes me feel like I\'m being useful to the planet.\"</p><cite>— Anna Wong, <em>Volunteer</em></cite></blockquote>\n<!-- /wp:quote -->\n\n<!-- wp:separator {\"className\":\"is-style-default\"} -->\n<hr class=\"wp-block-separator is-style-default\" />\n<!-- /wp:separator -->\";}i:42;O:8:\"stdClass\":7:{s:2:\"id\";i:29;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:29:\"Two columns of text and title\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1424:\"\n<h2 class=\"wp-block-heading\" style=\"font-size:38px;line-height:1.4\"><strong>The voyage had begun, and had begun happily with a soft blue sky, and a calm sea.</strong></h2>\n\n\n\n<div class=\"wp-block-columns is-layout-flex wp-container-147\">\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:18px\">They followed her on to the deck. All the smoke and the houses had disappeared, and the ship was out in a wide space of sea very fresh and clear though pale in the early light. They had left London sitting on its mud. A very thin line of shadow tapered on the horizon, scarcely thick enough to stand the burden of Paris, which nevertheless rested upon it. They were free of roads, free of mankind, and the same exhilaration at their freedom ran through them all.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:18px\">The ship was making her way steadily through small waves which slapped her and then fizzled like effervescing water, leaving a little border of bubbles and foam on either side. The colourless October sky above was thinly clouded as if by the trail of wood-fire smoke, and the air was wonderfully salt and brisk. Indeed it was too cold to stand still. Mrs. Ambrose drew her arm within her husband&rsquo;s, and as they moved off it could be seen from the way in which her sloping cheek turned up to his that she had something private to communicate.</p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:47:\"Two columns of text preceded by a long heading.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:52:\"core/column,core/columns,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1711:\"<!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":38,\"lineHeight\":\"1.4\"}}} -->\n<h2 style=\"font-size:38px;line-height:1.4\"><strong>The voyage had begun, and had begun happily with a soft blue sky, and a calm sea.</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":18}}} -->\n<p style=\"font-size:18px\">They followed her on to the deck. All the smoke and the houses had disappeared, and the ship was out in a wide space of sea very fresh and clear though pale in the early light. They had left London sitting on its mud. A very thin line of shadow tapered on the horizon, scarcely thick enough to stand the burden of Paris, which nevertheless rested upon it. They were free of roads, free of mankind, and the same exhilaration at their freedom ran through them all.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":18}}} -->\n<p style=\"font-size:18px\">The ship was making her way steadily through small waves which slapped her and then fizzled like effervescing water, leaving a little border of bubbles and foam on either side. The colourless October sky above was thinly clouded as if by the trail of wood-fire smoke, and the air was wonderfully salt and brisk. Indeed it was too cold to stand still. Mrs. Ambrose drew her arm within her husband\'s, and as they moved off it could be seen from the way in which her sloping cheek turned up to his that she had something private to communicate.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:43;O:8:\"stdClass\":7:{s:2:\"id\";i:19;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:23:\"Two images side by side\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:717:\"\n<figure class=\"wp-block-gallery alignwide columns-2 is-cropped wp-block-gallery-148 is-layout-flex\"><ul class=\"blocks-gallery-grid\"><li class=\"blocks-gallery-item\"><figure><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" alt=\"An aerial view of waves crashing against a shore.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" data-link=\"#\" /></figure></li><li class=\"blocks-gallery-item\"><figure><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" alt=\"An aerial view of a field. A road runs through the upper right corner.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" data-link=\"#\" /></figure></li></ul></figure>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:41:\"An image gallery with two example images.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:12:\"core/gallery\";}s:14:\"category_slugs\";a:1:{i:0;s:7:\"gallery\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:737:\"<!-- wp:gallery {\"ids\":[null,null],\"linkTo\":\"none\",\"align\":\"wide\"} -->\n<figure class=\"wp-block-gallery alignwide columns-2 is-cropped\"><ul class=\"blocks-gallery-grid\"><li class=\"blocks-gallery-item\"><figure><img src=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" alt=\"An aerial view of waves crashing against a shore.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-01.jpg\" data-link=\"#\" /></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" alt=\"An aerial view of a field. A road runs through the upper right corner.\" data-full-url=\"https://s.w.org/images/core/5.8/nature-above-02.jpg\" data-link=\"#\" /></figure></li></ul></figure>\n<!-- /wp:gallery -->\";}}", "no");
INSERT INTO `wp_options` VALUES("56503", "_site_transient_timeout_wp_remote_block_patterns_6a465bb1f25227b9b68ddbcd3c2dece0", "1674104878", "no");
INSERT INTO `wp_options` VALUES("56504", "_site_transient_wp_remote_block_patterns_6a465bb1f25227b9b68ddbcd3c2dece0", "a:29:{i:0;O:8:\"stdClass\":7:{s:2:\"id\";i:1267;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:26:\"Simple appel à l’action\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:908:\"\n<div class=\"wp-block-group alignfull has-text-color has-background is-layout-flow\" style=\"background-color:#ffffff;color:#000000\">\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-align-center has-small-font-size\" style=\"line-height:.9\"><strong>Contactez nous</strong></p>\n\n\n\n<h2 class=\"has-text-align-center wp-block-heading\" id=\"schedule-a-visit\" style=\"font-size:59px;line-height:1.15\"><strong>Prévoir une visite</strong></h2>\n\n\n\n<div class=\"wp-block-buttons is-horizontal is-content-justification-center is-layout-flex wp-container-1\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-50\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"border-radius:50px;background-color:#000000;color:#ffffff\">Contactez-nous</a></div>\n</div>\n\n\n\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:115:\"Un conteneur avec un fond blanc. À l’intérieur se trouvent un paragraphe, un titre et un bouton, tous centrés.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/button,core/buttons,core/group,core/heading,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"buttons\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1515:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"text\":\"#000000\",\"background\":\"#ffffff\"}}} -->\n<div class=\"wp-block-group alignfull has-text-color has-background\" style=\"background-color:#ffffff;color:#000000\"><!-- wp:spacer {\"height\":64} -->\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"style\":{\"typography\":{\"lineHeight\":\".9\"}},\"fontSize\":\"small\"} -->\n<p class=\"has-text-align-center has-small-font-size\" style=\"line-height:.9\"><strong>Contactez nous</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading {\"textAlign\":\"center\",\"style\":{\"typography\":{\"fontSize\":59,\"lineHeight\":\"1.15\"}}} -->\n<h2 class=\"has-text-align-center\" id=\"schedule-a-visit\" style=\"font-size:59px;line-height:1.15\"><strong>Prévoir une visite</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:buttons {\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"width\":50,\"style\":{\"color\":{\"background\":\"#000000\",\"text\":\"#ffffff\"},\"border\":{\"radius\":\"50px\"}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-50\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"border-radius:50px;background-color:#000000;color:#ffffff\">Contactez-nous</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons -->\n\n<!-- wp:spacer {\"height\":64} -->\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:group -->\";}i:1;O:8:\"stdClass\":7:{s:2:\"id\";i:1281;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:17:\"Tableau de tarifs\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:3458:\"\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-9\">\n<div class=\"wp-elements-f0774b77f5d41f7b136cdf050f4f4439 wp-block-column has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#ffe97d;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" id=\"single\" style=\"font-size:40px\"><strong>Individuel</strong></h2>\n\n\n\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Contribuez à notre communauté en pleine expansion.</strong> </p>\n\n\n\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n\n\n\n<ul class=\"has-normal-font-size\"><li>Entrée libre et réductions réservées aux membres pour un adulte</li><li>Un billet gratuit par exposition temporaire</li><li>Deux laissez-passer à usage unique par an</li></ul>\n\n\n\n<div class=\"wp-block-buttons alignfull is-horizontal is-content-justification-center is-layout-flex wp-container-3\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$110 / an</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-elements-637dd2fd5d80b0094d33643330ae8790 wp-block-column has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#d1d1e1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" id=\"family\" style=\"font-size:40px\"><strong>Famille</strong></h2>\n\n\n\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Soutenez les expositions spéciales.</strong></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<ul class=\"has-normal-font-size\"><li>Entrée libre et réductions réservées aux membres pour deux adultes</li><li>Quatre billets gratuits par exposition temporaire</li><li>Quatre laissez-passer à usage unique par an</li></ul>\n\n\n\n<div class=\"wp-block-buttons alignfull is-horizontal is-content-justification-center is-layout-flex wp-container-5\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100 is-style-fill\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">200€ / an</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-elements-3564fc5bbd2a7ea02939852d112332b3 wp-block-column has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#c0ebf1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" id=\"patron\" style=\"font-size:40px\"><strong>Mécène</strong></h2>\n\n\n\n<p class=\"has-normal-font-size\"><strong>Soutenez-nous encore plus.</strong></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<ul class=\"has-normal-font-size\"><li>Entrée libre et réductions réservées aux membres pour deux adultes</li><li>Cinq billets gratuits par exposition temporaire</li><li>Quatre laissez-passer à usage unique par an</li></ul>\n\n\n\n<div class=\"wp-block-buttons alignfull is-horizontal is-content-justification-center is-layout-flex wp-container-7\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$400 / an</a></div>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:280:\"Trois colonnes de largeur égale configurées comme un barème de tarifs. La colonne de gauche a un fond jaune, celle du milieu un fond violet clair, et celle de droite un fond bleu clair. Chaque colonne contient un titre, un sous-titre, un séparateur, une liste, puis un bouton.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:102:\"core/button,core/buttons,core/column,core/columns,core/heading,core/list,core/paragraph,core/separator\";}s:14:\"category_slugs\";a:3:{i:0;s:7:\"buttons\";i:1;s:7:\"columns\";i:2;s:8:\"featured\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:5460:\"<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"style\":{\"color\":{\"background\":\"#ffe97d\",\"text\":\"#000000\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#000000\"}}},\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-column has-text-color has-background has-link-color\" style=\"background-color:#ffe97d;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"40px\"}}} -->\n<h2 id=\"single\" style=\"font-size:40px\"><strong>Individuel</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.5\"}},\"fontSize\":\"normal\"} -->\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Contribuez à notre communauté en pleine expansion.</strong> </p>\n<!-- /wp:paragraph -->\n\n<!-- wp:separator {\"customColor\":\"#000000\",\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n<!-- /wp:separator -->\n\n<!-- wp:list {\"fontSize\":\"normal\"} -->\n<ul class=\"has-normal-font-size\"><li>Entrée libre et réductions réservées aux membres pour un adulte</li><li>Un billet gratuit par exposition temporaire</li><li>Deux laissez-passer à usage unique par an</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:buttons {\"align\":\"full\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons alignfull\"><!-- wp:button {\"textColor\":\"white\",\"width\":100,\"style\":{\"color\":{\"background\":\"#000000\"},\"border\":{\"radius\":0}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$110 / an</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"style\":{\"color\":{\"background\":\"#d1d1e1\",\"text\":\"#000000\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#000000\"}}},\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-column has-text-color has-background has-link-color\" style=\"background-color:#d1d1e1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"40px\"}}} -->\n<h2 id=\"family\" style=\"font-size:40px\"><strong>Famille</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.5\"}},\"fontSize\":\"normal\"} -->\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Soutenez les expositions spéciales.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:separator {\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator is-style-wide\" />\n<!-- /wp:separator -->\n\n<!-- wp:list {\"fontSize\":\"normal\"} -->\n<ul class=\"has-normal-font-size\"><li>Entrée libre et réductions réservées aux membres pour deux adultes</li><li>Quatre billets gratuits par exposition temporaire</li><li>Quatre laissez-passer à usage unique par an</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:buttons {\"align\":\"full\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons alignfull\"><!-- wp:button {\"textColor\":\"white\",\"width\":100,\"style\":{\"color\":{\"background\":\"#000000\"},\"border\":{\"radius\":0}},\"className\":\"is-style-fill\"} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100 is-style-fill\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">200€ / an</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"style\":{\"color\":{\"background\":\"#c0ebf1\",\"text\":\"#000000\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#000000\"}}},\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-column has-text-color has-background has-link-color\" style=\"background-color:#c0ebf1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"40px\"}}} -->\n<h2 id=\"patron\" style=\"font-size:40px\"><strong>Mécène</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"fontSize\":\"normal\"} -->\n<p class=\"has-normal-font-size\"><strong>Soutenez-nous encore plus.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:separator {\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator is-style-wide\" />\n<!-- /wp:separator -->\n\n<!-- wp:list {\"fontSize\":\"normal\"} -->\n<ul class=\"has-normal-font-size\"><li>Entrée libre et réductions réservées aux membres pour deux adultes</li><li>Cinq billets gratuits par exposition temporaire</li><li>Quatre laissez-passer à usage unique par an</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:buttons {\"align\":\"full\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons alignfull\"><!-- wp:button {\"textColor\":\"white\",\"width\":100,\"style\":{\"color\":{\"background\":\"#000000\"},\"border\":{\"radius\":0}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$400 / an</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:2;O:8:\"stdClass\":7:{s:2:\"id\";i:8394;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:38:\"Image et citation sur un arrière-plan\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:2243:\"\n<div class=\"wp-block-media-text alignwide has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#f1f5c7\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/pear-1-1024x1024.png\" alt=\"\" class=\"wp-image-5263 size-full\" srcset=\"https://s.w.org/patterns/files/2021/06/pear-1-1024x1024.png 1024w, https://s.w.org/patterns/files/2021/06/pear-1-300x300.png 300w, https://s.w.org/patterns/files/2021/06/pear-1-150x150.png 150w, https://s.w.org/patterns/files/2021/06/pear-1-768x768.png 768w, https://s.w.org/patterns/files/2021/06/pear-1.png 1300w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure><div class=\"wp-block-media-text__content\">\n<div class=\"wp-block-group is-layout-flow\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<p style=\"font-size:36px;line-height:1.2\"><strong>Même le fruit le plus amer contient du sucre.</strong></p>\n\n\n\n<p class=\"has-extra-small-font-size\">– Terry a. O’Neal</p>\n</div>\n</div></div>\n\n\n\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#fffdea\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/pear-half-1024x1024.png\" alt=\"\" class=\"wp-image-673 size-full\" srcset=\"https://s.w.org/patterns/files/2021/06/pear-half-1024x1024.png 1024w, https://s.w.org/patterns/files/2021/06/pear-half-300x300.png 300w, https://s.w.org/patterns/files/2021/06/pear-half-150x150.png 150w, https://s.w.org/patterns/files/2021/06/pear-half-768x768.png 768w, https://s.w.org/patterns/files/2021/06/pear-half.png 1300w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure><div class=\"wp-block-media-text__content\">\n<div class=\"wp-block-group is-layout-flow\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<p style=\"font-size:36px;line-height:1.2\"><strong>Les arbres qui mettent du temps à pousser donnent les meilleurs fruits.</strong></p>\n\n\n\n<p class=\"has-extra-small-font-size\">– Molière</p>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:255:\"Deux blocs contenu chacun un fichier média et du texte. Le bloc du haut a un fond vert pâle. Le texte est à gauche et contient une citation, et l’image est à droite. Le bloc suivant, en dessous, contient l’image à gauche et la citation à droite.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:41:\"core/group,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:6:\"images\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:2432:\"<!-- wp:media-text {\"mediaPosition\":\"right\",\"mediaId\":5263,\"mediaLink\":\"https://wordpress.org/patterns/pattern/image-and-quote-on-a-background/pear-3/\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\",\"style\":{\"color\":{\"background\":\"#f1f5c7\"}}} -->\n<div class=\"wp-block-media-text alignwide has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#f1f5c7\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/patterns/files/2021/06/pear-1-1024x1024.png\" alt=\"\" class=\"wp-image-5263 size-full\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-group\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.2\",\"fontSize\":\"36px\"}}} -->\n<p style=\"font-size:36px;line-height:1.2\"><strong>Même le fruit le plus amer contient du sucre.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph {\"fontSize\":\"extra-small\"} -->\n<p class=\"has-extra-small-font-size\">– Terry a. O’Neal</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div></div>\n<!-- /wp:media-text -->\n\n<!-- wp:media-text {\"mediaId\":673,\"mediaLink\":\"https://wordpress.org/patterns/pear-half/\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\",\"style\":{\"color\":{\"background\":\"#fffdea\"}}} -->\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#fffdea\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/patterns/files/2021/06/pear-half-1024x1024.png\" alt=\"\" class=\"wp-image-673 size-full\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-group\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.2\",\"fontSize\":\"36px\"}}} -->\n<p style=\"font-size:36px;line-height:1.2\"><strong>Les arbres qui mettent du temps à pousser donnent les meilleurs fruits.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph {\"fontSize\":\"extra-small\"} -->\n<p class=\"has-extra-small-font-size\">– Molière</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div></div>\n<!-- /wp:media-text -->\";}i:3;O:8:\"stdClass\":7:{s:2:\"id\";i:1290;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:11:\"Évènement\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1663:\"\n<div class=\"wp-elements-3a87edf8748e353341993873368aa148 wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-top has-text-color has-background has-link-color\" style=\"color:#fffdc7;background-color:#121c1c;grid-template-columns:auto 60%\"><div class=\"wp-block-media-text__content\">\n<div class=\"wp-elements-b94d31a8170cfb1b430035d912452f46 wp-block-group has-link-color is-layout-flow\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" style=\"font-size:48px;font-weight:700;line-height:1.15\">Fête <br>d‘ouverture</h2>\n\n\n\n<p class=\"wp-elements-0860918d5b16b9e1778b1966b333b980 has-text-color has-link-color\" style=\"color:#fffdc7\"><strong><a href=\"#\">RSVP →</a></strong></p>\n</div>\n</div><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1024x1024.jpg\" alt=\"\" class=\"wp-image-590 size-full\" srcset=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1024x1024.jpg 1024w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-300x300.jpg 300w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-150x150.jpg 150w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-768x768.jpg 768w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1536x1536.jpg 1536w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1.jpg 1572w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:54:\"core/group,core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";i:2;s:6:\"images\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1623:\"<!-- wp:media-text {\"align\":\"full\",\"mediaPosition\":\"right\",\"mediaId\":590,\"mediaLink\":\"https://wordpress.org/patterns/image-from-rawpixel-id-430289-jpeg-1/\",\"mediaType\":\"image\",\"mediaWidth\":60,\"verticalAlignment\":\"top\",\"style\":{\"color\":{\"background\":\"#121c1c\",\"text\":\"#fffdc7\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#fffdc7\"}}}}} -->\n<div class=\"wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-top has-text-color has-background has-link-color\" style=\"color:#fffdc7;background-color:#121c1c;grid-template-columns:auto 60%\"><div class=\"wp-block-media-text__content\"><!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}},\"elements\":{\"link\":{\"color\":{\"text\":\"#fffdc7\"}}}}} -->\n<div class=\"wp-block-group has-link-color\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontWeight\":\"700\",\"fontSize\":\"48px\",\"lineHeight\":\"1.15\"}}} -->\n<h2 class=\"wp-block-heading\" style=\"font-size:48px;font-weight:700;line-height:1.15\">Fête <br>d‘ouverture</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"elements\":{\"link\":{\"color\":{\"text\":\"#fffdc7\"}}},\"color\":{\"text\":\"#fffdc7\"}}} -->\n<p class=\"has-text-color has-link-color\" style=\"color:#fffdc7\"><strong><a href=\"#\">RSVP →</a></strong></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1024x1024.jpg\" alt=\"\" class=\"wp-image-590 size-full\" /></figure></div>\n<!-- /wp:media-text -->\";}i:4;O:8:\"stdClass\":7:{s:2:\"id\";i:8524;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:38:\"Annonce détaillée d’un événement\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1621:\"\n<div class=\"wp-elements-bdaf09705b636e6e43f0db96ecd59640 wp-block-group alignfull has-black-color has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#d2cdc7\">\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 class=\"alignwide wp-block-heading\" style=\"font-size:46px;font-weight:400;line-height:1.1\">HÉLÈNE DUMAS<br><em>FRAGMENTS</em></h2>\n\n\n\n<h3 class=\"alignwide wp-block-heading\" style=\"font-size:46px;font-weight:400;line-height:1.1\">DU 20/04 AU 9/09/2021<br>SOUTH LONDON GALLERY</h3>\n\n\n\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-15\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:25%\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:75%\">\n<figure class=\"wp-block-image size-full\"><img decoding=\"async\" src=\"https://mywptesting.site/wp-content/uploads/2021/06/Histoire_naturelle_..._-fragments-_-_Upper_cover_C108eee15-1.jpg\" alt=\"\" class=\"wp-image-3173\" /></figure>\n</div>\n</div>\n\n\n\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-18\">\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:25px\">PLUS d’INFO SUR : WP.ORG · +44 21 1234 5678</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p class=\"has-text-align-right\" style=\"font-size:25px\">INSTAGRAM · <a href=\"#\">BILLETS</a></p>\n</div>\n</div>\n\n\n\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:86:\"core/column,core/columns,core/group,core/heading,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:6:\"images\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:2629:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#d2cdc7\"},\"elements\":{\"link\":{\"color\":{\"text\":\"var:preset|color|black\"}}}},\"textColor\":\"black\"} -->\n<div class=\"wp-block-group alignfull has-black-color has-text-color has-background has-link-color\" style=\"background-color:#d2cdc7\"><!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:heading {\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"46px\",\"lineHeight\":\"1.1\",\"fontWeight\":\"400\"}}} -->\n<h2 class=\"alignwide\" style=\"font-size:46px;font-weight:400;line-height:1.1\">HÉLÈNE DUMAS<br><em>FRAGMENTS</em></h2>\n<!-- /wp:heading -->\n\n<!-- wp:heading {\"level\":3,\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"46px\",\"lineHeight\":\"1.1\",\"fontWeight\":\"400\"}}} -->\n<h3 class=\"alignwide\" style=\"font-size:46px;font-weight:400;line-height:1.1\">DU 20/04 AU 9/09/2021<br>SOUTH LONDON GALLERY</h3>\n<!-- /wp:heading -->\n\n<!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"25%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:25%\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"75%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:75%\"><!-- wp:image {\"id\":3173,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-full\"><img src=\"https://mywptesting.site/wp-content/uploads/2021/06/Histoire_naturelle_..._-fragments-_-_Upper_cover_C108eee15-1.jpg\" alt=\"\" class=\"wp-image-3173\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"25px\"}}} -->\n<p style=\"font-size:25px\">PLUS d’INFO SUR : WP.ORG · +44 21 1234 5678</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"align\":\"right\",\"style\":{\"typography\":{\"fontSize\":\"25px\"}}} -->\n<p class=\"has-text-align-right\" style=\"font-size:25px\">INSTAGRAM · <a href=\"#\">BILLETS</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:group -->\";}i:5;O:8:\"stdClass\":7:{s:2:\"id\";i:1372;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:39:\"Image sur couleur unie avec description\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1727:\"\n<div class=\"wp-block-columns alignfull is-layout-flex wp-container-24\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\">\n<div class=\"wp-block-cover has-background-dim\" style=\"background-color:#f6f6f6;min-height:600px\"><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-medium\"><img decoding=\"async\" loading=\"lazy\" width=\"263\" height=\"300\" src=\"https://s.w.org/patterns/files/2021/06/wire-sculpture-263x300.jpg\" alt=\"\" class=\"wp-image-571\" srcset=\"https://s.w.org/patterns/files/2021/06/wire-sculpture-263x300.jpg 263w, https://s.w.org/patterns/files/2021/06/wire-sculpture-898x1024.jpg 898w, https://s.w.org/patterns/files/2021/06/wire-sculpture-768x875.jpg 768w, https://s.w.org/patterns/files/2021/06/wire-sculpture-1347x1536.jpg 1347w, https://s.w.org/patterns/files/2021/06/wire-sculpture.jpg 1658w\" sizes=\"(max-width: 263px) 100vw, 263px\" /></figure></div>\n</div></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\" style=\"padding-top:1em;padding-right:1em;padding-bottom:1em;padding-left:1em\">\n<div class=\"wp-block-columns is-layout-flex wp-container-22\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:320px\">\n<p class=\"has-small-font-size\" style=\"line-height:1.6\"><strong>Avion</strong></p>\n\n\n\n<p class=\"has-small-font-size\" style=\"line-height:1.6\">Fil de cuivre, base en bois. J’ai créé cette pièce à la fin de l’année 2008. Pour cette œuvre, j’ai cherché à transmettre à la fois la lourdeur industrielle d’un avion, mais aussi la sensation de flottement, semblable à celui d’un nuage, que l’on ressent lorsque l’on est dans un avion.</p>\n</div>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:43:\"Image avec aplat de couleur et description.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:61:\"core/column,core/columns,core/cover,core/image,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:6:\"images\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1925:\"<!-- wp:columns {\"align\":\"full\"} -->\n<div class=\"wp-block-columns alignfull\"><!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:cover {\"customOverlayColor\":\"#f6f6f6\",\"minHeight\":600} -->\n<div class=\"wp-block-cover has-background-dim\" style=\"background-color:#f6f6f6;min-height:600px\"><div class=\"wp-block-cover__inner-container\"><!-- wp:image {\"align\":\"center\",\"id\":571,\"sizeSlug\":\"medium\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-medium\"><img src=\"https://s.w.org/patterns/files/2021/06/wire-sculpture-263x300.jpg\" alt=\"\" class=\"wp-image-571\" /></figure></div>\n<!-- /wp:image --></div></div>\n<!-- /wp:cover --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"1em\",\"right\":\"1em\",\"bottom\":\"1em\",\"left\":\"1em\"}}}} -->\n<div class=\"wp-block-column is-vertically-aligned-center\" style=\"padding-top:1em;padding-right:1em;padding-bottom:1em;padding-left:1em\"><!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column {\"width\":\"320px\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:320px\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.6\"}},\"fontSize\":\"small\"} -->\n<p class=\"has-small-font-size\" style=\"line-height:1.6\"><strong>Avion</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.6\"}},\"fontSize\":\"small\"} -->\n<p class=\"has-small-font-size\" style=\"line-height:1.6\">Fil de cuivre, base en bois. J’ai créé cette pièce à la fin de l’année 2008. Pour cette œuvre, j’ai cherché à transmettre à la fois la lourdeur industrielle d’un avion, mais aussi la sensation de flottement, semblable à celui d’un nuage, que l’on ressent lorsque l’on est dans un avion.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:6;O:8:\"stdClass\":7:{s:2:\"id\";i:8085;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:36:\"Images décalées avec descriptions.\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1757:\"\n<div class=\"wp-block-columns is-layout-flex wp-container-27\">\n<div class=\"wp-block-column is-layout-flow\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" loading=\"lazy\" width=\"793\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/Iris-793x1024.jpg\" alt=\"\" class=\"wp-image-525\" srcset=\"https://s.w.org/patterns/files/2021/06/Iris-793x1024.jpg 793w, https://s.w.org/patterns/files/2021/06/Iris-232x300.jpg 232w, https://s.w.org/patterns/files/2021/06/Iris-768x992.jpg 768w, https://s.w.org/patterns/files/2021/06/Iris-1189x1536.jpg 1189w, https://s.w.org/patterns/files/2021/06/Iris-1586x2048.jpg 1586w, https://s.w.org/patterns/files/2021/06/Iris.jpg 1920w\" sizes=\"(max-width: 793px) 100vw, 793px\" /></figure>\n\n\n\n<p style=\"font-size:14px\"><strong>Iris blancs</strong><br>Ogawa Kazumasa</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p style=\"font-size:14px\"><strong>Fleurs de cerisier</strong><br>Ogawa Kazumasa</p>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" loading=\"lazy\" width=\"707\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/Cherry-Blossom-707x1024.jpg\" alt=\"\" class=\"wp-image-524\" srcset=\"https://s.w.org/patterns/files/2021/06/Cherry-Blossom-707x1024.jpg 707w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-207x300.jpg 207w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-768x1112.jpg 768w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-1061x1536.jpg 1061w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-1414x2048.jpg 1414w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-scaled.jpg 1768w\" sizes=\"(max-width: 707px) 100vw, 707px\" /></figure>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:36:\"Images décalées avec descriptions.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:62:\"core/column,core/columns,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:7:\"gallery\";i:2;s:6:\"images\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1178:\"<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:image {\"id\":525,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/patterns/files/2021/06/Iris-793x1024.jpg\" alt=\"\" class=\"wp-image-525\" /></figure>\n<!-- /wp:image -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"14px\"}}} -->\n<p style=\"font-size:14px\"><strong>Iris blancs</strong><br>Ogawa Kazumasa</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"14px\"}}} -->\n<p style=\"font-size:14px\"><strong>Fleurs de cerisier</strong><br>Ogawa Kazumasa</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":524,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/patterns/files/2021/06/Cherry-Blossom-707x1024.jpg\" alt=\"\" class=\"wp-image-524\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:7;O:8:\"stdClass\":7:{s:2:\"id\";i:1306;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:39:\"Image avec description en bas à droite\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1462:\"\n<div class=\"wp-block-columns is-layout-flex wp-container-32\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:10%\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-1024x1024.jpg\" alt=\"Représentation ancienne de Cupidon\" class=\"wp-image-522\" srcset=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-1024x1024.jpg 1024w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-300x300.jpg 300w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-150x150.jpg 150w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-768x768.jpg 768w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1.jpg 1510w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:10%\"></div>\n</div>\n\n\n\n<div class=\"wp-block-columns is-layout-flex wp-container-35\">\n<div class=\"wp-block-column is-layout-flow\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:14px\"><strong>Cupidon en plein vol</strong><br>Carré de 121 cm de côté<br>Impression « giclée » sur papier non-acide.</p>\n</div>\n</div>\n\n\n\n<p></p>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:51:\"Image avec une description en-dessous et à droite.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:50:\"core/column,core/columns,core/image,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:6:\"images\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1288:\"<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column {\"width\":\"10%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:10%\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:image {\"id\":522,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-1024x1024.jpg\" alt=\"Représentation ancienne de Cupidon\" class=\"wp-image-522\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"10%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:10%\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"14px\"}}} -->\n<p style=\"font-size:14px\"><strong>Cupidon en plein vol</strong><br>Carré de 121 cm de côté<br>Impression « giclée » sur papier non-acide.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\";}i:8;O:8:\"stdClass\":7:{s:2:\"id\";i:1310;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:27:\"Détails de l’évènement\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1520:\"\n<figure class=\"wp-block-image alignwide size-full\"><img decoding=\"async\" loading=\"lazy\" width=\"2560\" height=\"1227\" src=\"https://s.w.org/patterns/files/2021/06/Group-17-scaled.jpg\" alt=\"Image d’une femme portée dans les airs par des cygnes.\" class=\"wp-image-501\" srcset=\"https://s.w.org/patterns/files/2021/06/Group-17-scaled.jpg 2560w, https://s.w.org/patterns/files/2021/06/Group-17-300x144.jpg 300w, https://s.w.org/patterns/files/2021/06/Group-17-1024x491.jpg 1024w, https://s.w.org/patterns/files/2021/06/Group-17-768x368.jpg 768w, https://s.w.org/patterns/files/2021/06/Group-17-1536x736.jpg 1536w, https://s.w.org/patterns/files/2021/06/Group-17-2048x981.jpg 2048w\" sizes=\"(max-width: 2560px) 100vw, 2560px\" /></figure>\n\n\n\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center is-layout-flex wp-container-40\">\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<p style=\"line-height:2\"><strong>Localisation :</strong><br>82 Main St. Brooklyn, NY</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<p style=\"line-height:2\"><strong>Date :</strong><br>24 octobre 2021</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<div class=\"wp-block-buttons is-layout-flex\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"background-color:#262626;color:#efefef\">Acheter des billets</a></div>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:28:\"Détails de l’évènement.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/button,core/buttons,core/column,core/columns,core/image,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1635:\"<!-- wp:image {\"align\":\"wide\",\"id\":501,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image alignwide size-full\"><img src=\"https://s.w.org/patterns/files/2021/06/Group-17-scaled.jpg\" alt=\"Image d’une femme portée dans les airs par des cygnes.\" class=\"wp-image-501\" /></figure>\n<!-- /wp:image -->\n\n<!-- wp:columns {\"verticalAlignment\":\"center\",\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center\"><!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"2\"}}} -->\n<p style=\"line-height:2\"><strong>Localisation :</strong><br>82 Main St. Brooklyn, NY</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"2\"}}} -->\n<p style=\"line-height:2\"><strong>Date :</strong><br>24 octobre 2021</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:buttons -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"width\":100,\"style\":{\"color\":{\"background\":\"#262626\",\"text\":\"#efefef\"}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"background-color:#262626;color:#efefef\">Acheter des billets</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:9;O:8:\"stdClass\":7:{s:2:\"id\";i:1320;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:23:\"Trois colonnes de texte\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1020:\"\n<div class=\"wp-block-columns alignfull has-text-color has-background is-layout-flex wp-container-44\" style=\"background-color:#ffffff;color:#000000\">\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Visite virtuelle ↗</a></strong></h3>\n\n\n\n<p>Parcourez le musée depuis votre ordinateur. Idéal pour les écoles et les événements.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Expos actuelles ↗</a></strong></h3>\n\n\n\n<p>Suivez nos actualités et parcourez nos expositions en cours ici.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Infos utiles ↗</a></strong></h3>\n\n\n\n<p>Découvrez nos horaires d’ouverture, les prix des billets et les réductions.</p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:24:\"Trois colonnes de texte.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:52:\"core/column,core/columns,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1564:\"<!-- wp:columns {\"align\":\"full\",\"style\":{\"color\":{\"text\":\"#000000\",\"background\":\"#ffffff\"}}} -->\n<div class=\"wp-block-columns alignfull has-text-color has-background\" style=\"background-color:#ffffff;color:#000000\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Visite virtuelle ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Parcourez le musée depuis votre ordinateur. Idéal pour les écoles et les événements.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Expos actuelles ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Suivez nos actualités et parcourez nos expositions en cours ici.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Infos utiles ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Découvrez nos horaires d’ouverture, les prix des billets et les réductions.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:10;O:8:\"stdClass\":7:{s:2:\"id\";i:1321;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:35:\"Trois colonnes avec images et texte\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:3028:\"\n<div class=\"wp-block-group alignfull has-background is-layout-flow\" style=\"background-color:#f8f4e4\">\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-46\">\n<div class=\"wp-block-column is-layout-flow\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h6 class=\"has-text-color wp-block-heading\" id=\"ecosystem\" style=\"color:#000000\">ÉCOSYSTÈME</h6>\n\n\n\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Croissance positive.</strong></p>\n\n\n\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-50\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.38%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>La Nature</em>, dans le sens courant, désigne les essences inchangées par l’homme ; l’espace, l’air, le fleuve, la feuille.&nbsp;<em>L’Art</em>&nbsp;s’applique au mélange de sa volonté avec les mêmes choses, comme dans une maison, un canal, une statue, un tableau. Mais ses opérations prises ensemble sont si insignifiantes, un peu d’écaillage, de cuisson, de rapiéçage, de lavage, que dans une impression aussi grandiose que celle du monde sur l’esprit humain, elles ne changent pas le résultat.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33%\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"Le soleil se couchant derrière une forêt dense.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.62%\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Des éoliennes se tiennent sur une plaine herbeuse, avec un ciel bleu en arrière-plan.\" /></figure>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-53\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:67%\">\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"Le soleil brille au dessus d’une crête donnant sur le bord de mer. Plus loin, une voiture est visible.\" /></figure></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\" style=\"flex-basis:33%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Sans doute n’avons-nous pas de questions à poser qui soient sans réponse. Nous devons faire confiance à la perfection de la création au point de croire que, quelle que soit la curiosité que l’ordre des choses a éveillée dans notre esprit, l’ordre des choses peut la satisfaire. La condition de chaque homme est une solution en hiéroglyphes aux questions qu’il poserait.</p>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:96:\"Trois colonnes avec des images et du texte, avec un espacement vertical pour un aspect décalé.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:86:\"core/column,core/columns,core/group,core/heading,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:4184:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#f8f4e4\"}}} -->\n<div class=\"wp-block-group alignfull has-background\" style=\"background-color:#f8f4e4\"><!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:heading {\"level\":6,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h6 class=\"has-text-color\" id=\"ecosystem\" style=\"color:#000000\">ÉCOSYSTÈME</h6>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"5vw\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Croissance positive.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:spacer {\"height\":\"5px\"} -->\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"33.38%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.38%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>La Nature</em>, dans le sens courant, désigne les essences inchangées par l’homme ; l’espace, l’air, le fleuve, la feuille.&nbsp;<em>L’Art</em>&nbsp;s’applique au mélange de sa volonté avec les mêmes choses, comme dans une maison, un canal, une statue, un tableau. Mais ses opérations prises ensemble sont si insignifiantes, un peu d’écaillage, de cuisson, de rapiéçage, de lavage, que dans une impression aussi grandiose que celle du monde sur l’esprit humain, elles ne changent pas le résultat.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33%\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"Le soleil se couchant derrière une forêt dense.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33.62%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.62%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Des éoliennes se tiennent sur une plaine herbeuse, avec un ciel bleu en arrière-plan.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"67%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:67%\"><!-- wp:image {\"align\":\"right\",\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"Le soleil brille au dessus d’une crête donnant sur le bord de mer. Plus loin, une voiture est visible.\" /></figure></div>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"width\":\"33%\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\" style=\"flex-basis:33%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Sans doute n’avons-nous pas de questions à poser qui soient sans réponse. Nous devons faire confiance à la perfection de la création au point de croire que, quelle que soit la curiosité que l’ordre des choses a éveillée dans notre esprit, l’ordre des choses peut la satisfaire. La condition de chaque homme est une solution en hiéroglyphes aux questions qu’il poserait.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:group -->\";}i:11;O:8:\"stdClass\":7:{s:2:\"id\";i:1355;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:40:\"Média et texte avec image sur la gauche\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:568:\"\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Vue de près d’un détail architectural.\" /></figure><div class=\"wp-block-media-text__content\">\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Espaces ouverts</strong></h3>\n\n\n\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">Voir l’étude de cas ↗</a></p>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:74:\"Bloc média et bloc texte, avec l’image à gauche et le texte à droite.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:43:\"core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:858:\"<!-- wp:media-text {\"align\":\"full\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Vue de près d’un détail architectural.\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"textAlign\":\"center\",\"level\":3,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Espaces ouverts</strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">Voir l’étude de cas ↗</a></p>\n<!-- /wp:paragraph --></div></div>\n<!-- /wp:media-text -->\";}i:12;O:8:\"stdClass\":7:{s:2:\"id\";i:1325;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:44:\"Large en-tête avec texte aligné à gauche.\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1260:\"\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forêt.</h2>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-57\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:55%\">\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Même un enfant sait combien la forêt est précieuse. L’odeur fraîche des arbres, à vous couper le souffle. L’écho des oiseaux volant au-dessus de cette magnitude dense. Un climat stable, une vie durable et diversifiée et une source de culture. Pourtant, les forêts et d’autres écosystèmes sont en péril, menacés de devenir des terres de culture, des pâturages ou des plantations.</em></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:35:\"Bannière avec une citation en haut\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:0:\"\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/column,core/columns,core/cover,core/heading,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1777:\"<!-- wp:cover {\"url\":\"https://s.w.org/images/core/5.8/forest.jpg\",\"dimRatio\":60,\"minHeight\":800,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:heading {\"align\":\"wide\",\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"fontSize\":\"64px\"}}} -->\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forêt.</h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"55%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:55%\"><!-- wp:spacer {\"height\":\"330px\"} -->\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"lineHeight\":\"1.3\",\"fontSize\":\"12px\"}}} -->\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Même un enfant sait combien la forêt est précieuse. L’odeur fraîche des arbres, à vous couper le souffle. L’écho des oiseaux volant au-dessus de cette magnitude dense. Un climat stable, une vie durable et diversifiée et une source de culture. Pourtant, les forêts et d’autres écosystèmes sont en péril, menacés de devenir des terres de culture, des pâturages ou des plantations.</em></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div></div>\n<!-- /wp:cover -->\";}i:13;O:8:\"stdClass\":7:{s:2:\"id\";i:1326;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:5:\"Titre\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:608:\"\n<h2 class=\"alignwide wp-block-heading\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">Nous sommes un studio situé à Berlin, avec une forte expérience internationale dans les domaines de l’architecture, de l’urbanisme et de l’aménagement intérieur. Nous croyons au partage des connaissances et à la promotion du dialogue pour accroître le potentiel créatif de la collaboration.</h2>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:18:\"grand texte, titre\";s:16:\"wpop_description\";s:14:\"Texte du titre\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:12:\"core/heading\";}s:11:\"wpop_locale\";s:5:\"fr_FR\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:12:\"core/heading\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:709:\"<!-- wp:heading {\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"48px\",\"lineHeight\":\"1.1\"}}} -->\n<h2 class=\"alignwide\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">Nous sommes un studio situé à Berlin, avec une forte expérience internationale dans les domaines de l’architecture, de l’urbanisme et de l’aménagement intérieur. Nous croyons au partage des connaissances et à la promotion du dialogue pour accroître le potentiel créatif de la collaboration.</h2>\n<!-- /wp:heading -->\";}i:14;O:8:\"stdClass\":7:{s:2:\"id\";i:207567;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:11:\"Link in Bio\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:6361:\"\n<div class=\"wp-block-group has-white-background-color has-background is-layout-flow\" style=\"padding-top:var(--wp--preset--spacing--80);padding-right:0;padding-bottom:var(--wp--preset--spacing--80);padding-left:0\"><h1 style=\"font-style:normal;font-weight:700;\" class=\"has-text-align-center wp-block-site-title has-medium-font-size\"><a href=\"https://wordpress.org/patterns\" target=\"_self\" rel=\"home\">Block Pattern Directory</a></h1>\n\n<p class=\"has-text-align-center wp-block-site-tagline\">Beautifully designed patterns ready to go with a simple copy/paste</p>\n\n\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-buttons is-content-justification-center is-layout-flex wp-container-58\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link wp-element-button\">Watch my latest videos</a></div>\n\n\n\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link wp-element-button\">Buy merch</a></div>\n\n\n\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link wp-element-button\">Support me on Patreon</a></div>\n\n\n\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100 is-style-fill\"><a class=\"wp-block-button__link wp-element-button\">Get tickets for my show</a></div>\n</div>\n\n\n\n<ul class=\"wp-block-social-links has-normal-icon-size has-icon-color has-icon-background-color is-content-justification-center is-layout-flex wp-container-59\" style=\"padding-top:var(--wp--preset--spacing--60);padding-bottom:var(--wp--preset--spacing--60)\"><li style=\"color: #000000; background-color: #ffffff; \" class=\"wp-social-link wp-social-link-instagram wp-block-social-link\"><a href=\"https://wordpress.org/patterns/\" class=\"wp-block-social-link-anchor\"><svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" aria-hidden=\"true\" focusable=\"false\"><path d=\"M12,4.622c2.403,0,2.688,0.009,3.637,0.052c0.877,0.04,1.354,0.187,1.671,0.31c0.42,0.163,0.72,0.358,1.035,0.673 c0.315,0.315,0.51,0.615,0.673,1.035c0.123,0.317,0.27,0.794,0.31,1.671c0.043,0.949,0.052,1.234,0.052,3.637 s-0.009,2.688-0.052,3.637c-0.04,0.877-0.187,1.354-0.31,1.671c-0.163,0.42-0.358,0.72-0.673,1.035 c-0.315,0.315-0.615,0.51-1.035,0.673c-0.317,0.123-0.794,0.27-1.671,0.31c-0.949,0.043-1.233,0.052-3.637,0.052 s-2.688-0.009-3.637-0.052c-0.877-0.04-1.354-0.187-1.671-0.31c-0.42-0.163-0.72-0.358-1.035-0.673 c-0.315-0.315-0.51-0.615-0.673-1.035c-0.123-0.317-0.27-0.794-0.31-1.671C4.631,14.688,4.622,14.403,4.622,12 s0.009-2.688,0.052-3.637c0.04-0.877,0.187-1.354,0.31-1.671c0.163-0.42,0.358-0.72,0.673-1.035 c0.315-0.315,0.615-0.51,1.035-0.673c0.317-0.123,0.794-0.27,1.671-0.31C9.312,4.631,9.597,4.622,12,4.622 M12,3 C9.556,3,9.249,3.01,8.289,3.054C7.331,3.098,6.677,3.25,6.105,3.472C5.513,3.702,5.011,4.01,4.511,4.511 c-0.5,0.5-0.808,1.002-1.038,1.594C3.25,6.677,3.098,7.331,3.054,8.289C3.01,9.249,3,9.556,3,12c0,2.444,0.01,2.751,0.054,3.711 c0.044,0.958,0.196,1.612,0.418,2.185c0.23,0.592,0.538,1.094,1.038,1.594c0.5,0.5,1.002,0.808,1.594,1.038 c0.572,0.222,1.227,0.375,2.185,0.418C9.249,20.99,9.556,21,12,21s2.751-0.01,3.711-0.054c0.958-0.044,1.612-0.196,2.185-0.418 c0.592-0.23,1.094-0.538,1.594-1.038c0.5-0.5,0.808-1.002,1.038-1.594c0.222-0.572,0.375-1.227,0.418-2.185 C20.99,14.751,21,14.444,21,12s-0.01-2.751-0.054-3.711c-0.044-0.958-0.196-1.612-0.418-2.185c-0.23-0.592-0.538-1.094-1.038-1.594 c-0.5-0.5-1.002-0.808-1.594-1.038c-0.572-0.222-1.227-0.375-2.185-0.418C14.751,3.01,14.444,3,12,3L12,3z M12,7.378 c-2.552,0-4.622,2.069-4.622,4.622S9.448,16.622,12,16.622s4.622-2.069,4.622-4.622S14.552,7.378,12,7.378z M12,15 c-1.657,0-3-1.343-3-3s1.343-3,3-3s3,1.343,3,3S13.657,15,12,15z M16.804,6.116c-0.596,0-1.08,0.484-1.08,1.08 s0.484,1.08,1.08,1.08c0.596,0,1.08-0.484,1.08-1.08S17.401,6.116,16.804,6.116z\"></path></svg><span class=\"wp-block-social-link-label screen-reader-text\">Instagram</span></a></li>\n\n<li style=\"color: #000000; background-color: #ffffff; \" class=\"wp-social-link wp-social-link-bandcamp wp-block-social-link\"><a href=\"https://wordpress.org/patterns/\" class=\"wp-block-social-link-anchor\"><svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" aria-hidden=\"true\" focusable=\"false\"><path d=\"M15.27 17.289 3 17.289 8.73 6.711 21 6.711 15.27 17.289\"></path></svg><span class=\"wp-block-social-link-label screen-reader-text\">Bandcamp</span></a></li>\n\n<li style=\"color: #000000; background-color: #ffffff; \" class=\"wp-social-link wp-social-link-twitter wp-block-social-link\"><a href=\"https://wordpress.org/patterns/\" class=\"wp-block-social-link-anchor\"><svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" aria-hidden=\"true\" focusable=\"false\"><path d=\"M22.23,5.924c-0.736,0.326-1.527,0.547-2.357,0.646c0.847-0.508,1.498-1.312,1.804-2.27 c-0.793,0.47-1.671,0.812-2.606,0.996C18.324,4.498,17.257,4,16.077,4c-2.266,0-4.103,1.837-4.103,4.103 c0,0.322,0.036,0.635,0.106,0.935C8.67,8.867,5.647,7.234,3.623,4.751C3.27,5.357,3.067,6.062,3.067,6.814 c0,1.424,0.724,2.679,1.825,3.415c-0.673-0.021-1.305-0.206-1.859-0.513c0,0.017,0,0.034,0,0.052c0,1.988,1.414,3.647,3.292,4.023 c-0.344,0.094-0.707,0.144-1.081,0.144c-0.264,0-0.521-0.026-0.772-0.074c0.522,1.63,2.038,2.816,3.833,2.85 c-1.404,1.1-3.174,1.756-5.096,1.756c-0.331,0-0.658-0.019-0.979-0.057c1.816,1.164,3.973,1.843,6.29,1.843 c7.547,0,11.675-6.252,11.675-11.675c0-0.178-0.004-0.355-0.012-0.531C20.985,7.47,21.68,6.747,22.23,5.924z\"></path></svg><span class=\"wp-block-social-link-label screen-reader-text\">Twitter</span></a></li>\n\n<li style=\"color: #000000; background-color: #ffffff; \" class=\"wp-social-link wp-social-link-twitch wp-block-social-link\"><a href=\"https://wordpress.org/patterns/\" class=\"wp-block-social-link-anchor\"><svg width=\"24\" height=\"24\" viewBox=\"0 0 24 24\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" aria-hidden=\"true\" focusable=\"false\"><path d=\"M16.499,8.089h-1.636v4.91h1.636V8.089z M12,8.089h-1.637v4.91H12V8.089z M4.228,3.178L3,6.451v13.092h4.499V22h2.456 l2.454-2.456h3.681L21,14.636V3.178H4.228z M19.364,13.816l-2.864,2.865H12l-2.453,2.453V16.68H5.863V4.814h13.501V13.816z\"></path></svg><span class=\"wp-block-social-link-label screen-reader-text\">Twitch</span></a></li></ul>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:3:\"6.1\";s:25:\"wpop_contains_block_types\";s:116:\"core/button,core/buttons,core/group,core/site-tagline,core/site-title,core/social-link,core/social-links,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:9:\"wireframe\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:2665:\"<!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"var:preset|spacing|80\",\"right\":\"0\",\"bottom\":\"var:preset|spacing|80\",\"left\":\"0\"}}},\"backgroundColor\":\"white\",\"layout\":{\"type\":\"default\"}} -->\n<div class=\"wp-block-group has-white-background-color has-background\" style=\"padding-top:var(--wp--preset--spacing--80);padding-right:0;padding-bottom:var(--wp--preset--spacing--80);padding-left:0\"><!-- wp:site-title {\"textAlign\":\"center\",\"style\":{\"typography\":{\"fontStyle\":\"normal\",\"fontWeight\":\"700\"}},\"fontSize\":\"medium\"} /-->\n\n<!-- wp:site-tagline {\"textAlign\":\"center\"} /-->\n\n<!-- wp:spacer {\"height\":\"20px\"} -->\n<div style=\"height:20px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:buttons {\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\"}} -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"width\":100} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link wp-element-button\">Watch my latest videos</a></div>\n<!-- /wp:button -->\n\n<!-- wp:button {\"width\":100} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link wp-element-button\">Buy merch</a></div>\n<!-- /wp:button -->\n\n<!-- wp:button {\"width\":100} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link wp-element-button\">Support me on Patreon</a></div>\n<!-- /wp:button -->\n\n<!-- wp:button {\"width\":100,\"className\":\"is-style-fill\"} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100 is-style-fill\"><a class=\"wp-block-button__link wp-element-button\">Get tickets for my show</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons -->\n\n<!-- wp:social-links {\"iconColor\":\"black\",\"iconColorValue\":\"#000000\",\"iconBackgroundColor\":\"white\",\"iconBackgroundColorValue\":\"#ffffff\",\"size\":\"has-normal-icon-size\",\"style\":{\"spacing\":{\"blockGap\":{\"top\":\"0\",\"left\":\"0\"},\"padding\":{\"top\":\"var:preset|spacing|60\",\"bottom\":\"var:preset|spacing|60\"}}},\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\"}} -->\n<ul class=\"wp-block-social-links has-normal-icon-size has-icon-color has-icon-background-color\" style=\"padding-top:var(--wp--preset--spacing--60);padding-bottom:var(--wp--preset--spacing--60)\"><!-- wp:social-link {\"url\":\"https://wordpress.org/patterns/\",\"service\":\"instagram\"} /-->\n\n<!-- wp:social-link {\"url\":\"https://wordpress.org/patterns/\",\"service\":\"bandcamp\"} /-->\n\n<!-- wp:social-link {\"url\":\"https://wordpress.org/patterns/\",\"service\":\"twitter\"} /-->\n\n<!-- wp:social-link {\"url\":\"https://wordpress.org/patterns/\",\"service\":\"twitch\"} /--></ul>\n<!-- /wp:social-links --></div>\n<!-- /wp:group -->\";}i:15;O:8:\"stdClass\":7:{s:2:\"id\";i:732;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:21:\"Simple call to action\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:900:\"\n<div class=\"wp-block-group alignfull has-text-color has-background is-layout-flow\" style=\"background-color:#ffffff;color:#000000\">\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-align-center has-small-font-size\" style=\"line-height:.9\"><strong>GET IN TOUCH</strong></p>\n\n\n\n<h2 class=\"has-text-align-center wp-block-heading\" id=\"schedule-a-visit\" style=\"font-size:59px;line-height:1.15\"><strong>Schedule a Visit</strong></h2>\n\n\n\n<div class=\"wp-block-buttons is-horizontal is-content-justification-center is-layout-flex wp-container-61\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-50\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"border-radius:50px;background-color:#000000;color:#ffffff\">Contact us</a></div>\n</div>\n\n\n\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:89:\"A container with a white background. Inside is a centered paragraph, heading, and button.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/button,core/buttons,core/group,core/heading,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"buttons\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1506:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"text\":\"#000000\",\"background\":\"#ffffff\"}}} -->\n<div class=\"wp-block-group alignfull has-text-color has-background\" style=\"background-color:#ffffff;color:#000000\"><!-- wp:spacer {\"height\":64} -->\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"style\":{\"typography\":{\"lineHeight\":\".9\"}},\"fontSize\":\"small\"} -->\n<p class=\"has-text-align-center has-small-font-size\" style=\"line-height:.9\"><strong>GET IN TOUCH</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading {\"textAlign\":\"center\",\"style\":{\"typography\":{\"fontSize\":59,\"lineHeight\":\"1.15\"}}} -->\n<h2 class=\"has-text-align-center\" id=\"schedule-a-visit\" style=\"font-size:59px;line-height:1.15\"><strong>Schedule a Visit</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:buttons {\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"width\":50,\"style\":{\"color\":{\"background\":\"#000000\",\"text\":\"#ffffff\"},\"border\":{\"radius\":\"50px\"}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-50\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"border-radius:50px;background-color:#000000;color:#ffffff\">Contact us</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons -->\n\n<!-- wp:spacer {\"height\":64} -->\n<div style=\"height:64px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:group -->\";}i:16;O:8:\"stdClass\":7:{s:2:\"id\";i:678;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:13:\"Pricing table\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:3342:\"\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-69\">\n<div class=\"wp-elements-9b0ec38802488b5326b5833c551a99b8 wp-block-column has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#ffe97d;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" id=\"single\" style=\"font-size:40px\"><strong>Single</strong></h2>\n\n\n\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Enrich our growing community.</strong> </p>\n\n\n\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n\n\n\n<ul class=\"has-normal-font-size\"><li>General admission and member discounts for one adult</li><li>One free ticket per special exhibition</li><li>Two single-use guest passes per year</li></ul>\n\n\n\n<div class=\"wp-block-buttons alignfull is-horizontal is-content-justification-center is-layout-flex wp-container-63\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$110 / year</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-elements-9add2e813d78c88d00f9bd37bafd7af9 wp-block-column has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#d1d1e1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" id=\"family\" style=\"font-size:40px\"><strong>Family</strong></h2>\n\n\n\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Support special exhibitions.</strong></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<ul class=\"has-normal-font-size\"><li>General admission and member discounts for two adults</li><li>Four free tickets per special exhibition</li><li>Four single-use guest passes per year</li></ul>\n\n\n\n<div class=\"wp-block-buttons alignfull is-horizontal is-content-justification-center is-layout-flex wp-container-65\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100 is-style-fill\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$200 / year</a></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-elements-2500c6475a3fa956c7c9f0264bdaf6c7 wp-block-column has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#c0ebf1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" id=\"patron\" style=\"font-size:40px\"><strong>Patron</strong></h2>\n\n\n\n<p class=\"has-normal-font-size\"><strong>Take support to the next level.</strong></p>\n\n\n\n<hr class=\"wp-block-separator is-style-wide\" />\n\n\n\n<ul class=\"has-normal-font-size\"><li>General admission and member discounts for two adults</li><li>Five free tickets per special exhibition</li><li>Six single-use guest passes per year</li></ul>\n\n\n\n<div class=\"wp-block-buttons alignfull is-horizontal is-content-justification-center is-layout-flex wp-container-67\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$400 / year</a></div>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:272:\"Three equal-width columns set up as a pricing table. The left column has a yellow background, the middle column has a light purple background, and the right column has a light blue background. Each column contains a heading, subheading, separator, list, and then a button.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:102:\"core/button,core/buttons,core/column,core/columns,core/heading,core/list,core/paragraph,core/separator\";}s:14:\"category_slugs\";a:3:{i:0;s:7:\"buttons\";i:1;s:7:\"columns\";i:2;s:8:\"featured\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:5340:\"<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"style\":{\"color\":{\"background\":\"#ffe97d\",\"text\":\"#000000\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#000000\"}}},\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-column has-text-color has-background has-link-color\" style=\"background-color:#ffe97d;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"40px\"}}} -->\n<h2 id=\"single\" style=\"font-size:40px\"><strong>Single</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.5\"}},\"fontSize\":\"normal\"} -->\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Enrich our growing community.</strong> </p>\n<!-- /wp:paragraph -->\n\n<!-- wp:separator {\"customColor\":\"#000000\",\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator has-text-color has-background is-style-wide\" style=\"background-color:#000000;color:#000000\" />\n<!-- /wp:separator -->\n\n<!-- wp:list {\"fontSize\":\"normal\"} -->\n<ul class=\"has-normal-font-size\"><li>General admission and member discounts for one adult</li><li>One free ticket per special exhibition</li><li>Two single-use guest passes per year</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:buttons {\"align\":\"full\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons alignfull\"><!-- wp:button {\"textColor\":\"white\",\"width\":100,\"style\":{\"color\":{\"background\":\"#000000\"},\"border\":{\"radius\":0}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$110 / year</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"style\":{\"color\":{\"background\":\"#d1d1e1\",\"text\":\"#000000\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#000000\"}}},\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-column has-text-color has-background has-link-color\" style=\"background-color:#d1d1e1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"40px\"}}} -->\n<h2 id=\"family\" style=\"font-size:40px\"><strong>Family</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.5\"}},\"fontSize\":\"normal\"} -->\n<p class=\"has-normal-font-size\" style=\"line-height:1.5\"><strong>Support special exhibitions.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:separator {\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator is-style-wide\" />\n<!-- /wp:separator -->\n\n<!-- wp:list {\"fontSize\":\"normal\"} -->\n<ul class=\"has-normal-font-size\"><li>General admission and member discounts for two adults</li><li>Four free tickets per special exhibition</li><li>Four single-use guest passes per year</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:buttons {\"align\":\"full\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons alignfull\"><!-- wp:button {\"textColor\":\"white\",\"width\":100,\"style\":{\"color\":{\"background\":\"#000000\"},\"border\":{\"radius\":0}},\"className\":\"is-style-fill\"} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100 is-style-fill\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$200 / year</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"style\":{\"color\":{\"background\":\"#c0ebf1\",\"text\":\"#000000\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#000000\"}}},\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-column has-text-color has-background has-link-color\" style=\"background-color:#c0ebf1;color:#000000;padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontSize\":\"40px\"}}} -->\n<h2 id=\"patron\" style=\"font-size:40px\"><strong>Patron</strong></h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"fontSize\":\"normal\"} -->\n<p class=\"has-normal-font-size\"><strong>Take support to the next level.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:separator {\"className\":\"is-style-wide\"} -->\n<hr class=\"wp-block-separator is-style-wide\" />\n<!-- /wp:separator -->\n\n<!-- wp:list {\"fontSize\":\"normal\"} -->\n<ul class=\"has-normal-font-size\"><li>General admission and member discounts for two adults</li><li>Five free tickets per special exhibition</li><li>Six single-use guest passes per year</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:buttons {\"align\":\"full\",\"layout\":{\"type\":\"flex\",\"justifyContent\":\"center\",\"orientation\":\"horizontal\"}} -->\n<div class=\"wp-block-buttons alignfull\"><!-- wp:button {\"textColor\":\"white\",\"width\":100,\"style\":{\"color\":{\"background\":\"#000000\"},\"border\":{\"radius\":0}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-white-color has-text-color has-background no-border-radius\" style=\"background-color:#000000\">$400 / year</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:17;O:8:\"stdClass\":7:{s:2:\"id\";i:669;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:31:\"Image and quote on a background\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:2221:\"\n<div class=\"wp-block-media-text alignwide has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#f1f5c7\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/pear-1-1024x1024.png\" alt=\"\" class=\"wp-image-5263 size-full\" srcset=\"https://s.w.org/patterns/files/2021/06/pear-1-1024x1024.png 1024w, https://s.w.org/patterns/files/2021/06/pear-1-300x300.png 300w, https://s.w.org/patterns/files/2021/06/pear-1-150x150.png 150w, https://s.w.org/patterns/files/2021/06/pear-1-768x768.png 768w, https://s.w.org/patterns/files/2021/06/pear-1.png 1300w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure><div class=\"wp-block-media-text__content\">\n<div class=\"wp-block-group is-layout-flow\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<p style=\"font-size:36px;line-height:1.2\"><strong>Even the bitterest fruit has sugar in it.</strong></p>\n\n\n\n<p class=\"has-extra-small-font-size\">– Terry a O&rsquo;Neal</p>\n</div>\n</div></div>\n\n\n\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#fffdea\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/pear-half-1024x1024.png\" alt=\"\" class=\"wp-image-673 size-full\" srcset=\"https://s.w.org/patterns/files/2021/06/pear-half-1024x1024.png 1024w, https://s.w.org/patterns/files/2021/06/pear-half-300x300.png 300w, https://s.w.org/patterns/files/2021/06/pear-half-150x150.png 150w, https://s.w.org/patterns/files/2021/06/pear-half-768x768.png 768w, https://s.w.org/patterns/files/2021/06/pear-half.png 1300w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure><div class=\"wp-block-media-text__content\">\n<div class=\"wp-block-group is-layout-flow\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<p style=\"font-size:36px;line-height:1.2\"><strong>The trees that are slow to grow bear the best fruit.</strong></p>\n\n\n\n<p class=\"has-extra-small-font-size\">– Molière</p>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:221:\"Two media and text blocks. The top one has a pale green background. The text is on the left and contains a quote, and the image is on the right. The next block underneath has the image on the left, and quote on the right.\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:41:\"core/group,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:6:\"images\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:2404:\"<!-- wp:media-text {\"mediaPosition\":\"right\",\"mediaId\":5263,\"mediaLink\":\"https://wordpress.org/patterns/pattern/image-and-quote-on-a-background/pear-3/\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\",\"style\":{\"color\":{\"background\":\"#f1f5c7\"}}} -->\n<div class=\"wp-block-media-text alignwide has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#f1f5c7\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/patterns/files/2021/06/pear-1-1024x1024.png\" alt=\"\" class=\"wp-image-5263 size-full\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-group\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.2\",\"fontSize\":\"36px\"}}} -->\n<p style=\"font-size:36px;line-height:1.2\"><strong>Even the bitterest fruit has sugar in it.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph {\"fontSize\":\"extra-small\"} -->\n<p class=\"has-extra-small-font-size\">– Terry a O\'Neal</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div></div>\n<!-- /wp:media-text -->\n\n<!-- wp:media-text {\"mediaId\":673,\"mediaLink\":\"https://wordpress.org/patterns/pear-half/\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\",\"style\":{\"color\":{\"background\":\"#fffdea\"}}} -->\n<div class=\"wp-block-media-text alignwide is-stacked-on-mobile is-vertically-aligned-center has-background\" style=\"background-color:#fffdea\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/patterns/files/2021/06/pear-half-1024x1024.png\" alt=\"\" class=\"wp-image-673 size-full\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}}}} -->\n<div class=\"wp-block-group\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.2\",\"fontSize\":\"36px\"}}} -->\n<p style=\"font-size:36px;line-height:1.2\"><strong>The trees that are slow to grow bear the best fruit.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph {\"fontSize\":\"extra-small\"} -->\n<p class=\"has-extra-small-font-size\">– Molière</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div></div>\n<!-- /wp:media-text -->\";}i:18;O:8:\"stdClass\":7:{s:2:\"id\";i:591;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:5:\"Event\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1657:\"\n<div class=\"wp-elements-5fce4e677a9b9d7d0cae0196c9d74d97 wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-top has-text-color has-background has-link-color\" style=\"color:#fffdc7;background-color:#121c1c;grid-template-columns:auto 60%\"><div class=\"wp-block-media-text__content\">\n<div class=\"wp-elements-71b4a847bbd96313422a1303e9ba41f3 wp-block-group has-link-color is-layout-flow\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\">\n<h2 class=\"wp-block-heading\" style=\"font-size:48px;font-weight:700;line-height:1.15\">Opening <br>Party</h2>\n\n\n\n<p class=\"wp-elements-0860918d5b16b9e1778b1966b333b980 has-text-color has-link-color\" style=\"color:#fffdc7\"><strong><a href=\"#\">RSVP →</a></strong></p>\n</div>\n</div><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1024x1024.jpg\" alt=\"\" class=\"wp-image-590 size-full\" srcset=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1024x1024.jpg 1024w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-300x300.jpg 300w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-150x150.jpg 150w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-768x768.jpg 768w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1536x1536.jpg 1536w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1.jpg 1572w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:54:\"core/group,core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";i:2;s:6:\"images\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1617:\"<!-- wp:media-text {\"align\":\"full\",\"mediaPosition\":\"right\",\"mediaId\":590,\"mediaLink\":\"https://wordpress.org/patterns/image-from-rawpixel-id-430289-jpeg-1/\",\"mediaType\":\"image\",\"mediaWidth\":60,\"verticalAlignment\":\"top\",\"style\":{\"color\":{\"background\":\"#121c1c\",\"text\":\"#fffdc7\"},\"elements\":{\"link\":{\"color\":{\"text\":\"#fffdc7\"}}}}} -->\n<div class=\"wp-block-media-text alignfull has-media-on-the-right is-stacked-on-mobile is-vertically-aligned-top has-text-color has-background has-link-color\" style=\"color:#fffdc7;background-color:#121c1c;grid-template-columns:auto 60%\"><div class=\"wp-block-media-text__content\"><!-- wp:group {\"style\":{\"spacing\":{\"padding\":{\"top\":\"2em\",\"right\":\"2em\",\"bottom\":\"2em\",\"left\":\"2em\"}},\"elements\":{\"link\":{\"color\":{\"text\":\"#fffdc7\"}}}}} -->\n<div class=\"wp-block-group has-link-color\" style=\"padding-top:2em;padding-right:2em;padding-bottom:2em;padding-left:2em\"><!-- wp:heading {\"style\":{\"typography\":{\"fontWeight\":\"700\",\"fontSize\":\"48px\",\"lineHeight\":\"1.15\"}}} -->\n<h2 class=\"wp-block-heading\" style=\"font-size:48px;font-weight:700;line-height:1.15\">Opening <br>Party</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"elements\":{\"link\":{\"color\":{\"text\":\"#fffdc7\"}}},\"color\":{\"text\":\"#fffdc7\"}}} -->\n<p class=\"has-text-color has-link-color\" style=\"color:#fffdc7\"><strong><a href=\"#\">RSVP →</a></strong></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:group --></div><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-430289-jpeg-1-1024x1024.jpg\" alt=\"\" class=\"wp-image-590 size-full\" /></figure></div>\n<!-- /wp:media-text -->\";}i:19;O:8:\"stdClass\":7:{s:2:\"id\";i:566;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:30:\"Event announcement and details\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1614:\"\n<div class=\"wp-elements-b69341fa8ca2b5011df7156020136c46 wp-block-group alignfull has-black-color has-text-color has-background has-link-color is-layout-flow\" style=\"background-color:#d2cdc7\">\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h2 class=\"alignwide wp-block-heading\" style=\"font-size:46px;font-weight:400;line-height:1.1\">HÉLÈNE DUMAS<br><em>FRAGMENTS</em></h2>\n\n\n\n<h3 class=\"alignwide wp-block-heading\" style=\"font-size:46px;font-weight:400;line-height:1.1\">20/4 — 9/9/2021<br>SOUTH LONDON ART GALLERY</h3>\n\n\n\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-75\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:25%\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:75%\">\n<figure class=\"wp-block-image size-full\"><img decoding=\"async\" src=\"https://mywptesting.site/wp-content/uploads/2021/06/Histoire_naturelle_..._-fragments-_-_Upper_cover_C108eee15-1.jpg\" alt=\"\" class=\"wp-image-3173\" /></figure>\n</div>\n</div>\n\n\n\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-78\">\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:25px\">MORE INFO AT: WP.ORG · +44 21 1234 5678</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p class=\"has-text-align-right\" style=\"font-size:25px\">INSTAGRAM · <a href=\"#\">TICKETS</a></p>\n</div>\n</div>\n\n\n\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:0:\"\";s:19:\"wpop_viewport_width\";i:800;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:86:\"core/column,core/columns,core/group,core/heading,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:6:\"images\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:2622:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#d2cdc7\"},\"elements\":{\"link\":{\"color\":{\"text\":\"var:preset|color|black\"}}}},\"textColor\":\"black\"} -->\n<div class=\"wp-block-group alignfull has-black-color has-text-color has-background has-link-color\" style=\"background-color:#d2cdc7\"><!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:heading {\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"46px\",\"lineHeight\":\"1.1\",\"fontWeight\":\"400\"}}} -->\n<h2 class=\"alignwide\" style=\"font-size:46px;font-weight:400;line-height:1.1\">HÉLÈNE DUMAS<br><em>FRAGMENTS</em></h2>\n<!-- /wp:heading -->\n\n<!-- wp:heading {\"level\":3,\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"46px\",\"lineHeight\":\"1.1\",\"fontWeight\":\"400\"}}} -->\n<h3 class=\"alignwide\" style=\"font-size:46px;font-weight:400;line-height:1.1\">20/4 — 9/9/2021<br>SOUTH LONDON ART GALLERY</h3>\n<!-- /wp:heading -->\n\n<!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"25%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:25%\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"75%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:75%\"><!-- wp:image {\"id\":3173,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-full\"><img src=\"https://mywptesting.site/wp-content/uploads/2021/06/Histoire_naturelle_..._-fragments-_-_Upper_cover_C108eee15-1.jpg\" alt=\"\" class=\"wp-image-3173\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"25px\"}}} -->\n<p style=\"font-size:25px\">MORE INFO AT: WP.ORG · +44 21 1234 5678</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"align\":\"right\",\"style\":{\"typography\":{\"fontSize\":\"25px\"}}} -->\n<p class=\"has-text-align-right\" style=\"font-size:25px\">INSTAGRAM · <a href=\"#\">TICKETS</a></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:spacer {\"height\":50} -->\n<div style=\"height:50px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:group -->\";}i:20;O:8:\"stdClass\":7:{s:2:\"id\";i:573;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:37:\"Image on solid color with description\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1628:\"\n<div class=\"wp-block-columns alignfull is-layout-flex wp-container-84\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:50%\">\n<div class=\"wp-block-cover has-background-dim\" style=\"background-color:#f6f6f6;min-height:600px\"><div class=\"wp-block-cover__inner-container\">\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-medium\"><img decoding=\"async\" loading=\"lazy\" width=\"263\" height=\"300\" src=\"https://s.w.org/patterns/files/2021/06/wire-sculpture-263x300.jpg\" alt=\"\" class=\"wp-image-571\" srcset=\"https://s.w.org/patterns/files/2021/06/wire-sculpture-263x300.jpg 263w, https://s.w.org/patterns/files/2021/06/wire-sculpture-898x1024.jpg 898w, https://s.w.org/patterns/files/2021/06/wire-sculpture-768x875.jpg 768w, https://s.w.org/patterns/files/2021/06/wire-sculpture-1347x1536.jpg 1347w, https://s.w.org/patterns/files/2021/06/wire-sculpture.jpg 1658w\" sizes=\"(max-width: 263px) 100vw, 263px\" /></figure></div>\n</div></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\" style=\"padding-top:1em;padding-right:1em;padding-bottom:1em;padding-left:1em\">\n<div class=\"wp-block-columns is-layout-flex wp-container-82\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:320px\">\n<p class=\"has-small-font-size\" style=\"line-height:1.6\"><strong>Airplane</strong></p>\n\n\n\n<p class=\"has-small-font-size\" style=\"line-height:1.6\">Copper wire, wood base. I created this piece in late 2008. For this work, I aimed to convey both the industrial heaviness of an airplane, but also the cloudlike floating quality you feel when you’re in one.</p>\n</div>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:38:\"Image on solid color with description.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:61:\"core/column,core/columns,core/cover,core/image,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:6:\"images\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1826:\"<!-- wp:columns {\"align\":\"full\"} -->\n<div class=\"wp-block-columns alignfull\"><!-- wp:column {\"width\":\"50%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:50%\"><!-- wp:cover {\"customOverlayColor\":\"#f6f6f6\",\"minHeight\":600} -->\n<div class=\"wp-block-cover has-background-dim\" style=\"background-color:#f6f6f6;min-height:600px\"><div class=\"wp-block-cover__inner-container\"><!-- wp:image {\"align\":\"center\",\"id\":571,\"sizeSlug\":\"medium\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-medium\"><img src=\"https://s.w.org/patterns/files/2021/06/wire-sculpture-263x300.jpg\" alt=\"\" class=\"wp-image-571\" /></figure></div>\n<!-- /wp:image --></div></div>\n<!-- /wp:cover --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"style\":{\"spacing\":{\"padding\":{\"top\":\"1em\",\"right\":\"1em\",\"bottom\":\"1em\",\"left\":\"1em\"}}}} -->\n<div class=\"wp-block-column is-vertically-aligned-center\" style=\"padding-top:1em;padding-right:1em;padding-bottom:1em;padding-left:1em\"><!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column {\"width\":\"320px\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:320px\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.6\"}},\"fontSize\":\"small\"} -->\n<p class=\"has-small-font-size\" style=\"line-height:1.6\"><strong>Airplane</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.6\"}},\"fontSize\":\"small\"} -->\n<p class=\"has-small-font-size\" style=\"line-height:1.6\">Copper wire, wood base. I created this piece in late 2008. For this work, I aimed to convey both the industrial heaviness of an airplane, but also the cloudlike floating quality you feel when you’re in one.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:21;O:8:\"stdClass\":7:{s:2:\"id\";i:526;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:32:\"Offset images with descriptions.\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1754:\"\n<div class=\"wp-block-columns is-layout-flex wp-container-87\">\n<div class=\"wp-block-column is-layout-flow\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" loading=\"lazy\" width=\"793\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/Iris-793x1024.jpg\" alt=\"\" class=\"wp-image-525\" srcset=\"https://s.w.org/patterns/files/2021/06/Iris-793x1024.jpg 793w, https://s.w.org/patterns/files/2021/06/Iris-232x300.jpg 232w, https://s.w.org/patterns/files/2021/06/Iris-768x992.jpg 768w, https://s.w.org/patterns/files/2021/06/Iris-1189x1536.jpg 1189w, https://s.w.org/patterns/files/2021/06/Iris-1586x2048.jpg 1586w, https://s.w.org/patterns/files/2021/06/Iris.jpg 1920w\" sizes=\"(max-width: 793px) 100vw, 793px\" /></figure>\n\n\n\n<p style=\"font-size:14px\"><strong>White Irises</strong><br>Ogawa Kazumasa</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p style=\"font-size:14px\"><strong>Cherry Blossom</strong><br>Ogawa Kazumasa</p>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" loading=\"lazy\" width=\"707\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/Cherry-Blossom-707x1024.jpg\" alt=\"\" class=\"wp-image-524\" srcset=\"https://s.w.org/patterns/files/2021/06/Cherry-Blossom-707x1024.jpg 707w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-207x300.jpg 207w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-768x1112.jpg 768w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-1061x1536.jpg 1061w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-1414x2048.jpg 1414w, https://s.w.org/patterns/files/2021/06/Cherry-Blossom-scaled.jpg 1768w\" sizes=\"(max-width: 707px) 100vw, 707px\" /></figure>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:32:\"Offset images with descriptions.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:62:\"core/column,core/columns,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:3:{i:0;s:8:\"featured\";i:1;s:7:\"gallery\";i:2;s:6:\"images\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1175:\"<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:image {\"id\":525,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/patterns/files/2021/06/Iris-793x1024.jpg\" alt=\"\" class=\"wp-image-525\" /></figure>\n<!-- /wp:image -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"14px\"}}} -->\n<p style=\"font-size:14px\"><strong>White Irises</strong><br>Ogawa Kazumasa</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"14px\"}}} -->\n<p style=\"font-size:14px\"><strong>Cherry Blossom</strong><br>Ogawa Kazumasa</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":524,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/patterns/files/2021/06/Cherry-Blossom-707x1024.jpg\" alt=\"\" class=\"wp-image-524\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:22;O:8:\"stdClass\":7:{s:2:\"id\";i:521;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:45:\"Image with description below and to the right\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1415:\"\n<div class=\"wp-block-columns is-layout-flex wp-container-92\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:10%\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" loading=\"lazy\" width=\"1024\" height=\"1024\" src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-1024x1024.jpg\" alt=\"Vintage Cupid Illustration\" class=\"wp-image-522\" srcset=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-1024x1024.jpg 1024w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-300x300.jpg 300w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-150x150.jpg 150w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-768x768.jpg 768w, https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1.jpg 1510w\" sizes=\"(max-width: 1024px) 100vw, 1024px\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:10%\"></div>\n</div>\n\n\n\n<div class=\"wp-block-columns is-layout-flex wp-container-95\">\n<div class=\"wp-block-column is-layout-flow\"></div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<p style=\"font-size:14px\"><strong>Cupid in Flight</strong><br>48” x 48” Giclee print on archival paper.</p>\n</div>\n</div>\n\n\n\n<p></p>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:46:\"Image with description below and to the right.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:50:\"core/column,core/columns,core/image,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:6:\"images\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1241:\"<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column {\"width\":\"10%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:10%\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:image {\"id\":522,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/patterns/files/2021/06/image-from-rawpixel-id-539759-jpeg-1-1024x1024.jpg\" alt=\"Vintage Cupid Illustration\" class=\"wp-image-522\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"10%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:10%\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns -->\n<div class=\"wp-block-columns\"><!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:paragraph {\"style\":{\"typography\":{\"fontSize\":\"14px\"}}} -->\n<p style=\"font-size:14px\"><strong>Cupid in Flight</strong><br>48” x 48” Giclee print on archival paper.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\";}i:23;O:8:\"stdClass\":7:{s:2:\"id\";i:502;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:13:\"Event details\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1510:\"\n<figure class=\"wp-block-image alignwide size-full\"><img decoding=\"async\" loading=\"lazy\" width=\"2560\" height=\"1227\" src=\"https://s.w.org/patterns/files/2021/06/Group-17-scaled.jpg\" alt=\"Image of a woman being carried through the air by swans.\" class=\"wp-image-501\" srcset=\"https://s.w.org/patterns/files/2021/06/Group-17-scaled.jpg 2560w, https://s.w.org/patterns/files/2021/06/Group-17-300x144.jpg 300w, https://s.w.org/patterns/files/2021/06/Group-17-1024x491.jpg 1024w, https://s.w.org/patterns/files/2021/06/Group-17-768x368.jpg 768w, https://s.w.org/patterns/files/2021/06/Group-17-1536x736.jpg 1536w, https://s.w.org/patterns/files/2021/06/Group-17-2048x981.jpg 2048w\" sizes=\"(max-width: 2560px) 100vw, 2560px\" /></figure>\n\n\n\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center is-layout-flex wp-container-100\">\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<p style=\"line-height:2\"><strong>Location:</strong><br>82 Main St. Brooklyn, NY</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<p style=\"line-height:2\"><strong>Date:</strong><br>October 24, 2021</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\">\n<div class=\"wp-block-buttons is-layout-flex\">\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"background-color:#262626;color:#efefef\">Purchase Tickets</a></div>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:14:\"Event details.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/button,core/buttons,core/column,core/columns,core/image,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:1:{i:0;s:8:\"featured\";}s:15:\"pattern_content\";s:1624:\"<!-- wp:image {\"align\":\"wide\",\"id\":501,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image alignwide size-full\"><img src=\"https://s.w.org/patterns/files/2021/06/Group-17-scaled.jpg\" alt=\"Image of a woman being carried through the air by swans.\" class=\"wp-image-501\" /></figure>\n<!-- /wp:image -->\n\n<!-- wp:columns {\"verticalAlignment\":\"center\",\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide are-vertically-aligned-center\"><!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"2\"}}} -->\n<p style=\"line-height:2\"><strong>Location:</strong><br>82 Main St. Brooklyn, NY</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"2\"}}} -->\n<p style=\"line-height:2\"><strong>Date:</strong><br>October 24, 2021</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\"><!-- wp:buttons -->\n<div class=\"wp-block-buttons\"><!-- wp:button {\"width\":100,\"style\":{\"color\":{\"background\":\"#262626\",\"text\":\"#efefef\"}}} -->\n<div class=\"wp-block-button has-custom-width wp-block-button__width-100\"><a class=\"wp-block-button__link has-text-color has-background\" style=\"background-color:#262626;color:#efefef\">Purchase Tickets</a></div>\n<!-- /wp:button --></div>\n<!-- /wp:buttons --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:24;O:8:\"stdClass\":7:{s:2:\"id\";i:200;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:21:\"Three columns of text\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:953:\"\n<div class=\"wp-block-columns alignfull has-text-color has-background is-layout-flex wp-container-104\" style=\"background-color:#ffffff;color:#000000\">\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Virtual Tour ↗</a></strong></h3>\n\n\n\n<p>Get a virtual tour of the museum. Ideal for schools and events.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Current Shows ↗</a></strong></h3>\n\n\n\n<p>Stay updated and see our current exhibitions here.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\">\n<h3 class=\"wp-block-heading\" style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Useful Info ↗</a></strong></h3>\n\n\n\n<p>Get to know our opening times, ticket prices and discounts.</p>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:22:\"Three columns of text.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:52:\"core/column,core/columns,core/heading,core/paragraph\";}s:14:\"category_slugs\";a:3:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";i:2;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1496:\"<!-- wp:columns {\"align\":\"full\",\"style\":{\"color\":{\"text\":\"#000000\",\"background\":\"#ffffff\"}}} -->\n<div class=\"wp-block-columns alignfull has-text-color has-background\" style=\"background-color:#ffffff;color:#000000\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"http://wordpress.org\">Virtual Tour ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Get a virtual tour of the museum. Ideal for schools and events.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Current Shows ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Stay updated and see our current exhibitions here.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:heading {\"level\":3,\"style\":{\"typography\":{\"fontSize\":\"24px\",\"lineHeight\":\"1.3\"}}} -->\n<h3 style=\"font-size:24px;line-height:1.3\"><strong><a href=\"https://wordpress.org\">Useful Info ↗</a></strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Get to know our opening times, ticket prices and discounts.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\";}i:25;O:8:\"stdClass\":7:{s:2:\"id\";i:199;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:34:\"Three columns with images and text\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:2843:\"\n<div class=\"wp-block-group alignfull has-background is-layout-flow\" style=\"background-color:#f8f4e4\">\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-106\">\n<div class=\"wp-block-column is-layout-flow\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<h6 class=\"has-text-color wp-block-heading\" id=\"ecosystem\" style=\"color:#000000\">ECOSYSTEM</h6>\n\n\n\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Positive growth.</strong></p>\n\n\n\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-110\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.38%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>Nature</em>, in the common sense, refers to essences unchanged by man; space, the air, the river, the leaf.&nbsp;<em>Art</em>&nbsp;is applied to the mixture of his will with the same things, as in a house, a canal, a statue, a picture. But his operations taken together are so insignificant, a little chipping, baking, patching, and washing, that in an impression so grand as that of the world on the human mind, they do not vary the result.</p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33%\">\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"The sun setting through a dense forest.\" /></figure>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:33.62%\">\n<figure class=\"wp-block-image size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Wind turbines standing on a grassy plain, against a blue sky.\" /></figure>\n</div>\n</div>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-113\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:67%\">\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"The sun shining over a ridge leading down into the shore. In the distance, a car drives down a road.\" /></figure></div>\n</div>\n\n\n\n<div class=\"wp-block-column is-vertically-aligned-center is-layout-flow\" style=\"flex-basis:33%\">\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Undoubtedly we have no questions to ask which are unanswerable. We must trust the perfection of the creation so far, as to believe that whatever curiosity the order of things has awakened in our minds, the order of things can satisfy. Every man&rsquo;s condition is a solution in hieroglyphic to those inquiries he would put.</p>\n</div>\n</div>\n</div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:77:\"Three columns with images and text, with vertical spacing for an offset look.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:86:\"core/column,core/columns,core/group,core/heading,core/image,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:7:\"columns\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:3990:\"<!-- wp:group {\"align\":\"full\",\"style\":{\"color\":{\"background\":\"#f8f4e4\"}}} -->\n<div class=\"wp-block-group alignfull has-background\" style=\"background-color:#f8f4e4\"><!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column -->\n<div class=\"wp-block-column\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:heading {\"level\":6,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h6 class=\"has-text-color\" id=\"ecosystem\" style=\"color:#000000\">ECOSYSTEM</h6>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"style\":{\"typography\":{\"lineHeight\":\"1.1\",\"fontSize\":\"5vw\"},\"color\":{\"text\":\"#000000\"}}} -->\n<p class=\"has-text-color\" style=\"color:#000000;font-size:5vw;line-height:1.1\"><strong>Positive growth.</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:spacer {\"height\":\"5px\"} -->\n<div style=\"height:5px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"33.38%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.38%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\"><em>Nature</em>, in the common sense, refers to essences unchanged by man; space, the air, the river, the leaf.&nbsp;<em>Art</em>&nbsp;is applied to the mixture of his will with the same things, as in a house, a canal, a statue, a picture. But his operations taken together are so insignificant, a little chipping, baking, patching, and washing, that in an impression so grand as that of the world on the human mind, they do not vary the result.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33%\"><!-- wp:spacer -->\n<div style=\"height:100px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-01.jpg\" alt=\"The sun setting through a dense forest.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"width\":\"33.62%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:33.62%\"><!-- wp:image {\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-02.jpg\" alt=\"Wind turbines standing on a grassy plain, against a blue sky.\" /></figure>\n<!-- /wp:image --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"67%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:67%\"><!-- wp:image {\"align\":\"right\",\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"alignright size-large\"><img src=\"https://s.w.org/images/core/5.8/outside-03.jpg\" alt=\"The sun shining over a ridge leading down into the shore. In the distance, a car drives down a road.\" /></figure></div>\n<!-- /wp:image --></div>\n<!-- /wp:column -->\n\n<!-- wp:column {\"verticalAlignment\":\"center\",\"width\":\"33%\"} -->\n<div class=\"wp-block-column is-vertically-aligned-center\" style=\"flex-basis:33%\"><!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#000000\"}},\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-color has-extra-small-font-size\" style=\"color:#000000\">Undoubtedly we have no questions to ask which are unanswerable. We must trust the perfection of the creation so far, as to believe that whatever curiosity the order of things has awakened in our minds, the order of things can satisfy. Every man\'s condition is a solution in hieroglyphic to those inquiries he would put.</p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div>\n<!-- /wp:group -->\";}i:26;O:8:\"stdClass\":7:{s:2:\"id\";i:192;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:37:\"Media and text with image on the left\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:554:\"\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img decoding=\"async\" src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Close-up, abstract view of architecture.\" /></figure><div class=\"wp-block-media-text__content\">\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Open Spaces</strong></h3>\n\n\n\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">See case study ↗</a></p>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:66:\"Media and text block with image to the left and text to the right.\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:43:\"core/heading,core/media-text,core/paragraph\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:844:\"<!-- wp:media-text {\"align\":\"full\",\"mediaType\":\"image\",\"verticalAlignment\":\"center\"} -->\n<div class=\"wp-block-media-text alignfull is-stacked-on-mobile is-vertically-aligned-center\"><figure class=\"wp-block-media-text__media\"><img src=\"https://s.w.org/images/core/5.8/architecture-04.jpg\" alt=\"Close-up, abstract view of architecture.\" /></figure><div class=\"wp-block-media-text__content\"><!-- wp:heading {\"textAlign\":\"center\",\"level\":3,\"style\":{\"color\":{\"text\":\"#000000\"}}} -->\n<h3 class=\"wp-block-heading has-text-align-center has-text-color\" style=\"color:#000000\"><strong>Open Spaces</strong></h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph {\"align\":\"center\",\"fontSize\":\"extra-small\"} -->\n<p class=\"has-text-align-center has-extra-small-font-size\"><a href=\"#\">See case study ↗</a></p>\n<!-- /wp:paragraph --></div></div>\n<!-- /wp:media-text -->\";}i:27;O:8:\"stdClass\":7:{s:2:\"id\";i:185;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:35:\"Large header with left-aligned text\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:1182:\"\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img decoding=\"async\" class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\">\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forest.</h2>\n\n\n\n<div class=\"wp-block-columns alignwide is-layout-flex wp-container-117\">\n<div class=\"wp-block-column is-layout-flow\" style=\"flex-basis:55%\">\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n\n\n\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Even a child knows how valuable the forest is. The fresh, breathtaking smell of trees. Echoing birds flying above that dense magnitude. A stable climate, a sustainable diverse life and a source of culture. Yet, forests and other ecosystems hang in the balance, threatened to become croplands, pasture, and plantations.</em></p>\n</div>\n\n\n\n<div class=\"wp-block-column is-layout-flow\"></div>\n</div>\n</div></div>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:0:\"\";s:16:\"wpop_description\";s:29:\"Cover image with quote on top\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:0:{}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:75:\"core/column,core/columns,core/cover,core/heading,core/paragraph,core/spacer\";}s:14:\"category_slugs\";a:2:{i:0;s:6:\"banner\";i:1;s:8:\"featured\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:1698:\"<!-- wp:cover {\"url\":\"https://s.w.org/images/core/5.8/forest.jpg\",\"dimRatio\":60,\"minHeight\":800,\"align\":\"full\"} -->\n<div class=\"wp-block-cover alignfull\" style=\"min-height:800px\"><span aria-hidden=\"true\" class=\"wp-block-cover__background has-background-dim-60 has-background-dim\"></span><img class=\"wp-block-cover__image-background\" alt=\"\" src=\"https://s.w.org/images/core/5.8/forest.jpg\" data-object-fit=\"cover\" /><div class=\"wp-block-cover__inner-container\"><!-- wp:heading {\"align\":\"wide\",\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"fontSize\":\"64px\"}}} -->\n<h2 class=\"wp-block-heading alignwide has-text-color\" style=\"color:#ffe074;font-size:64px\">Forest.</h2>\n<!-- /wp:heading -->\n\n<!-- wp:columns {\"align\":\"wide\"} -->\n<div class=\"wp-block-columns alignwide\"><!-- wp:column {\"width\":\"55%\"} -->\n<div class=\"wp-block-column\" style=\"flex-basis:55%\"><!-- wp:spacer {\"height\":\"330px\"} -->\n<div style=\"height:330px\" aria-hidden=\"true\" class=\"wp-block-spacer\"></div>\n<!-- /wp:spacer -->\n\n<!-- wp:paragraph {\"style\":{\"color\":{\"text\":\"#ffe074\"},\"typography\":{\"lineHeight\":\"1.3\",\"fontSize\":\"12px\"}}} -->\n<p class=\"has-text-color\" style=\"color:#ffe074;font-size:12px;line-height:1.3\"><em>Even a child knows how valuable the forest is. The fresh, breathtaking smell of trees. Echoing birds flying above that dense magnitude. A stable climate, a sustainable diverse life and a source of culture. Yet, forests and other ecosystems hang in the balance, threatened to become croplands, pasture, and plantations.</em></p>\n<!-- /wp:paragraph --></div>\n<!-- /wp:column -->\n\n<!-- wp:column -->\n<div class=\"wp-block-column\"></div>\n<!-- /wp:column --></div>\n<!-- /wp:columns --></div></div>\n<!-- /wp:cover -->\";}i:28;O:8:\"stdClass\":7:{s:2:\"id\";i:184;s:5:\"title\";O:8:\"stdClass\":1:{s:8:\"rendered\";s:7:\"Heading\";}s:7:\"content\";O:8:\"stdClass\":2:{s:8:\"rendered\";s:526:\"\n<h2 class=\"alignwide wp-block-heading\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">We&rsquo;re a studio in Berlin with an international practice in architecture, urban planning and interior design. We believe in sharing knowledge and promoting dialogue to increase the creative potential of collaboration.</h2>\n\";s:9:\"protected\";b:0;}s:4:\"meta\";O:8:\"stdClass\":7:{s:13:\"wpop_keywords\";s:17:\"large text, title\";s:16:\"wpop_description\";s:12:\"Heading text\";s:19:\"wpop_viewport_width\";i:1200;s:16:\"wpop_block_types\";a:1:{i:0;s:12:\"core/heading\";}s:11:\"wpop_locale\";s:5:\"en_US\";s:15:\"wpop_wp_version\";s:0:\"\";s:25:\"wpop_contains_block_types\";s:12:\"core/heading\";}s:14:\"category_slugs\";a:2:{i:0;s:8:\"featured\";i:1;s:4:\"text\";}s:13:\"keyword_slugs\";a:2:{i:0;s:4:\"core\";i:1;s:8:\"featured\";}s:15:\"pattern_content\";s:621:\"<!-- wp:heading {\"align\":\"wide\",\"style\":{\"typography\":{\"fontSize\":\"48px\",\"lineHeight\":\"1.1\"}}} -->\n<h2 class=\"alignwide\" id=\"we-re-a-studio-in-berlin-with-an-international-practice-in-architecture-urban-planning-and-interior-design-we-believe-in-sharing-knowledge-and-promoting-dialogue-to-increase-the-creative-potential-of-collaboration\" style=\"font-size:48px;line-height:1.1\">We\'re a studio in Berlin with an international practice in architecture, urban planning and interior design. We believe in sharing knowledge and promoting dialogue to increase the creative potential of collaboration.</h2>\n<!-- /wp:heading -->\";}}", "no");
INSERT INTO `wp_options` VALUES("56534", "_transient_timeout_wpseo-statistics-totals", "1674188826", "no");
INSERT INTO `wp_options` VALUES("56535", "_transient_wpseo-statistics-totals", "a:1:{i:1;a:2:{s:6:\"scores\";a:0:{}s:8:\"division\";b:0;}}", "no");
INSERT INTO `wp_options` VALUES("56546", "_transient_timeout_global_styles_virtue", "1674103012", "no");
INSERT INTO `wp_options` VALUES("56547", "_transient_global_styles_virtue", "body{--wp--preset--color--black: #000;--wp--preset--color--cyan-bluish-gray: #abb8c3;--wp--preset--color--white: #fff;--wp--preset--color--pale-pink: #f78da7;--wp--preset--color--vivid-red: #cf2e2e;--wp--preset--color--luminous-vivid-orange: #ff6900;--wp--preset--color--luminous-vivid-amber: #fcb900;--wp--preset--color--light-green-cyan: #7bdcb5;--wp--preset--color--vivid-green-cyan: #00d084;--wp--preset--color--pale-cyan-blue: #8ed1fc;--wp--preset--color--vivid-cyan-blue: #0693e3;--wp--preset--color--vivid-purple: #9b51e0;--wp--preset--color--virtue-primary: #2d5c88;--wp--preset--color--virtue-primary-light: #6c8dab;--wp--preset--color--very-light-gray: #eee;--wp--preset--color--very-dark-gray: #444;--wp--preset--gradient--vivid-cyan-blue-to-vivid-purple: linear-gradient(135deg,rgba(6,147,227,1) 0%,rgb(155,81,224) 100%);--wp--preset--gradient--light-green-cyan-to-vivid-green-cyan: linear-gradient(135deg,rgb(122,220,180) 0%,rgb(0,208,130) 100%);--wp--preset--gradient--luminous-vivid-amber-to-luminous-vivid-orange: linear-gradient(135deg,rgba(252,185,0,1) 0%,rgba(255,105,0,1) 100%);--wp--preset--gradient--luminous-vivid-orange-to-vivid-red: linear-gradient(135deg,rgba(255,105,0,1) 0%,rgb(207,46,46) 100%);--wp--preset--gradient--very-light-gray-to-cyan-bluish-gray: linear-gradient(135deg,rgb(238,238,238) 0%,rgb(169,184,195) 100%);--wp--preset--gradient--cool-to-warm-spectrum: linear-gradient(135deg,rgb(74,234,220) 0%,rgb(151,120,209) 20%,rgb(207,42,186) 40%,rgb(238,44,130) 60%,rgb(251,105,98) 80%,rgb(254,248,76) 100%);--wp--preset--gradient--blush-light-purple: linear-gradient(135deg,rgb(255,206,236) 0%,rgb(152,150,240) 100%);--wp--preset--gradient--blush-bordeaux: linear-gradient(135deg,rgb(254,205,165) 0%,rgb(254,45,45) 50%,rgb(107,0,62) 100%);--wp--preset--gradient--luminous-dusk: linear-gradient(135deg,rgb(255,203,112) 0%,rgb(199,81,192) 50%,rgb(65,88,208) 100%);--wp--preset--gradient--pale-ocean: linear-gradient(135deg,rgb(255,245,203) 0%,rgb(182,227,212) 50%,rgb(51,167,181) 100%);--wp--preset--gradient--electric-grass: linear-gradient(135deg,rgb(202,248,128) 0%,rgb(113,206,126) 100%);--wp--preset--gradient--midnight: linear-gradient(135deg,rgb(2,3,129) 0%,rgb(40,116,252) 100%);--wp--preset--duotone--dark-grayscale: url(\'#wp-duotone-dark-grayscale\');--wp--preset--duotone--grayscale: url(\'#wp-duotone-grayscale\');--wp--preset--duotone--purple-yellow: url(\'#wp-duotone-purple-yellow\');--wp--preset--duotone--blue-red: url(\'#wp-duotone-blue-red\');--wp--preset--duotone--midnight: url(\'#wp-duotone-midnight\');--wp--preset--duotone--magenta-yellow: url(\'#wp-duotone-magenta-yellow\');--wp--preset--duotone--purple-green: url(\'#wp-duotone-purple-green\');--wp--preset--duotone--blue-orange: url(\'#wp-duotone-blue-orange\');--wp--preset--font-size--small: 13px;--wp--preset--font-size--medium: 20px;--wp--preset--font-size--large: 36px;--wp--preset--font-size--x-large: 42px;--wp--preset--spacing--20: 0.44rem;--wp--preset--spacing--30: 0.67rem;--wp--preset--spacing--40: 1rem;--wp--preset--spacing--50: 1.5rem;--wp--preset--spacing--60: 2.25rem;--wp--preset--spacing--70: 3.38rem;--wp--preset--spacing--80: 5.06rem;}:where(.is-layout-flex){gap: 0.5em;}body .is-layout-flow > .alignleft{float: left;margin-inline-start: 0;margin-inline-end: 2em;}body .is-layout-flow > .alignright{float: right;margin-inline-start: 2em;margin-inline-end: 0;}body .is-layout-flow > .aligncenter{margin-left: auto !important;margin-right: auto !important;}body .is-layout-constrained > .alignleft{float: left;margin-inline-start: 0;margin-inline-end: 2em;}body .is-layout-constrained > .alignright{float: right;margin-inline-start: 2em;margin-inline-end: 0;}body .is-layout-constrained > .aligncenter{margin-left: auto !important;margin-right: auto !important;}body .is-layout-constrained > :where(:not(.alignleft):not(.alignright):not(.alignfull)){max-width: var(--wp--style--global--content-size);margin-left: auto !important;margin-right: auto !important;}body .is-layout-constrained > .alignwide{max-width: var(--wp--style--global--wide-size);}body .is-layout-flex{display: flex;}body .is-layout-flex{flex-wrap: wrap;align-items: center;}body .is-layout-flex > *{margin: 0;}:where(.wp-block-columns.is-layout-flex){gap: 2em;}.has-black-color{color: var(--wp--preset--color--black) !important;}.has-cyan-bluish-gray-color{color: var(--wp--preset--color--cyan-bluish-gray) !important;}.has-white-color{color: var(--wp--preset--color--white) !important;}.has-pale-pink-color{color: var(--wp--preset--color--pale-pink) !important;}.has-vivid-red-color{color: var(--wp--preset--color--vivid-red) !important;}.has-luminous-vivid-orange-color{color: var(--wp--preset--color--luminous-vivid-orange) !important;}.has-luminous-vivid-amber-color{color: var(--wp--preset--color--luminous-vivid-amber) !important;}.has-light-green-cyan-color{color: var(--wp--preset--color--light-green-cyan) !important;}.has-vivid-green-cyan-color{color: var(--wp--preset--color--vivid-green-cyan) !important;}.has-pale-cyan-blue-color{color: var(--wp--preset--color--pale-cyan-blue) !important;}.has-vivid-cyan-blue-color{color: var(--wp--preset--color--vivid-cyan-blue) !important;}.has-vivid-purple-color{color: var(--wp--preset--color--vivid-purple) !important;}.has-black-background-color{background-color: var(--wp--preset--color--black) !important;}.has-cyan-bluish-gray-background-color{background-color: var(--wp--preset--color--cyan-bluish-gray) !important;}.has-white-background-color{background-color: var(--wp--preset--color--white) !important;}.has-pale-pink-background-color{background-color: var(--wp--preset--color--pale-pink) !important;}.has-vivid-red-background-color{background-color: var(--wp--preset--color--vivid-red) !important;}.has-luminous-vivid-orange-background-color{background-color: var(--wp--preset--color--luminous-vivid-orange) !important;}.has-luminous-vivid-amber-background-color{background-color: var(--wp--preset--color--luminous-vivid-amber) !important;}.has-light-green-cyan-background-color{background-color: var(--wp--preset--color--light-green-cyan) !important;}.has-vivid-green-cyan-background-color{background-color: var(--wp--preset--color--vivid-green-cyan) !important;}.has-pale-cyan-blue-background-color{background-color: var(--wp--preset--color--pale-cyan-blue) !important;}.has-vivid-cyan-blue-background-color{background-color: var(--wp--preset--color--vivid-cyan-blue) !important;}.has-vivid-purple-background-color{background-color: var(--wp--preset--color--vivid-purple) !important;}.has-black-border-color{border-color: var(--wp--preset--color--black) !important;}.has-cyan-bluish-gray-border-color{border-color: var(--wp--preset--color--cyan-bluish-gray) !important;}.has-white-border-color{border-color: var(--wp--preset--color--white) !important;}.has-pale-pink-border-color{border-color: var(--wp--preset--color--pale-pink) !important;}.has-vivid-red-border-color{border-color: var(--wp--preset--color--vivid-red) !important;}.has-luminous-vivid-orange-border-color{border-color: var(--wp--preset--color--luminous-vivid-orange) !important;}.has-luminous-vivid-amber-border-color{border-color: var(--wp--preset--color--luminous-vivid-amber) !important;}.has-light-green-cyan-border-color{border-color: var(--wp--preset--color--light-green-cyan) !important;}.has-vivid-green-cyan-border-color{border-color: var(--wp--preset--color--vivid-green-cyan) !important;}.has-pale-cyan-blue-border-color{border-color: var(--wp--preset--color--pale-cyan-blue) !important;}.has-vivid-cyan-blue-border-color{border-color: var(--wp--preset--color--vivid-cyan-blue) !important;}.has-vivid-purple-border-color{border-color: var(--wp--preset--color--vivid-purple) !important;}.has-vivid-cyan-blue-to-vivid-purple-gradient-background{background: var(--wp--preset--gradient--vivid-cyan-blue-to-vivid-purple) !important;}.has-light-green-cyan-to-vivid-green-cyan-gradient-background{background: var(--wp--preset--gradient--light-green-cyan-to-vivid-green-cyan) !important;}.has-luminous-vivid-amber-to-luminous-vivid-orange-gradient-background{background: var(--wp--preset--gradient--luminous-vivid-amber-to-luminous-vivid-orange) !important;}.has-luminous-vivid-orange-to-vivid-red-gradient-background{background: var(--wp--preset--gradient--luminous-vivid-orange-to-vivid-red) !important;}.has-very-light-gray-to-cyan-bluish-gray-gradient-background{background: var(--wp--preset--gradient--very-light-gray-to-cyan-bluish-gray) !important;}.has-cool-to-warm-spectrum-gradient-background{background: var(--wp--preset--gradient--cool-to-warm-spectrum) !important;}.has-blush-light-purple-gradient-background{background: var(--wp--preset--gradient--blush-light-purple) !important;}.has-blush-bordeaux-gradient-background{background: var(--wp--preset--gradient--blush-bordeaux) !important;}.has-luminous-dusk-gradient-background{background: var(--wp--preset--gradient--luminous-dusk) !important;}.has-pale-ocean-gradient-background{background: var(--wp--preset--gradient--pale-ocean) !important;}.has-electric-grass-gradient-background{background: var(--wp--preset--gradient--electric-grass) !important;}.has-midnight-gradient-background{background: var(--wp--preset--gradient--midnight) !important;}.has-small-font-size{font-size: var(--wp--preset--font-size--small) !important;}.has-medium-font-size{font-size: var(--wp--preset--font-size--medium) !important;}.has-large-font-size{font-size: var(--wp--preset--font-size--large) !important;}.has-x-large-font-size{font-size: var(--wp--preset--font-size--x-large) !important;}", "no");
INSERT INTO `wp_options` VALUES("56548", "_transient_timeout_global_styles_svg_filters_virtue", "1674103012", "no");
INSERT INTO `wp_options` VALUES("56549", "_transient_global_styles_svg_filters_virtue", "<svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-dark-grayscale\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 0.49803921568627\" /><feFuncG type=\"table\" tableValues=\"0 0.49803921568627\" /><feFuncB type=\"table\" tableValues=\"0 0.49803921568627\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-grayscale\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 1\" /><feFuncG type=\"table\" tableValues=\"0 1\" /><feFuncB type=\"table\" tableValues=\"0 1\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-purple-yellow\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.54901960784314 0.98823529411765\" /><feFuncG type=\"table\" tableValues=\"0 1\" /><feFuncB type=\"table\" tableValues=\"0.71764705882353 0.25490196078431\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-blue-red\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 1\" /><feFuncG type=\"table\" tableValues=\"0 0.27843137254902\" /><feFuncB type=\"table\" tableValues=\"0.5921568627451 0.27843137254902\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-midnight\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0 0\" /><feFuncG type=\"table\" tableValues=\"0 0.64705882352941\" /><feFuncB type=\"table\" tableValues=\"0 1\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-magenta-yellow\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.78039215686275 1\" /><feFuncG type=\"table\" tableValues=\"0 0.94901960784314\" /><feFuncB type=\"table\" tableValues=\"0.35294117647059 0.47058823529412\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-purple-green\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.65098039215686 0.40392156862745\" /><feFuncG type=\"table\" tableValues=\"0 1\" /><feFuncB type=\"table\" tableValues=\"0.44705882352941 0.4\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg><svg xmlns=\"http://www.w3.org/2000/svg\" viewBox=\"0 0 0 0\" width=\"0\" height=\"0\" focusable=\"false\" role=\"none\" style=\"visibility: hidden; position: absolute; left: -9999px; overflow: hidden;\" ><defs><filter id=\"wp-duotone-blue-orange\"><feColorMatrix color-interpolation-filters=\"sRGB\" type=\"matrix\" values=\" .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 .299 .587 .114 0 0 \" /><feComponentTransfer color-interpolation-filters=\"sRGB\" ><feFuncR type=\"table\" tableValues=\"0.098039215686275 1\" /><feFuncG type=\"table\" tableValues=\"0 0.66274509803922\" /><feFuncB type=\"table\" tableValues=\"0.84705882352941 0.41960784313725\" /><feFuncA type=\"table\" tableValues=\"1 1\" /></feComponentTransfer><feComposite in2=\"SourceGraphic\" operator=\"in\" /></filter></defs></svg>", "no");
INSERT INTO `wp_options` VALUES("56550", "_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a", "1674113933", "no");
INSERT INTO `wp_options` VALUES("56551", "_site_transient_poptags_40cd750bba9870f18aada2478b24840a", "O:8:\"stdClass\":100:{s:11:\"woocommerce\";a:3:{s:4:\"name\";s:11:\"woocommerce\";s:4:\"slug\";s:11:\"woocommerce\";s:5:\"count\";i:5921;}s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";i:4810;}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";i:2779;}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";i:2649;}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";i:2047;}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";i:1901;}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";i:1897;}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";i:1614;}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";i:1560;}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";i:1542;}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";i:1541;}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";i:1516;}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";i:1502;}s:9:\"ecommerce\";a:3:{s:4:\"name\";s:9:\"ecommerce\";s:4:\"slug\";s:9:\"ecommerce\";s:5:\"count\";i:1451;}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";i:1357;}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";i:1316;}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";i:1268;}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";i:1176;}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";i:1156;}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";i:1141;}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";i:1041;}s:10:\"e-commerce\";a:3:{s:4:\"name\";s:10:\"e-commerce\";s:4:\"slug\";s:10:\"e-commerce\";s:5:\"count\";i:1009;}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";i:992;}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";i:961;}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";i:900;}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";i:869;}s:9:\"analytics\";a:3:{s:4:\"name\";s:9:\"analytics\";s:4:\"slug\";s:9:\"analytics\";s:5:\"count\";i:866;}s:7:\"payment\";a:3:{s:4:\"name\";s:7:\"payment\";s:4:\"slug\";s:7:\"payment\";s:5:\"count\";i:865;}s:4:\"form\";a:3:{s:4:\"name\";s:4:\"form\";s:4:\"slug\";s:4:\"form\";s:5:\"count\";i:863;}s:6:\"slider\";a:3:{s:4:\"name\";s:6:\"slider\";s:4:\"slug\";s:6:\"slider\";s:5:\"count\";i:861;}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";i:859;}s:9:\"gutenberg\";a:3:{s:4:\"name\";s:9:\"gutenberg\";s:4:\"slug\";s:9:\"gutenberg\";s:5:\"count\";i:812;}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";i:789;}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";i:779;}s:6:\"search\";a:3:{s:4:\"name\";s:6:\"search\";s:4:\"slug\";s:6:\"search\";s:5:\"count\";i:769;}s:6:\"editor\";a:3:{s:4:\"name\";s:6:\"editor\";s:4:\"slug\";s:6:\"editor\";s:5:\"count\";i:765;}s:5:\"block\";a:3:{s:4:\"name\";s:5:\"block\";s:4:\"slug\";s:5:\"block\";s:5:\"count\";i:764;}s:15:\"payment-gateway\";a:3:{s:4:\"name\";s:15:\"payment gateway\";s:4:\"slug\";s:15:\"payment-gateway\";s:5:\"count\";i:756;}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";i:731;}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";i:728;}s:4:\"menu\";a:3:{s:4:\"name\";s:4:\"menu\";s:4:\"slug\";s:4:\"menu\";s:5:\"count\";i:719;}s:12:\"contact-form\";a:3:{s:4:\"name\";s:12:\"contact form\";s:4:\"slug\";s:12:\"contact-form\";s:5:\"count\";i:715;}s:9:\"elementor\";a:3:{s:4:\"name\";s:9:\"elementor\";s:4:\"slug\";s:9:\"elementor\";s:5:\"count\";i:713;}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";i:682;}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";i:681;}s:5:\"embed\";a:3:{s:4:\"name\";s:5:\"embed\";s:4:\"slug\";s:5:\"embed\";s:5:\"count\";i:681;}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"ajax\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";i:672;}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";i:666;}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";i:627;}s:3:\"css\";a:3:{s:4:\"name\";s:3:\"css\";s:4:\"slug\";s:3:\"css\";s:5:\"count\";i:620;}s:9:\"affiliate\";a:3:{s:4:\"name\";s:9:\"affiliate\";s:4:\"slug\";s:9:\"affiliate\";s:5:\"count\";i:610;}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";i:605;}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";i:604;}s:3:\"api\";a:3:{s:4:\"name\";s:3:\"api\";s:4:\"slug\";s:3:\"api\";s:5:\"count\";i:602;}s:7:\"contact\";a:3:{s:4:\"name\";s:7:\"contact\";s:4:\"slug\";s:7:\"contact\";s:5:\"count\";i:593;}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";i:590;}s:10:\"responsive\";a:3:{s:4:\"name\";s:10:\"responsive\";s:4:\"slug\";s:10:\"responsive\";s:5:\"count\";i:587;}s:9:\"dashboard\";a:3:{s:4:\"name\";s:9:\"dashboard\";s:4:\"slug\";s:9:\"dashboard\";s:5:\"count\";i:584;}s:5:\"theme\";a:3:{s:4:\"name\";s:5:\"theme\";s:4:\"slug\";s:5:\"theme\";s:5:\"count\";i:574;}s:3:\"ads\";a:3:{s:4:\"name\";s:3:\"ads\";s:4:\"slug\";s:3:\"ads\";s:5:\"count\";i:568;}s:7:\"comment\";a:3:{s:4:\"name\";s:7:\"comment\";s:4:\"slug\";s:7:\"comment\";s:5:\"count\";i:567;}s:6:\"custom\";a:3:{s:4:\"name\";s:6:\"custom\";s:4:\"slug\";s:6:\"custom\";s:5:\"count\";i:560;}s:8:\"shipping\";a:3:{s:4:\"name\";s:8:\"shipping\";s:4:\"slug\";s:8:\"shipping\";s:5:\"count\";i:552;}s:9:\"marketing\";a:3:{s:4:\"name\";s:9:\"marketing\";s:4:\"slug\";s:9:\"marketing\";s:5:\"count\";i:551;}s:10:\"categories\";a:3:{s:4:\"name\";s:10:\"categories\";s:4:\"slug\";s:10:\"categories\";s:5:\"count\";i:539;}s:4:\"chat\";a:3:{s:4:\"name\";s:4:\"chat\";s:4:\"slug\";s:4:\"chat\";s:5:\"count\";i:539;}s:6:\"events\";a:3:{s:4:\"name\";s:6:\"events\";s:4:\"slug\";s:6:\"events\";s:5:\"count\";i:538;}s:4:\"user\";a:3:{s:4:\"name\";s:4:\"user\";s:4:\"slug\";s:4:\"user\";s:5:\"count\";i:530;}s:14:\"contact-form-7\";a:3:{s:4:\"name\";s:14:\"contact form 7\";s:4:\"slug\";s:14:\"contact-form-7\";s:5:\"count\";i:527;}s:6:\"button\";a:3:{s:4:\"name\";s:6:\"button\";s:4:\"slug\";s:6:\"button\";s:5:\"count\";i:526;}s:5:\"forms\";a:3:{s:4:\"name\";s:5:\"forms\";s:4:\"slug\";s:5:\"forms\";s:5:\"count\";i:520;}s:5:\"popup\";a:3:{s:4:\"name\";s:5:\"popup\";s:4:\"slug\";s:5:\"popup\";s:5:\"count\";i:513;}s:6:\"mobile\";a:3:{s:4:\"name\";s:6:\"mobile\";s:4:\"slug\";s:6:\"mobile\";s:5:\"count\";i:509;}s:5:\"users\";a:3:{s:4:\"name\";s:5:\"users\";s:4:\"slug\";s:5:\"users\";s:5:\"count\";i:509;}s:4:\"tags\";a:3:{s:4:\"name\";s:4:\"tags\";s:4:\"slug\";s:4:\"tags\";s:5:\"count\";i:507;}s:8:\"calendar\";a:3:{s:4:\"name\";s:8:\"calendar\";s:4:\"slug\";s:8:\"calendar\";s:5:\"count\";i:496;}s:10:\"newsletter\";a:3:{s:4:\"name\";s:10:\"newsletter\";s:4:\"slug\";s:10:\"newsletter\";s:5:\"count\";i:474;}s:11:\"performance\";a:3:{s:4:\"name\";s:11:\"performance\";s:4:\"slug\";s:11:\"performance\";s:5:\"count\";i:472;}s:10:\"navigation\";a:3:{s:4:\"name\";s:10:\"navigation\";s:4:\"slug\";s:10:\"navigation\";s:5:\"count\";i:466;}s:6:\"blocks\";a:3:{s:4:\"name\";s:6:\"blocks\";s:4:\"slug\";s:6:\"blocks\";s:5:\"count\";i:463;}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";i:450;}s:9:\"slideshow\";a:3:{s:4:\"name\";s:9:\"slideshow\";s:4:\"slug\";s:9:\"slideshow\";s:5:\"count\";i:448;}s:5:\"stats\";a:3:{s:4:\"name\";s:5:\"stats\";s:4:\"slug\";s:5:\"stats\";s:5:\"count\";i:444;}s:10:\"statistics\";a:3:{s:4:\"name\";s:10:\"statistics\";s:4:\"slug\";s:10:\"statistics\";s:5:\"count\";i:435;}s:12:\"social-media\";a:3:{s:4:\"name\";s:12:\"social media\";s:4:\"slug\";s:12:\"social-media\";s:5:\"count\";i:430;}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";i:426;}s:8:\"redirect\";a:3:{s:4:\"name\";s:8:\"redirect\";s:4:\"slug\";s:8:\"redirect\";s:5:\"count\";i:424;}s:12:\"notification\";a:3:{s:4:\"name\";s:12:\"notification\";s:4:\"slug\";s:12:\"notification\";s:5:\"count\";i:419;}s:4:\"news\";a:3:{s:4:\"name\";s:4:\"news\";s:4:\"slug\";s:4:\"news\";s:5:\"count\";i:417;}s:6:\"import\";a:3:{s:4:\"name\";s:6:\"import\";s:4:\"slug\";s:6:\"import\";s:5:\"count\";i:416;}s:8:\"tracking\";a:3:{s:4:\"name\";s:8:\"tracking\";s:4:\"slug\";s:8:\"tracking\";s:5:\"count\";i:411;}s:7:\"gateway\";a:3:{s:4:\"name\";s:7:\"gateway\";s:4:\"slug\";s:7:\"gateway\";s:5:\"count\";i:410;}s:10:\"shortcodes\";a:3:{s:4:\"name\";s:10:\"shortcodes\";s:4:\"slug\";s:10:\"shortcodes\";s:5:\"count\";i:409;}s:4:\"code\";a:3:{s:4:\"name\";s:4:\"code\";s:4:\"slug\";s:4:\"code\";s:5:\"count\";i:401;}s:7:\"plugins\";a:3:{s:4:\"name\";s:7:\"plugins\";s:4:\"slug\";s:7:\"plugins\";s:5:\"count\";i:397;}s:9:\"multisite\";a:3:{s:4:\"name\";s:9:\"multisite\";s:4:\"slug\";s:9:\"multisite\";s:5:\"count\";i:394;}s:8:\"payments\";a:3:{s:4:\"name\";s:8:\"payments\";s:4:\"slug\";s:8:\"payments\";s:5:\"count\";i:394;}s:4:\"meta\";a:3:{s:4:\"name\";s:4:\"meta\";s:4:\"slug\";s:4:\"meta\";s:5:\"count\";i:390;}s:5:\"cache\";a:3:{s:4:\"name\";s:5:\"cache\";s:4:\"slug\";s:5:\"cache\";s:5:\"count\";i:389;}s:3:\"url\";a:3:{s:4:\"name\";s:3:\"url\";s:4:\"slug\";s:3:\"url\";s:5:\"count\";i:386;}}", "no");
INSERT INTO `wp_options` VALUES("56553", "_site_transient_update_core", "O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:65:\"https://downloads.wordpress.org/release/fr_FR/wordpress-6.1.1.zip\";s:6:\"locale\";s:5:\"fr_FR\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:65:\"https://downloads.wordpress.org/release/fr_FR/wordpress-6.1.1.zip\";s:10:\"no_content\";s:0:\"\";s:11:\"new_bundled\";s:0:\"\";s:7:\"partial\";s:0:\"\";s:8:\"rollback\";s:0:\"\";}s:7:\"current\";s:5:\"6.1.1\";s:7:\"version\";s:5:\"6.1.1\";s:11:\"php_version\";s:6:\"5.6.20\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"6.1\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1674103178;s:15:\"version_checked\";s:5:\"6.1.1\";s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("56554", "_site_transient_update_plugins", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1674103178;s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}s:9:\"no_update\";a:7:{s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:37:\"w.org/plugins/all-in-one-wp-migration\";s:4:\"slug\";s:23:\"all-in-one-wp-migration\";s:6:\"plugin\";s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";s:11:\"new_version\";s:4:\"7.70\";s:3:\"url\";s:54:\"https://wordpress.org/plugins/all-in-one-wp-migration/\";s:7:\"package\";s:71:\"https://downloads.wordpress.org/plugin/all-in-one-wp-migration.7.70.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:76:\"https://ps.w.org/all-in-one-wp-migration/assets/icon-256x256.png?rev=2458334\";s:2:\"1x\";s:76:\"https://ps.w.org/all-in-one-wp-migration/assets/icon-128x128.png?rev=2458334\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:79:\"https://ps.w.org/all-in-one-wp-migration/assets/banner-1544x500.png?rev=2837281\";s:2:\"1x\";s:78:\"https://ps.w.org/all-in-one-wp-migration/assets/banner-772x250.png?rev=2837281\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"3.3\";}s:25:\"duplicator/duplicator.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:24:\"w.org/plugins/duplicator\";s:4:\"slug\";s:10:\"duplicator\";s:6:\"plugin\";s:25:\"duplicator/duplicator.php\";s:11:\"new_version\";s:5:\"1.5.1\";s:3:\"url\";s:41:\"https://wordpress.org/plugins/duplicator/\";s:7:\"package\";s:59:\"https://downloads.wordpress.org/plugin/duplicator.1.5.1.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:63:\"https://ps.w.org/duplicator/assets/icon-256x256.png?rev=2605836\";s:2:\"1x\";s:63:\"https://ps.w.org/duplicator/assets/icon-128x128.png?rev=2605835\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:65:\"https://ps.w.org/duplicator/assets/banner-772x250.png?rev=2085472\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.0\";}s:33:\"kadence-blocks/kadence-blocks.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:28:\"w.org/plugins/kadence-blocks\";s:4:\"slug\";s:14:\"kadence-blocks\";s:6:\"plugin\";s:33:\"kadence-blocks/kadence-blocks.php\";s:11:\"new_version\";s:6:\"2.4.22\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/kadence-blocks/\";s:7:\"package\";s:64:\"https://downloads.wordpress.org/plugin/kadence-blocks.2.4.22.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/kadence-blocks/assets/icon-256x256.png?rev=2502131\";s:2:\"1x\";s:67:\"https://ps.w.org/kadence-blocks/assets/icon-128x128.png?rev=2502131\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:70:\"https://ps.w.org/kadence-blocks/assets/banner-1544x500.jpg?rev=1954109\";s:2:\"1x\";s:69:\"https://ps.w.org/kadence-blocks/assets/banner-772x250.jpg?rev=1954109\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.9\";}s:41:\"advanced-gutenberg/advanced-gutenberg.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:32:\"w.org/plugins/advanced-gutenberg\";s:4:\"slug\";s:18:\"advanced-gutenberg\";s:6:\"plugin\";s:41:\"advanced-gutenberg/advanced-gutenberg.php\";s:11:\"new_version\";s:5:\"3.1.2\";s:3:\"url\";s:49:\"https://wordpress.org/plugins/advanced-gutenberg/\";s:7:\"package\";s:67:\"https://downloads.wordpress.org/plugin/advanced-gutenberg.3.1.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:71:\"https://ps.w.org/advanced-gutenberg/assets/icon-256x256.png?rev=2467302\";s:2:\"1x\";s:71:\"https://ps.w.org/advanced-gutenberg/assets/icon-128x128.png?rev=2467302\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:74:\"https://ps.w.org/advanced-gutenberg/assets/banner-1544x500.png?rev=2389802\";s:2:\"1x\";s:73:\"https://ps.w.org/advanced-gutenberg/assets/banner-772x250.png?rev=2389802\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"5.0\";}s:33:\"virtue-toolkit/virtue_toolkit.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:28:\"w.org/plugins/virtue-toolkit\";s:4:\"slug\";s:14:\"virtue-toolkit\";s:6:\"plugin\";s:33:\"virtue-toolkit/virtue_toolkit.php\";s:11:\"new_version\";s:5:\"4.9.8\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/virtue-toolkit/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/virtue-toolkit.4.9.8.zip\";s:5:\"icons\";a:1:{s:7:\"default\";s:58:\"https://s.w.org/plugins/geopattern-icon/virtue-toolkit.svg\";}s:7:\"banners\";a:0:{}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"4.5\";}s:33:\"wp-maintenance/wp-maintenance.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:28:\"w.org/plugins/wp-maintenance\";s:4:\"slug\";s:14:\"wp-maintenance\";s:6:\"plugin\";s:33:\"wp-maintenance/wp-maintenance.php\";s:11:\"new_version\";s:5:\"6.1.2\";s:3:\"url\";s:45:\"https://wordpress.org/plugins/wp-maintenance/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/plugin/wp-maintenance.6.1.2.zip\";s:5:\"icons\";a:2:{s:2:\"2x\";s:67:\"https://ps.w.org/wp-maintenance/assets/icon-256x256.png?rev=2194706\";s:2:\"1x\";s:67:\"https://ps.w.org/wp-maintenance/assets/icon-128x128.png?rev=2194706\";}s:7:\"banners\";a:1:{s:2:\"1x\";s:69:\"https://ps.w.org/wp-maintenance/assets/banner-772x250.png?rev=2661063\";}s:11:\"banners_rtl\";a:0:{}s:8:\"requires\";s:3:\"3.0\";}s:24:\"wordpress-seo/wp-seo.php\";O:8:\"stdClass\":10:{s:2:\"id\";s:27:\"w.org/plugins/wordpress-seo\";s:4:\"slug\";s:13:\"wordpress-seo\";s:6:\"plugin\";s:24:\"wordpress-seo/wp-seo.php\";s:11:\"new_version\";s:5:\"19.14\";s:3:\"url\";s:44:\"https://wordpress.org/plugins/wordpress-seo/\";s:7:\"package\";s:62:\"https://downloads.wordpress.org/plugin/wordpress-seo.19.14.zip\";s:5:\"icons\";a:3:{s:2:\"2x\";s:66:\"https://ps.w.org/wordpress-seo/assets/icon-256x256.png?rev=2643727\";s:2:\"1x\";s:58:\"https://ps.w.org/wordpress-seo/assets/icon.svg?rev=2363699\";s:3:\"svg\";s:58:\"https://ps.w.org/wordpress-seo/assets/icon.svg?rev=2363699\";}s:7:\"banners\";a:2:{s:2:\"2x\";s:69:\"https://ps.w.org/wordpress-seo/assets/banner-1544x500.png?rev=2643727\";s:2:\"1x\";s:68:\"https://ps.w.org/wordpress-seo/assets/banner-772x250.png?rev=2643727\";}s:11:\"banners_rtl\";a:2:{s:2:\"2x\";s:73:\"https://ps.w.org/wordpress-seo/assets/banner-1544x500-rtl.png?rev=2643727\";s:2:\"1x\";s:72:\"https://ps.w.org/wordpress-seo/assets/banner-772x250-rtl.png?rev=2643727\";}s:8:\"requires\";s:3:\"6.0\";}}s:7:\"checked\";a:7:{s:51:\"all-in-one-wp-migration/all-in-one-wp-migration.php\";s:4:\"7.70\";s:25:\"duplicator/duplicator.php\";s:5:\"1.5.1\";s:33:\"kadence-blocks/kadence-blocks.php\";s:6:\"2.4.22\";s:41:\"advanced-gutenberg/advanced-gutenberg.php\";s:5:\"3.1.2\";s:33:\"virtue-toolkit/virtue_toolkit.php\";s:5:\"4.9.8\";s:33:\"wp-maintenance/wp-maintenance.php\";s:5:\"6.1.2\";s:24:\"wordpress-seo/wp-seo.php\";s:5:\"19.14\";}}", "no");
INSERT INTO `wp_options` VALUES("56555", "_site_transient_update_themes", "O:8:\"stdClass\":5:{s:12:\"last_checked\";i:1674103178;s:7:\"checked\";a:2:{s:17:\"twentytwentythree\";s:3:\"1.0\";s:6:\"virtue\";s:5:\"3.4.7\";}s:8:\"response\";a:0:{}s:9:\"no_update\";a:2:{s:17:\"twentytwentythree\";a:6:{s:5:\"theme\";s:17:\"twentytwentythree\";s:11:\"new_version\";s:3:\"1.0\";s:3:\"url\";s:47:\"https://wordpress.org/themes/twentytwentythree/\";s:7:\"package\";s:63:\"https://downloads.wordpress.org/theme/twentytwentythree.1.0.zip\";s:8:\"requires\";s:3:\"6.1\";s:12:\"requires_php\";s:3:\"5.6\";}s:6:\"virtue\";a:6:{s:5:\"theme\";s:6:\"virtue\";s:11:\"new_version\";s:5:\"3.4.7\";s:3:\"url\";s:36:\"https://wordpress.org/themes/virtue/\";s:7:\"package\";s:54:\"https://downloads.wordpress.org/theme/virtue.3.4.7.zip\";s:8:\"requires\";b:0;s:12:\"requires_php\";s:3:\"5.6\";}}s:12:\"translations\";a:0:{}}", "no");
INSERT INTO `wp_options` VALUES("56556", "duplicator_settings", "a:19:{s:7:\"version\";s:5:\"1.5.1\";s:18:\"uninstall_settings\";b:1;s:15:\"uninstall_files\";b:1;s:16:\"uninstall_tables\";b:1;s:13:\"package_debug\";b:0;s:17:\"package_mysqldump\";s:1:\"0\";s:22:\"package_mysqldump_path\";s:0:\"\";s:24:\"package_phpdump_qrylimit\";s:3:\"100\";s:17:\"package_zip_flush\";s:1:\"0\";s:19:\"installer_name_mode\";s:6:\"simple\";s:16:\"storage_position\";s:6:\"legacy\";s:20:\"storage_htaccess_off\";s:0:\"\";s:18:\"archive_build_mode\";s:1:\"2\";s:17:\"skip_archive_scan\";b:0;s:21:\"unhook_third_party_js\";b:0;s:22:\"unhook_third_party_css\";b:0;s:17:\"active_package_id\";i:1;s:12:\"last_updated\";s:19:\"2023-01-19-04-41-21\";s:18:\"package_ui_created\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("56557", "duplicator_version_plugin", "1.5.1", "yes");
INSERT INTO `wp_options` VALUES("56558", "_transient_timeout_wpseo_total_unindexed_posts_limited", "1674104134", "no");
INSERT INTO `wp_options` VALUES("56559", "_transient_wpseo_total_unindexed_posts_limited", "0", "no");
INSERT INTO `wp_options` VALUES("56560", "_transient_timeout_wpseo_total_unindexed_terms_limited", "1674104134", "no");
INSERT INTO `wp_options` VALUES("56561", "_transient_wpseo_total_unindexed_terms_limited", "0", "no");
INSERT INTO `wp_options` VALUES("56562", "duplicator_ui_view_state", "a:2:{s:22:\"dup-pack-storage-panel\";s:1:\"1\";s:22:\"dup-pack-archive-panel\";s:1:\"1\";}", "yes");
INSERT INTO `wp_options` VALUES("56563", "duplicator_package_active", "O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2023-01-19 04:47:02\";s:7:\"Version\";s:5:\"1.5.1\";s:9:\"VersionWP\";s:5:\"6.1.1\";s:9:\"VersionDB\";s:6:\"5.7.40\";s:10:\"VersionPHP\";s:6:\"7.4.29\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:38:\"2023_01_19_cabinetorthopediepodologiea\";s:4:\"Hash\";s:35:\"7e5b19f61af022e77317_20230119044702\";s:8:\"NameHash\";s:74:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";s:84:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702_scan.json\";s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";O:11:\"DUP_Archive\":26:{s:10:\"FilterDirs\";s:0:\"\";s:11:\"FilterFiles\";s:0:\"\";s:10:\"FilterExts\";s:0:\"\";s:13:\"FilterDirsAll\";a:0:{}s:14:\"FilterFilesAll\";a:0:{}s:13:\"FilterExtsAll\";a:0:{}s:8:\"FilterOn\";i:0;s:12:\"ExportOnlyDB\";i:0;s:4:\"File\";N;s:6:\"Format\";s:3:\"ZIP\";s:7:\"PackDir\";s:17:\"/home/orthopa/www\";s:4:\"Size\";i:0;s:4:\"Dirs\";a:0:{}s:9:\"dirsCount\";i:1017;s:5:\"Files\";a:0:{}s:10:\"filesCount\";i:7659;s:10:\"FilterInfo\";O:23:\"DUP_Archive_Filter_Info\":8:{s:4:\"Dirs\";O:34:\"DUP_Archive_Filter_Scope_Directory\":6:{s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:5:\"Files\";O:29:\"DUP_Archive_Filter_Scope_File\":7:{s:4:\"Size\";a:0:{}s:7:\"Warning\";a:0:{}s:10:\"Unreadable\";a:0:{}s:10:\"AddonSites\";a:0:{}s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:4:\"Exts\";O:29:\"DUP_Archive_Filter_Scope_Base\":3:{s:4:\"Core\";a:0:{}s:6:\"Global\";a:0:{}s:8:\"Instance\";a:0:{}}s:9:\"UDirCount\";i:0;s:10:\"UFileCount\";i:0;s:9:\"UExtCount\";i:0;s:8:\"TreeSize\";a:0:{}s:11:\"TreeWarning\";a:0:{}}s:14:\"RecursiveLinks\";a:0:{}s:10:\"file_count\";i:-1;s:10:\"\0*\0Package\";O:11:\"DUP_Package\":23:{s:7:\"Created\";s:19:\"2023-01-19 04:47:02\";s:7:\"Version\";s:5:\"1.5.1\";s:9:\"VersionWP\";s:5:\"6.1.1\";s:9:\"VersionDB\";s:6:\"5.7.40\";s:10:\"VersionPHP\";s:6:\"7.4.29\";s:9:\"VersionOS\";s:5:\"Linux\";s:2:\"ID\";N;s:4:\"Name\";s:38:\"2023_01_19_cabinetorthopediepodologiea\";s:4:\"Hash\";s:35:\"7e5b19f61af022e77317_20230119044702\";s:8:\"NameHash\";s:74:\"2023_01_19_cabinetorthopediepodologiea_7e5b19f61af022e77317_20230119044702\";s:4:\"Type\";i:0;s:5:\"Notes\";s:0:\"\";s:8:\"ScanFile\";N;s:10:\"TimerStart\";i:-1;s:7:\"Runtime\";N;s:7:\"ExeSize\";N;s:7:\"ZipSize\";N;s:6:\"Status\";i:0;s:6:\"WPUser\";N;s:7:\"Archive\";r:21;s:9:\"Installer\";O:13:\"DUP_Installer\":15:{s:4:\"File\";N;s:4:\"Size\";i:0;s:10:\"OptsDBHost\";s:0:\"\";s:10:\"OptsDBPort\";s:0:\"\";s:10:\"OptsDBName\";s:0:\"\";s:10:\"OptsDBUser\";s:0:\"\";s:13:\"OptsDBCharset\";s:0:\"\";s:15:\"OptsDBCollation\";s:0:\"\";s:12:\"OptsSecureOn\";i:0;s:14:\"OptsSecurePass\";s:0:\"\";s:13:\"numFilesAdded\";i:0;s:12:\"numDirsAdded\";i:0;s:10:\"\0*\0Package\";r:65;s:17:\"\0*\0origFileManger\";N;s:32:\"\0DUP_Installer\0configTransformer\";O:44:\"Duplicator\\Libs\\WpConfig\\WPConfigTransformer\":3:{s:17:\"\0*\0wp_config_path\";s:31:\"/home/orthopa/www/wp-config.php\";s:16:\"\0*\0wp_config_src\";N;s:13:\"\0*\0wp_configs\";a:0:{}}}s:8:\"Database\";O:12:\"DUP_Database\":14:{s:4:\"Type\";s:5:\"MySQL\";s:4:\"Size\";N;s:4:\"File\";N;s:4:\"Path\";N;s:12:\"FilterTables\";s:0:\"\";s:8:\"FilterOn\";i:0;s:4:\"Name\";N;s:10:\"Compatible\";s:0:\"\";s:8:\"Comments\";s:28:\"MySQL Community Server (GPL)\";s:4:\"info\";O:16:\"DUP_DatabaseInfo\":23:{s:9:\"buildMode\";s:3:\"PHP\";s:11:\"charSetList\";a:0:{}s:13:\"collationList\";a:0:{}s:10:\"engineList\";a:0:{}s:17:\"isTablesUpperCase\";b:0;s:15:\"isNameUpperCase\";b:0;s:4:\"name\";s:0:\"\";s:15:\"tablesBaseCount\";i:0;s:16:\"tablesFinalCount\";i:0;s:20:\"muFilteredTableCount\";i:0;s:14:\"tablesRowCount\";i:0;s:16:\"tablesSizeOnDisk\";i:0;s:10:\"tablesList\";a:0:{}s:18:\"varLowerCaseTables\";i:0;s:8:\"dbEngine\";s:0:\"\";s:7:\"version\";i:0;s:14:\"versionComment\";i:0;s:9:\"viewCount\";i:0;s:9:\"procCount\";i:0;s:9:\"funcCount\";i:0;s:11:\"triggerList\";a:0:{}s:33:\"\0DUP_DatabaseInfo\0intFieldsStruct\";a:0:{}s:42:\"\0DUP_DatabaseInfo\0indexProcessedSchemaSize\";a:0:{}}s:10:\"\0*\0Package\";r:65;s:24:\"\0DUP_Database\0tempDbPath\";N;s:23:\"\0DUP_Database\0EOFMarker\";s:0:\"\";s:26:\"\0DUP_Database\0networkFlush\";b:0;}s:13:\"BuildProgress\";O:18:\"DUP_Build_Progress\":12:{s:17:\"thread_start_time\";N;s:11:\"initialized\";b:0;s:15:\"installer_built\";b:0;s:15:\"archive_started\";b:0;s:20:\"archive_has_database\";b:0;s:13:\"archive_built\";b:0;s:21:\"database_script_built\";b:0;s:6:\"failed\";b:0;s:7:\"retries\";i:0;s:14:\"build_failures\";a:0:{}s:19:\"validation_failures\";a:0:{}s:27:\"\0DUP_Build_Progress\0package\";r:65;}}s:29:\"\0DUP_Archive\0tmpFilterDirsAll\";a:0:{}s:24:\"\0DUP_Archive\0wpCorePaths\";a:3:{i:0;s:26:\"/home/orthopa/www/wp-admin\";i:1;s:29:\"/home/orthopa/www/wp-includes\";i:2;s:38:\"/home/orthopa/www/wp-content/languages\";}s:29:\"\0DUP_Archive\0wpCoreExactPaths\";a:7:{i:0;s:17:\"/home/orthopa/www\";i:1;s:17:\"/home/orthopa/www\";i:2;s:28:\"/home/orthopa/www/wp-content\";i:3;s:36:\"/home/orthopa/www/wp-content/uploads\";i:4;s:36:\"/home/orthopa/www/wp-content/plugins\";i:5;s:39:\"/home/orthopa/www/wp-content/mu-plugins\";i:6;s:35:\"/home/orthopa/www/wp-content/themes\";}s:31:\"\0DUP_Archive\0relativeFiltersDir\";a:2:{i:0;s:34:\"/home/orthopa/www/wp-snapshots/tmp\";i:1;s:15:\"backups-dup-pro\";}s:24:\"\0DUP_Archive\0listFileObj\";N;s:23:\"\0DUP_Archive\0listDirObj\";N;}s:9:\"Installer\";r:86;s:8:\"Database\";r:105;s:13:\"BuildProgress\";r:143;}", "yes");

/* INSERT TABLE DATA: wp_postmeta */
INSERT INTO `wp_postmeta` VALUES("2", "3", "_wp_page_template", "default");
INSERT INTO `wp_postmeta` VALUES("10", "8", "_edit_lock", "1635401874:1");
INSERT INTO `wp_postmeta` VALUES("11", "8", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("12", "8", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("13", "8", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("14", "8", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("15", "8", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("16", "8", "_kad_subtitle", "Cabinet Orthopédie Podologie l\'ANTHOARD");
INSERT INTO `wp_postmeta` VALUES("17", "8", "_yoast_wpseo_metadesc", "Bienvenue au Cabinet d\'orthopédie et de podologie fondé en 1995 par M Aubertin, diplômé de l\'école ECOTEV et installé à Grenoble depuis 2006 .");
INSERT INTO `wp_postmeta` VALUES("18", "8", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("22", "13", "_wp_attached_file", "2021/09/Image-accueil.png");
INSERT INTO `wp_postmeta` VALUES("23", "13", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:1084;s:6:\"height\";i:825;s:4:\"file\";s:25:\"2021/09/Image-accueil.png\";s:5:\"sizes\";a:5:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"Image-accueil-300x228.png\";s:5:\"width\";i:300;s:6:\"height\";i:228;s:9:\"mime-type\";s:9:\"image/png\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"Image-accueil-1024x779.png\";s:5:\"width\";i:1024;s:6:\"height\";i:779;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"Image-accueil-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:25:\"Image-accueil-768x585.png\";s:5:\"width\";i:768;s:6:\"height\";i:585;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:23:\"Image-accueil-80x50.png\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("24", "8", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("25", "16", "_edit_lock", "1635400570:1");
INSERT INTO `wp_postmeta` VALUES("26", "16", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("27", "16", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("28", "16", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("29", "16", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("30", "16", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("31", "16", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("32", "19", "_edit_lock", "1670591016:1");
INSERT INTO `wp_postmeta` VALUES("33", "19", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("34", "19", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("35", "19", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("36", "19", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("37", "19", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("38", "19", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("39", "21", "_edit_lock", "1670590316:1");
INSERT INTO `wp_postmeta` VALUES("40", "21", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("41", "21", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("42", "21", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("43", "21", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("44", "21", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("45", "21", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("46", "24", "_edit_lock", "1670590133:1");
INSERT INTO `wp_postmeta` VALUES("47", "24", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("48", "24", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("49", "24", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("50", "24", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("51", "24", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("52", "24", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("53", "26", "_edit_lock", "1635248613:1");
INSERT INTO `wp_postmeta` VALUES("54", "26", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("55", "26", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("56", "26", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("57", "26", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("58", "26", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("59", "26", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("60", "3", "_edit_lock", "1635400763:1");
INSERT INTO `wp_postmeta` VALUES("61", "28", "_edit_lock", "1674101902:1");
INSERT INTO `wp_postmeta` VALUES("62", "28", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("63", "28", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("64", "28", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("65", "28", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("66", "28", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("67", "28", "_yoast_wpseo_estimated-reading-time-minutes", "2");
INSERT INTO `wp_postmeta` VALUES("68", "3", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("69", "3", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("70", "3", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("71", "3", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("72", "3", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("73", "3", "_yoast_wpseo_content_score", "30");
INSERT INTO `wp_postmeta` VALUES("74", "3", "_yoast_wpseo_estimated-reading-time-minutes", "14");
INSERT INTO `wp_postmeta` VALUES("75", "31", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("76", "31", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("77", "31", "_menu_item_object_id", "26");
INSERT INTO `wp_postmeta` VALUES("78", "31", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("79", "31", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("80", "31", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("81", "31", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("82", "31", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("84", "32", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("85", "32", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("86", "32", "_menu_item_object_id", "24");
INSERT INTO `wp_postmeta` VALUES("87", "32", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("88", "32", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("89", "32", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("90", "32", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("91", "32", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("93", "33", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("94", "33", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("95", "33", "_menu_item_object_id", "21");
INSERT INTO `wp_postmeta` VALUES("96", "33", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("97", "33", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("98", "33", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("99", "33", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("100", "33", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("102", "34", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("103", "34", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("104", "34", "_menu_item_object_id", "16");
INSERT INTO `wp_postmeta` VALUES("105", "34", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("106", "34", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("107", "34", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("108", "34", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("109", "34", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("120", "36", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("121", "36", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("122", "36", "_menu_item_object_id", "19");
INSERT INTO `wp_postmeta` VALUES("123", "36", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("124", "36", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("125", "36", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("126", "36", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("127", "36", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("129", "37", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("130", "37", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("131", "37", "_menu_item_object_id", "28");
INSERT INTO `wp_postmeta` VALUES("132", "37", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("133", "37", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("134", "37", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("135", "37", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("136", "37", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("162", "36", "_wp_old_date", "2021-09-01");
INSERT INTO `wp_postmeta` VALUES("163", "37", "_wp_old_date", "2021-09-01");
INSERT INTO `wp_postmeta` VALUES("166", "34", "_wp_old_date", "2021-09-01");
INSERT INTO `wp_postmeta` VALUES("167", "33", "_wp_old_date", "2021-09-01");
INSERT INTO `wp_postmeta` VALUES("168", "32", "_wp_old_date", "2021-09-01");
INSERT INTO `wp_postmeta` VALUES("169", "31", "_wp_old_date", "2021-09-01");
INSERT INTO `wp_postmeta` VALUES("170", "48", "_edit_lock", "1635401672:1");
INSERT INTO `wp_postmeta` VALUES("171", "48", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("172", "48", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("173", "48", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("174", "48", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("175", "48", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("176", "48", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("177", "50", "_edit_lock", "1670590439:1");
INSERT INTO `wp_postmeta` VALUES("178", "50", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("179", "50", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("180", "50", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("181", "50", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("182", "50", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("183", "50", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("184", "52", "_edit_lock", "1635401143:1");
INSERT INTO `wp_postmeta` VALUES("185", "52", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("186", "52", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("187", "52", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("188", "52", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("189", "52", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("190", "52", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("191", "54", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("192", "54", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("193", "54", "_menu_item_object_id", "48");
INSERT INTO `wp_postmeta` VALUES("194", "54", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("195", "54", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("196", "54", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("197", "54", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("198", "54", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("200", "55", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("201", "55", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("202", "55", "_menu_item_object_id", "50");
INSERT INTO `wp_postmeta` VALUES("203", "55", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("204", "55", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("205", "55", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("206", "55", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("207", "55", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("209", "56", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("210", "56", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("211", "56", "_menu_item_object_id", "52");
INSERT INTO `wp_postmeta` VALUES("212", "56", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("213", "56", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("214", "56", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("215", "56", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("216", "56", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("218", "57", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("219", "57", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("220", "57", "_menu_item_object_id", "3");
INSERT INTO `wp_postmeta` VALUES("221", "57", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("222", "57", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("223", "57", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("224", "57", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("225", "57", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("226", "57", "_menu_item_orphaned", "1635151591");
INSERT INTO `wp_postmeta` VALUES("227", "58", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("228", "58", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("229", "58", "_menu_item_object_id", "3");
INSERT INTO `wp_postmeta` VALUES("230", "58", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("231", "58", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("232", "58", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("233", "58", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("234", "58", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("236", "13", "_edit_lock", "1635176370:1");
INSERT INTO `wp_postmeta` VALUES("237", "59", "_wp_attached_file", "2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg");
INSERT INTO `wp_postmeta` VALUES("238", "59", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:786;s:6:\"height\";i:628;s:4:\"file\";s:52:\"2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:52:\"cabinet-anthoard-podologie-grenoble-fond-300x240.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:240;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:52:\"cabinet-anthoard-podologie-grenoble-fond-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:52:\"cabinet-anthoard-podologie-grenoble-fond-768x614.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:614;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:50:\"cabinet-anthoard-podologie-grenoble-fond-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1634309868\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("239", "59", "_wp_attachment_image_alt", "Cabinet anthoard orthopedie podologie a Grenoble");
INSERT INTO `wp_postmeta` VALUES("240", "61", "_wp_attached_file", "2021/10/99-002657_max.jpg");
INSERT INTO `wp_postmeta` VALUES("241", "61", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:658;s:6:\"height\";i:1280;s:4:\"file\";s:25:\"2021/10/99-002657_max.jpg\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"99-002657_max-154x300.jpg\";s:5:\"width\";i:154;s:6:\"height\";i:300;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:5:\"large\";a:4:{s:4:\"file\";s:26:\"99-002657_max-526x1024.jpg\";s:5:\"width\";i:526;s:6:\"height\";i:1024;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"99-002657_max-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:23:\"99-002657_max-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("242", "62", "_wp_attached_file", "2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png");
INSERT INTO `wp_postmeta` VALUES("243", "62", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:800;s:6:\"height\";i:746;s:4:\"file\";s:63:\"2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:63:\"cabinet-anthoard-orthopedie-podologie-grenoble-fond-300x280.png\";s:5:\"width\";i:300;s:6:\"height\";i:280;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:63:\"cabinet-anthoard-orthopedie-podologie-grenoble-fond-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:63:\"cabinet-anthoard-orthopedie-podologie-grenoble-fond-768x716.png\";s:5:\"width\";i:768;s:6:\"height\";i:716;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:61:\"cabinet-anthoard-orthopedie-podologie-grenoble-fond-80x50.png\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("244", "16", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("245", "19", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("246", "21", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("247", "24", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("248", "26", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("249", "115", "_wp_attached_file", "2021/10/doc-rendezvous-aubertin-roger.png");
INSERT INTO `wp_postmeta` VALUES("250", "115", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:847;s:6:\"height\";i:174;s:4:\"file\";s:41:\"2021/10/doc-rendezvous-aubertin-roger.png\";s:5:\"sizes\";a:4:{s:6:\"medium\";a:4:{s:4:\"file\";s:40:\"doc-rendezvous-aubertin-roger-300x62.png\";s:5:\"width\";i:300;s:6:\"height\";i:62;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:41:\"doc-rendezvous-aubertin-roger-150x150.png\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"medium_large\";a:4:{s:4:\"file\";s:41:\"doc-rendezvous-aubertin-roger-768x158.png\";s:5:\"width\";i:768;s:6:\"height\";i:158;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:39:\"doc-rendezvous-aubertin-roger-80x50.png\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("251", "52", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("252", "48", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("253", "50", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("259", "149", "_wp_attached_file", "2021/10/cabinet-atelier.jpg");
INSERT INTO `wp_postmeta` VALUES("260", "149", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:555;s:6:\"height\";i:371;s:4:\"file\";s:27:\"2021/10/cabinet-atelier.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"cabinet-atelier-300x201.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:201;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"cabinet-atelier-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:25:\"cabinet-atelier-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("261", "150", "_wp_attached_file", "2021/10/cabinet-couloir.jpg");
INSERT INTO `wp_postmeta` VALUES("262", "150", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:548;s:6:\"height\";i:326;s:4:\"file\";s:27:\"2021/10/cabinet-couloir.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"cabinet-couloir-300x178.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:178;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"cabinet-couloir-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:25:\"cabinet-couloir-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("263", "151", "_wp_attached_file", "2021/10/cabinet-exterieur.jpg");
INSERT INTO `wp_postmeta` VALUES("264", "151", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:526;s:6:\"height\";i:355;s:4:\"file\";s:29:\"2021/10/cabinet-exterieur.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:29:\"cabinet-exterieur-300x202.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:202;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:29:\"cabinet-exterieur-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:27:\"cabinet-exterieur-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("265", "152", "_wp_attached_file", "2021/10/cabinet-machine-physioforme.jpg");
INSERT INTO `wp_postmeta` VALUES("266", "152", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:567;s:6:\"height\";i:381;s:4:\"file\";s:39:\"2021/10/cabinet-machine-physioforme.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:39:\"cabinet-machine-physioforme-300x202.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:202;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:39:\"cabinet-machine-physioforme-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:37:\"cabinet-machine-physioforme-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("267", "153", "_wp_attached_file", "2021/10/cabinet-parking.jpg");
INSERT INTO `wp_postmeta` VALUES("268", "153", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:544;s:6:\"height\";i:346;s:4:\"file\";s:27:\"2021/10/cabinet-parking.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:27:\"cabinet-parking-300x191.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:191;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:27:\"cabinet-parking-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:25:\"cabinet-parking-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("269", "154", "_wp_attached_file", "2021/10/cabinet-salle-attente.jpg");
INSERT INTO `wp_postmeta` VALUES("270", "154", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:545;s:6:\"height\";i:364;s:4:\"file\";s:33:\"2021/10/cabinet-salle-attente.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"cabinet-salle-attente-300x200.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:200;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"cabinet-salle-attente-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:31:\"cabinet-salle-attente-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("271", "155", "_wp_attached_file", "2021/10/cabinet-salle-examen-1.jpg");
INSERT INTO `wp_postmeta` VALUES("272", "155", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:555;s:6:\"height\";i:416;s:4:\"file\";s:34:\"2021/10/cabinet-salle-examen-1.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cabinet-salle-examen-1-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cabinet-salle-examen-1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:32:\"cabinet-salle-examen-1-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("273", "156", "_wp_attached_file", "2021/10/cabinet-salle-examen-2.jpg");
INSERT INTO `wp_postmeta` VALUES("274", "156", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:555;s:6:\"height\";i:416;s:4:\"file\";s:34:\"2021/10/cabinet-salle-examen-2.jpg\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"cabinet-salle-examen-2-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"cabinet-salle-examen-2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:32:\"cabinet-salle-examen-2-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("275", "151", "_wp_attachment_image_alt", "6 Rue ANTHOARD 38000 Grenoble");
INSERT INTO `wp_postmeta` VALUES("276", "153", "_wp_attachment_image_alt", "Entrée 6 rue ANTHOARD 38000 Grenoble");
INSERT INTO `wp_postmeta` VALUES("277", "154", "_wp_attachment_image_alt", "Salle d\'attente cabinet");
INSERT INTO `wp_postmeta` VALUES("278", "150", "_wp_attachment_image_alt", "Couloir accès cabinet");
INSERT INTO `wp_postmeta` VALUES("279", "155", "_wp_attachment_image_alt", "Cabinet Podologie");
INSERT INTO `wp_postmeta` VALUES("280", "156", "_wp_attachment_image_alt", "Cabinet Orthopedie");
INSERT INTO `wp_postmeta` VALUES("281", "152", "_wp_attachment_image_alt", "Machine Physioforme");
INSERT INTO `wp_postmeta` VALUES("282", "149", "_wp_attachment_image_alt", "Atelier Cabinet Podologie");
INSERT INTO `wp_postmeta` VALUES("283", "28", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("284", "158", "_wp_attached_file", "2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png");
INSERT INTO `wp_postmeta` VALUES("285", "158", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:256;s:6:\"height\";i:100;s:4:\"file\";s:63:\"2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:63:\"cabinet-anthoard-orthopedie-podologie-grenoble-logo-150x100.png\";s:5:\"width\";i:150;s:6:\"height\";i:100;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:61:\"cabinet-anthoard-orthopedie-podologie-grenoble-logo-80x50.png\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("286", "165", "_edit_lock", "1635399912:1");
INSERT INTO `wp_postmeta` VALUES("287", "165", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("288", "165", "_kad_page_sidebar", "default");
INSERT INTO `wp_postmeta` VALUES("289", "165", "_kad_sidebar_choice", "sidebar-primary");
INSERT INTO `wp_postmeta` VALUES("290", "165", "_kad_page_content_width", "default");
INSERT INTO `wp_postmeta` VALUES("291", "165", "_kad_show_page_title", "default");
INSERT INTO `wp_postmeta` VALUES("292", "165", "_yoast_wpseo_content_score", "90");
INSERT INTO `wp_postmeta` VALUES("293", "165", "_yoast_wpseo_estimated-reading-time-minutes", "1");
INSERT INTO `wp_postmeta` VALUES("294", "169", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("295", "169", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("296", "169", "_menu_item_object_id", "165");
INSERT INTO `wp_postmeta` VALUES("297", "169", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("298", "169", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("299", "169", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("300", "169", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("301", "169", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("303", "34", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("304", "33", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("305", "32", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("306", "31", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("324", "176", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("325", "176", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("326", "176", "_menu_item_object_id", "19");
INSERT INTO `wp_postmeta` VALUES("327", "176", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("328", "176", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("329", "176", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("330", "176", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("331", "176", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("333", "177", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("334", "177", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("335", "177", "_menu_item_object_id", "28");
INSERT INTO `wp_postmeta` VALUES("336", "177", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("337", "177", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("338", "177", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("339", "177", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("340", "177", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("342", "178", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("343", "178", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("344", "178", "_menu_item_object_id", "48");
INSERT INTO `wp_postmeta` VALUES("345", "178", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("346", "178", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("347", "178", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("348", "178", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("349", "178", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("351", "179", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("352", "179", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("353", "179", "_menu_item_object_id", "50");
INSERT INTO `wp_postmeta` VALUES("354", "179", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("355", "179", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("356", "179", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("357", "179", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("358", "179", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("360", "180", "_menu_item_type", "post_type");
INSERT INTO `wp_postmeta` VALUES("361", "180", "_menu_item_menu_item_parent", "0");
INSERT INTO `wp_postmeta` VALUES("362", "180", "_menu_item_object_id", "52");
INSERT INTO `wp_postmeta` VALUES("363", "180", "_menu_item_object", "page");
INSERT INTO `wp_postmeta` VALUES("364", "180", "_menu_item_target", "");
INSERT INTO `wp_postmeta` VALUES("365", "180", "_menu_item_classes", "a:1:{i:0;s:0:\"\";}");
INSERT INTO `wp_postmeta` VALUES("366", "180", "_menu_item_xfn", "");
INSERT INTO `wp_postmeta` VALUES("367", "180", "_menu_item_url", "");
INSERT INTO `wp_postmeta` VALUES("369", "36", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("370", "37", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("371", "3", "_wp_suggested_privacy_policy_content", "a:3:{s:11:\"plugin_name\";s:9:\"WordPress\";s:11:\"policy_text\";s:5174:\"<h2>Qui sommes-nous ?</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>L’adresse de notre site est : https://www.orthopedie-podologie-anthoard-grenoble.com.</p><h2>Commentaires</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Quand vous laissez un commentaire sur notre site, les données inscrites dans le formulaire de commentaire, mais aussi votre adresse IP et l’agent utilisateur de votre navigateur sont collectés pour nous aider à la détection des commentaires indésirables.</p><p>Une chaîne anonymisée créée à partir de votre adresse e-mail (également appelée hash) peut être envoyée au service Gravatar pour vérifier si vous utilisez ce dernier. Les clauses de confidentialité du service Gravatar sont disponibles ici : https://automattic.com/privacy/. Après validation de votre commentaire, votre photo de profil sera visible publiquement à coté de votre commentaire.</p><h2>Médias</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Si vous téléversez des images sur le site, nous vous conseillons d’éviter de téléverser des images contenant des données EXIF de coordonnées GPS. Les personnes visitant votre site peuvent télécharger et extraire des données de localisation depuis ces images.</p><h2>Cookies</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Si vous déposez un commentaire sur notre site, il vous sera proposé d’enregistrer votre nom, adresse e-mail et site dans des cookies. C’est uniquement pour votre confort afin de ne pas avoir à saisir ces informations si vous déposez un autre commentaire plus tard. Ces cookies expirent au bout d’un an.</p><p>Si vous vous rendez sur la page de connexion, un cookie temporaire sera créé afin de déterminer si votre navigateur accepte les cookies. Il ne contient pas de données personnelles et sera supprimé automatiquement à la fermeture de votre navigateur.</p><p>Lorsque vous vous connecterez, nous mettrons en place un certain nombre de cookies pour enregistrer vos informations de connexion et vos préférences d’écran. La durée de vie d’un cookie de connexion est de deux jours, celle d’un cookie d’option d’écran est d’un an. Si vous cochez « Se souvenir de moi », votre cookie de connexion sera conservé pendant deux semaines. Si vous vous déconnectez de votre compte, le cookie de connexion sera effacé.</p><p>En modifiant ou en publiant une publication, un cookie supplémentaire sera enregistré dans votre navigateur. Ce cookie ne comprend aucune donnée personnelle. Il indique simplement l’ID de la publication que vous venez de modifier. Il expire au bout d’un jour.</p><h2>Contenu embarqué depuis d’autres sites</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Les articles de ce site peuvent inclure des contenus intégrés (par exemple des vidéos, images, articles…). Le contenu intégré depuis d’autres sites se comporte de la même manière que si le visiteur se rendait sur cet autre site.</p><p>Ces sites web pourraient collecter des données sur vous, utiliser des cookies, embarquer des outils de suivis tiers, suivre vos interactions avec ces contenus embarqués si vous disposez d’un compte connecté sur leur site web.</p><h2>Utilisation et transmission de vos données personnelles</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Si vous demandez une réinitialisation de votre mot de passe, votre adresse IP sera incluse dans l’e-mail de réinitialisation.</p><h2>Durées de stockage de vos données</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Si vous laissez un commentaire, le commentaire et ses métadonnées sont conservés indéfiniment. Cela permet de reconnaître et approuver automatiquement les commentaires suivants au lieu de les laisser dans la file de modération.</p><p>Pour les comptes qui s’inscrivent sur notre site (le cas échéant), nous stockons également les données personnelles indiquées dans leur profil. Tous les comptes peuvent voir, modifier ou supprimer leurs informations personnelles à tout moment (à l’exception de leur identifiant). Les gestionnaires du site peuvent aussi voir et modifier ces informations.</p><h2>Les droits que vous avez sur vos données</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Si vous avez un compte ou si vous avez laissé des commentaires sur le site, vous pouvez demander à recevoir un fichier contenant toutes les données personnelles que nous possédons à votre sujet, incluant celles que vous nous avez fournies. Vous pouvez également demander la suppression des données personnelles vous concernant. Cela ne prend pas en compte les données stockées à des fins administratives, légales ou pour des raisons de sécurité.</p><h2>Transmission de vos données personnelles</h2><p><strong class=\"privacy-policy-tutorial\">Texte suggéré : </strong>Les commentaires des visiteurs peuvent être vérifiés à l’aide d’un service automatisé de détection des commentaires indésirables.</p>\";s:5:\"added\";i:1635326766;}");
INSERT INTO `wp_postmeta` VALUES("399", "8", "_yoast_wpseo_title", "cabinet orthopédie podologie grenoble %%sep%% cabinet Antoard Grenoble Aubertin");
INSERT INTO `wp_postmeta` VALUES("400", "8", "_yoast_wpseo_focuskw", "cabinet orthopédie podologie grenoble");
INSERT INTO `wp_postmeta` VALUES("401", "8", "_yoast_wpseo_linkdex", "49");
INSERT INTO `wp_postmeta` VALUES("411", "58", "_wp_old_date", "2021-10-25");
INSERT INTO `wp_postmeta` VALUES("413", "16", "_yoast_wpseo_title", "cabinet d\'orthopédie et de podologie de Grenoble ANTHOARD : horaires");
INSERT INTO `wp_postmeta` VALUES("414", "16", "_yoast_wpseo_metadesc", "les consultations du cabinet de podologie orthopédie de Grenoble ANTHOARD sont sur rendez-vous Contacter le Secrétariat en cas d’urgence");
INSERT INTO `wp_postmeta` VALUES("416", "28", "_yoast_wpseo_title", "cabinet d\'orthopédie et de podologie de Grenoble ANTHOARD : en images");
INSERT INTO `wp_postmeta` VALUES("417", "28", "_yoast_wpseo_metadesc", "Visite du cabinet d\'orthopédie et de podologie de Grenoble ANTHOARD : en images - présentation visuelle du cabinet de M AUBERTIN Roger");
INSERT INTO `wp_postmeta` VALUES("418", "165", "_yoast_wpseo_focuskw", "Podologie Grenoble");
INSERT INTO `wp_postmeta` VALUES("419", "165", "_yoast_wpseo_title", "PODOLOGIE Grenoble %%sep%%");
INSERT INTO `wp_postmeta` VALUES("420", "165", "_yoast_wpseo_metadesc", "Cabinet de Podologie à Grenoble. pour Venir au Cabinet de podologie Situé Rue Anthoard à Grenoble vous devez prendre un Rendez Vous");
INSERT INTO `wp_postmeta` VALUES("421", "165", "_yoast_wpseo_linkdex", "57");
INSERT INTO `wp_postmeta` VALUES("422", "200", "_wp_attached_file", "2021/10/img-podologie-grenoble.png");
INSERT INTO `wp_postmeta` VALUES("423", "200", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:709;s:6:\"height\";i:46;s:4:\"file\";s:34:\"2021/10/img-podologie-grenoble.png\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:33:\"img-podologie-grenoble-300x19.png\";s:5:\"width\";i:300;s:6:\"height\";i:19;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:33:\"img-podologie-grenoble-150x46.png\";s:5:\"width\";i:150;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:32:\"img-podologie-grenoble-80x46.png\";s:5:\"width\";i:80;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("424", "58", "_wp_old_date", "2021-10-27");
INSERT INTO `wp_postmeta` VALUES("425", "19", "_yoast_wpseo_title", "histoire cabinet orthopedie podologie aubertin grenoble");
INSERT INTO `wp_postmeta` VALUES("426", "19", "_yoast_wpseo_metadesc", "Crée en aout 1995 par M AUBERTIN diplômé de l’ école ECOTEV de VIENNE en novembre 1993 , le cabinet s’est installé à Grenoble depuis 2006");
INSERT INTO `wp_postmeta` VALUES("427", "3", "_yoast_wpseo_title", "cabinet anthoard podologie grenoble mentions legales");
INSERT INTO `wp_postmeta` VALUES("428", "3", "_yoast_wpseo_metadesc", "mentions légales du cabinet de podologie et d\'orthopédie l\' Anthoard, de M Aubertin a Grenoble. Cabinet de Podologie à Grenoble depuis 2006.");
INSERT INTO `wp_postmeta` VALUES("429", "207", "_wp_attached_file", "2021/10/img-orthesiste-grenoble.png");
INSERT INTO `wp_postmeta` VALUES("430", "207", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:709;s:6:\"height\";i:46;s:4:\"file\";s:35:\"2021/10/img-orthesiste-grenoble.png\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"img-orthesiste-grenoble-300x19.png\";s:5:\"width\";i:300;s:6:\"height\";i:19;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"img-orthesiste-grenoble-150x46.png\";s:5:\"width\";i:150;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:33:\"img-orthesiste-grenoble-80x46.png\";s:5:\"width\";i:80;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("431", "52", "_yoast_wpseo_focuskw", "Orthesiste grenoble");
INSERT INTO `wp_postmeta` VALUES("432", "52", "_yoast_wpseo_title", "orthesiste grenoble");
INSERT INTO `wp_postmeta` VALUES("433", "52", "_yoast_wpseo_metadesc", "orthesiste grenoble - Spécialiste des orthèses sportives, des pathologies du pied, ou des pathologies posturales");
INSERT INTO `wp_postmeta` VALUES("434", "52", "_yoast_wpseo_linkdex", "53");
INSERT INTO `wp_postmeta` VALUES("435", "211", "_wp_attached_file", "2021/10/img-orthopedie-podologie-grenoble.png");
INSERT INTO `wp_postmeta` VALUES("436", "211", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:709;s:6:\"height\";i:46;s:4:\"file\";s:45:\"2021/10/img-orthopedie-podologie-grenoble.png\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:44:\"img-orthopedie-podologie-grenoble-300x19.png\";s:5:\"width\";i:300;s:6:\"height\";i:19;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:44:\"img-orthopedie-podologie-grenoble-150x46.png\";s:5:\"width\";i:150;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:43:\"img-orthopedie-podologie-grenoble-80x46.png\";s:5:\"width\";i:80;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("437", "21", "_yoast_wpseo_focuskw", "orthopedie podologie grenoble");
INSERT INTO `wp_postmeta` VALUES("438", "21", "_yoast_wpseo_title", "orthopedie podologie grenoble");
INSERT INTO `wp_postmeta` VALUES("439", "21", "_yoast_wpseo_metadesc", "Les prestations possibles en Orthopedie, podologie a Grenoble par le cabinet Anthoard sont nombreuses. Cabinet installé depuis 2006.");
INSERT INTO `wp_postmeta` VALUES("440", "21", "_yoast_wpseo_linkdex", "53");
INSERT INTO `wp_postmeta` VALUES("441", "214", "_wp_attached_file", "2021/10/img-orthopedie-grenoble.png");
INSERT INTO `wp_postmeta` VALUES("442", "214", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:709;s:6:\"height\";i:46;s:4:\"file\";s:35:\"2021/10/img-orthopedie-grenoble.png\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"img-orthopedie-grenoble-300x19.png\";s:5:\"width\";i:300;s:6:\"height\";i:19;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"img-orthopedie-grenoble-150x46.png\";s:5:\"width\";i:150;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:33:\"img-orthopedie-grenoble-80x46.png\";s:5:\"width\";i:80;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("443", "48", "_yoast_wpseo_focuskw", "orthopedie grenoble");
INSERT INTO `wp_postmeta` VALUES("444", "48", "_yoast_wpseo_title", "orthopedie grenoble");
INSERT INTO `wp_postmeta` VALUES("445", "48", "_yoast_wpseo_metadesc", "le cabinet d\' orthopedie à grenoble saura vous soulager pour toutes vos pathologies du pied, quelles que soient leurs origines");
INSERT INTO `wp_postmeta` VALUES("446", "48", "_yoast_wpseo_linkdex", "53");
INSERT INTO `wp_postmeta` VALUES("447", "217", "_wp_attached_file", "2021/10/img-podologiste-grenoble.png");
INSERT INTO `wp_postmeta` VALUES("448", "217", "_wp_attachment_metadata", "a:5:{s:5:\"width\";i:709;s:6:\"height\";i:46;s:4:\"file\";s:36:\"2021/10/img-podologiste-grenoble.png\";s:5:\"sizes\";a:3:{s:6:\"medium\";a:4:{s:4:\"file\";s:35:\"img-podologiste-grenoble-300x19.png\";s:5:\"width\";i:300;s:6:\"height\";i:19;s:9:\"mime-type\";s:9:\"image/png\";}s:9:\"thumbnail\";a:4:{s:4:\"file\";s:35:\"img-podologiste-grenoble-150x46.png\";s:5:\"width\";i:150;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}s:12:\"widget-thumb\";a:4:{s:4:\"file\";s:34:\"img-podologiste-grenoble-80x46.png\";s:5:\"width\";i:80;s:6:\"height\";i:46;s:9:\"mime-type\";s:9:\"image/png\";}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"0\";s:8:\"keywords\";a:0:{}}}");
INSERT INTO `wp_postmeta` VALUES("449", "50", "_yoast_wpseo_focuskw", "podologiste grenoble");
INSERT INTO `wp_postmeta` VALUES("450", "50", "_yoast_wpseo_title", "podologiste grenoble");
INSERT INTO `wp_postmeta` VALUES("451", "50", "_yoast_wpseo_metadesc", "M Aubertin Podologiste a Grenoble vous accueille dans son cabinet de podologie installé depuis 2006 pour vous fabriquer vos orthèses");
INSERT INTO `wp_postmeta` VALUES("452", "50", "_yoast_wpseo_linkdex", "53");
INSERT INTO `wp_postmeta` VALUES("453", "24", "_yoast_wpseo_wordproof_timestamp", "");
INSERT INTO `wp_postmeta` VALUES("454", "21", "_yoast_wpseo_wordproof_timestamp", "");
INSERT INTO `wp_postmeta` VALUES("455", "50", "_yoast_wpseo_wordproof_timestamp", "");
INSERT INTO `wp_postmeta` VALUES("456", "19", "_yoast_wpseo_wordproof_timestamp", "");
INSERT INTO `wp_postmeta` VALUES("457", "228", "_wp_attached_file", "2023/01/Physioforme-scaled-e1674101573361.jpg");
INSERT INTO `wp_postmeta` VALUES("458", "228", "_wp_attachment_metadata", "a:7:{s:5:\"width\";i:567;s:6:\"height\";i:425;s:4:\"file\";s:45:\"2023/01/Physioforme-scaled-e1674101573361.jpg\";s:8:\"filesize\";i:585320;s:5:\"sizes\";a:7:{s:6:\"medium\";a:5:{s:4:\"file\";s:45:\"Physioforme-scaled-e1674101573361-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:74579;}s:5:\"large\";a:5:{s:4:\"file\";s:24:\"Physioforme-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:147355;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:45:\"Physioforme-scaled-e1674101573361-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:69526;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:23:\"Physioforme-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:112963;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:25:\"Physioforme-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:245262;}s:9:\"2048x2048\";a:5:{s:4:\"file\";s:25:\"Physioforme-2048x1536.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:389792;}s:12:\"widget-thumb\";a:5:{s:4:\"file\";s:43:\"Physioforme-scaled-e1674101573361-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:66906;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"1.8\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"SM-S901B\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1670505484\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:3:\"5.4\";s:3:\"iso\";s:2:\"50\";s:13:\"shutter_speed\";s:18:\"0.0055555555555556\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:15:\"Physioforme.jpg\";}");
INSERT INTO `wp_postmeta` VALUES("459", "228", "_edit_lock", "1674101364:1");
INSERT INTO `wp_postmeta` VALUES("460", "228", "_wp_attachment_image_alt", "Physioforme vue globale");
INSERT INTO `wp_postmeta` VALUES("461", "228", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("462", "228", "_wp_attachment_backup_sizes", "a:8:{s:9:\"full-orig\";a:3:{s:5:\"width\";i:2560;s:6:\"height\";i:1920;s:4:\"file\";s:22:\"Physioforme-scaled.jpg\";}s:14:\"thumbnail-orig\";a:5:{s:4:\"file\";s:23:\"Physioforme-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:69644;}s:11:\"medium-orig\";a:5:{s:4:\"file\";s:23:\"Physioforme-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:74897;}s:17:\"medium_large-orig\";a:5:{s:4:\"file\";s:23:\"Physioforme-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:112963;}s:10:\"large-orig\";a:5:{s:4:\"file\";s:24:\"Physioforme-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:147355;}s:14:\"1536x1536-orig\";a:5:{s:4:\"file\";s:25:\"Physioforme-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:245262;}s:14:\"2048x2048-orig\";a:5:{s:4:\"file\";s:25:\"Physioforme-2048x1536.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:389792;}s:17:\"widget-thumb-orig\";a:5:{s:4:\"file\";s:21:\"Physioforme-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:66916;}}");
INSERT INTO `wp_postmeta` VALUES("463", "28", "_yoast_wpseo_wordproof_timestamp", "");
INSERT INTO `wp_postmeta` VALUES("464", "231", "_wp_attached_file", "2023/01/orthese-plantaire-scaled-e1674101767598.jpg");
INSERT INTO `wp_postmeta` VALUES("465", "231", "_wp_attachment_metadata", "a:7:{s:5:\"width\";i:560;s:6:\"height\";i:420;s:4:\"file\";s:51:\"2023/01/orthese-plantaire-scaled-e1674101767598.jpg\";s:8:\"filesize\";i:451923;s:5:\"sizes\";a:7:{s:6:\"medium\";a:5:{s:4:\"file\";s:51:\"orthese-plantaire-scaled-e1674101767598-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:46590;}s:5:\"large\";a:5:{s:4:\"file\";s:30:\"orthese-plantaire-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:106065;}s:9:\"thumbnail\";a:5:{s:4:\"file\";s:51:\"orthese-plantaire-scaled-e1674101767598-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:42903;}s:12:\"medium_large\";a:5:{s:4:\"file\";s:29:\"orthese-plantaire-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:76078;}s:9:\"1536x1536\";a:5:{s:4:\"file\";s:31:\"orthese-plantaire-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:193853;}s:9:\"2048x2048\";a:5:{s:4:\"file\";s:31:\"orthese-plantaire-2048x1536.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:310783;}s:12:\"widget-thumb\";a:5:{s:4:\"file\";s:49:\"orthese-plantaire-scaled-e1674101767598-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:41209;}}s:10:\"image_meta\";a:12:{s:8:\"aperture\";s:3:\"2.4\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:8:\"SM-G970F\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:10:\"1587129596\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:4:\"4.32\";s:3:\"iso\";s:3:\"200\";s:13:\"shutter_speed\";s:4:\"0.02\";s:5:\"title\";s:0:\"\";s:11:\"orientation\";s:1:\"1\";s:8:\"keywords\";a:0:{}}s:14:\"original_image\";s:21:\"orthese-plantaire.jpg\";}");
INSERT INTO `wp_postmeta` VALUES("466", "231", "_edit_lock", "1674101631:1");
INSERT INTO `wp_postmeta` VALUES("467", "231", "_wp_attachment_image_alt", "orthèse plantaire");
INSERT INTO `wp_postmeta` VALUES("468", "231", "_edit_last", "1");
INSERT INTO `wp_postmeta` VALUES("469", "231", "_wp_attachment_backup_sizes", "a:8:{s:9:\"full-orig\";a:3:{s:5:\"width\";i:2560;s:6:\"height\";i:1920;s:4:\"file\";s:28:\"orthese-plantaire-scaled.jpg\";}s:14:\"thumbnail-orig\";a:5:{s:4:\"file\";s:29:\"orthese-plantaire-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:42950;}s:11:\"medium-orig\";a:5:{s:4:\"file\";s:29:\"orthese-plantaire-300x225.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:225;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:46780;}s:17:\"medium_large-orig\";a:5:{s:4:\"file\";s:29:\"orthese-plantaire-768x576.jpg\";s:5:\"width\";i:768;s:6:\"height\";i:576;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:76078;}s:10:\"large-orig\";a:5:{s:4:\"file\";s:30:\"orthese-plantaire-1024x768.jpg\";s:5:\"width\";i:1024;s:6:\"height\";i:768;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:106065;}s:14:\"1536x1536-orig\";a:5:{s:4:\"file\";s:31:\"orthese-plantaire-1536x1152.jpg\";s:5:\"width\";i:1536;s:6:\"height\";i:1152;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:193853;}s:14:\"2048x2048-orig\";a:5:{s:4:\"file\";s:31:\"orthese-plantaire-2048x1536.jpg\";s:5:\"width\";i:2048;s:6:\"height\";i:1536;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:310783;}s:17:\"widget-thumb-orig\";a:5:{s:4:\"file\";s:27:\"orthese-plantaire-80x50.jpg\";s:5:\"width\";i:80;s:6:\"height\";i:50;s:9:\"mime-type\";s:10:\"image/jpeg\";s:8:\"filesize\";i:41226;}}");

/* INSERT TABLE DATA: wp_posts */
INSERT INTO `wp_posts` VALUES("3", "1", "2021-08-31 08:03:25", "2021-08-31 06:03:25", "<!-- wp:heading -->\n<h2>Qui sommes-nous&nbsp;?</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>L’adresse de notre site est&nbsp;: https://www.orthopedie-podologie-anthoard-grenoble.com.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Commentaires</h2>\n<!-- /wp:heading -->\n\n<!-- wp:html -->\n<h2>Définitions</h2>\n                <p><b>Client :</b> tout professionnel ou personne physique capable au sens des articles 1123 et suivants du Code civil, ou personne morale, qui visite le Site objet des présentes conditions générales.<br>\n                <b>Prestations et Services :</b> <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> met à disposition des Clients :</p>\n\n                <p><b>Contenu :</b> Ensemble des éléments constituants l’information présente sur le Site, notamment textes – images – vidéos.</p>\n\n                <p><b>Informations clients :</b> Ci après dénommé « Information (s) » qui correspondent à l’ensemble des données personnelles susceptibles d’être détenues par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> pour la gestion de votre compte, de la gestion de la relation client et à des fins d’analyses et de statistiques.</p>\n\n\n                <p><b>Utilisateur :</b> Internaute se connectant, utilisant le site susnommé.</p>\n                <p><b>Informations personnelles :</b> « Les informations qui permettent, sous quelque forme que ce soit, directement ou non, l\'identification des personnes physiques auxquelles elles s\'appliquent » (article 4 de la loi n° 78-17 du 6 janvier 1978).</p>\n                <p>Les termes « données à caractère personnel », « personne concernée », « sous traitant » et « données sensibles » ont le sens défini par le Règlement Général sur la Protection des Données (RGPD : n° 2016-679)</p>\n\n                <h2>1. Présentation du site internet.</h2>\n                <p>En vertu de l\'article 6 de la loi n° 2004-575 du 21 juin 2004 pour la confiance dans l\'économie numérique, il est précisé aux utilisateurs du site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> l\'identité des différents intervenants dans le cadre de sa réalisation et de son suivi:\n                </p><p><strong>Propriétaire</strong> :   Cabinet d\'orthopédie et de Podologie l\'ANTHOARD   – 6 rue anthoard 38000 GRENOBLE<br>\n                              \n                <strong>Responsable publication</strong> : Aubertin Roger – auberoger.2@orange.fr<br>\n                Le responsable publication est une personne physique ou une personne morale.<br>\n                <strong>Webmaster</strong> : Cabaré Michel – michel@cabare.net<br>\n                <strong>Hébergeur</strong> : ovh – 2 rue Kellermann 59100 Roubaix 1007<br>\n                <strong>Délégué à la protection des données</strong> : Aubertin Roger – auberoger.2@orange.fr<br>\n                </p>\n\n                <div ng-bind-html=\"linkHTML\"><p>Ce modèle de mentions légales est proposé par le <a href=\"https://fr.orson.io/1371/generateur-mentions-legales\" title=\"générateur gratuit de mentions légales pour un site internet\">générateur gratuit de mentions légales pour un site internet</a></p></div>\n\n\n\n                <h2>2. Conditions générales d’utilisation du site et des services proposés.</h2>\n\n                <p>Le Site constitue une œuvre de l’esprit protégée par les dispositions du Code de la Propriété Intellectuelle et des Réglementations Internationales applicables. \n                Le Client ne peut en aucune manière réutiliser, céder ou exploiter pour son propre compte tout ou partie des éléments ou travaux du Site.</p>\n\n                <p>L’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> implique l’acceptation pleine et entière des conditions générales d’utilisation ci-après décrites. Ces conditions d’utilisation sont susceptibles d’être modifiées ou complétées à tout moment, les utilisateurs du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont donc invités à les consulter de manière régulière.</p>\n\n                <p>Ce site internet est normalement accessible à tout moment aux utilisateurs. Une interruption pour raison de maintenance technique peut être toutefois décidée par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, qui s’efforcera alors de communiquer préalablement aux utilisateurs les dates et heures de l’intervention.\n                Le site web <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est mis à jour régulièrement par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> responsable. De la même façon, les mentions légales peuvent être modifiées à tout moment : elles s’imposent néanmoins à l’utilisateur qui est invité à s’y référer le plus souvent possible afin d’en prendre connaissance.</p>\n\n                <h2>3. Description des services fournis.</h2>\n\n                <p>Le site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> a pour objet de fournir une information concernant l’ensemble des activités de la société.\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’efforce de fournir sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> des informations aussi précises que possible. Toutefois, il ne pourra être tenu responsable des oublis, des inexactitudes et des carences dans la mise à jour, qu’elles soient de son fait ou du fait des tiers partenaires qui lui fournissent ces informations.</p>\n\n                <p>Toutes les informations indiquées sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont données à titre indicatif, et sont susceptibles d’évoluer. Par ailleurs, les renseignements figurant sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne sont pas exhaustifs. Ils sont donnés sous réserve de modifications ayant été apportées depuis leur mise en ligne.</p>\n\n                <h2>4. Limitations contractuelles sur les données techniques.</h2>\n\n                <p>Le site utilise la technologie JavaScript.\n\n                Le site Internet ne pourra être tenu responsable de dommages matériels liés à l’utilisation du site. De plus, l’utilisateur du site s’engage à accéder au site en utilisant un matériel récent, ne contenant pas de virus et avec un navigateur de dernière génération mis-à-jour\n                Le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est hébergé chez un prestataire sur le territoire de l’Union Européenne conformément aux dispositions du Règlement Général sur la Protection des Données (RGPD : n° 2016-679)</p>\n\n                <p>L’objectif est d’apporter une prestation qui assure le meilleur taux d’accessibilité. L’hébergeur assure la continuité de son service 24 Heures sur 24, tous les jours de l’année. Il se réserve néanmoins la possibilité d’interrompre le service d’hébergement pour les durées les plus courtes possibles notamment à des fins de maintenance, d’amélioration de ses infrastructures, de défaillance de ses infrastructures ou si les Prestations et Services génèrent un trafic réputé anormal.</p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et l’hébergeur ne pourront être tenus responsables en cas de dysfonctionnement du réseau Internet, des lignes téléphoniques ou du matériel informatique et de téléphonie lié notamment à l’encombrement du réseau empêchant l’accès au serveur.</p>\n\n                <h2>5. Propriété intellectuelle et contrefaçons.</h2>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est propriétaire des droits de propriété intellectuelle et détient les droits d’usage sur tous les éléments accessibles sur le site internet, notamment les textes, images, graphismes, logos, vidéos, icônes et sons.\n                Toute reproduction, représentation, modification, publication, adaptation de tout ou partie des éléments du site, quel que soit le moyen ou le procédé utilisé, est interdite, sauf autorisation écrite préalable de : <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.</p>\n\n                <p>Toute exploitation non autorisée du site ou de l’un quelconque des éléments qu’il contient sera considérée comme constitutive d’une contrefaçon et poursuivie conformément aux dispositions des articles L.335-2 et suivants du Code de Propriété Intellectuelle.</p>\n\n                <h2>6. Limitations de responsabilité.</h2>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> agit en tant qu’éditeur du site. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>  est responsable de la qualité et de la véracité du Contenu qu’il publie. </p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne pourra être tenu responsable des dommages directs et indirects causés au matériel de l’utilisateur, lors de l’accès au site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, et résultant soit de l’utilisation d’un matériel ne répondant pas aux spécifications indiquées au point 4, soit de l’apparition d’un bug ou d’une incompatibilité.</p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne pourra également être tenu responsable des dommages indirects (tels par exemple qu’une perte de marché ou perte d’une chance) consécutifs à l’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.\n                Des espaces interactifs (possibilité de poser des questions dans l’espace contact) sont à la disposition des utilisateurs. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> se réserve le droit de supprimer, sans mise en demeure préalable, tout contenu déposé dans cet espace qui contreviendrait à la législation applicable en France, en particulier aux dispositions relatives à la protection des données. Le cas échéant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> se réserve également la possibilité de mettre en cause la responsabilité civile et/ou pénale de l’utilisateur, notamment en cas de message à caractère raciste, injurieux, diffamant, ou pornographique, quel que soit le support utilisé (texte, photographie …).</p>\n\n                <h2>7. Gestion des données personnelles.</h2>\n\n                <p>Le Client est informé des réglementations concernant la communication marketing, la loi du 21 Juin 2014 pour la confiance dans l’Economie Numérique, la Loi Informatique et Liberté du 06 Août 2004 ainsi que du Règlement Général sur la Protection des Données (RGPD : n° 2016-679). </p>\n\n                <h3>7.1 Responsables de la collecte des données personnelles</h3>\n\n                <p>Pour les Données Personnelles collectées dans le cadre de la création du compte personnel de l’Utilisateur et de sa navigation sur le Site, le responsable du traitement des Données Personnelles est : Cabinet d\'orthopédie et de Podologie l\'ANTHOARD. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>est représenté par Aubertin Roger, son représentant légal</p>\n\n                <p>En tant que responsable du traitement des données qu’il collecte, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à respecter le cadre des dispositions légales en vigueur. Il lui appartient notamment au Client d’établir les finalités de ses traitements de données, de fournir à ses prospects et clients, à partir de la collecte de leurs consentements, une information complète sur le traitement de leurs données personnelles et de maintenir un registre des traitements conforme à la réalité.\n                Chaque fois que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> traite des Données Personnelles, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> prend toutes les mesures raisonnables pour s’assurer de l’exactitude et de la pertinence des Données Personnelles au regard des finalités pour lesquelles <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> les traite.</p>\n                 \n                <h3>7.2 Finalité des données collectées</h3>\n                 \n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est susceptible de traiter tout ou partie des données : </p>\n\n                <ul>\n                  \n                <li>pour permettre la navigation sur le Site et la gestion et la traçabilité des prestations et services commandés par l’utilisateur : données de connexion et d’utilisation du Site, facturation, historique des commandes, etc. </li>\n                 \n                <li>pour prévenir et lutter contre la fraude informatique (spamming, hacking…) : matériel informatique utilisé pour la navigation, l’adresse IP, le mot de passe (hashé) </li>\n                 \n                <li>pour améliorer la navigation sur le Site : données de connexion et d’utilisation </li>\n                 \n                <li>pour mener des enquêtes de satisfaction facultatives sur <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> : adresse email </li>\n                <li>pour mener des campagnes de communication (sms, mail) : numéro de téléphone, adresse email</li>\n\n\n                </ul>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne commercialise pas vos données personnelles qui sont donc uniquement utilisées par nécessité ou à des fins statistiques et d’analyses.</p>\n                 \n                <h3>7.3 Droit d’accès, de rectification et d’opposition</h3>\n                 \n                <p>\n                Conformément à la réglementation européenne en vigueur, les Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> disposent des droits suivants : </p>\n                 <ul>\n\n                <li>droit d\'accès (article 15 RGPD) et de rectification (article 16 RGPD), de mise à jour, de complétude des données des Utilisateurs droit de verrouillage ou d’effacement des données des Utilisateurs à caractère personnel (article 17 du RGPD), lorsqu’elles sont inexactes, incomplètes, équivoques, périmées, ou dont la collecte, l\'utilisation, la communication ou la conservation est interdite </li>\n                 \n                <li>droit de retirer à tout moment un consentement (article 13-2c RGPD) </li>\n                 \n                <li>droit à la limitation du traitement des données des Utilisateurs (article 18 RGPD) </li>\n                 \n                <li>droit d’opposition au traitement des données des Utilisateurs (article 21 RGPD) </li>\n                 \n                <li>droit à la portabilité des données que les Utilisateurs auront fournies, lorsque ces données font l’objet de traitements automatisés fondés sur leur consentement ou sur un contrat (article 20 RGPD) </li>\n                 \n                <li>droit de définir le sort des données des Utilisateurs après leur mort et de choisir à qui <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> devra communiquer (ou non) ses données à un tiers qu’ils aura préalablement désigné</li>\n                 </ul>\n\n                <p>Dès que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> a connaissance du décès d’un Utilisateur et à défaut d’instructions de sa part, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à détruire ses données, sauf si leur conservation s’avère nécessaire à des fins probatoires ou pour répondre à une obligation légale.</p>\n                 \n                <p>Si l’Utilisateur souhaite savoir comment <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> utilise ses Données Personnelles, demander à les rectifier ou s’oppose à leur traitement, l’Utilisateur peut contacter <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> par écrit à l’adresse suivante : </p>\n                 \n                Cabinet d\'orthopédie et de Podologie l\'ANTHOARD – DPO, Aubertin Roger <br>\n                6 rue anthoard 38000 GRENOBLE.\n                 \n                <p>Dans ce cas, l’Utilisateur doit indiquer les Données Personnelles qu’il souhaiterait que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> corrige, mette à jour ou supprime, en s’identifiant précisément avec une copie d’une pièce d’identité (carte d’identité ou passeport). </p>\n\n                <p>\n                Les demandes de suppression de Données Personnelles seront soumises aux obligations qui sont imposées à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> par la loi, notamment en matière de conservation ou d’archivage des documents. Enfin, les Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> peuvent déposer une réclamation auprès des autorités de contrôle, et notamment de la CNIL (https://www.cnil.fr/fr/plaintes).</p>\n                 \n                <h3>7.4 Non-communication des données personnelles</h3>\n\n                <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’interdit de traiter, héberger ou transférer les Informations collectées sur ses Clients vers un pays situé en dehors de l’Union européenne ou reconnu comme « non adéquat » par la Commission européenne sans en informer préalablement le client. Pour autant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> reste libre du choix de ses sous-traitants techniques et commerciaux à la condition qu’il présentent les garanties suffisantes au regard des exigences du Règlement Général sur la Protection des Données (RGPD : n° 2016-679).</p>\n\n                <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à prendre toutes les précautions nécessaires afin de préserver la sécurité des Informations et notamment qu’elles ne soient pas communiquées à des personnes non autorisées. Cependant, si un incident impactant l’intégrité ou la confidentialité des Informations du Client est portée à la connaissance de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, celle-ci devra dans les meilleurs délais informer le Client et lui communiquer les mesures de corrections prises. Par ailleurs <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne collecte aucune « données sensibles ».</p>\n\n                <p>\n                Les Données Personnelles de l’Utilisateur peuvent être traitées par des filiales de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et des sous-traitants (prestataires de services), exclusivement afin de réaliser les finalités de la présente politique.</p>\n                <p>\n                Dans la limite de leurs attributions respectives et pour les finalités rappelées ci-dessus, les principales personnes susceptibles d’avoir accès aux données des Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont principalement les agents de notre service client.</p>\n                \n                <div ng-bind-html=\"rgpdHTML\"><h3>7.5 Types de données collectées</h3><p>Concernant les utilisateurs d’un Site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, nous collectons les données suivantes qui sont indispensables au fonctionnement du service&nbsp;, et qui seront conservées pendant une période maximale de 0 mois après la fin de la relation contractuelle:<br>Aucunes</p><p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> collecte en outre des informations qui permettent d’améliorer l’expérience utilisateur et de proposer des conseils contextualisés&nbsp;:<br>Aucunes</p><p> Ces &nbsp;données sont conservées pour une période maximale de 0 mois après la fin de la relation contractuelle</p></div>\n\n\n                <h2>8. Notification d’incident</h2>\n                <p>\n                Quels que soient les efforts fournis, aucune méthode de transmission sur Internet et aucune méthode de stockage électronique n\'est complètement sûre. Nous ne pouvons en conséquence pas garantir une sécurité absolue. \n                Si nous prenions connaissance d\'une brèche de la sécurité, nous avertirions les utilisateurs concernés afin qu\'ils puissent prendre les mesures appropriées. Nos procédures de notification d’incident tiennent compte de nos obligations légales, qu\'elles se situent au niveau national ou européen. Nous nous engageons à informer pleinement nos clients de toutes les questions relevant de la sécurité de leur compte et à leur fournir toutes les informations nécessaires pour les aider à respecter leurs propres obligations réglementaires en matière de reporting.</p>\n                <p>\n                Aucune information personnelle de l\'utilisateur du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> n\'est publiée à l\'insu de l\'utilisateur, échangée, transférée, cédée ou vendue sur un support quelconque à des tiers. Seule l\'hypothèse du rachat de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et de ses droits permettrait la transmission des dites informations à l\'éventuel acquéreur qui serait à son tour tenu de la même obligation de conservation et de modification des données vis à vis de l\'utilisateur du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.</p>\n\n                <h3>Sécurité</h3>\n\n                <p>\n                Pour assurer la sécurité et la confidentialité des Données Personnelles et des Données Personnelles de Santé, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> utilise des réseaux protégés par des dispositifs standards tels que par pare-feu, la pseudonymisation, l’encryption et mot de passe. </p>\n                 \n                <p>\n                Lors du traitement des Données Personnelles, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>prend toutes les mesures raisonnables visant à les protéger contre toute perte, utilisation détournée, accès non autorisé, divulgation, altération ou destruction.</p>\n                 \n                <h2>9. Liens hypertextes « cookies » et balises (“tags”) internet</h2>\n                <p>\n                Le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> contient un certain nombre de liens hypertextes vers d’autres sites, mis en place avec l’autorisation de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>. Cependant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> n’a pas la possibilité de vérifier le contenu des sites ainsi visités, et n’assumera en conséquence aucune responsabilité de ce fait.</p>\n                Sauf si vous décidez de désactiver les cookies, vous acceptez que le site puisse les utiliser. Vous pouvez à tout moment désactiver ces cookies et ce gratuitement à partir des possibilités de désactivation qui vous sont offertes et rappelées ci-après, sachant que cela peut réduire ou empêcher l’accessibilité à tout ou partie des Services proposés par le site.\n                <p></p>\n\n                <h3>9.1. « COOKIES »</h3>\n                 <p>\n                Un « cookie » est un petit fichier d’information envoyé sur le navigateur de l’Utilisateur et enregistré au sein du terminal de l’Utilisateur (ex : ordinateur, smartphone), (ci-après « Cookies »). Ce fichier comprend des informations telles que le nom de domaine de l’Utilisateur, le fournisseur d’accès Internet de l’Utilisateur, le système d’exploitation de l’Utilisateur, ainsi que la date et l’heure d’accès. Les Cookies ne risquent en aucun cas d’endommager le terminal de l’Utilisateur.</p>\n                 <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est susceptible de traiter les informations de l’Utilisateur concernant sa visite du Site, telles que les pages consultées, les recherches effectuées. Ces informations permettent à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’améliorer le contenu du Site, de la navigation de l’Utilisateur.</p>\n                 <p>\n                Les Cookies facilitant la navigation et/ou la fourniture des services proposés par le Site, l’Utilisateur peut configurer son navigateur pour qu’il lui permette de décider s’il souhaite ou non les accepter de manière à ce que des Cookies soient enregistrés dans le terminal ou, au contraire, qu’ils soient rejetés, soit systématiquement, soit selon leur émetteur. L’Utilisateur peut également configurer son logiciel de navigation de manière à ce que l’acceptation ou le refus des Cookies lui soient proposés ponctuellement, avant qu’un Cookie soit susceptible d’être enregistré dans son terminal. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> informe l’Utilisateur que, dans ce cas, il se peut que les fonctionnalités de son logiciel de navigation ne soient pas toutes disponibles.</p>\n                 <p>\n                Si l’Utilisateur refuse l’enregistrement de Cookies dans son terminal ou son navigateur, ou si l’Utilisateur supprime ceux qui y sont enregistrés, l’Utilisateur est informé que sa navigation et son expérience sur le Site peuvent être limitées. Cela pourrait également être le cas lorsque <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ou l’un de ses prestataires ne peut pas reconnaître, à des fins de compatibilité technique, le type de navigateur utilisé par le terminal, les paramètres de langue et d’affichage ou le pays depuis lequel le terminal semble connecté à Internet.</p>\n                 <p>\n                Le cas échéant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> décline toute responsabilité pour les conséquences liées au fonctionnement dégradé du Site et des services éventuellement proposés par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, résultant (i) du refus de Cookies par l’Utilisateur (ii) de l’impossibilité pour <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’enregistrer ou de consulter les Cookies nécessaires à leur fonctionnement du fait du choix de l’Utilisateur. Pour la gestion des Cookies et des choix de l’Utilisateur, la configuration de chaque navigateur est différente. Elle est décrite dans le menu d’aide du navigateur, qui permettra de savoir de quelle manière l’Utilisateur peut modifier ses souhaits en matière de Cookies.</p>\n                 <p>\n                À tout moment, l’Utilisateur peut faire le choix d’exprimer et de modifier ses souhaits en matière de Cookies. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> pourra en outre faire appel aux services de prestataires externes pour l’aider à recueillir et traiter les informations décrites dans cette section.</p>\n                 <p>\n                Enfin, en cliquant sur les icônes dédiées aux réseaux sociaux Twitter, Facebook, Linkedin et Google Plus figurant sur le Site de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ou dans son application mobile et si l’Utilisateur a accepté le dépôt de cookies en poursuivant sa navigation sur le Site Internet ou l’application mobile de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, Twitter, Facebook, Linkedin et Google Plus peuvent également déposer des cookies sur vos terminaux (ordinateur, tablette, téléphone portable).</p>\n                 <p>\n                Ces types de cookies ne sont déposés sur vos terminaux qu’à condition que vous y consentiez, en continuant votre navigation sur le Site Internet ou l’application mobile de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>. À tout moment, l’Utilisateur peut néanmoins revenir sur son consentement à ce que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> dépose ce type de cookies.</p>\n                 \n                <h3>Article 9.2. BALISES (“TAGS”) INTERNET</h3>\n                 \n\n                <p>\n\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> peut employer occasionnellement des balises Internet (également appelées « tags », ou balises d’action, GIF à un pixel, GIF transparents, GIF invisibles et GIF un à un) et les déployer par l’intermédiaire d’un partenaire spécialiste d’analyses Web susceptible de se trouver (et donc de stocker les informations correspondantes, y compris l’adresse IP de l’Utilisateur) dans un pays étranger.</p>\n                 \n                <p>\n                Ces balises sont placées à la fois dans les publicités en ligne permettant aux internautes d’accéder au Site, et sur les différentes pages de celui-ci. \n                 </p>\n                <p>\n                Cette technologie permet à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’évaluer les réponses des visiteurs face au Site et l’efficacité de ses actions (par exemple, le nombre de fois où une page est ouverte et les informations consultées), ainsi que l’utilisation de ce Site par l’Utilisateur. </p>\n                 <p>\n                Le prestataire externe pourra éventuellement recueillir des informations sur les visiteurs du Site et d’autres sites Internet grâce à ces balises, constituer des rapports sur l’activité du Site à l’attention de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, et fournir d’autres services relatifs à l’utilisation de celui-ci et d’Internet.</p>\n                 <p>\n                </p><h2>10. Droit applicable et attribution de juridiction.</h2>  \n                 <p>\n                Tout litige en relation avec l’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est soumis au droit français. \n                En dehors des cas où la loi ne le permet pas, il est fait attribution exclusive de juridiction aux tribunaux compétents de Grenoble</p>\n<!-- /wp:html -->", "Mentions Légales - Politique de confidentialité", "", "publish", "closed", "open", "", "cabinet-anthoard-podologie-grenoble-mentions-legales", "", "", "2021-10-28 07:59:13", "2021-10-28 05:59:13", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=3", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("8", "1", "2021-09-01 09:17:56", "2021-09-01 07:17:56", "<!-- wp:html -->\n<p align=\"center\">6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"cabinet orthopédie podologie grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->\n\n<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Bienvenue au cabinet d\'orthopédie et de podologie à Grenoble</p>\n<!-- /wp:paragraph -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "publish", "closed", "closed", "", "cabinet-orthopedie-podologie-posturologie-a-grenoble", "", "", "2021-10-27 17:27:17", "2021-10-27 15:27:17", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=8", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("9", "1", "2021-09-01 09:17:56", "2021-09-01 07:17:56", "", "Cabinet d\'orthopedie podologie l\'Anthoard Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-09-01 09:17:56", "2021-09-01 07:17:56", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=9", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("10", "1", "2021-09-01 09:18:13", "2021-09-01 07:18:13", "", "Cabinet d\'orthopédie podologie l\'Anthoard Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-09-01 09:18:13", "2021-09-01 07:18:13", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=10", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("13", "1", "2021-09-01 09:32:43", "2021-09-01 07:32:43", "", "Image-accueil", "", "inherit", "open", "closed", "", "image-accueil", "", "", "2021-09-01 09:32:43", "2021-09-01 07:32:43", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("14", "1", "2021-09-01 09:32:50", "2021-09-01 07:32:50", "<!-- wp:image {\"id\":13,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil-1024x779.png\" alt=\"\" class=\"wp-image-13\"/></figure>\n<!-- /wp:image -->", "Cabinet d\'orthopédie podologie l\'Anthoard Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-09-01 09:32:50", "2021-09-01 07:32:50", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=14", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("15", "1", "2021-09-01 09:44:53", "2021-09-01 07:44:53", "<!-- wp:image {\"id\":13,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil-1024x779.png\" alt=\"\" class=\"wp-image-13\"/></figure>\n<!-- /wp:image -->", "Cabinet d\'orthopédie podologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-09-01 09:44:53", "2021-09-01 07:44:53", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=15", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("16", "1", "2021-09-01 09:56:54", "2021-09-01 07:56:54", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le Cabinet / Secretariat en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\" data-border-color=\"#000\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\" data-border-color=\"#000\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "publish", "closed", "closed", "", "podologie-orthopedie-grenoble-anthoard-horaires", "", "", "2021-10-28 07:56:10", "2021-10-28 05:56:10", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=16", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("17", "1", "2021-09-01 09:56:54", "2021-09-01 07:56:54", "", "Horaires", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-09-01 09:56:54", "2021-09-01 07:56:54", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=17", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("18", "1", "2021-09-01 09:57:31", "2021-09-01 07:57:31", "", "Horaires cabinet podologie orthopédie", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-09-01 09:57:31", "2021-09-01 07:57:31", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=18", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("19", "1", "2021-09-01 09:58:55", "2021-09-01 07:58:55", "<!-- wp:paragraph -->\n<p>Crée&nbsp; en aout 1995&nbsp; par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE&nbsp; en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble&nbsp; depuis&nbsp; janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Agrée par la CRAM Rhône-Alpes et la CPAM  de Grenoble.</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Le&nbsp; cabinet vous accueille&nbsp; dans&nbsp; la quiétude et le respect&nbsp; des règles&nbsp; médicales.</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Un parking&nbsp; privé&nbsp; est à votre service (rue Gelin : places numérotées 20 - 21).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Accès&nbsp; par interphone.</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Le cabinet est aux normes (accessibilité).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "publish", "closed", "closed", "", "histoire-du-cabinet-orthopedie-et-podologie-anthoard-grenoble", "", "", "2022-12-09 13:54:40", "2022-12-09 12:54:40", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=19", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("20", "1", "2021-09-01 09:58:55", "2021-09-01 07:58:55", "", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2021-09-01 09:58:55", "2021-09-01 07:58:55", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=20", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("21", "1", "2021-09-01 10:00:21", "2021-09-01 08:00:21", "<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>La principale activité  est la  réalisation d’orthèse plantaire  sur mesure (semelle orthopédique) remboursée par la CPAM et les mutuelles santé . </li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proproceptive dynamique étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux (œil –oreille – atm) , étude complétée par un bilan radiologique ciblé sur la pathologie. </li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformer en contre pesanteur).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":211,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png\" alt=\"orthopedie podologie grenoble\" class=\"wp-image-211\" width=\"532\" height=\"35\" title=\"orthopedie podologie grenoble\"/></a></figure>\n<!-- /wp:image -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "publish", "closed", "closed", "", "orthopedie-podologie-grenoble", "", "", "2022-12-09 13:51:55", "2022-12-09 12:51:55", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=21", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("22", "1", "2021-09-01 10:00:21", "2021-09-01 08:00:21", "", "Prestations du Cabinet d\'Orthopédie et de podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2021-09-01 10:00:21", "2021-09-01 08:00:21", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=22", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("23", "1", "2021-09-01 10:00:44", "2021-09-01 08:00:44", "", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2021-09-01 10:00:44", "2021-09-01 08:00:44", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=23", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("24", "1", "2021-09-01 10:01:54", "2021-09-01 08:01:54", "<!-- wp:heading -->\n<h2>Prestation remboursée par la CPAM</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Avec ordonnance médicale, comprenant la consultation, la fabrication, l\'essayage et le suivit du traitement :</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>170,00 Euros pour les adultes</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>150,00 euros pour les enfants</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>CMU et AT par convention de la CPAM</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading -->\n<h2>Prestation remboursée par les mutuelles santé (mais non pas la CPAM)</h2>\n<!-- /wp:heading -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>50,00 Euros la Consultation avec Bilan Podologique</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>50,00 Euros la Consultation en traumatologie</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->", "Tarifs en Orthopédie et Podologie", "", "publish", "closed", "closed", "", "tarifs-en-orthopedie-et-podologie", "", "", "2022-12-09 13:48:30", "2022-12-09 12:48:30", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=24", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("25", "1", "2021-09-01 10:01:54", "2021-09-01 08:01:54", "", "Tarifs en Orthopédie et Podologie", "", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2021-09-01 10:01:54", "2021-09-01 08:01:54", "", "24", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=25", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("26", "1", "2021-09-01 10:02:41", "2021-09-01 08:02:41", "<!-- wp:heading -->\n<h2>Nouveaux patients :</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading -->\n<h2>Anciens patients</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant <strong>AUBERTIN - roger GRENOBLE</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":115,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><a href=\"https://docrendezvous.fr/\" target=\"_blank\" rel=\"noopener\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\" alt=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\" class=\"wp-image-115\" title=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\"/></a></figure>\n<!-- /wp:image -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "publish", "closed", "closed", "", "rendez-vous-au-cabinet-de-orthopedie-et-podologie-a-grenoble", "", "", "2021-10-26 13:33:45", "2021-10-26 11:33:45", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=26", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("27", "1", "2021-09-01 10:02:41", "2021-09-01 08:02:41", "", "Rendez Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-09-01 10:02:41", "2021-09-01 08:02:41", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=27", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("28", "1", "2021-09-01 10:04:12", "2021-09-01 08:04:12", "<!-- wp:gallery {\"linkTo\":\"none\",\"advgbBlockControls\":[]} -->\n<figure class=\"wp-block-gallery has-nested-images columns-default is-cropped\"><!-- wp:image {\"id\":151,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\" alt=\"6 Rue ANTHOARD 38000 Grenoble\" class=\"wp-image-151\"/><figcaption class=\"wp-element-caption\">Arrivée 6 Rue ANTHOARD</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":153,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\" alt=\"Entrée 6 rue ANTHOARD 38000 Grenoble\" class=\"wp-image-153\"/><figcaption class=\"wp-element-caption\">Entrée 6 rue ANTHOARD 38000 Grenoble</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":154,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\" alt=\"Salle d\'attente cabinet\" class=\"wp-image-154\"/><figcaption class=\"wp-element-caption\">Salle d\'attente</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":150,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\" alt=\"Couloir accès cabinet\" class=\"wp-image-150\"/><figcaption class=\"wp-element-caption\">Couloir accès cabinet</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":155,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\" alt=\"Cabinet Podologie\" class=\"wp-image-155\"/><figcaption class=\"wp-element-caption\">Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":156,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\" alt=\"Cabinet Orthopedie\" class=\"wp-image-156\"/><figcaption class=\"wp-element-caption\">Cabinet Orthopedie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":152,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\" alt=\"Machine Physioforme\" class=\"wp-image-152\"/><figcaption class=\"wp-element-caption\">Machine Physioforme</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":149,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\" alt=\"Atelier Cabinet Podologie\" class=\"wp-image-149\"/><figcaption class=\"wp-element-caption\">Atelier Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":231,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-1024x768.jpg\" alt=\"orthèse plantaire\" class=\"wp-image-231\"/><figcaption class=\"wp-element-caption\">orthèse plantaire</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":228,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-1024x768.jpg\" alt=\"Physioforme vue globale\" class=\"wp-image-228\"/><figcaption class=\"wp-element-caption\">Physioforme vue globale</figcaption></figure>\n<!-- /wp:image --><figcaption class=\"blocks-gallery-caption wp-element-caption\">Le Cabinet de Podologie l\'Anthoard à Grenoble en Images !</figcaption></figure>\n<!-- /wp:gallery -->", "Cabinet Orthopédie Podologie l\'ANTHOARD en images", "", "publish", "closed", "closed", "", "cabinet-orthopedie-podologie-grenoble-anthoard-en-images", "", "", "2023-01-19 05:18:20", "2023-01-19 04:18:20", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=28", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("29", "1", "2021-09-01 10:04:12", "2021-09-01 08:04:12", "", "Cabinet Orthopédie Podologie l\'ANTHOARD en images", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2021-09-01 10:04:12", "2021-09-01 08:04:12", "", "28", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=29", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("30", "1", "2021-09-01 10:04:56", "2021-09-01 08:04:56", "<!-- wp:heading -->\n<h2>Qui sommes-nous&nbsp;?</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>L’adresse de notre site est&nbsp;: https://www.orthopedie-podologie-anthoard-grenoble.com.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Commentaires</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Quand vous laissez un commentaire sur notre site, les données inscrites dans le formulaire de commentaire, mais aussi votre adresse IP et l’agent utilisateur de votre navigateur sont collectés pour nous aider à la détection des commentaires indésirables.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>Une chaîne anonymisée créée à partir de votre adresse e-mail (également appelée hash) peut être envoyée au service Gravatar pour vérifier si vous utilisez ce dernier. Les clauses de confidentialité du service Gravatar sont disponibles ici&nbsp;: https://automattic.com/privacy/. Après validation de votre commentaire, votre photo de profil sera visible publiquement à coté de votre commentaire.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Médias</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Si vous téléversez des images sur le site, nous vous conseillons d’éviter de téléverser des images contenant des données EXIF de coordonnées GPS. Les personnes visitant votre site peuvent télécharger et extraire des données de localisation depuis ces images.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Cookies</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Si vous déposez un commentaire sur notre site, il vous sera proposé d’enregistrer votre nom, adresse e-mail et site dans des cookies. C’est uniquement pour votre confort afin de ne pas avoir à saisir ces informations si vous déposez un autre commentaire plus tard. Ces cookies expirent au bout d’un an.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>Si vous vous rendez sur la page de connexion, un cookie temporaire sera créé afin de déterminer si votre navigateur accepte les cookies. Il ne contient pas de données personnelles et sera supprimé automatiquement à la fermeture de votre navigateur.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>Lorsque vous vous connecterez, nous mettrons en place un certain nombre de cookies pour enregistrer vos informations de connexion et vos préférences d’écran. La durée de vie d’un cookie de connexion est de deux jours, celle d’un cookie d’option d’écran est d’un an. Si vous cochez «&nbsp;Se souvenir de moi&nbsp;», votre cookie de connexion sera conservé pendant deux semaines. Si vous vous déconnectez de votre compte, le cookie de connexion sera effacé.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>En modifiant ou en publiant une publication, un cookie supplémentaire sera enregistré dans votre navigateur. Ce cookie ne comprend aucune donnée personnelle. Il indique simplement l’ID de la publication que vous venez de modifier. Il expire au bout d’un jour.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Contenu embarqué depuis d’autres sites</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Les articles de ce site peuvent inclure des contenus intégrés (par exemple des vidéos, images, articles…). Le contenu intégré depuis d’autres sites se comporte de la même manière que si le visiteur se rendait sur cet autre site.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>Ces sites web pourraient collecter des données sur vous, utiliser des cookies, embarquer des outils de suivis tiers, suivre vos interactions avec ces contenus embarqués si vous disposez d’un compte connecté sur leur site web.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Utilisation et transmission de vos données personnelles</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Si vous demandez une réinitialisation de votre mot de passe, votre adresse IP sera incluse dans l’e-mail de réinitialisation.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Durées de stockage de vos données</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Si vous laissez un commentaire, le commentaire et ses métadonnées sont conservés indéfiniment. Cela permet de reconnaître et approuver automatiquement les commentaires suivants au lieu de les laisser dans la file de modération.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p>Pour les comptes qui s’inscrivent sur notre site (le cas échéant), nous stockons également les données personnelles indiquées dans leur profil. Tous les comptes peuvent voir, modifier ou supprimer leurs informations personnelles à tout moment (à l’exception de leur identifiant). Les gestionnaires du site peuvent aussi voir et modifier ces informations.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Les droits que vous avez sur vos données</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Si vous avez un compte ou si vous avez laissé des commentaires sur le site, vous pouvez demander à recevoir un fichier contenant toutes les données personnelles que nous possédons à votre sujet, incluant celles que vous nous avez fournies. Vous pouvez également demander la suppression des données personnelles vous concernant. Cela ne prend pas en compte les données stockées à des fins administratives, légales ou pour des raisons de sécurité.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Transmission de vos données personnelles</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p><strong class=\"privacy-policy-tutorial\">Texte suggéré&nbsp;: </strong>Les commentaires des visiteurs peuvent être vérifiés à l’aide d’un service automatisé de détection des commentaires indésirables.</p>\n<!-- /wp:paragraph -->", "Mentions Légales - Politique de confidentialité", "", "inherit", "closed", "closed", "", "3-revision-v1", "", "", "2021-09-01 10:04:56", "2021-09-01 08:04:56", "", "3", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=30", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("31", "1", "2021-10-27 10:41:22", "2021-09-01 08:36:21", "", "Rendez Vous", "", "publish", "closed", "closed", "", "31", "", "", "2021-10-27 10:41:22", "2021-10-27 08:41:22", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=31", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("32", "1", "2021-10-27 10:41:22", "2021-09-01 08:36:21", "", "Nos Tarifs", "", "publish", "closed", "closed", "", "32", "", "", "2021-10-27 10:41:22", "2021-10-27 08:41:22", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=32", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("33", "1", "2021-10-27 10:41:22", "2021-09-01 08:36:21", "", "Nos Prestations", "", "publish", "closed", "closed", "", "prestations-du-cabinet-dorthopedie-et-de-podologie", "", "", "2021-10-27 10:41:22", "2021-10-27 08:41:22", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=33", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("34", "1", "2021-10-27 10:41:22", "2021-09-01 08:36:21", "", "Horaires du cabinet", "", "publish", "closed", "closed", "", "34", "", "", "2021-10-27 10:41:22", "2021-10-27 08:41:22", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=34", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("36", "1", "2021-10-27 10:44:08", "2021-09-01 08:38:05", "", "Histoire du Cabinet d’orthopedie et de Podologie l’Anthoard", "", "publish", "closed", "closed", "", "histoire-du-cabinet-dorthopedie-et-de-podologie-lanthoard", "", "", "2021-10-27 10:44:08", "2021-10-27 08:44:08", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=36", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("37", "1", "2021-10-27 10:44:08", "2021-09-01 08:38:05", "", "Visite du Cabinet Orthopédie Podologie l’ANTHOARD en images", "", "publish", "closed", "closed", "", "cabinet-orthopedie-podologie-lanthoard-en-images", "", "", "2021-10-27 10:44:08", "2021-10-27 08:44:08", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=37", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("48", "1", "2021-10-25 10:24:03", "2021-10-25 08:24:03", "<!-- wp:list -->\n<ul><li>douleurs plantaires (ménopause , marche intense)</li><li>épine calcanéenne</li><li>aponévrose plantaire</li><li>hallux valgus / hallux rigidus (pré-post opératoire)</li><li>névrome  de Morton</li><li>inflammation du tendon d\'Achille</li><li>ténosynovite tibiale et fibulaire</li><li>maladie de Sever</li><li>séquelle traumatique après accident</li><li>traumatologie  pied / cheville</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":214,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png\" alt=\"orthopedie grenoble\" class=\"wp-image-214\" width=\"532\" height=\"35\" title=\"orthopedie grenoble\"/></a></figure>\n<!-- /wp:image -->", "Pathologies du Pied", "", "publish", "closed", "closed", "", "orthopedie-grenoble", "", "", "2021-10-28 08:14:31", "2021-10-28 06:14:31", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=48", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("49", "1", "2021-10-25 10:24:03", "2021-10-25 08:24:03", "", "Pathologies du Pied", "", "inherit", "closed", "closed", "", "48-revision-v1", "", "", "2021-10-25 10:24:03", "2021-10-25 08:24:03", "", "48", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=49", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("50", "1", "2021-10-25 10:24:40", "2021-10-25 08:24:40", "<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>maladie de croissance de l’ adolescence</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>maladie de croissance \"Osggod-Schlatter\"</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>douleurs de genoux ( axe / suite prothèse)</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>déséquilibre du bassin</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>lombalgie&nbsp; / dorsalgie / cervicalgie</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>anomalie vertébrale / scoliose</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>troubles positionnels</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>troubles de la proprioception (équilibre)</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>vertiges</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":217,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png\" alt=\"podologiste grenoble\" class=\"wp-image-217\" width=\"532\" height=\"35\" title=\"podologiste grenoble\"/></a></figure>\n<!-- /wp:image -->", "Pathologies Posturales", "", "publish", "closed", "closed", "", "podologiste-grenoble", "", "", "2022-12-09 13:53:58", "2022-12-09 12:53:58", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=50", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("51", "1", "2021-10-25 10:24:40", "2021-10-25 08:24:40", "", "Pathologies Posturales", "", "inherit", "closed", "closed", "", "50-revision-v1", "", "", "2021-10-25 10:24:40", "2021-10-25 08:24:40", "", "50", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=51", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("52", "1", "2021-10-25 10:25:04", "2021-10-25 08:25:04", "<!-- wp:list -->\n<ul><li>Course à Pied</li><li>Football</li><li>Cyclisme</li><li>Rugby</li><li>Handball</li><li>Basketball</li><li>Tennis</li><li>Randonnée</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":207,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png\" alt=\"orthesiste grenoble\" class=\"wp-image-207\" width=\"532\" height=\"35\" title=\"orthesiste grenoble\"/></a></figure>\n<!-- /wp:image -->", "Orthèses Sportives", "", "publish", "closed", "closed", "", "orthesiste-grenoble", "", "", "2021-10-28 08:05:02", "2021-10-28 06:05:02", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=52", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("53", "1", "2021-10-25 10:25:04", "2021-10-25 08:25:04", "", "Orthèse Sportive", "", "inherit", "closed", "closed", "", "52-revision-v1", "", "", "2021-10-25 10:25:04", "2021-10-25 08:25:04", "", "52", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=53", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("54", "1", "2021-10-25 10:35:49", "2021-10-25 08:34:39", " ", "", "", "publish", "closed", "closed", "", "54", "", "", "2021-10-25 10:35:49", "2021-10-25 08:35:49", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=54", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("55", "1", "2021-10-25 10:35:49", "2021-10-25 08:34:39", " ", "", "", "publish", "closed", "closed", "", "55", "", "", "2021-10-25 10:35:49", "2021-10-25 08:35:49", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=55", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("56", "1", "2021-10-25 10:35:49", "2021-10-25 08:34:39", " ", "", "", "publish", "closed", "closed", "", "56", "", "", "2021-10-25 10:35:49", "2021-10-25 08:35:49", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=56", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("57", "1", "2021-10-25 10:46:31", "0000-00-00 00:00:00", " ", "", "", "draft", "closed", "closed", "", "", "", "", "2021-10-25 10:46:31", "0000-00-00 00:00:00", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=57", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("58", "1", "2021-10-28 07:39:43", "2021-10-25 08:47:08", "", "Mentions Légales – Politique de confidentialité", "", "publish", "closed", "closed", "", "mentions-legales-politique-de-confidentialite", "", "", "2021-10-28 07:39:43", "2021-10-28 05:39:43", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=58", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("59", "1", "2021-10-25 17:47:34", "2021-10-25 15:47:34", "", "cabinet-anthoard-podologie-grenoble-fond", "", "inherit", "open", "closed", "", "cabinet-anthoard-podologie-grenoble-fond", "", "", "2021-10-25 17:48:23", "2021-10-25 15:48:23", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("61", "1", "2021-10-25 18:03:06", "2021-10-25 16:03:06", "", "99-002657_max", "", "inherit", "open", "closed", "", "99-002657_max", "", "", "2021-10-25 18:03:06", "2021-10-25 16:03:06", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/99-002657_max.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("62", "1", "2021-10-25 18:08:51", "2021-10-25 16:08:51", "", "cabinet-anthoard-orthopedie-podologie-grenoble-fond", "", "inherit", "open", "closed", "", "cabinet-anthoard-orthopedie-podologie-grenoble-fond", "", "", "2021-10-25 18:08:51", "2021-10-25 16:08:51", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("63", "1", "2021-10-25 18:10:04", "2021-10-25 16:10:04", "<!-- wp:image {\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"\" class=\"wp-image-62\"/></figure>\n<!-- /wp:image -->", "Cabinet d\'orthopédie podologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:10:04", "2021-10-25 16:10:04", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=63", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("65", "1", "2021-10-25 18:12:57", "2021-10-25 16:12:57", "<!-- wp:image {\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\"/></figure>\n<!-- /wp:image -->", "Cabinet d\'orthopédie podologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:12:57", "2021-10-25 16:12:57", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=65", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("66", "1", "2021-10-25 18:13:21", "2021-10-25 16:13:21", "<!-- wp:image {\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure>\n<!-- /wp:image -->", "Cabinet d\'orthopédie podologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:13:21", "2021-10-25 16:13:21", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=66", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("67", "1", "2021-10-25 18:15:00", "2021-10-25 16:15:00", "<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'orthopédie podologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:15:00", "2021-10-25 16:15:00", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=67", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("68", "1", "2021-10-25 18:15:46", "2021-10-25 16:15:46", "<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie Podologie Posturologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:15:46", "2021-10-25 16:15:46", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=68", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("69", "1", "2021-10-25 18:16:06", "2021-10-25 16:16:06", "<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard à Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:16:06", "2021-10-25 16:16:06", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=69", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("70", "1", "2021-10-25 18:17:04", "2021-10-25 16:17:04", "<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-25 18:17:04", "2021-10-25 16:17:04", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=70", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("72", "1", "2021-10-26 10:07:00", "2021-10-26 08:07:00", "<!-- wp:heading -->\n<h2>Orthopédie Podologie Posturologie</h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 10:07:00", "2021-10-26 08:07:00", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=72", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("74", "1", "2021-10-26 10:16:12", "2021-10-26 08:16:12", "<!-- wp:heading -->\n<h2>Orthopédie Podologie Posturologie </h2>\n<!-- /wp:heading -->\n\n<!-- wp:table -->\n<figure class=\"wp-block-table\"><table><tbody><tr><td></td><td>6 Rue ANTHOARD </td></tr><tr><td>Orthopédie</td><td>38000 GRENOBLE</td></tr><tr><td>Podologie</td><td>04 76 00 11 59</td></tr><tr><td>Posturologie</td><td>auberoger.2@orange.fr</td></tr></tbody></table></figure>\n<!-- /wp:table -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 10:16:12", "2021-10-26 08:16:12", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=74", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("75", "1", "2021-10-26 10:18:57", "2021-10-26 08:18:57", "<!-- wp:heading -->\n<h2>Orthopédie Podologie Posturologie </h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 10:18:57", "2021-10-26 08:18:57", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=75", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("76", "1", "2021-10-26 10:26:42", "2021-10-26 08:26:42", "", "Horaires Cabinet Podologie Orthopédie Anthoard - grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:26:42", "2021-10-26 08:26:42", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=76", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("78", "1", "2021-10-26 10:31:51", "2021-10-26 08:31:51", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table -->\n<figure class=\"wp-block-table\"><table><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:31:51", "2021-10-26 08:31:51", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=78", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("80", "1", "2021-10-26 10:33:51", "2021-10-26 08:33:51", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:33:51", "2021-10-26 08:33:51", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=80", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("83", "1", "2021-10-26 10:58:50", "2021-10-26 08:58:50", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"></td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:58:50", "2021-10-26 08:58:50", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=83", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("84", "1", "2021-10-26 10:59:17", "2021-10-26 08:59:17", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-default\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-default\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"></td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:59:17", "2021-10-26 08:59:17", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=84", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("85", "1", "2021-10-26 10:59:37", "2021-10-26 08:59:37", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"tableCollapsed\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;border-collapse:collapse;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"></td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:59:37", "2021-10-26 08:59:37", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=85", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("86", "1", "2021-10-26 10:59:50", "2021-10-26 08:59:50", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"tableCollapsed\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;border-collapse:collapse;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\"></td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;background-color:#eee\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 10:59:50", "2021-10-26 08:59:50", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=86", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("88", "1", "2021-10-26 11:00:09", "2021-10-26 09:00:09", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"tableCollapsed\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;border-collapse:collapse;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\"></td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures </td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:00:09", "2021-10-26 09:00:09", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=88", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("90", "1", "2021-10-26 11:02:31", "2021-10-26 09:02:31", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"tableCollapsed\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;border-collapse:collapse;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:02:31", "2021-10-26 09:02:31", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=90", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("91", "1", "2021-10-26 11:03:00", "2021-10-26 09:03:00", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:03:00", "2021-10-26 09:03:00", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=91", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("92", "1", "2021-10-26 11:03:42", "2021-10-26 09:03:42", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"tableCollapsed\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;border-collapse:collapse;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-style:none\"></td><td style=\"border-style:none\"></td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:03:42", "2021-10-26 09:03:42", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=92", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("94", "1", "2021-10-26 11:06:10", "2021-10-26 09:06:10", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td colspan=\"2\"></td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:06:10", "2021-10-26 09:06:10", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=94", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("95", "1", "2021-10-26 11:06:45", "2021-10-26 09:06:45", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px\" colspan=\"2\"></td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:06:45", "2021-10-26 09:06:45", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=95", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("96", "1", "2021-10-26 11:07:19", "2021-10-26 09:07:19", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px\" colspan=\"2\"></td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:07:19", "2021-10-26 09:07:19", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=96", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("97", "1", "2021-10-26 11:08:12", "2021-10-26 09:08:12", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;background-color:#6c8dab\" colspan=\"2\"></td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:08:12", "2021-10-26 09:08:12", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=97", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("98", "1", "2021-10-26 11:08:46", "2021-10-26 09:08:46", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:08:46", "2021-10-26 09:08:46", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=98", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("100", "1", "2021-10-26 11:09:06", "2021-10-26 09:09:06", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:09:06", "2021-10-26 09:09:06", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=100", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("101", "1", "2021-10-26 11:13:19", "2021-10-26 09:13:19", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#2d5c88;border-right-color:#2d5c88;border-width:2px\" data-border-color=\"#2d5c88\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:13:19", "2021-10-26 09:13:19", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=101", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("102", "1", "2021-10-26 11:13:48", "2021-10-26 09:13:48", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\" data-border-color=\"#000\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:13:48", "2021-10-26 09:13:48", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=102", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("103", "1", "2021-10-26 11:14:20", "2021-10-26 09:14:20", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:table {\"gradient\":\"very-light-gray-to-cyan-bluish-gray\",\"className\":\"is-style-stripes\"} -->\n<figure class=\"wp-block-table is-style-stripes\"><table class=\"has-very-light-gray-to-cyan-bluish-gray-gradient-background has-background\"><tbody><tr><td>LUNDI</td><td>de 10 heures à 18 heures</td></tr><tr><td>MARDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>MERCREDI</td><td> de 10 heures à 18 heures </td></tr><tr><td>JEUDI</td><td>fermé</td></tr><tr><td>VENDREDI</td><td>fermé</td></tr></tbody></table><figcaption>Horaires Cabinet Podologie - 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr</figcaption></figure>\n<!-- /wp:table -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\" data-border-color=\"#000\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\" data-border-color=\"#000\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:14:20", "2021-10-26 09:14:20", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=103", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("104", "1", "2021-10-26 11:15:49", "2021-10-26 09:15:49", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\" data-border-color=\"#000\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\" data-border-color=\"#000\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:15:49", "2021-10-26 09:15:49", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=104", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("105", "1", "2021-10-26 11:16:01", "2021-10-26 09:16:01", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le professionnel de santé en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\" data-border-color=\"#000\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\" data-border-color=\"#000\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 11:16:01", "2021-10-26 09:16:01", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=105", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("107", "1", "2021-10-26 13:00:50", "2021-10-26 11:00:50", "<!-- wp:paragraph -->\n<p>Crée  en aout 1995  par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE  en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble  depuis  janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>Agréer par la CRAM Rhône-Alpes et la CPAM  de Grenoble.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le  cabinet vous accueille  dans  la quiétude et le respect  des règles  médicales.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Un parking  privé  est à votre service (impasse Gelin ).</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Numéroté avec  un accès  par interphone.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le cabinet est aux normes (  accessibilité  ).</li></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2021-10-26 13:00:50", "2021-10-26 11:00:50", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=107", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("109", "1", "2021-10-26 13:09:59", "2021-10-26 11:09:59", "<!-- wp:list -->\n<ul><li>La principale activité  est la  réalisation d’orthèse plantaire  sur mesure ( semelle orthopédique ) remboursé par la CPAM et les mutuelles santé . </li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proprioceptives dynamiques étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux ( œil –oreille – atm ), étude complétée par un bilan radiologique ciblé sur la pathologie </li><li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformée en contre pesanteur).</li></ul>\n<!-- /wp:list -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2021-10-26 13:09:59", "2021-10-26 11:09:59", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=109", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("110", "1", "2021-10-26 13:12:23", "2021-10-26 11:12:23", "<!-- wp:list -->\n<ul><li>La principale activité  est la  réalisation d’orthèse plantaire  sur mesure (semelle orthopédique) remboursé par la CPAM et les mutuelles santé . </li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proprioceptives dynamiques étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux (œil –oreille – atm) , étude complétée par un bilan radiologique ciblé sur la pathologie </li><li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformée en contre pesanteur).</li></ul>\n<!-- /wp:list -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2021-10-26 13:12:23", "2021-10-26 11:12:23", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=110", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("112", "1", "2021-10-26 13:18:06", "2021-10-26 11:18:06", "<!-- wp:heading -->\n<h2>Prestation remboursée par la CPAM</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Avec ordonnance médicale, comprenant la consultation, la fabrication, l\'essayage et le suivit du traitement :</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>150,00 Euros pour les adultes</li><li>130,00 euros pour les enfants</li><li>CMU et AT par convention de la CPAM</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading -->\n<h2>Prestation remboursée par les mutuelles santé (mais non pas la CPAM)</h2>\n<!-- /wp:heading -->\n\n<!-- wp:list -->\n<ul><li>48,00 Euros la Consultation avec Bilan Podologique</li><li>48,00 Euros la Consultation en traumatologie</li></ul>\n<!-- /wp:list -->", "Tarifs en Orthopédie et Podologie", "", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2021-10-26 13:18:06", "2021-10-26 11:18:06", "", "24", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=112", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("114", "1", "2021-10-26 13:24:05", "2021-10-26 11:24:05", "<!-- wp:heading {\"level\":3} -->\n<h3>Nouveaux patients :</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading {\"level\":3} -->\n<h3>Anciens patients</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant aubertin - roger grenoble)</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-10-26 13:24:05", "2021-10-26 11:24:05", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=114", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("115", "1", "2021-10-26 13:28:11", "2021-10-26 11:28:11", "", "doc-rendezvous-aubertin-roger", "", "inherit", "open", "closed", "", "doc-rendezvous-aubertin-roger", "", "", "2021-10-26 13:28:11", "2021-10-26 11:28:11", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("117", "1", "2021-10-26 13:29:02", "2021-10-26 11:29:02", "<!-- wp:heading {\"level\":3} -->\n<h3>Nouveaux patients :</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading {\"level\":3} -->\n<h3>Anciens patients</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant aubertin - roger grenoble)</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":115,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\" alt=\"\" class=\"wp-image-115\"/></figure>\n<!-- /wp:image -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-10-26 13:29:02", "2021-10-26 11:29:02", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=117", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("118", "1", "2021-10-26 13:29:32", "2021-10-26 11:29:32", "<!-- wp:heading {\"level\":3} -->\n<h3>Nouveaux patients :</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading {\"level\":3} -->\n<h3>Anciens patients</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant aubertin - roger grenoble)</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":115,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><a href=\"https://docrendezvous.fr/\" target=\"_blank\" rel=\"noopener\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\" alt=\"\" class=\"wp-image-115\"/></a></figure>\n<!-- /wp:image -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-10-26 13:29:32", "2021-10-26 11:29:32", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=118", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("120", "1", "2021-10-26 13:31:07", "2021-10-26 11:31:07", "<!-- wp:heading {\"level\":3} -->\n<h3>Nouveaux patients :</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading {\"level\":3} -->\n<h3>Anciens patients</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant aubertin - roger grenoble)</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":115,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><a href=\"https://docrendezvous.fr/\" target=\"_blank\" rel=\"noopener\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\" alt=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\" class=\"wp-image-115\" title=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\"/></a></figure>\n<!-- /wp:image -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-10-26 13:31:07", "2021-10-26 11:31:07", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=120", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("122", "1", "2021-10-26 13:31:58", "2021-10-26 11:31:58", "<!-- wp:heading {\"level\":3} -->\n<h3>Nouveaux patients :</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading {\"level\":3} -->\n<h3>Anciens patients</h3>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant <strong>AUBERTIN - roger GRENOBLE</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":115,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><a href=\"https://docrendezvous.fr/\" target=\"_blank\" rel=\"noopener\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\" alt=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\" class=\"wp-image-115\" title=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\"/></a></figure>\n<!-- /wp:image -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-10-26 13:31:58", "2021-10-26 11:31:58", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=122", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("123", "1", "2021-10-26 13:33:44", "2021-10-26 11:33:44", "<!-- wp:heading -->\n<h2>Nouveaux patients :</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Contacter le sécrétariat par téléphone aux</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>04.76.41.78.65</li><li>04.76.00.11.59</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading -->\n<h2>Anciens patients</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Accès au planning via Internet directement, en allant sur le site <br><a href=\"https://docrendezvous.fr\" target=\"_blank\" rel=\"noreferrer noopener nofollow\">https://docrendezvous.fr</a> et en demandant <strong>AUBERTIN - roger GRENOBLE</strong></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:image {\"id\":115,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\",\"className\":\"is-style-default\"} -->\n<figure class=\"wp-block-image size-full is-style-default\"><a href=\"https://docrendezvous.fr/\" target=\"_blank\" rel=\"noopener\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\" alt=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\" class=\"wp-image-115\" title=\"Rendez vous sur Docrendezvous.fr avec Aubertin roger - Grenoble\"/></a></figure>\n<!-- /wp:image -->", "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "", "inherit", "closed", "closed", "", "26-revision-v1", "", "", "2021-10-26 13:33:44", "2021-10-26 11:33:44", "", "26", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=123", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("124", "1", "2021-10-26 13:36:31", "2021-10-26 11:36:31", "", "Orthèses Sportives", "", "inherit", "closed", "closed", "", "52-revision-v1", "", "", "2021-10-26 13:36:31", "2021-10-26 11:36:31", "", "52", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=124", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("125", "1", "2021-10-26 13:37:52", "2021-10-26 11:37:52", "<!-- wp:list -->\n<ul><li>Course à Pied</li><li>Football</li><li>Cyclisme</li><li>Rugby</li><li>Handball</li><li>Basketball</li><li>Tennis</li><li>Randonnée</li></ul>\n<!-- /wp:list -->", "Orthèses Sportives", "", "inherit", "closed", "closed", "", "52-revision-v1", "", "", "2021-10-26 13:37:52", "2021-10-26 11:37:52", "", "52", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=125", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("127", "1", "2021-10-26 13:40:25", "2021-10-26 11:40:25", "<!-- wp:list -->\n<ul><li>douleurs plantaires (ménopause , marche intense)</li><li>épine calcanéenne</li><li>aponévrose plantaire</li><li>hallux valgus / hallux rigidus (pré-post opératoire)</li><li>névrome  de Morton</li><li>inflammation du tendon d\'Achille</li><li>ténosynovite tibiale et fibulaire</li><li>maladie de Sever</li><li>séquelle traumatique après accident</li><li>traumatologie  pied / cheville</li></ul>\n<!-- /wp:list -->", "Pathologies du Pied", "", "inherit", "closed", "closed", "", "48-revision-v1", "", "", "2021-10-26 13:40:25", "2021-10-26 11:40:25", "", "48", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=127", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("129", "1", "2021-10-26 13:42:46", "2021-10-26 11:42:46", "<!-- wp:list -->\n<ul><li>maladie de croissance de l’ adolescence</li><li>douleurs de genoux ( axe / suite prothèse)</li><li>déséquilibre du bassin</li><li>lombalgie  / dorsalgie / cervicalgie</li><li>anomalie vertébrale / scoliose</li><li>troubles positionnels</li><li>troubles de la proprioception (équilibre)</li><li>vertiges</li></ul>\n<!-- /wp:list -->", "Pathologies Posturales", "", "inherit", "closed", "closed", "", "50-revision-v1", "", "", "2021-10-26 13:42:46", "2021-10-26 11:42:46", "", "50", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=129", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("131", "1", "2021-10-26 14:10:08", "2021-10-26 12:10:08", "<!-- wp:heading -->\n<h2>Qui sommes-nous&nbsp;?</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>L’adresse de notre site est : https://www.orthopedie-podologie-anthoard-grenoble.com.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Commentaires</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Une chaîne anonymisée créée à partir de votre adresse e-mail (également appelée hash) peut être envoyée au service Gravatar pour vérifier si vous utilisez ce dernier. Les clauses de confidentialité du service Gravatar sont disponibles ici&nbsp;: https://automattic.com/privacy/. Après validation de votre commentaire, votre photo de profil sera visible publiquement à coté de votre commentaire.</p>\n<!-- /wp:paragraph -->", "Mentions Légales - Politique de confidentialité", "", "inherit", "closed", "closed", "", "3-revision-v1", "", "", "2021-10-26 14:10:08", "2021-10-26 12:10:08", "", "3", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=131", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("133", "1", "2021-10-26 14:11:39", "2021-10-26 12:11:39", "<!-- wp:heading -->\n<h2>Qui sommes-nous&nbsp;?</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>L’adresse de notre site est : https://www.orthopedie-podologie-anthoard-grenoble.com.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Commentaires</h2>\n<!-- /wp:heading -->\n\n<!-- wp:html -->\n<h2>Définitions</h2>\n                <p><b>Client :</b> tout professionnel ou personne physique capable au sens des articles 1123 et suivants du Code civil, ou personne morale, qui visite le Site objet des présentes conditions générales.<br>\n                <b>Prestations et Services :</b> <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> met à disposition des Clients :</p>\n\n                <p><b>Contenu :</b> Ensemble des éléments constituants l’information présente sur le Site, notamment textes – images – vidéos.</p>\n\n                <p><b>Informations clients :</b> Ci après dénommé « Information (s) » qui correspondent à l’ensemble des données personnelles susceptibles d’être détenues par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> pour la gestion de votre compte, de la gestion de la relation client et à des fins d’analyses et de statistiques.</p>\n\n\n                <p><b>Utilisateur :</b> Internaute se connectant, utilisant le site susnommé.</p>\n                <p><b>Informations personnelles :</b> « Les informations qui permettent, sous quelque forme que ce soit, directement ou non, l\'identification des personnes physiques auxquelles elles s\'appliquent » (article 4 de la loi n° 78-17 du 6 janvier 1978).</p>\n                <p>Les termes « données à caractère personnel », « personne concernée », « sous traitant » et « données sensibles » ont le sens défini par le Règlement Général sur la Protection des Données (RGPD : n° 2016-679)</p>\n\n                <h2>1. Présentation du site internet.</h2>\n                <p>En vertu de l\'article 6 de la loi n° 2004-575 du 21 juin 2004 pour la confiance dans l\'économie numérique, il est précisé aux utilisateurs du site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> l\'identité des différents intervenants dans le cadre de sa réalisation et de son suivi:\n                </p><p><strong>Propriétaire</strong> :   Cabinet d\'orthopédie et de Podologie l\'ANTHOARD   – 6 rue anthoard 38000 GRENOBLE<br>\n                              \n                <strong>Responsable publication</strong> : Aubertin Roger – auberoger.2@orange.fr<br>\n                Le responsable publication est une personne physique ou une personne morale.<br>\n                <strong>Webmaster</strong> : Cabaré Michel – michel@cabare.net<br>\n                <strong>Hébergeur</strong> : ovh – 2 rue Kellermann 59100 Roubaix 1007<br>\n                <strong>Délégué à la protection des données</strong> : Aubertin Roger – auberoger.2@orange.fr<br>\n                </p>\n\n                <div ng-bind-html=\"linkHTML\"><p>Ce modèle de mentions légales est proposé par le <a href=\"https://fr.orson.io/1371/generateur-mentions-legales\" title=\"générateur gratuit de mentions légales pour un site internet\">générateur gratuit de mentions légales pour un site internet</a></p></div>\n\n\n\n                <h2>2. Conditions générales d’utilisation du site et des services proposés.</h2>\n\n                <p>Le Site constitue une œuvre de l’esprit protégée par les dispositions du Code de la Propriété Intellectuelle et des Réglementations Internationales applicables. \n                Le Client ne peut en aucune manière réutiliser, céder ou exploiter pour son propre compte tout ou partie des éléments ou travaux du Site.</p>\n\n                <p>L’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> implique l’acceptation pleine et entière des conditions générales d’utilisation ci-après décrites. Ces conditions d’utilisation sont susceptibles d’être modifiées ou complétées à tout moment, les utilisateurs du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont donc invités à les consulter de manière régulière.</p>\n\n                <p>Ce site internet est normalement accessible à tout moment aux utilisateurs. Une interruption pour raison de maintenance technique peut être toutefois décidée par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, qui s’efforcera alors de communiquer préalablement aux utilisateurs les dates et heures de l’intervention.\n                Le site web <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est mis à jour régulièrement par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> responsable. De la même façon, les mentions légales peuvent être modifiées à tout moment : elles s’imposent néanmoins à l’utilisateur qui est invité à s’y référer le plus souvent possible afin d’en prendre connaissance.</p>\n\n                <h2>3. Description des services fournis.</h2>\n\n                <p>Le site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> a pour objet de fournir une information concernant l’ensemble des activités de la société.\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’efforce de fournir sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> des informations aussi précises que possible. Toutefois, il ne pourra être tenu responsable des oublis, des inexactitudes et des carences dans la mise à jour, qu’elles soient de son fait ou du fait des tiers partenaires qui lui fournissent ces informations.</p>\n\n                <p>Toutes les informations indiquées sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont données à titre indicatif, et sont susceptibles d’évoluer. Par ailleurs, les renseignements figurant sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne sont pas exhaustifs. Ils sont donnés sous réserve de modifications ayant été apportées depuis leur mise en ligne.</p>\n\n                <h2>4. Limitations contractuelles sur les données techniques.</h2>\n\n                <p>Le site utilise la technologie JavaScript.\n\n                Le site Internet ne pourra être tenu responsable de dommages matériels liés à l’utilisation du site. De plus, l’utilisateur du site s’engage à accéder au site en utilisant un matériel récent, ne contenant pas de virus et avec un navigateur de dernière génération mis-à-jour\n                Le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est hébergé chez un prestataire sur le territoire de l’Union Européenne conformément aux dispositions du Règlement Général sur la Protection des Données (RGPD : n° 2016-679)</p>\n\n                <p>L’objectif est d’apporter une prestation qui assure le meilleur taux d’accessibilité. L’hébergeur assure la continuité de son service 24 Heures sur 24, tous les jours de l’année. Il se réserve néanmoins la possibilité d’interrompre le service d’hébergement pour les durées les plus courtes possibles notamment à des fins de maintenance, d’amélioration de ses infrastructures, de défaillance de ses infrastructures ou si les Prestations et Services génèrent un trafic réputé anormal.</p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et l’hébergeur ne pourront être tenus responsables en cas de dysfonctionnement du réseau Internet, des lignes téléphoniques ou du matériel informatique et de téléphonie lié notamment à l’encombrement du réseau empêchant l’accès au serveur.</p>\n\n                <h2>5. Propriété intellectuelle et contrefaçons.</h2>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est propriétaire des droits de propriété intellectuelle et détient les droits d’usage sur tous les éléments accessibles sur le site internet, notamment les textes, images, graphismes, logos, vidéos, icônes et sons.\n                Toute reproduction, représentation, modification, publication, adaptation de tout ou partie des éléments du site, quel que soit le moyen ou le procédé utilisé, est interdite, sauf autorisation écrite préalable de : <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.</p>\n\n                <p>Toute exploitation non autorisée du site ou de l’un quelconque des éléments qu’il contient sera considérée comme constitutive d’une contrefaçon et poursuivie conformément aux dispositions des articles L.335-2 et suivants du Code de Propriété Intellectuelle.</p>\n\n                <h2>6. Limitations de responsabilité.</h2>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> agit en tant qu’éditeur du site. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>  est responsable de la qualité et de la véracité du Contenu qu’il publie. </p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne pourra être tenu responsable des dommages directs et indirects causés au matériel de l’utilisateur, lors de l’accès au site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, et résultant soit de l’utilisation d’un matériel ne répondant pas aux spécifications indiquées au point 4, soit de l’apparition d’un bug ou d’une incompatibilité.</p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne pourra également être tenu responsable des dommages indirects (tels par exemple qu’une perte de marché ou perte d’une chance) consécutifs à l’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.\n                Des espaces interactifs (possibilité de poser des questions dans l’espace contact) sont à la disposition des utilisateurs. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> se réserve le droit de supprimer, sans mise en demeure préalable, tout contenu déposé dans cet espace qui contreviendrait à la législation applicable en France, en particulier aux dispositions relatives à la protection des données. Le cas échéant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> se réserve également la possibilité de mettre en cause la responsabilité civile et/ou pénale de l’utilisateur, notamment en cas de message à caractère raciste, injurieux, diffamant, ou pornographique, quel que soit le support utilisé (texte, photographie …).</p>\n\n                <h2>7. Gestion des données personnelles.</h2>\n\n                <p>Le Client est informé des réglementations concernant la communication marketing, la loi du 21 Juin 2014 pour la confiance dans l’Economie Numérique, la Loi Informatique et Liberté du 06 Août 2004 ainsi que du Règlement Général sur la Protection des Données (RGPD : n° 2016-679). </p>\n\n                <h3>7.1 Responsables de la collecte des données personnelles</h3>\n\n                <p>Pour les Données Personnelles collectées dans le cadre de la création du compte personnel de l’Utilisateur et de sa navigation sur le Site, le responsable du traitement des Données Personnelles est : Cabinet d\'orthopédie et de Podologie l\'ANTHOARD. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>est représenté par Aubertin Roger, son représentant légal</p>\n\n                <p>En tant que responsable du traitement des données qu’il collecte, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à respecter le cadre des dispositions légales en vigueur. Il lui appartient notamment au Client d’établir les finalités de ses traitements de données, de fournir à ses prospects et clients, à partir de la collecte de leurs consentements, une information complète sur le traitement de leurs données personnelles et de maintenir un registre des traitements conforme à la réalité.\n                Chaque fois que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> traite des Données Personnelles, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> prend toutes les mesures raisonnables pour s’assurer de l’exactitude et de la pertinence des Données Personnelles au regard des finalités pour lesquelles <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> les traite.</p>\n                 \n                <h3>7.2 Finalité des données collectées</h3>\n                 \n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est susceptible de traiter tout ou partie des données : </p>\n\n                <ul>\n                  \n                <li>pour permettre la navigation sur le Site et la gestion et la traçabilité des prestations et services commandés par l’utilisateur : données de connexion et d’utilisation du Site, facturation, historique des commandes, etc. </li>\n                 \n                <li>pour prévenir et lutter contre la fraude informatique (spamming, hacking…) : matériel informatique utilisé pour la navigation, l’adresse IP, le mot de passe (hashé) </li>\n                 \n                <li>pour améliorer la navigation sur le Site : données de connexion et d’utilisation </li>\n                 \n                <li>pour mener des enquêtes de satisfaction facultatives sur <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> : adresse email </li>\n                <li>pour mener des campagnes de communication (sms, mail) : numéro de téléphone, adresse email</li>\n\n\n                </ul>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne commercialise pas vos données personnelles qui sont donc uniquement utilisées par nécessité ou à des fins statistiques et d’analyses.</p>\n                 \n                <h3>7.3 Droit d’accès, de rectification et d’opposition</h3>\n                 \n                <p>\n                Conformément à la réglementation européenne en vigueur, les Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> disposent des droits suivants : </p>\n                 <ul>\n\n                <li>droit d\'accès (article 15 RGPD) et de rectification (article 16 RGPD), de mise à jour, de complétude des données des Utilisateurs droit de verrouillage ou d’effacement des données des Utilisateurs à caractère personnel (article 17 du RGPD), lorsqu’elles sont inexactes, incomplètes, équivoques, périmées, ou dont la collecte, l\'utilisation, la communication ou la conservation est interdite </li>\n                 \n                <li>droit de retirer à tout moment un consentement (article 13-2c RGPD) </li>\n                 \n                <li>droit à la limitation du traitement des données des Utilisateurs (article 18 RGPD) </li>\n                 \n                <li>droit d’opposition au traitement des données des Utilisateurs (article 21 RGPD) </li>\n                 \n                <li>droit à la portabilité des données que les Utilisateurs auront fournies, lorsque ces données font l’objet de traitements automatisés fondés sur leur consentement ou sur un contrat (article 20 RGPD) </li>\n                 \n                <li>droit de définir le sort des données des Utilisateurs après leur mort et de choisir à qui <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> devra communiquer (ou non) ses données à un tiers qu’ils aura préalablement désigné</li>\n                 </ul>\n\n                <p>Dès que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> a connaissance du décès d’un Utilisateur et à défaut d’instructions de sa part, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à détruire ses données, sauf si leur conservation s’avère nécessaire à des fins probatoires ou pour répondre à une obligation légale.</p>\n                 \n                <p>Si l’Utilisateur souhaite savoir comment <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> utilise ses Données Personnelles, demander à les rectifier ou s’oppose à leur traitement, l’Utilisateur peut contacter <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> par écrit à l’adresse suivante : </p>\n                 \n                Cabinet d\'orthopédie et de Podologie l\'ANTHOARD – DPO, Aubertin Roger <br>\n                6 rue anthoard 38000 GRENOBLE.\n                 \n                <p>Dans ce cas, l’Utilisateur doit indiquer les Données Personnelles qu’il souhaiterait que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> corrige, mette à jour ou supprime, en s’identifiant précisément avec une copie d’une pièce d’identité (carte d’identité ou passeport). </p>\n\n                <p>\n                Les demandes de suppression de Données Personnelles seront soumises aux obligations qui sont imposées à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> par la loi, notamment en matière de conservation ou d’archivage des documents. Enfin, les Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> peuvent déposer une réclamation auprès des autorités de contrôle, et notamment de la CNIL (https://www.cnil.fr/fr/plaintes).</p>\n                 \n                <h3>7.4 Non-communication des données personnelles</h3>\n\n                <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’interdit de traiter, héberger ou transférer les Informations collectées sur ses Clients vers un pays situé en dehors de l’Union européenne ou reconnu comme « non adéquat » par la Commission européenne sans en informer préalablement le client. Pour autant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> reste libre du choix de ses sous-traitants techniques et commerciaux à la condition qu’il présentent les garanties suffisantes au regard des exigences du Règlement Général sur la Protection des Données (RGPD : n° 2016-679).</p>\n\n                <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à prendre toutes les précautions nécessaires afin de préserver la sécurité des Informations et notamment qu’elles ne soient pas communiquées à des personnes non autorisées. Cependant, si un incident impactant l’intégrité ou la confidentialité des Informations du Client est portée à la connaissance de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, celle-ci devra dans les meilleurs délais informer le Client et lui communiquer les mesures de corrections prises. Par ailleurs <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne collecte aucune « données sensibles ».</p>\n\n                <p>\n                Les Données Personnelles de l’Utilisateur peuvent être traitées par des filiales de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et des sous-traitants (prestataires de services), exclusivement afin de réaliser les finalités de la présente politique.</p>\n                <p>\n                Dans la limite de leurs attributions respectives et pour les finalités rappelées ci-dessus, les principales personnes susceptibles d’avoir accès aux données des Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont principalement les agents de notre service client.</p>\n                \n                <div ng-bind-html=\"rgpdHTML\"><h3>7.5 Types de données collectées</h3><p>Concernant les utilisateurs d’un Site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, nous collectons les données suivantes qui sont indispensables au fonctionnement du service&nbsp;, et qui seront conservées pendant une période maximale de 0 mois après la fin de la relation contractuelle:<br>Aucunes</p><p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> collecte en outre des informations qui permettent d’améliorer l’expérience utilisateur et de proposer des conseils contextualisés&nbsp;:<br>Aucunes</p><p> Ces &nbsp;données sont conservées pour une période maximale de 0 mois après la fin de la relation contractuelle</p></div>\n\n\n                <h2>8. Notification d’incident</h2>\n                <p>\n                Quels que soient les efforts fournis, aucune méthode de transmission sur Internet et aucune méthode de stockage électronique n\'est complètement sûre. Nous ne pouvons en conséquence pas garantir une sécurité absolue. \n                Si nous prenions connaissance d\'une brèche de la sécurité, nous avertirions les utilisateurs concernés afin qu\'ils puissent prendre les mesures appropriées. Nos procédures de notification d’incident tiennent compte de nos obligations légales, qu\'elles se situent au niveau national ou européen. Nous nous engageons à informer pleinement nos clients de toutes les questions relevant de la sécurité de leur compte et à leur fournir toutes les informations nécessaires pour les aider à respecter leurs propres obligations réglementaires en matière de reporting.</p>\n                <p>\n                Aucune information personnelle de l\'utilisateur du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> n\'est publiée à l\'insu de l\'utilisateur, échangée, transférée, cédée ou vendue sur un support quelconque à des tiers. Seule l\'hypothèse du rachat de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et de ses droits permettrait la transmission des dites informations à l\'éventuel acquéreur qui serait à son tour tenu de la même obligation de conservation et de modification des données vis à vis de l\'utilisateur du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.</p>\n\n                <h3>Sécurité</h3>\n\n                <p>\n                Pour assurer la sécurité et la confidentialité des Données Personnelles et des Données Personnelles de Santé, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> utilise des réseaux protégés par des dispositifs standards tels que par pare-feu, la pseudonymisation, l’encryption et mot de passe. </p>\n                 \n                <p>\n                Lors du traitement des Données Personnelles, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>prend toutes les mesures raisonnables visant à les protéger contre toute perte, utilisation détournée, accès non autorisé, divulgation, altération ou destruction.</p>\n                 \n                <h2>9. Liens hypertextes « cookies » et balises (“tags”) internet</h2>\n                <p>\n                Le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> contient un certain nombre de liens hypertextes vers d’autres sites, mis en place avec l’autorisation de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>. Cependant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> n’a pas la possibilité de vérifier le contenu des sites ainsi visités, et n’assumera en conséquence aucune responsabilité de ce fait.</p>\n                Sauf si vous décidez de désactiver les cookies, vous acceptez que le site puisse les utiliser. Vous pouvez à tout moment désactiver ces cookies et ce gratuitement à partir des possibilités de désactivation qui vous sont offertes et rappelées ci-après, sachant que cela peut réduire ou empêcher l’accessibilité à tout ou partie des Services proposés par le site.\n                <p></p>\n\n                <h3>9.1. « COOKIES »</h3>\n                 <p>\n                Un « cookie » est un petit fichier d’information envoyé sur le navigateur de l’Utilisateur et enregistré au sein du terminal de l’Utilisateur (ex : ordinateur, smartphone), (ci-après « Cookies »). Ce fichier comprend des informations telles que le nom de domaine de l’Utilisateur, le fournisseur d’accès Internet de l’Utilisateur, le système d’exploitation de l’Utilisateur, ainsi que la date et l’heure d’accès. Les Cookies ne risquent en aucun cas d’endommager le terminal de l’Utilisateur.</p>\n                 <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est susceptible de traiter les informations de l’Utilisateur concernant sa visite du Site, telles que les pages consultées, les recherches effectuées. Ces informations permettent à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’améliorer le contenu du Site, de la navigation de l’Utilisateur.</p>\n                 <p>\n                Les Cookies facilitant la navigation et/ou la fourniture des services proposés par le Site, l’Utilisateur peut configurer son navigateur pour qu’il lui permette de décider s’il souhaite ou non les accepter de manière à ce que des Cookies soient enregistrés dans le terminal ou, au contraire, qu’ils soient rejetés, soit systématiquement, soit selon leur émetteur. L’Utilisateur peut également configurer son logiciel de navigation de manière à ce que l’acceptation ou le refus des Cookies lui soient proposés ponctuellement, avant qu’un Cookie soit susceptible d’être enregistré dans son terminal. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> informe l’Utilisateur que, dans ce cas, il se peut que les fonctionnalités de son logiciel de navigation ne soient pas toutes disponibles.</p>\n                 <p>\n                Si l’Utilisateur refuse l’enregistrement de Cookies dans son terminal ou son navigateur, ou si l’Utilisateur supprime ceux qui y sont enregistrés, l’Utilisateur est informé que sa navigation et son expérience sur le Site peuvent être limitées. Cela pourrait également être le cas lorsque <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ou l’un de ses prestataires ne peut pas reconnaître, à des fins de compatibilité technique, le type de navigateur utilisé par le terminal, les paramètres de langue et d’affichage ou le pays depuis lequel le terminal semble connecté à Internet.</p>\n                 <p>\n                Le cas échéant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> décline toute responsabilité pour les conséquences liées au fonctionnement dégradé du Site et des services éventuellement proposés par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, résultant (i) du refus de Cookies par l’Utilisateur (ii) de l’impossibilité pour <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’enregistrer ou de consulter les Cookies nécessaires à leur fonctionnement du fait du choix de l’Utilisateur. Pour la gestion des Cookies et des choix de l’Utilisateur, la configuration de chaque navigateur est différente. Elle est décrite dans le menu d’aide du navigateur, qui permettra de savoir de quelle manière l’Utilisateur peut modifier ses souhaits en matière de Cookies.</p>\n                 <p>\n                À tout moment, l’Utilisateur peut faire le choix d’exprimer et de modifier ses souhaits en matière de Cookies. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> pourra en outre faire appel aux services de prestataires externes pour l’aider à recueillir et traiter les informations décrites dans cette section.</p>\n                 <p>\n                Enfin, en cliquant sur les icônes dédiées aux réseaux sociaux Twitter, Facebook, Linkedin et Google Plus figurant sur le Site de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ou dans son application mobile et si l’Utilisateur a accepté le dépôt de cookies en poursuivant sa navigation sur le Site Internet ou l’application mobile de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, Twitter, Facebook, Linkedin et Google Plus peuvent également déposer des cookies sur vos terminaux (ordinateur, tablette, téléphone portable).</p>\n                 <p>\n                Ces types de cookies ne sont déposés sur vos terminaux qu’à condition que vous y consentiez, en continuant votre navigation sur le Site Internet ou l’application mobile de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>. À tout moment, l’Utilisateur peut néanmoins revenir sur son consentement à ce que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> dépose ce type de cookies.</p>\n                 \n                <h3>Article 9.2. BALISES (“TAGS”) INTERNET</h3>\n                 \n\n                <p>\n\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> peut employer occasionnellement des balises Internet (également appelées « tags », ou balises d’action, GIF à un pixel, GIF transparents, GIF invisibles et GIF un à un) et les déployer par l’intermédiaire d’un partenaire spécialiste d’analyses Web susceptible de se trouver (et donc de stocker les informations correspondantes, y compris l’adresse IP de l’Utilisateur) dans un pays étranger.</p>\n                 \n                <p>\n                Ces balises sont placées à la fois dans les publicités en ligne permettant aux internautes d’accéder au Site, et sur les différentes pages de celui-ci. \n                 </p>\n                <p>\n                Cette technologie permet à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’évaluer les réponses des visiteurs face au Site et l’efficacité de ses actions (par exemple, le nombre de fois où une page est ouverte et les informations consultées), ainsi que l’utilisation de ce Site par l’Utilisateur. </p>\n                 <p>\n                Le prestataire externe pourra éventuellement recueillir des informations sur les visiteurs du Site et d’autres sites Internet grâce à ces balises, constituer des rapports sur l’activité du Site à l’attention de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, et fournir d’autres services relatifs à l’utilisation de celui-ci et d’Internet.</p>\n                 <p>\n                </p><h2>10. Droit applicable et attribution de juridiction.</h2>  \n                 <p>\n                Tout litige en relation avec l’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est soumis au droit français. \n                En dehors des cas où la loi ne le permet pas, il est fait attribution exclusive de juridiction aux tribunaux compétents de Grenoble</p>\n<!-- /wp:html -->", "Mentions Légales - Politique de confidentialité", "", "inherit", "closed", "closed", "", "3-revision-v1", "", "", "2021-10-26 14:11:39", "2021-10-26 12:11:39", "", "3", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=133", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("137", "1", "2021-10-26 14:29:54", "2021-10-26 12:29:54", "<!-- wp:heading -->\n<h2>6 rue ANTHOARD 38000 Grenoble </h2>\n<!-- /wp:heading -->\n\n<!-- wp:heading {\"level\":3} -->\n<h3><a href=\"http://04.76.00.11.59\">04.76.00.11.59</a> auberoger.2@orange.fr</h3>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:29:54", "2021-10-26 12:29:54", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=137", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("138", "1", "2021-10-26 14:30:33", "2021-10-26 12:30:33", "<!-- wp:heading -->\n<h2>6 rue ANTHOARD 38000 Grenoble  <a href=\"http://04.76.00.11.59\">04.76.00.11.59</a> auberoger.2@orange.fr </h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:30:33", "2021-10-26 12:30:33", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=138", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("139", "1", "2021-10-26 14:31:36", "2021-10-26 12:31:36", "<!-- wp:heading -->\n<h2>6 rue ANTHOARD 38000 Grenoble  <a href=\"http://0476001159\">0476001159</a> auberoger.2@orange.fr </h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:31:36", "2021-10-26 12:31:36", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=139", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("141", "1", "2021-10-26 14:34:45", "2021-10-26 12:34:45", "<!-- wp:heading -->\n<h2>6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">04.76.00.11.59</a> auberoger.2@orange.fr </h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:34:45", "2021-10-26 12:34:45", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=141", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("142", "1", "2021-10-26 14:35:51", "2021-10-26 12:35:51", "<!-- wp:heading -->\n<h2>6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">04.76.00.11.59</a> <a href=\"mailto:auberoger.2@orange.fr\">auberoger.2@orange.fr </a></h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:35:51", "2021-10-26 12:35:51", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=142", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("143", "1", "2021-10-26 14:37:43", "2021-10-26 12:37:43", "<!-- wp:heading -->\n<h2>6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></h2>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:37:43", "2021-10-26 12:37:43", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=143", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("144", "1", "2021-10-26 14:38:13", "2021-10-26 12:38:13", "<!-- wp:heading -->\n<h4>6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></h4>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:38:13", "2021-10-26 12:38:13", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=144", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("145", "1", "2021-10-26 14:39:07", "2021-10-26 12:39:07", "<!-- wp:heading -->\n<p>6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:heading -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:39:07", "2021-10-26 12:39:07", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=145", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("146", "1", "2021-10-26 14:39:33", "2021-10-26 12:39:33", "<!-- wp:html -->\n<p>6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:39:33", "2021-10-26 12:39:33", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=146", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("147", "1", "2021-10-26 14:41:51", "2021-10-26 12:41:51", "<!-- wp:html -->\n<p align=\"center\">6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-26 14:41:51", "2021-10-26 12:41:51", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=147", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("149", "1", "2021-10-26 14:54:55", "2021-10-26 12:54:55", "", "cabinet-atelier", "Atelier Cabinet Podologie", "inherit", "open", "closed", "", "cabinet-atelier", "", "", "2021-10-26 15:02:18", "2021-10-26 13:02:18", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("150", "1", "2021-10-26 14:54:56", "2021-10-26 12:54:56", "", "cabinet-couloir", "Couloir accès cabinet", "inherit", "open", "closed", "", "cabinet-couloir", "", "", "2021-10-26 15:01:58", "2021-10-26 13:01:58", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("151", "1", "2021-10-26 14:54:56", "2021-10-26 12:54:56", "", "cabinet-exterieur", "Arrivée 6 Rue ANTHOARD", "inherit", "open", "closed", "", "cabinet-exterieur", "", "", "2021-10-26 15:01:20", "2021-10-26 13:01:20", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("152", "1", "2021-10-26 14:54:56", "2021-10-26 12:54:56", "", "cabinet-machine-physioforme", "Machine Physioforme", "inherit", "open", "closed", "", "cabinet-machine-physioforme", "", "", "2021-10-26 15:02:12", "2021-10-26 13:02:12", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("153", "1", "2021-10-26 14:54:57", "2021-10-26 12:54:57", "", "cabinet-parking", "Entrée 6 rue ANTHOARD 38000 Grenoble", "inherit", "open", "closed", "", "cabinet-parking", "", "", "2021-10-26 15:01:32", "2021-10-26 13:01:32", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("154", "1", "2021-10-26 14:54:57", "2021-10-26 12:54:57", "", "cabinet-salle-attente", "Salle d\'attente", "inherit", "open", "closed", "", "cabinet-salle-attente", "", "", "2021-10-26 15:01:51", "2021-10-26 13:01:51", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("155", "1", "2021-10-26 14:54:57", "2021-10-26 12:54:57", "", "cabinet-salle-examen-1", "Cabinet Podologie", "inherit", "open", "closed", "", "cabinet-salle-examen-1", "", "", "2021-10-26 15:02:04", "2021-10-26 13:02:04", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("156", "1", "2021-10-26 14:54:57", "2021-10-26 12:54:57", "", "cabinet-salle-examen-2", "Cabinet Orthopedie", "inherit", "open", "closed", "", "cabinet-salle-examen-2", "", "", "2021-10-26 15:02:08", "2021-10-26 13:02:08", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("157", "1", "2021-10-26 15:03:30", "2021-10-26 13:03:30", "<!-- wp:gallery {\"ids\":[151,153,154,150,155,156,152,149],\"linkTo\":\"none\"} -->\n<figure class=\"wp-block-gallery columns-3 is-cropped\"><ul class=\"blocks-gallery-grid\"><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\" alt=\"6 Rue ANTHOARD 38000 Grenoble\" data-id=\"151\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-exterieur/\" class=\"wp-image-151\"/><figcaption class=\"blocks-gallery-item__caption\">Arrivée 6 Rue ANTHOARD</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\" alt=\"Entrée 6 rue ANTHOARD 38000 Grenoble\" data-id=\"153\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-parking/\" class=\"wp-image-153\"/><figcaption class=\"blocks-gallery-item__caption\">Entrée 6 rue ANTHOARD 38000 Grenoble</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\" alt=\"Salle d\'attente cabinet\" data-id=\"154\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-salle-attente/\" class=\"wp-image-154\"/><figcaption class=\"blocks-gallery-item__caption\">Salle d\'attente</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\" alt=\"Couloir accès cabinet\" data-id=\"150\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-couloir/\" class=\"wp-image-150\"/><figcaption class=\"blocks-gallery-item__caption\">Couloir accès cabinet</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\" alt=\"Cabinet Podologie\" data-id=\"155\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-salle-examen-1/\" class=\"wp-image-155\"/><figcaption class=\"blocks-gallery-item__caption\">Cabinet Podologie</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\" alt=\"Cabinet Orthopedie\" data-id=\"156\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-salle-examen-2/\" class=\"wp-image-156\"/><figcaption class=\"blocks-gallery-item__caption\">Cabinet Orthopedie</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\" alt=\"Machine Physioforme\" data-id=\"152\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-machine-physioforme/\" class=\"wp-image-152\"/><figcaption class=\"blocks-gallery-item__caption\">Machine Physioforme</figcaption></figure></li><li class=\"blocks-gallery-item\"><figure><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\" alt=\"Atelier Cabinet Podologie\" data-id=\"149\" data-full-url=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\" data-link=\"https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-atelier/\" class=\"wp-image-149\"/><figcaption class=\"blocks-gallery-item__caption\">Atelier Cabinet Podologie</figcaption></figure></li></ul><figcaption class=\"blocks-gallery-caption\">Le Cabinet de Podologie l\'Anthoard à Grenoble en Images !</figcaption></figure>\n<!-- /wp:gallery -->", "Cabinet Orthopédie Podologie l\'ANTHOARD en images", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2021-10-26 15:03:30", "2021-10-26 13:03:30", "", "28", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=157", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("158", "1", "2021-10-26 18:24:52", "2021-10-26 16:24:52", "", "cabinet-anthoard-orthopedie-podologie-grenoble-logo", "", "inherit", "open", "closed", "", "cabinet-anthoard-orthopedie-podologie-grenoble-logo", "", "", "2021-10-26 18:24:52", "2021-10-26 16:24:52", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("159", "1", "2021-10-26 18:54:10", "2021-10-26 16:54:10", "<!-- wp:list -->\n<ul><li>les consultations sont sur rendez-vous</li><li>merci de contacter le Cabinet / Secretariat en cas d\'urgence</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->\n\n<!-- wp:advgb/table {\"maxWidth\":800,\"hasFixedLayout\":true,\"changed\":true,\"className\":\"is-style-stripes\"} -->\n<table class=\"wp-block-advgb-table advgb-table-frontend is-style-stripes\" style=\"max-width:800px;table-layout:fixed\"><tbody><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-left-color:#000;border-width:2px\" data-border-color=\"#000\">LUNDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-top-color:#000;border-right-color:#000;border-width:2px\">  de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MARDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">MERCREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\"> de 10 heures à 18 heures</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-left-color:#000;border-width:2px\">JEUDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-right-color:#000;border-width:2px\">Fermé</td></tr><tr><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-left-color:#000;border-width:2px\">VENDREDI</td><td style=\"text-align:center;vertical-align:middle;padding-top:10px;padding-bottom:10px;border-bottom-color:#000;border-right-color:#000;border-width:2px\" data-border-color=\"#000\"> Fermé </td></tr></tbody><tfoot><tr><td style=\"border-width:2px;padding-top:10px;padding-bottom:10px;text-align:center\" colspan=\"2\"> Horaires Cabinet 6 rue ANTHOARD 38000 GRENOBLE - 04.76.00.11.59 - auberoger.2@orange.fr </td></tr></tfoot></table>\n<!-- /wp:advgb/table -->", "Horaires Cabinet Podologie Orthopédie Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "16-revision-v1", "", "", "2021-10-26 18:54:10", "2021-10-26 16:54:10", "", "16", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=159", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("160", "1", "2021-10-26 18:55:54", "2021-10-26 16:55:54", "<!-- wp:paragraph -->\n<p>Crée&nbsp; en aout 1995&nbsp; par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE&nbsp; en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble&nbsp; depuis&nbsp; janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>Agréer par la CRAM Rhône-Alpes et la CPAM&nbsp; de Grenoble.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le&nbsp; cabinet vous accueille&nbsp; dans&nbsp; la quiétude et le respect&nbsp; des règles&nbsp; médicales.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Un parking  privé  est à votre service (rue Gelin : places numérotées 20 - 21 ).</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Accès  par interphone.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le cabinet est aux normes (&nbsp; accessibilité&nbsp; ).</li></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2021-10-26 18:55:54", "2021-10-26 16:55:54", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=160", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("161", "1", "2021-10-26 18:56:04", "2021-10-26 16:56:04", "<!-- wp:paragraph -->\n<p>Crée&nbsp; en aout 1995&nbsp; par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE&nbsp; en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble&nbsp; depuis&nbsp; janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>Agréer par la CRAM Rhône-Alpes et la CPAM&nbsp; de Grenoble.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le&nbsp; cabinet vous accueille&nbsp; dans&nbsp; la quiétude et le respect&nbsp; des règles&nbsp; médicales.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Un parking  privé  est à votre service (rue Gelin : places numérotées 20 - 21).</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Accès  par interphone.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le cabinet est aux normes (&nbsp; accessibilité&nbsp; ).</li></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2021-10-26 18:56:04", "2021-10-26 16:56:04", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=161", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("163", "1", "2021-10-26 18:56:19", "2021-10-26 16:56:19", "<!-- wp:paragraph -->\n<p>Crée&nbsp; en aout 1995&nbsp; par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE&nbsp; en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble&nbsp; depuis&nbsp; janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>Agréer par la CRAM Rhône-Alpes et la CPAM&nbsp; de Grenoble.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le&nbsp; cabinet vous accueille&nbsp; dans&nbsp; la quiétude et le respect&nbsp; des règles&nbsp; médicales.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Un parking  privé  est à votre service (rue Gelin : places numérotées 20 - 21).</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Accès  par interphone.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le cabinet est aux normes (accessibilité).</li></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2021-10-26 18:56:19", "2021-10-26 16:56:19", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=163", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("164", "1", "2021-10-26 18:58:37", "2021-10-26 16:58:37", "<!-- wp:list -->\n<ul><li>La principale activité&nbsp; est la&nbsp; réalisation d’orthèse plantaire&nbsp; sur mesure (semelle orthopédique) remboursé par la CPAM et les mutuelles santé . </li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proprioceptives dynamiques étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux (œil –oreille – atm) , étude complétée par un bilan radiologique ciblé sur la pathologie. </li><li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformée en contre pesanteur).</li></ul>\n<!-- /wp:list -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2021-10-26 18:58:37", "2021-10-26 16:58:37", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=164", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("165", "1", "2021-10-27 09:11:57", "2021-10-27 07:11:57", "<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<p align=\"center\"><iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":200,\"width\":355,\"height\":23,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png\" alt=\"podologie grenoble\" class=\"wp-image-200\" width=\"355\" height=\"23\" title=\"podologie grenoble\"/></a></figure></div>\n<!-- /wp:image -->", "Venir au Cabinet d\'Orthopédie et de Podologie à Grenoble", "", "publish", "closed", "closed", "", "podologie-grenoble", "", "", "2021-10-28 07:36:19", "2021-10-28 05:36:19", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?page_id=165", "0", "page", "", "0");
INSERT INTO `wp_posts` VALUES("166", "1", "2021-10-27 09:11:57", "2021-10-27 07:11:57", "<!-- wp:paragraph -->\n<p>Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:paragraph -->\n<p></p>\n<!-- /wp:paragraph -->", "Venir au Cabinet d\'Orthopédie Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-27 09:11:57", "2021-10-27 07:11:57", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=166", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("168", "1", "2021-10-27 09:20:23", "2021-10-27 07:20:23", "<!-- wp:paragraph -->\n<p>Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" width=\"800\" height=\"600\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\"></iframe>\n<!-- /wp:html -->", "Venir au Cabinet d\'Orthopédie Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-27 09:20:23", "2021-10-27 07:20:23", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=168", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("169", "1", "2021-10-27 10:41:22", "2021-10-27 07:22:12", "", "Venir au Cabinet", "", "publish", "closed", "closed", "", "venir-au-cabinet", "", "", "2021-10-27 10:41:22", "2021-10-27 08:41:22", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=169", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("172", "1", "2021-10-27 09:34:17", "2021-10-27 07:34:17", ".topbarmenu ul li a {\n    font-size: 20px;\n}", "virtue", "", "publish", "closed", "closed", "", "virtue", "", "", "2021-10-27 09:39:25", "2021-10-27 07:39:25", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/2021/10/27/virtue/", "0", "custom_css", "", "0");
INSERT INTO `wp_posts` VALUES("173", "1", "2021-10-27 09:34:17", "2021-10-27 07:34:17", ".topbarmenu ul li a {\n    font-size: 20px;\n}", "virtue", "", "inherit", "closed", "closed", "", "172-revision-v1", "", "", "2021-10-27 09:34:17", "2021-10-27 07:34:17", "", "172", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=173", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("176", "1", "2021-10-27 10:43:35", "2021-10-27 08:42:31", "", "Histoire du Cabinet", "", "publish", "closed", "closed", "", "histoire-du-cabinet", "", "", "2021-10-27 10:43:35", "2021-10-27 08:43:35", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=176", "1", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("177", "1", "2021-10-27 10:43:35", "2021-10-27 08:43:12", "", "Visite du cabinet en images", "", "publish", "closed", "closed", "", "visite-du-cabinet-en-images", "", "", "2021-10-27 10:43:35", "2021-10-27 08:43:35", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=177", "2", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("178", "1", "2021-10-27 10:43:35", "2021-10-27 08:43:35", " ", "", "", "publish", "closed", "closed", "", "178", "", "", "2021-10-27 10:43:35", "2021-10-27 08:43:35", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=178", "3", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("179", "1", "2021-10-27 10:43:35", "2021-10-27 08:43:35", " ", "", "", "publish", "closed", "closed", "", "179", "", "", "2021-10-27 10:43:35", "2021-10-27 08:43:35", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=179", "4", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("180", "1", "2021-10-27 10:43:35", "2021-10-27 08:43:35", " ", "", "", "publish", "closed", "closed", "", "180", "", "", "2021-10-27 10:43:35", "2021-10-27 08:43:35", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=180", "5", "nav_menu_item", "", "0");
INSERT INTO `wp_posts` VALUES("181", "1", "2021-10-27 10:48:02", "2021-10-27 08:48:02", "<!-- wp:paragraph -->\n<p>Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe>\n<!-- /wp:html -->", "Venir au Cabinet d\'Orthopédie Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-27 10:48:02", "2021-10-27 08:48:02", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=181", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("182", "1", "2021-10-27 10:49:03", "2021-10-27 08:49:03", "<!-- wp:paragraph -->\n<p>Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<p align=\"center\"><iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe></p>\n<!-- /wp:html -->", "Venir au Cabinet d\'Orthopédie Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-27 10:49:03", "2021-10-27 08:49:03", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=182", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("183", "1", "2021-10-27 10:49:20", "2021-10-27 08:49:20", "<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<p align=\"center\"><iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe></p>\n<!-- /wp:html -->", "Venir au Cabinet d\'Orthopédie Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-27 10:49:20", "2021-10-27 08:49:20", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=183", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("189", "1", "2021-10-27 11:35:15", "2021-10-27 09:35:15", "<!-- wp:paragraph -->\n<p>Crée&nbsp; en aout 1995&nbsp; par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE&nbsp; en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble&nbsp; depuis&nbsp; janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><li>Agréer par la CRAM Rhône-Alpes et la CPAM&nbsp; de Grenoble.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le&nbsp; cabinet vous accueille&nbsp; dans&nbsp; la quiétude et le respect&nbsp; des règles&nbsp; médicales.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Un parking&nbsp; privé&nbsp; est à votre service (rue Gelin : places numérotées 20 - 21).</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Accès&nbsp; par interphone.</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>Le cabinet est aux normes (accessibilité).</li></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2021-10-27 11:35:15", "2021-10-27 09:35:15", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=189", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("192", "1", "2021-10-27 17:24:05", "2021-10-27 15:24:05", "<!-- wp:html -->\n<p align=\"center\">6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"cabinet orthopédie podologie grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->\n\n<!-- wp:paragraph -->\n<p>Bienvenu au cabinet d\'orthopédie et de podologie à Grenoble</p>\n<!-- /wp:paragraph -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-27 17:24:05", "2021-10-27 15:24:05", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=192", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("193", "1", "2021-10-27 17:24:09", "2021-10-27 15:24:09", "<!-- wp:html -->\n<p align=\"center\">6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"cabinet orthopédie podologie grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->\n\n<!-- wp:paragraph -->\n<p>Bienvenue au cabinet d\'orthopédie et de podologie à Grenoble</p>\n<!-- /wp:paragraph -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-27 17:24:09", "2021-10-27 15:24:09", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=193", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("194", "1", "2021-10-27 17:27:17", "2021-10-27 15:27:17", "<!-- wp:html -->\n<p align=\"center\">6 rue ANTHOARD 38000 Grenoble  <a href=\"tel:04.76.00.11.59\" rel=\"nofollow\">- 04.76.00.11.59 -</a> <a href=\"mailto:auberoger.2@orange.fr\"> auberoger.2@orange.fr </a></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":62,\"sizeSlug\":\"full\",\"linkDestination\":\"none\",\"className\":\"is-style-default\"} -->\n<div class=\"wp-block-image is-style-default\"><figure class=\"aligncenter size-full\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\" alt=\"cabinet orthopédie podologie grenoble\" class=\"wp-image-62\" title=\"Cabinet d\'Orthopédie et de Podologie l\'Anthoard à Grenoble\"/></figure></div>\n<!-- /wp:image -->\n\n<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Bienvenue au cabinet d\'orthopédie et de podologie à Grenoble</p>\n<!-- /wp:paragraph -->", "Cabinet d\'Orthopédie de Podologie et de Posturologie l\'Anthoard - Grenoble", "", "inherit", "closed", "closed", "", "8-revision-v1", "", "", "2021-10-27 17:27:17", "2021-10-27 15:27:17", "", "8", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=194", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("198", "1", "2021-10-28 07:30:12", "2021-10-28 05:30:12", "<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<p align=\"center\"><iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe></p>\n<!-- /wp:html -->", "Venir au Cabinet d\'Orthopédie et de Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-28 07:30:12", "2021-10-28 05:30:12", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=198", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("200", "1", "2021-10-28 07:31:42", "2021-10-28 05:31:42", "", "img-podologie-grenoble", "", "inherit", "open", "closed", "", "img-podologie-grenoble", "", "", "2021-10-28 07:31:42", "2021-10-28 05:31:42", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("201", "1", "2021-10-28 07:33:17", "2021-10-28 05:33:17", "<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<p align=\"center\"><iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":200,\"width\":355,\"height\":23,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full is-resized\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png\" alt=\"podologie grenoble\" class=\"wp-image-200\" width=\"355\" height=\"23\" title=\"podologie grenoble\"/></figure></div>\n<!-- /wp:image -->", "Venir au Cabinet d\'Orthopédie et de Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-28 07:33:17", "2021-10-28 05:33:17", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=201", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("202", "1", "2021-10-28 07:36:18", "2021-10-28 05:36:18", "<!-- wp:paragraph {\"align\":\"center\"} -->\n<p class=\"has-text-align-center\">Cabinet de Podologie et d\'Orthopédie 6 Rue ANTHOARD 38000 GRENOBLE</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:html -->\n<p align=\"center\"><iframe src=\"https://www.google.com/maps/embed?pb=!1m18!1m12!1m3!1d2812.0193694601367!2d5.716175260295177!3d45.18670414957318!2m3!1f0!2f0!3f0!3m2!1i1024!2i768!4f13.1!3m3!1m2!1s0x478af482220c923d%3A0x5f0468b80fbd0931!2s6%20Rue%20Anthoard%2C%2038000%20Grenoble!5e0!3m2!1sfr!2sfr!4v1635318998868!5m2!1sfr!2sfr\" style=\"border:0;\" allowfullscreen=\"\" loading=\"lazy\" width=\"600\" height=\"450\"></iframe></p>\n<!-- /wp:html -->\n\n<!-- wp:image {\"align\":\"center\",\"id\":200,\"width\":355,\"height\":23,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<div class=\"wp-block-image\"><figure class=\"aligncenter size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png\" alt=\"podologie grenoble\" class=\"wp-image-200\" width=\"355\" height=\"23\" title=\"podologie grenoble\"/></a></figure></div>\n<!-- /wp:image -->", "Venir au Cabinet d\'Orthopédie et de Podologie à Grenoble", "", "inherit", "closed", "closed", "", "165-revision-v1", "", "", "2021-10-28 07:36:18", "2021-10-28 05:36:18", "", "165", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=202", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("205", "1", "2021-10-28 07:59:13", "2021-10-28 05:59:13", "<!-- wp:heading -->\n<h2>Qui sommes-nous&nbsp;?</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>L’adresse de notre site est&nbsp;: https://www.orthopedie-podologie-anthoard-grenoble.com.</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:heading -->\n<h2>Commentaires</h2>\n<!-- /wp:heading -->\n\n<!-- wp:html -->\n<h2>Définitions</h2>\n                <p><b>Client :</b> tout professionnel ou personne physique capable au sens des articles 1123 et suivants du Code civil, ou personne morale, qui visite le Site objet des présentes conditions générales.<br>\n                <b>Prestations et Services :</b> <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> met à disposition des Clients :</p>\n\n                <p><b>Contenu :</b> Ensemble des éléments constituants l’information présente sur le Site, notamment textes – images – vidéos.</p>\n\n                <p><b>Informations clients :</b> Ci après dénommé « Information (s) » qui correspondent à l’ensemble des données personnelles susceptibles d’être détenues par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> pour la gestion de votre compte, de la gestion de la relation client et à des fins d’analyses et de statistiques.</p>\n\n\n                <p><b>Utilisateur :</b> Internaute se connectant, utilisant le site susnommé.</p>\n                <p><b>Informations personnelles :</b> « Les informations qui permettent, sous quelque forme que ce soit, directement ou non, l\'identification des personnes physiques auxquelles elles s\'appliquent » (article 4 de la loi n° 78-17 du 6 janvier 1978).</p>\n                <p>Les termes « données à caractère personnel », « personne concernée », « sous traitant » et « données sensibles » ont le sens défini par le Règlement Général sur la Protection des Données (RGPD : n° 2016-679)</p>\n\n                <h2>1. Présentation du site internet.</h2>\n                <p>En vertu de l\'article 6 de la loi n° 2004-575 du 21 juin 2004 pour la confiance dans l\'économie numérique, il est précisé aux utilisateurs du site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> l\'identité des différents intervenants dans le cadre de sa réalisation et de son suivi:\n                </p><p><strong>Propriétaire</strong> :   Cabinet d\'orthopédie et de Podologie l\'ANTHOARD   – 6 rue anthoard 38000 GRENOBLE<br>\n                              \n                <strong>Responsable publication</strong> : Aubertin Roger – auberoger.2@orange.fr<br>\n                Le responsable publication est une personne physique ou une personne morale.<br>\n                <strong>Webmaster</strong> : Cabaré Michel – michel@cabare.net<br>\n                <strong>Hébergeur</strong> : ovh – 2 rue Kellermann 59100 Roubaix 1007<br>\n                <strong>Délégué à la protection des données</strong> : Aubertin Roger – auberoger.2@orange.fr<br>\n                </p>\n\n                <div ng-bind-html=\"linkHTML\"><p>Ce modèle de mentions légales est proposé par le <a href=\"https://fr.orson.io/1371/generateur-mentions-legales\" title=\"générateur gratuit de mentions légales pour un site internet\">générateur gratuit de mentions légales pour un site internet</a></p></div>\n\n\n\n                <h2>2. Conditions générales d’utilisation du site et des services proposés.</h2>\n\n                <p>Le Site constitue une œuvre de l’esprit protégée par les dispositions du Code de la Propriété Intellectuelle et des Réglementations Internationales applicables. \n                Le Client ne peut en aucune manière réutiliser, céder ou exploiter pour son propre compte tout ou partie des éléments ou travaux du Site.</p>\n\n                <p>L’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> implique l’acceptation pleine et entière des conditions générales d’utilisation ci-après décrites. Ces conditions d’utilisation sont susceptibles d’être modifiées ou complétées à tout moment, les utilisateurs du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont donc invités à les consulter de manière régulière.</p>\n\n                <p>Ce site internet est normalement accessible à tout moment aux utilisateurs. Une interruption pour raison de maintenance technique peut être toutefois décidée par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, qui s’efforcera alors de communiquer préalablement aux utilisateurs les dates et heures de l’intervention.\n                Le site web <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est mis à jour régulièrement par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> responsable. De la même façon, les mentions légales peuvent être modifiées à tout moment : elles s’imposent néanmoins à l’utilisateur qui est invité à s’y référer le plus souvent possible afin d’en prendre connaissance.</p>\n\n                <h2>3. Description des services fournis.</h2>\n\n                <p>Le site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> a pour objet de fournir une information concernant l’ensemble des activités de la société.\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’efforce de fournir sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> des informations aussi précises que possible. Toutefois, il ne pourra être tenu responsable des oublis, des inexactitudes et des carences dans la mise à jour, qu’elles soient de son fait ou du fait des tiers partenaires qui lui fournissent ces informations.</p>\n\n                <p>Toutes les informations indiquées sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont données à titre indicatif, et sont susceptibles d’évoluer. Par ailleurs, les renseignements figurant sur le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne sont pas exhaustifs. Ils sont donnés sous réserve de modifications ayant été apportées depuis leur mise en ligne.</p>\n\n                <h2>4. Limitations contractuelles sur les données techniques.</h2>\n\n                <p>Le site utilise la technologie JavaScript.\n\n                Le site Internet ne pourra être tenu responsable de dommages matériels liés à l’utilisation du site. De plus, l’utilisateur du site s’engage à accéder au site en utilisant un matériel récent, ne contenant pas de virus et avec un navigateur de dernière génération mis-à-jour\n                Le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est hébergé chez un prestataire sur le territoire de l’Union Européenne conformément aux dispositions du Règlement Général sur la Protection des Données (RGPD : n° 2016-679)</p>\n\n                <p>L’objectif est d’apporter une prestation qui assure le meilleur taux d’accessibilité. L’hébergeur assure la continuité de son service 24 Heures sur 24, tous les jours de l’année. Il se réserve néanmoins la possibilité d’interrompre le service d’hébergement pour les durées les plus courtes possibles notamment à des fins de maintenance, d’amélioration de ses infrastructures, de défaillance de ses infrastructures ou si les Prestations et Services génèrent un trafic réputé anormal.</p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et l’hébergeur ne pourront être tenus responsables en cas de dysfonctionnement du réseau Internet, des lignes téléphoniques ou du matériel informatique et de téléphonie lié notamment à l’encombrement du réseau empêchant l’accès au serveur.</p>\n\n                <h2>5. Propriété intellectuelle et contrefaçons.</h2>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est propriétaire des droits de propriété intellectuelle et détient les droits d’usage sur tous les éléments accessibles sur le site internet, notamment les textes, images, graphismes, logos, vidéos, icônes et sons.\n                Toute reproduction, représentation, modification, publication, adaptation de tout ou partie des éléments du site, quel que soit le moyen ou le procédé utilisé, est interdite, sauf autorisation écrite préalable de : <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.</p>\n\n                <p>Toute exploitation non autorisée du site ou de l’un quelconque des éléments qu’il contient sera considérée comme constitutive d’une contrefaçon et poursuivie conformément aux dispositions des articles L.335-2 et suivants du Code de Propriété Intellectuelle.</p>\n\n                <h2>6. Limitations de responsabilité.</h2>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> agit en tant qu’éditeur du site. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>  est responsable de la qualité et de la véracité du Contenu qu’il publie. </p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne pourra être tenu responsable des dommages directs et indirects causés au matériel de l’utilisateur, lors de l’accès au site internet <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, et résultant soit de l’utilisation d’un matériel ne répondant pas aux spécifications indiquées au point 4, soit de l’apparition d’un bug ou d’une incompatibilité.</p>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne pourra également être tenu responsable des dommages indirects (tels par exemple qu’une perte de marché ou perte d’une chance) consécutifs à l’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.\n                Des espaces interactifs (possibilité de poser des questions dans l’espace contact) sont à la disposition des utilisateurs. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> se réserve le droit de supprimer, sans mise en demeure préalable, tout contenu déposé dans cet espace qui contreviendrait à la législation applicable en France, en particulier aux dispositions relatives à la protection des données. Le cas échéant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> se réserve également la possibilité de mettre en cause la responsabilité civile et/ou pénale de l’utilisateur, notamment en cas de message à caractère raciste, injurieux, diffamant, ou pornographique, quel que soit le support utilisé (texte, photographie …).</p>\n\n                <h2>7. Gestion des données personnelles.</h2>\n\n                <p>Le Client est informé des réglementations concernant la communication marketing, la loi du 21 Juin 2014 pour la confiance dans l’Economie Numérique, la Loi Informatique et Liberté du 06 Août 2004 ainsi que du Règlement Général sur la Protection des Données (RGPD : n° 2016-679). </p>\n\n                <h3>7.1 Responsables de la collecte des données personnelles</h3>\n\n                <p>Pour les Données Personnelles collectées dans le cadre de la création du compte personnel de l’Utilisateur et de sa navigation sur le Site, le responsable du traitement des Données Personnelles est : Cabinet d\'orthopédie et de Podologie l\'ANTHOARD. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>est représenté par Aubertin Roger, son représentant légal</p>\n\n                <p>En tant que responsable du traitement des données qu’il collecte, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à respecter le cadre des dispositions légales en vigueur. Il lui appartient notamment au Client d’établir les finalités de ses traitements de données, de fournir à ses prospects et clients, à partir de la collecte de leurs consentements, une information complète sur le traitement de leurs données personnelles et de maintenir un registre des traitements conforme à la réalité.\n                Chaque fois que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> traite des Données Personnelles, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> prend toutes les mesures raisonnables pour s’assurer de l’exactitude et de la pertinence des Données Personnelles au regard des finalités pour lesquelles <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> les traite.</p>\n                 \n                <h3>7.2 Finalité des données collectées</h3>\n                 \n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est susceptible de traiter tout ou partie des données : </p>\n\n                <ul>\n                  \n                <li>pour permettre la navigation sur le Site et la gestion et la traçabilité des prestations et services commandés par l’utilisateur : données de connexion et d’utilisation du Site, facturation, historique des commandes, etc. </li>\n                 \n                <li>pour prévenir et lutter contre la fraude informatique (spamming, hacking…) : matériel informatique utilisé pour la navigation, l’adresse IP, le mot de passe (hashé) </li>\n                 \n                <li>pour améliorer la navigation sur le Site : données de connexion et d’utilisation </li>\n                 \n                <li>pour mener des enquêtes de satisfaction facultatives sur <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> : adresse email </li>\n                <li>pour mener des campagnes de communication (sms, mail) : numéro de téléphone, adresse email</li>\n\n\n                </ul>\n\n                <p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne commercialise pas vos données personnelles qui sont donc uniquement utilisées par nécessité ou à des fins statistiques et d’analyses.</p>\n                 \n                <h3>7.3 Droit d’accès, de rectification et d’opposition</h3>\n                 \n                <p>\n                Conformément à la réglementation européenne en vigueur, les Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> disposent des droits suivants : </p>\n                 <ul>\n\n                <li>droit d\'accès (article 15 RGPD) et de rectification (article 16 RGPD), de mise à jour, de complétude des données des Utilisateurs droit de verrouillage ou d’effacement des données des Utilisateurs à caractère personnel (article 17 du RGPD), lorsqu’elles sont inexactes, incomplètes, équivoques, périmées, ou dont la collecte, l\'utilisation, la communication ou la conservation est interdite </li>\n                 \n                <li>droit de retirer à tout moment un consentement (article 13-2c RGPD) </li>\n                 \n                <li>droit à la limitation du traitement des données des Utilisateurs (article 18 RGPD) </li>\n                 \n                <li>droit d’opposition au traitement des données des Utilisateurs (article 21 RGPD) </li>\n                 \n                <li>droit à la portabilité des données que les Utilisateurs auront fournies, lorsque ces données font l’objet de traitements automatisés fondés sur leur consentement ou sur un contrat (article 20 RGPD) </li>\n                 \n                <li>droit de définir le sort des données des Utilisateurs après leur mort et de choisir à qui <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> devra communiquer (ou non) ses données à un tiers qu’ils aura préalablement désigné</li>\n                 </ul>\n\n                <p>Dès que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> a connaissance du décès d’un Utilisateur et à défaut d’instructions de sa part, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à détruire ses données, sauf si leur conservation s’avère nécessaire à des fins probatoires ou pour répondre à une obligation légale.</p>\n                 \n                <p>Si l’Utilisateur souhaite savoir comment <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> utilise ses Données Personnelles, demander à les rectifier ou s’oppose à leur traitement, l’Utilisateur peut contacter <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> par écrit à l’adresse suivante : </p>\n                 \n                Cabinet d\'orthopédie et de Podologie l\'ANTHOARD – DPO, Aubertin Roger <br>\n                6 rue anthoard 38000 GRENOBLE.\n                 \n                <p>Dans ce cas, l’Utilisateur doit indiquer les Données Personnelles qu’il souhaiterait que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> corrige, mette à jour ou supprime, en s’identifiant précisément avec une copie d’une pièce d’identité (carte d’identité ou passeport). </p>\n\n                <p>\n                Les demandes de suppression de Données Personnelles seront soumises aux obligations qui sont imposées à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> par la loi, notamment en matière de conservation ou d’archivage des documents. Enfin, les Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> peuvent déposer une réclamation auprès des autorités de contrôle, et notamment de la CNIL (https://www.cnil.fr/fr/plaintes).</p>\n                 \n                <h3>7.4 Non-communication des données personnelles</h3>\n\n                <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’interdit de traiter, héberger ou transférer les Informations collectées sur ses Clients vers un pays situé en dehors de l’Union européenne ou reconnu comme « non adéquat » par la Commission européenne sans en informer préalablement le client. Pour autant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> reste libre du choix de ses sous-traitants techniques et commerciaux à la condition qu’il présentent les garanties suffisantes au regard des exigences du Règlement Général sur la Protection des Données (RGPD : n° 2016-679).</p>\n\n                <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> s’engage à prendre toutes les précautions nécessaires afin de préserver la sécurité des Informations et notamment qu’elles ne soient pas communiquées à des personnes non autorisées. Cependant, si un incident impactant l’intégrité ou la confidentialité des Informations du Client est portée à la connaissance de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, celle-ci devra dans les meilleurs délais informer le Client et lui communiquer les mesures de corrections prises. Par ailleurs <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ne collecte aucune « données sensibles ».</p>\n\n                <p>\n                Les Données Personnelles de l’Utilisateur peuvent être traitées par des filiales de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et des sous-traitants (prestataires de services), exclusivement afin de réaliser les finalités de la présente politique.</p>\n                <p>\n                Dans la limite de leurs attributions respectives et pour les finalités rappelées ci-dessus, les principales personnes susceptibles d’avoir accès aux données des Utilisateurs de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> sont principalement les agents de notre service client.</p>\n                \n                <div ng-bind-html=\"rgpdHTML\"><h3>7.5 Types de données collectées</h3><p>Concernant les utilisateurs d’un Site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, nous collectons les données suivantes qui sont indispensables au fonctionnement du service&nbsp;, et qui seront conservées pendant une période maximale de 0 mois après la fin de la relation contractuelle:<br>Aucunes</p><p><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> collecte en outre des informations qui permettent d’améliorer l’expérience utilisateur et de proposer des conseils contextualisés&nbsp;:<br>Aucunes</p><p> Ces &nbsp;données sont conservées pour une période maximale de 0 mois après la fin de la relation contractuelle</p></div>\n\n\n                <h2>8. Notification d’incident</h2>\n                <p>\n                Quels que soient les efforts fournis, aucune méthode de transmission sur Internet et aucune méthode de stockage électronique n\'est complètement sûre. Nous ne pouvons en conséquence pas garantir une sécurité absolue. \n                Si nous prenions connaissance d\'une brèche de la sécurité, nous avertirions les utilisateurs concernés afin qu\'ils puissent prendre les mesures appropriées. Nos procédures de notification d’incident tiennent compte de nos obligations légales, qu\'elles se situent au niveau national ou européen. Nous nous engageons à informer pleinement nos clients de toutes les questions relevant de la sécurité de leur compte et à leur fournir toutes les informations nécessaires pour les aider à respecter leurs propres obligations réglementaires en matière de reporting.</p>\n                <p>\n                Aucune information personnelle de l\'utilisateur du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> n\'est publiée à l\'insu de l\'utilisateur, échangée, transférée, cédée ou vendue sur un support quelconque à des tiers. Seule l\'hypothèse du rachat de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> et de ses droits permettrait la transmission des dites informations à l\'éventuel acquéreur qui serait à son tour tenu de la même obligation de conservation et de modification des données vis à vis de l\'utilisateur du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>.</p>\n\n                <h3>Sécurité</h3>\n\n                <p>\n                Pour assurer la sécurité et la confidentialité des Données Personnelles et des Données Personnelles de Santé, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> utilise des réseaux protégés par des dispositifs standards tels que par pare-feu, la pseudonymisation, l’encryption et mot de passe. </p>\n                 \n                <p>\n                Lors du traitement des Données Personnelles, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>prend toutes les mesures raisonnables visant à les protéger contre toute perte, utilisation détournée, accès non autorisé, divulgation, altération ou destruction.</p>\n                 \n                <h2>9. Liens hypertextes « cookies » et balises (“tags”) internet</h2>\n                <p>\n                Le site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> contient un certain nombre de liens hypertextes vers d’autres sites, mis en place avec l’autorisation de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>. Cependant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> n’a pas la possibilité de vérifier le contenu des sites ainsi visités, et n’assumera en conséquence aucune responsabilité de ce fait.</p>\n                Sauf si vous décidez de désactiver les cookies, vous acceptez que le site puisse les utiliser. Vous pouvez à tout moment désactiver ces cookies et ce gratuitement à partir des possibilités de désactivation qui vous sont offertes et rappelées ci-après, sachant que cela peut réduire ou empêcher l’accessibilité à tout ou partie des Services proposés par le site.\n                <p></p>\n\n                <h3>9.1. « COOKIES »</h3>\n                 <p>\n                Un « cookie » est un petit fichier d’information envoyé sur le navigateur de l’Utilisateur et enregistré au sein du terminal de l’Utilisateur (ex : ordinateur, smartphone), (ci-après « Cookies »). Ce fichier comprend des informations telles que le nom de domaine de l’Utilisateur, le fournisseur d’accès Internet de l’Utilisateur, le système d’exploitation de l’Utilisateur, ainsi que la date et l’heure d’accès. Les Cookies ne risquent en aucun cas d’endommager le terminal de l’Utilisateur.</p>\n                 <p>\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est susceptible de traiter les informations de l’Utilisateur concernant sa visite du Site, telles que les pages consultées, les recherches effectuées. Ces informations permettent à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’améliorer le contenu du Site, de la navigation de l’Utilisateur.</p>\n                 <p>\n                Les Cookies facilitant la navigation et/ou la fourniture des services proposés par le Site, l’Utilisateur peut configurer son navigateur pour qu’il lui permette de décider s’il souhaite ou non les accepter de manière à ce que des Cookies soient enregistrés dans le terminal ou, au contraire, qu’ils soient rejetés, soit systématiquement, soit selon leur émetteur. L’Utilisateur peut également configurer son logiciel de navigation de manière à ce que l’acceptation ou le refus des Cookies lui soient proposés ponctuellement, avant qu’un Cookie soit susceptible d’être enregistré dans son terminal. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> informe l’Utilisateur que, dans ce cas, il se peut que les fonctionnalités de son logiciel de navigation ne soient pas toutes disponibles.</p>\n                 <p>\n                Si l’Utilisateur refuse l’enregistrement de Cookies dans son terminal ou son navigateur, ou si l’Utilisateur supprime ceux qui y sont enregistrés, l’Utilisateur est informé que sa navigation et son expérience sur le Site peuvent être limitées. Cela pourrait également être le cas lorsque <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ou l’un de ses prestataires ne peut pas reconnaître, à des fins de compatibilité technique, le type de navigateur utilisé par le terminal, les paramètres de langue et d’affichage ou le pays depuis lequel le terminal semble connecté à Internet.</p>\n                 <p>\n                Le cas échéant, <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> décline toute responsabilité pour les conséquences liées au fonctionnement dégradé du Site et des services éventuellement proposés par <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, résultant (i) du refus de Cookies par l’Utilisateur (ii) de l’impossibilité pour <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’enregistrer ou de consulter les Cookies nécessaires à leur fonctionnement du fait du choix de l’Utilisateur. Pour la gestion des Cookies et des choix de l’Utilisateur, la configuration de chaque navigateur est différente. Elle est décrite dans le menu d’aide du navigateur, qui permettra de savoir de quelle manière l’Utilisateur peut modifier ses souhaits en matière de Cookies.</p>\n                 <p>\n                À tout moment, l’Utilisateur peut faire le choix d’exprimer et de modifier ses souhaits en matière de Cookies. <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> pourra en outre faire appel aux services de prestataires externes pour l’aider à recueillir et traiter les informations décrites dans cette section.</p>\n                 <p>\n                Enfin, en cliquant sur les icônes dédiées aux réseaux sociaux Twitter, Facebook, Linkedin et Google Plus figurant sur le Site de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> ou dans son application mobile et si l’Utilisateur a accepté le dépôt de cookies en poursuivant sa navigation sur le Site Internet ou l’application mobile de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, Twitter, Facebook, Linkedin et Google Plus peuvent également déposer des cookies sur vos terminaux (ordinateur, tablette, téléphone portable).</p>\n                 <p>\n                Ces types de cookies ne sont déposés sur vos terminaux qu’à condition que vous y consentiez, en continuant votre navigation sur le Site Internet ou l’application mobile de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>. À tout moment, l’Utilisateur peut néanmoins revenir sur son consentement à ce que <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> dépose ce type de cookies.</p>\n                 \n                <h3>Article 9.2. BALISES (“TAGS”) INTERNET</h3>\n                 \n\n                <p>\n\n                <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> peut employer occasionnellement des balises Internet (également appelées « tags », ou balises d’action, GIF à un pixel, GIF transparents, GIF invisibles et GIF un à un) et les déployer par l’intermédiaire d’un partenaire spécialiste d’analyses Web susceptible de se trouver (et donc de stocker les informations correspondantes, y compris l’adresse IP de l’Utilisateur) dans un pays étranger.</p>\n                 \n                <p>\n                Ces balises sont placées à la fois dans les publicités en ligne permettant aux internautes d’accéder au Site, et sur les différentes pages de celui-ci. \n                 </p>\n                <p>\n                Cette technologie permet à <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> d’évaluer les réponses des visiteurs face au Site et l’efficacité de ses actions (par exemple, le nombre de fois où une page est ouverte et les informations consultées), ainsi que l’utilisation de ce Site par l’Utilisateur. </p>\n                 <p>\n                Le prestataire externe pourra éventuellement recueillir des informations sur les visiteurs du Site et d’autres sites Internet grâce à ces balises, constituer des rapports sur l’activité du Site à l’attention de <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a>, et fournir d’autres services relatifs à l’utilisation de celui-ci et d’Internet.</p>\n                 <p>\n                </p><h2>10. Droit applicable et attribution de juridiction.</h2>  \n                 <p>\n                Tout litige en relation avec l’utilisation du site <a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\">https://www.orthopedie-podologie-anthoard-grenoble.com/</a> est soumis au droit français. \n                En dehors des cas où la loi ne le permet pas, il est fait attribution exclusive de juridiction aux tribunaux compétents de Grenoble</p>\n<!-- /wp:html -->", "Mentions Légales - Politique de confidentialité", "", "inherit", "closed", "closed", "", "3-revision-v1", "", "", "2021-10-28 07:59:13", "2021-10-28 05:59:13", "", "3", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=205", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("207", "1", "2021-10-28 08:03:26", "2021-10-28 06:03:26", "", "img-orthesiste-grenoble", "", "inherit", "open", "closed", "", "img-orthesiste-grenoble", "", "", "2021-10-28 08:03:26", "2021-10-28 06:03:26", "", "52", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("208", "1", "2021-10-28 08:04:05", "2021-10-28 06:04:05", "<!-- wp:list -->\n<ul><li>Course à Pied</li><li>Football</li><li>Cyclisme</li><li>Rugby</li><li>Handball</li><li>Basketball</li><li>Tennis</li><li>Randonnée</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":207,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png\" alt=\"orthesiste grenoble\" class=\"wp-image-207\" width=\"532\" height=\"35\" title=\"orthesiste grenoble\"/></figure>\n<!-- /wp:image -->", "Orthèses Sportives", "", "inherit", "closed", "closed", "", "52-revision-v1", "", "", "2021-10-28 08:04:05", "2021-10-28 06:04:05", "", "52", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=208", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("209", "1", "2021-10-28 08:05:02", "2021-10-28 06:05:02", "<!-- wp:list -->\n<ul><li>Course à Pied</li><li>Football</li><li>Cyclisme</li><li>Rugby</li><li>Handball</li><li>Basketball</li><li>Tennis</li><li>Randonnée</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":207,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png\" alt=\"orthesiste grenoble\" class=\"wp-image-207\" width=\"532\" height=\"35\" title=\"orthesiste grenoble\"/></a></figure>\n<!-- /wp:image -->", "Orthèses Sportives", "", "inherit", "closed", "closed", "", "52-revision-v1", "", "", "2021-10-28 08:05:02", "2021-10-28 06:05:02", "", "52", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=209", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("211", "1", "2021-10-28 08:09:50", "2021-10-28 06:09:50", "", "img-orthopedie-podologie-grenoble", "", "inherit", "open", "closed", "", "img-orthopedie-podologie-grenoble", "", "", "2021-10-28 08:09:50", "2021-10-28 06:09:50", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("212", "1", "2021-10-28 08:10:39", "2021-10-28 06:10:39", "<!-- wp:list -->\n<ul><li>La principale activité&nbsp; est la&nbsp; réalisation d’orthèse plantaire&nbsp; sur mesure (semelle orthopédique) remboursé par la CPAM et les mutuelles santé . </li></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proprioceptives dynamiques étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux (œil –oreille – atm) , étude complétée par un bilan radiologique ciblé sur la pathologie. </li><li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformée en contre pesanteur).</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":211,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png\" alt=\"orthopedie podologie grenoble\" class=\"wp-image-211\" width=\"532\" height=\"35\" title=\"orthopedie podologie grenoble\"/></a></figure>\n<!-- /wp:image -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2021-10-28 08:10:39", "2021-10-28 06:10:39", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=212", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("214", "1", "2021-10-28 08:13:48", "2021-10-28 06:13:48", "", "img-orthopedie-grenoble", "", "inherit", "open", "closed", "", "img-orthopedie-grenoble", "", "", "2021-10-28 08:13:48", "2021-10-28 06:13:48", "", "48", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("215", "1", "2021-10-28 08:14:31", "2021-10-28 06:14:31", "<!-- wp:list -->\n<ul><li>douleurs plantaires (ménopause , marche intense)</li><li>épine calcanéenne</li><li>aponévrose plantaire</li><li>hallux valgus / hallux rigidus (pré-post opératoire)</li><li>névrome  de Morton</li><li>inflammation du tendon d\'Achille</li><li>ténosynovite tibiale et fibulaire</li><li>maladie de Sever</li><li>séquelle traumatique après accident</li><li>traumatologie  pied / cheville</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":214,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png\" alt=\"orthopedie grenoble\" class=\"wp-image-214\" width=\"532\" height=\"35\" title=\"orthopedie grenoble\"/></a></figure>\n<!-- /wp:image -->", "Pathologies du Pied", "", "inherit", "closed", "closed", "", "48-revision-v1", "", "", "2021-10-28 08:14:31", "2021-10-28 06:14:31", "", "48", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=215", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("217", "1", "2021-10-28 08:17:27", "2021-10-28 06:17:27", "", "img-podologiste-grenoble", "", "inherit", "open", "closed", "", "img-podologiste-grenoble", "", "", "2021-10-28 08:17:27", "2021-10-28 06:17:27", "", "50", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", "0", "attachment", "image/png", "0");
INSERT INTO `wp_posts` VALUES("218", "1", "2021-10-28 08:18:09", "2021-10-28 06:18:09", "<!-- wp:list -->\n<ul><li>maladie de croissance de l’ adolescence</li><li>douleurs de genoux ( axe / suite prothèse)</li><li>déséquilibre du bassin</li><li>lombalgie  / dorsalgie / cervicalgie</li><li>anomalie vertébrale / scoliose</li><li>troubles positionnels</li><li>troubles de la proprioception (équilibre)</li><li>vertiges</li></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":217,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png\" alt=\"podologiste grenoble\" class=\"wp-image-217\" width=\"532\" height=\"35\" title=\"podologiste grenoble\"/></a></figure>\n<!-- /wp:image -->", "Pathologies Posturales", "", "inherit", "closed", "closed", "", "50-revision-v1", "", "", "2021-10-28 08:18:09", "2021-10-28 06:18:09", "", "50", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=218", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("220", "1", "2022-12-09 13:48:29", "2022-12-09 12:48:29", "<!-- wp:heading -->\n<h2>Prestation remboursée par la CPAM</h2>\n<!-- /wp:heading -->\n\n<!-- wp:paragraph -->\n<p>Avec ordonnance médicale, comprenant la consultation, la fabrication, l\'essayage et le suivit du traitement :</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>170,00 Euros pour les adultes</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>150,00 euros pour les enfants</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>CMU et AT par convention de la CPAM</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:heading -->\n<h2>Prestation remboursée par les mutuelles santé (mais non pas la CPAM)</h2>\n<!-- /wp:heading -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>50,00 Euros la Consultation avec Bilan Podologique</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>50,00 Euros la Consultation en traumatologie</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->", "Tarifs en Orthopédie et Podologie", "", "inherit", "closed", "closed", "", "24-revision-v1", "", "", "2022-12-09 13:48:29", "2022-12-09 12:48:29", "", "24", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=220", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("222", "1", "2022-12-09 13:51:10", "2022-12-09 12:51:10", "<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>La principale activité  est la  réalisation d’orthèse plantaire  sur mesure (semelle orthopédique) remboursée par la CPAM et les mutuelles santé . </li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proproceptive dynamique étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux (œil –oreille – atm) , étude complétée par un bilan radiologique ciblé sur la pathologie. </li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformée en contre pesanteur).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":211,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png\" alt=\"orthopedie podologie grenoble\" class=\"wp-image-211\" width=\"532\" height=\"35\" title=\"orthopedie podologie grenoble\"/></a></figure>\n<!-- /wp:image -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2022-12-09 13:51:10", "2022-12-09 12:51:10", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=222", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("223", "1", "2022-12-09 13:51:35", "2022-12-09 12:51:35", "<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>La principale activité  est la  réalisation d’orthèse plantaire  sur mesure (semelle orthopédique) remboursée par la CPAM et les mutuelles santé . </li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>La technique du double thermoformage  est au cœur de la réalisation des orthèses plantaires  thermoformées . Le moulage en charge proproceptive dynamique étant une spécialité du cabinet. Ce moulage est lié a une étude podologique, podométrique  et posturale  par testing neuromusculaire  et autres  tests posturaux (œil –oreille – atm) , étude complétée par un bilan radiologique ciblé sur la pathologie. </li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>Les orthèses sont réalisées sur une machine type physioforme ( machine à thermoformer en contre pesanteur).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":211,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png\" alt=\"orthopedie podologie grenoble\" class=\"wp-image-211\" width=\"532\" height=\"35\" title=\"orthopedie podologie grenoble\"/></a></figure>\n<!-- /wp:image -->", "Prestations du Cabinet d\'Orthopédie et de Podologie", "", "inherit", "closed", "closed", "", "21-revision-v1", "", "", "2022-12-09 13:51:35", "2022-12-09 12:51:35", "", "21", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=223", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("224", "1", "2022-12-09 13:53:26", "2022-12-09 12:53:26", "<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>maladie de croissance de l’ adolescence</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>maladie de croissance \"Osggod-Schlatter\"</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>douleurs de genoux ( axe / suite prothèse)</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>déséquilibre du bassin</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>lombalgie&nbsp; / dorsalgie / cervicalgie</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>anomalie vertébrale / scoliose</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>troubles positionnels</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>troubles de la proprioception (équilibre)</li>\n<!-- /wp:list-item -->\n\n<!-- wp:list-item -->\n<li>vertiges</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:image {\"id\":217,\"width\":532,\"height\":35,\"sizeSlug\":\"full\",\"linkDestination\":\"custom\"} -->\n<figure class=\"wp-block-image size-full is-resized\"><a href=\"https://www.orthopedie-podologie-anthoard-grenoble.com/\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png\" alt=\"podologiste grenoble\" class=\"wp-image-217\" width=\"532\" height=\"35\" title=\"podologiste grenoble\"/></a></figure>\n<!-- /wp:image -->", "Pathologies Posturales", "", "inherit", "closed", "closed", "", "50-revision-v1", "", "", "2022-12-09 13:53:26", "2022-12-09 12:53:26", "", "50", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=224", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("225", "1", "2022-12-09 13:54:39", "2022-12-09 12:54:39", "<!-- wp:paragraph -->\n<p>Crée&nbsp; en aout 1995&nbsp; par monsieur AUBERTIN ROGER diplômé de l’ école ECOTEV de VIENNE&nbsp; en novembre 1993 , le cabinet s’est installé au 6 rue anthoard à Grenoble&nbsp; depuis&nbsp; janvier 2006 .</p>\n<!-- /wp:paragraph -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Agrée par la CRAM Rhône-Alpes et la CPAM  de Grenoble.</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Le&nbsp; cabinet vous accueille&nbsp; dans&nbsp; la quiétude et le respect&nbsp; des règles&nbsp; médicales.</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Un parking&nbsp; privé&nbsp; est à votre service (rue Gelin : places numérotées 20 - 21).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Accès&nbsp; par interphone.</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->\n\n<!-- wp:list -->\n<ul><!-- wp:list-item -->\n<li>Le cabinet est aux normes (accessibilité).</li>\n<!-- /wp:list-item --></ul>\n<!-- /wp:list -->", "Histoire du Cabinet d\'orthopedie et de Podologie l\'Anthoard", "", "inherit", "closed", "closed", "", "19-revision-v1", "", "", "2022-12-09 13:54:39", "2022-12-09 12:54:39", "", "19", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=225", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("227", "1", "2023-01-19 05:06:57", "0000-00-00 00:00:00", "", "Brouillon auto", "", "auto-draft", "open", "open", "", "", "", "", "2023-01-19 05:06:57", "0000-00-00 00:00:00", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=227", "0", "post", "", "0");
INSERT INTO `wp_posts` VALUES("228", "1", "2023-01-19 05:10:40", "2023-01-19 04:10:40", "", "Physioforme", "Physioforme vue globale", "inherit", "open", "closed", "", "physioforme", "", "", "2023-01-19 05:11:41", "2023-01-19 04:11:41", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("230", "1", "2023-01-19 05:14:28", "2023-01-19 04:14:28", "<!-- wp:gallery {\"linkTo\":\"none\",\"advgbBlockControls\":[]} -->\n<figure class=\"wp-block-gallery has-nested-images columns-default is-cropped\"><!-- wp:image {\"id\":151,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\" alt=\"6 Rue ANTHOARD 38000 Grenoble\" class=\"wp-image-151\"/><figcaption class=\"wp-element-caption\">Arrivée 6 Rue ANTHOARD</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":153,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\" alt=\"Entrée 6 rue ANTHOARD 38000 Grenoble\" class=\"wp-image-153\"/><figcaption class=\"wp-element-caption\">Entrée 6 rue ANTHOARD 38000 Grenoble</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":154,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\" alt=\"Salle d\'attente cabinet\" class=\"wp-image-154\"/><figcaption class=\"wp-element-caption\">Salle d\'attente</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":150,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\" alt=\"Couloir accès cabinet\" class=\"wp-image-150\"/><figcaption class=\"wp-element-caption\">Couloir accès cabinet</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":155,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\" alt=\"Cabinet Podologie\" class=\"wp-image-155\"/><figcaption class=\"wp-element-caption\">Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":156,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\" alt=\"Cabinet Orthopedie\" class=\"wp-image-156\"/><figcaption class=\"wp-element-caption\">Cabinet Orthopedie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":152,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\" alt=\"Machine Physioforme\" class=\"wp-image-152\"/><figcaption class=\"wp-element-caption\">Machine Physioforme</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":149,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\" alt=\"Atelier Cabinet Podologie\" class=\"wp-image-149\"/><figcaption class=\"wp-element-caption\">Atelier Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":228,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-1024x768.jpg\" alt=\"Physioforme vue globale\" class=\"wp-image-228\"/><figcaption class=\"wp-element-caption\">Physioforme vue globale</figcaption></figure>\n<!-- /wp:image --><figcaption class=\"blocks-gallery-caption wp-element-caption\">Le Cabinet de Podologie l\'Anthoard à Grenoble en Images !</figcaption></figure>\n<!-- /wp:gallery -->", "Cabinet Orthopédie Podologie l\'ANTHOARD en images", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2023-01-19 05:14:28", "2023-01-19 04:14:28", "", "28", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=230", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("231", "1", "2023-01-19 05:15:00", "2023-01-19 04:15:00", "", "orthese plantaire", "orthèse plantaire", "inherit", "open", "closed", "", "orthese-plantaire", "", "", "2023-01-19 05:16:13", "2023-01-19 04:16:13", "", "0", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire.jpg", "0", "attachment", "image/jpeg", "0");
INSERT INTO `wp_posts` VALUES("232", "1", "2023-01-19 05:17:05", "2023-01-19 04:17:05", "<!-- wp:gallery {\"linkTo\":\"none\",\"advgbBlockControls\":[]} -->\n<figure class=\"wp-block-gallery has-nested-images columns-default is-cropped\"><!-- wp:image {\"id\":151,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\" alt=\"6 Rue ANTHOARD 38000 Grenoble\" class=\"wp-image-151\"/><figcaption class=\"wp-element-caption\">Arrivée 6 Rue ANTHOARD</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":153,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\" alt=\"Entrée 6 rue ANTHOARD 38000 Grenoble\" class=\"wp-image-153\"/><figcaption class=\"wp-element-caption\">Entrée 6 rue ANTHOARD 38000 Grenoble</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":154,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\" alt=\"Salle d\'attente cabinet\" class=\"wp-image-154\"/><figcaption class=\"wp-element-caption\">Salle d\'attente</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":150,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\" alt=\"Couloir accès cabinet\" class=\"wp-image-150\"/><figcaption class=\"wp-element-caption\">Couloir accès cabinet</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":155,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\" alt=\"Cabinet Podologie\" class=\"wp-image-155\"/><figcaption class=\"wp-element-caption\">Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":156,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\" alt=\"Cabinet Orthopedie\" class=\"wp-image-156\"/><figcaption class=\"wp-element-caption\">Cabinet Orthopedie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":152,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\" alt=\"Machine Physioforme\" class=\"wp-image-152\"/><figcaption class=\"wp-element-caption\">Machine Physioforme</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":149,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\" alt=\"Atelier Cabinet Podologie\" class=\"wp-image-149\"/><figcaption class=\"wp-element-caption\">Atelier Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":228,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-1024x768.jpg\" alt=\"Physioforme vue globale\" class=\"wp-image-228\"/><figcaption class=\"wp-element-caption\">Physioforme vue globale</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":231,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-1024x768.jpg\" alt=\"orthèse plantaire\" class=\"wp-image-231\"/><figcaption class=\"wp-element-caption\">orthèse plantaire</figcaption></figure>\n<!-- /wp:image --><figcaption class=\"blocks-gallery-caption wp-element-caption\">Le Cabinet de Podologie l\'Anthoard à Grenoble en Images !</figcaption></figure>\n<!-- /wp:gallery -->", "Cabinet Orthopédie Podologie l\'ANTHOARD en images", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2023-01-19 05:17:05", "2023-01-19 04:17:05", "", "28", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=232", "0", "revision", "", "0");
INSERT INTO `wp_posts` VALUES("233", "1", "2023-01-19 05:18:20", "2023-01-19 04:18:20", "<!-- wp:gallery {\"linkTo\":\"none\",\"advgbBlockControls\":[]} -->\n<figure class=\"wp-block-gallery has-nested-images columns-default is-cropped\"><!-- wp:image {\"id\":151,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\" alt=\"6 Rue ANTHOARD 38000 Grenoble\" class=\"wp-image-151\"/><figcaption class=\"wp-element-caption\">Arrivée 6 Rue ANTHOARD</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":153,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\" alt=\"Entrée 6 rue ANTHOARD 38000 Grenoble\" class=\"wp-image-153\"/><figcaption class=\"wp-element-caption\">Entrée 6 rue ANTHOARD 38000 Grenoble</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":154,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\" alt=\"Salle d\'attente cabinet\" class=\"wp-image-154\"/><figcaption class=\"wp-element-caption\">Salle d\'attente</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":150,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\" alt=\"Couloir accès cabinet\" class=\"wp-image-150\"/><figcaption class=\"wp-element-caption\">Couloir accès cabinet</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":155,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\" alt=\"Cabinet Podologie\" class=\"wp-image-155\"/><figcaption class=\"wp-element-caption\">Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":156,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\" alt=\"Cabinet Orthopedie\" class=\"wp-image-156\"/><figcaption class=\"wp-element-caption\">Cabinet Orthopedie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":152,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\" alt=\"Machine Physioforme\" class=\"wp-image-152\"/><figcaption class=\"wp-element-caption\">Machine Physioforme</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":149,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\" alt=\"Atelier Cabinet Podologie\" class=\"wp-image-149\"/><figcaption class=\"wp-element-caption\">Atelier Cabinet Podologie</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":231,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-1024x768.jpg\" alt=\"orthèse plantaire\" class=\"wp-image-231\"/><figcaption class=\"wp-element-caption\">orthèse plantaire</figcaption></figure>\n<!-- /wp:image -->\n\n<!-- wp:image {\"id\":228,\"sizeSlug\":\"large\",\"linkDestination\":\"none\"} -->\n<figure class=\"wp-block-image size-large\"><img src=\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-1024x768.jpg\" alt=\"Physioforme vue globale\" class=\"wp-image-228\"/><figcaption class=\"wp-element-caption\">Physioforme vue globale</figcaption></figure>\n<!-- /wp:image --><figcaption class=\"blocks-gallery-caption wp-element-caption\">Le Cabinet de Podologie l\'Anthoard à Grenoble en Images !</figcaption></figure>\n<!-- /wp:gallery -->", "Cabinet Orthopédie Podologie l\'ANTHOARD en images", "", "inherit", "closed", "closed", "", "28-revision-v1", "", "", "2023-01-19 05:18:20", "2023-01-19 04:18:20", "", "28", "https://www.orthopedie-podologie-anthoard-grenoble.com/?p=233", "0", "revision", "", "0");

/* INSERT TABLE DATA: wp_term_relationships */
INSERT INTO `wp_term_relationships` VALUES("31", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("32", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("33", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("34", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("36", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("37", "3", "0");
INSERT INTO `wp_term_relationships` VALUES("54", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("55", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("56", "4", "0");
INSERT INTO `wp_term_relationships` VALUES("58", "5", "0");
INSERT INTO `wp_term_relationships` VALUES("169", "2", "0");
INSERT INTO `wp_term_relationships` VALUES("176", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("177", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("178", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("179", "6", "0");
INSERT INTO `wp_term_relationships` VALUES("180", "6", "0");

/* INSERT TABLE DATA: wp_term_taxonomy */
INSERT INTO `wp_term_taxonomy` VALUES("1", "1", "category", "", "0", "0");
INSERT INTO `wp_term_taxonomy` VALUES("2", "2", "nav_menu", "", "0", "5");
INSERT INTO `wp_term_taxonomy` VALUES("3", "3", "nav_menu", "", "0", "2");
INSERT INTO `wp_term_taxonomy` VALUES("4", "4", "nav_menu", "", "0", "3");
INSERT INTO `wp_term_taxonomy` VALUES("5", "5", "nav_menu", "", "0", "1");
INSERT INTO `wp_term_taxonomy` VALUES("6", "6", "nav_menu", "", "0", "5");

/* INSERT TABLE DATA: wp_terms */
INSERT INTO `wp_terms` VALUES("1", "Non classé", "non-classe", "0");
INSERT INTO `wp_terms` VALUES("2", "Menu-fonctionnel-base", "menu-fonctionnel-base", "0");
INSERT INTO `wp_terms` VALUES("3", "Menu-histoire-images", "menu-histoire-images", "0");
INSERT INTO `wp_terms` VALUES("4", "Menu-pathologies", "menu-pathologies", "0");
INSERT INTO `wp_terms` VALUES("5", "Menu-mentions légales -rgpd", "menu-mentions-legales-rgpd", "0");
INSERT INTO `wp_terms` VALUES("6", "Menu-Mobile", "menu-mobile", "0");

/* INSERT TABLE DATA: wp_usermeta */
INSERT INTO `wp_usermeta` VALUES("1", "1", "nickname", "Admin-site-wp");
INSERT INTO `wp_usermeta` VALUES("2", "1", "first_name", "");
INSERT INTO `wp_usermeta` VALUES("3", "1", "last_name", "");
INSERT INTO `wp_usermeta` VALUES("4", "1", "description", "");
INSERT INTO `wp_usermeta` VALUES("5", "1", "rich_editing", "true");
INSERT INTO `wp_usermeta` VALUES("6", "1", "syntax_highlighting", "true");
INSERT INTO `wp_usermeta` VALUES("7", "1", "comment_shortcuts", "false");
INSERT INTO `wp_usermeta` VALUES("8", "1", "admin_color", "fresh");
INSERT INTO `wp_usermeta` VALUES("9", "1", "use_ssl", "0");
INSERT INTO `wp_usermeta` VALUES("10", "1", "show_admin_bar_front", "true");
INSERT INTO `wp_usermeta` VALUES("11", "1", "locale", "");
INSERT INTO `wp_usermeta` VALUES("12", "1", "wp_capabilities", "a:1:{s:13:\"administrator\";b:1;}");
INSERT INTO `wp_usermeta` VALUES("13", "1", "wp_user_level", "10");
INSERT INTO `wp_usermeta` VALUES("14", "1", "dismissed_wp_pointers", "");
INSERT INTO `wp_usermeta` VALUES("15", "1", "show_welcome_panel", "0");
INSERT INTO `wp_usermeta` VALUES("16", "1", "session_tokens", "a:1:{s:64:\"9f9041dc9de887a565f1d4b1717ea0f555966a60415a3840b37b52f6f0a320a8\";a:4:{s:10:\"expiration\";i:1674274016;s:2:\"ip\";s:13:\"82.66.116.111\";s:2:\"ua\";s:132:\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/96.0.4664.174 Safari/537.36 Edg/96.0.1054.75\";s:5:\"login\";i:1674101216;}}");
INSERT INTO `wp_usermeta` VALUES("17", "1", "wp_dashboard_quick_press_last_post_id", "227");
INSERT INTO `wp_usermeta` VALUES("18", "1", "community-events-location", "a:1:{s:2:\"ip\";s:11:\"82.66.116.0\";}");
INSERT INTO `wp_usermeta` VALUES("20", "1", "wp_user-settings", "mfold=o&libraryContent=browse");
INSERT INTO `wp_usermeta` VALUES("21", "1", "wp_user-settings-time", "1635177889");
INSERT INTO `wp_usermeta` VALUES("22", "1", "_yoast_wpseo_profile_updated", "1630420132");
INSERT INTO `wp_usermeta` VALUES("23", "1", "managenav-menuscolumnshidden", "a:5:{i:0;s:11:\"link-target\";i:1;s:11:\"css-classes\";i:2;s:3:\"xfn\";i:3;s:11:\"description\";i:4;s:15:\"title-attribute\";}");
INSERT INTO `wp_usermeta` VALUES("24", "1", "metaboxhidden_nav-menus", "a:3:{i:0;s:23:\"add-post-type-portfolio\";i:1;s:12:\"add-post_tag\";i:2;s:18:\"add-portfolio-type\";}");
INSERT INTO `wp_usermeta` VALUES("27", "1", "closedpostboxes_dashboard", "a:0:{}");
INSERT INTO `wp_usermeta` VALUES("28", "1", "metaboxhidden_dashboard", "a:3:{i:0;s:18:\"dashboard_activity\";i:1;s:21:\"dashboard_quick_press\";i:2;s:17:\"dashboard_primary\";}");
INSERT INTO `wp_usermeta` VALUES("29", "1", "meta-box-order_dashboard", "a:4:{s:6:\"normal\";s:60:\"dashboard_site_health,dashboard_right_now,dashboard_activity\";s:4:\"side\";s:64:\"dashboard_quick_press,dashboard_primary,wpseo-dashboard-overview\";s:7:\"column3\";s:0:\"\";s:7:\"column4\";s:0:\"\";}");
INSERT INTO `wp_usermeta` VALUES("30", "1", "nav_menu_recently_edited", "5");
INSERT INTO `wp_usermeta` VALUES("32", "1", "wp_persisted_preferences", "a:2:{s:14:\"core/edit-post\";a:3:{s:10:\"openPanels\";a:2:{i:0;s:11:\"post-status\";i:1;s:24:\"yoast-seo/document-panel\";}s:26:\"isComplementaryAreaVisible\";b:1;s:12:\"welcomeGuide\";b:0;}s:9:\"_modified\";s:24:\"2022-12-09T12:47:57.503Z\";}");
INSERT INTO `wp_usermeta` VALUES("33", "1", "_advanced-gutenberg_wp_reviews_dismissed_triggers", "a:1:{s:14:\"time_installed\";i:10;}");
INSERT INTO `wp_usermeta` VALUES("34", "1", "_advanced-gutenberg_wp_reviews_last_dismissed", "2023-01-19 05:09:04");

/* INSERT TABLE DATA: wp_users */
INSERT INTO `wp_users` VALUES("1", "Admin-site-wp", "$P$B4brhS6t01CRbjD9aUnjDI/MshqMJk.", "admin-site-wp", "contact@cabare.net", "https://www.orthopedie-podologie-anthoard-grenoble.com", "2021-08-31 06:03:25", "", "0", "Admin-site-wp");

/* INSERT TABLE DATA: wp_yoast_indexable */
INSERT INTO `wp_yoast_indexable` VALUES("2", "https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-anthoard-podologie-grenoble-mentions-legales/", "108:d1897468da5d954c1dee7fe5c852a4d0", "3", "post", "page", "1", "0", "cabinet anthoard podologie grenoble mentions legales", "mentions légales du cabinet de podologie et d\'orthopédie l\' Anthoard, de M Aubertin a Grenoble. Cabinet de Podologie à Grenoble depuis 2006.", "Mentions Légales &#8211; Politique de confidentialité", "publish", NULL, "0", NULL, NULL, NULL, NULL, NULL, "30", "0", NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "75", NULL, NULL, "2021-08-31 13:35:55", "2021-11-21 15:19:39", "1", NULL, NULL, NULL, NULL, "0", "14", "2", "2021-10-28 05:59:13", "2021-08-31 06:03:25");
INSERT INTO `wp_yoast_indexable` VALUES("6", "https://www.orthopedie-podologie-anthoard-grenoble.com/category/non-classe/", "75:548ab1383cd5ae276e758752a996e6ba", "1", "term", "category", NULL, NULL, NULL, NULL, "Non classé", NULL, NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "0", NULL, NULL, "2021-08-31 13:35:55", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", NULL, NULL);
INSERT INTO `wp_yoast_indexable` VALUES("7", NULL, NULL, NULL, "system-page", "404", NULL, NULL, "Page non trouvée %%sep%% %%sitename%%", NULL, "Erreur 404 : Page introuvable", NULL, NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, "0", "1", "0", "0", "0", "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "2021-08-31 13:35:55", "2021-10-28 14:35:32", "1", NULL, NULL, NULL, NULL, "0", NULL, "1", NULL, NULL);
INSERT INTO `wp_yoast_indexable` VALUES("8", NULL, NULL, NULL, "system-page", "search-result", NULL, NULL, "Vous avez cherché %%searchphrase%% %%page%% %%sep%% %%sitename%%", NULL, NULL, NULL, NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, "0", "1", "0", "0", "0", "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "2021-08-31 13:35:55", "2021-11-10 20:02:53", "1", NULL, NULL, NULL, NULL, "0", NULL, "1", NULL, NULL);
INSERT INTO `wp_yoast_indexable` VALUES("9", NULL, NULL, NULL, "date-archive", NULL, NULL, NULL, "%%date%% %%page%% %%sep%% %%sitename%%", "", NULL, NULL, "0", "0", NULL, NULL, NULL, NULL, NULL, NULL, "0", "1", "0", "0", "0", "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "2021-08-31 13:35:55", "2021-11-10 20:02:53", "1", NULL, NULL, NULL, NULL, "0", NULL, "1", NULL, NULL);
INSERT INTO `wp_yoast_indexable` VALUES("10", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "55:aca61b6eb565b67b5f9a93f2d5e18ebb", NULL, "home-page", NULL, NULL, NULL, "%%sitename%% %%page%% %%sep%% %%sitedesc%%", "Présentation du Cabinet d&#039;orthopédie de Podologie et de Posturologie ANTHOARD de M Aubertin Roger à Grenoble", "Accueil", NULL, NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, "0", "0", "0", "0", "0", "0", NULL, NULL, NULL, NULL, NULL, "%%sitename%%", "", "", "0", NULL, NULL, NULL, "79", NULL, "2021-08-31 13:35:55", "2023-01-19 04:18:21", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2023-01-19 04:18:20", NULL);
INSERT INTO `wp_yoast_indexable` VALUES("12", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "55:aca61b6eb565b67b5f9a93f2d5e18ebb", "8", "post", "page", "1", "0", "cabinet orthopédie podologie grenoble %%sep%% cabinet Antoard Grenoble Aubertin", "Bienvenue au Cabinet d\'orthopédie et de podologie fondé en 1995 par M Aubertin, diplômé de l\'école ECOTEV et installé à Grenoble depuis 2006 .", "Cabinet d&rsquo;Orthopédie de Podologie et de Posturologie l&rsquo;Anthoard &#8211; Grenoble", "publish", NULL, "0", NULL, NULL, NULL, "cabinet orthopédie podologie grenoble", "49", "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", NULL, "first-content-image", NULL, "0", "1", NULL, "2021-09-01 07:13:04", "2021-11-17 00:24:38", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2021-10-27 15:27:17", "2021-09-01 07:17:56");
INSERT INTO `wp_yoast_indexable` VALUES("14", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil.png", "99:c780842a61ac43d26c88b233868712d8", "13", "post", "attachment", "1", "8", NULL, NULL, "Image-accueil", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil.png", NULL, "13", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil-1024x779.png", "13", "attachment-image", "{\"width\":1024,\"height\":779,\"path\":\"2021/09/Image-accueil-1024x779.png\",\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/09/Image-accueil-1024x779.png\",\"size\":\"large\",\"id\":13,\"alt\":\"\",\"pixels\":797696,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-09-01 07:32:43", "2022-11-08 17:43:41", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-09-01 07:32:43", "2021-09-01 07:32:43");
INSERT INTO `wp_yoast_indexable` VALUES("15", "https://www.orthopedie-podologie-anthoard-grenoble.com/podologie-orthopedie-grenoble-anthoard-horaires/", "103:46887c8cdbf31651170d28aebb98936c", "16", "post", "page", "1", "0", "cabinet d\'orthopédie et de podologie de Grenoble ANTHOARD : horaires", "les consultations du cabinet de podologie orthopédie de Grenoble ANTHOARD sont sur rendez-vous Contacter le Secrétariat en cas d’urgence", "Horaires Cabinet Podologie Orthopédie Anthoard &#8211; Grenoble", "publish", NULL, "0", NULL, NULL, NULL, NULL, NULL, "90", "0", NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "0", NULL, NULL, "2021-09-01 07:56:54", "2021-11-21 15:19:36", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2021-10-28 05:56:10", "2021-09-01 07:56:54");
INSERT INTO `wp_yoast_indexable` VALUES("16", "https://www.orthopedie-podologie-anthoard-grenoble.com/histoire-du-cabinet-orthopedie-et-podologie-anthoard-grenoble/", "117:ae2d1db803c86eaa406cffda90989915", "19", "post", "page", "1", "0", "histoire cabinet orthopedie podologie aubertin grenoble", "Crée en aout 1995 par M AUBERTIN diplômé de l’ école ECOTEV de VIENNE en novembre 1993 , le cabinet s’est installé à Grenoble depuis 2006", "Histoire du Cabinet d&rsquo;orthopedie et de Podologie l&rsquo;Anthoard", "publish", NULL, "0", NULL, NULL, NULL, NULL, NULL, "90", "0", NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "0", NULL, NULL, "2021-09-01 07:58:55", "2022-12-09 12:54:40", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2022-12-09 12:54:40", "2021-09-01 07:58:55");
INSERT INTO `wp_yoast_indexable` VALUES("17", "https://www.orthopedie-podologie-anthoard-grenoble.com/orthopedie-podologie-grenoble/", "85:d168d30109a13fecdcd535b347dd3be3", "21", "post", "page", "1", "0", "orthopedie podologie grenoble", "Les prestations possibles en Orthopedie, podologie a Grenoble par le cabinet Anthoard sont nombreuses. Cabinet installé depuis 2006.", "Prestations du Cabinet d&rsquo;Orthopédie et de Podologie", "publish", NULL, "0", NULL, NULL, NULL, "orthopedie podologie grenoble", "53", "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", NULL, "first-content-image", NULL, "1", NULL, NULL, "2021-09-01 08:00:21", "2022-12-09 12:51:55", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2022-12-09 12:51:55", "2021-09-01 08:00:21");
INSERT INTO `wp_yoast_indexable` VALUES("18", "https://www.orthopedie-podologie-anthoard-grenoble.com/tarifs-en-orthopedie-et-podologie/", "89:dc1e277306aa46355c24a52bb0c979d7", "24", "post", "page", "1", "0", NULL, NULL, "Tarifs en Orthopédie et Podologie", "publish", NULL, "0", NULL, NULL, NULL, NULL, NULL, "90", "0", NULL, "0", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, "0", NULL, NULL, "2021-09-01 08:01:54", "2022-12-09 12:48:30", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2022-12-09 12:48:30", "2021-09-01 08:01:54");
INSERT INTO `wp_yoast_indexable` VALUES("19", "https://www.orthopedie-podologie-anthoard-grenoble.com/rendez-vous-au-cabinet-de-orthopedie-et-podologie-a-grenoble/", "116:40fc9c959e309eab473a9b7d5edb60ad", "26", "post", "page", "1", "0", NULL, NULL, "Rendez-Vous au Cabinet de Orthopédie et Podologie à Grenoble", "publish", NULL, "0", NULL, NULL, NULL, NULL, NULL, "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", NULL, "first-content-image", NULL, "0", NULL, NULL, "2021-09-01 08:02:41", "2021-11-19 09:48:33", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2021-10-26 11:33:45", "2021-09-01 08:02:41");
INSERT INTO `wp_yoast_indexable` VALUES("20", "https://www.orthopedie-podologie-anthoard-grenoble.com/cabinet-orthopedie-podologie-grenoble-anthoard-en-images/", "112:be54f1df42c60019fd36a0b0e1ff67a1", "28", "post", "page", "1", "0", "cabinet d\'orthopédie et de podologie de Grenoble ANTHOARD : en images", "Visite du cabinet d\'orthopédie et de podologie de Grenoble ANTHOARD : en images - présentation visuelle du cabinet de M AUBERTIN Roger", "Cabinet Orthopédie Podologie l&rsquo;ANTHOARD en images", "publish", NULL, "0", NULL, NULL, NULL, NULL, NULL, "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", NULL, "first-content-image", NULL, "0", NULL, NULL, "2021-09-01 08:04:12", "2023-01-19 04:18:21", "1", NULL, NULL, NULL, NULL, "0", "2", "2", "2023-01-19 04:18:20", "2021-09-01 08:04:12");
INSERT INTO `wp_yoast_indexable` VALUES("35", "https://www.orthopedie-podologie-anthoard-grenoble.com/orthopedie-grenoble/", "75:5c161dc0b7539f7d69ae5d44bd04e44b", "48", "post", "page", "1", "0", "orthopedie grenoble", "le cabinet d\' orthopedie à grenoble saura vous soulager pour toutes vos pathologies du pied, quelles que soient leurs origines", "Pathologies du Pied", "publish", NULL, "0", NULL, NULL, NULL, "orthopedie grenoble", "53", "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", NULL, "first-content-image", NULL, "1", NULL, NULL, "2021-10-25 08:24:03", "2021-11-20 10:39:06", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2021-10-28 06:14:31", "2021-10-25 08:24:03");
INSERT INTO `wp_yoast_indexable` VALUES("36", "https://www.orthopedie-podologie-anthoard-grenoble.com/podologiste-grenoble/", "76:bcc07736884ae7aa7aba2d6a602e3eb2", "50", "post", "page", "1", "0", "podologiste grenoble", "M Aubertin Podologiste a Grenoble vous accueille dans son cabinet de podologie installé depuis 2006 pour vous fabriquer vos orthèses", "Pathologies Posturales", "publish", NULL, "0", NULL, NULL, NULL, "podologiste grenoble", "53", "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", NULL, "first-content-image", NULL, "1", NULL, NULL, "2021-10-25 08:24:40", "2022-12-09 12:53:58", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2022-12-09 12:53:58", "2021-10-25 08:24:40");
INSERT INTO `wp_yoast_indexable` VALUES("37", "https://www.orthopedie-podologie-anthoard-grenoble.com/orthesiste-grenoble/", "75:6e2c04131853ba525e56bf3232383fec", "52", "post", "page", "1", "0", "orthesiste grenoble", "orthesiste grenoble - Spécialiste des orthèses sportives, des pathologies du pied, ou des pathologies posturales", "Orthèses Sportives", "publish", NULL, "0", NULL, NULL, NULL, "Orthesiste grenoble", "53", "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", NULL, "first-content-image", NULL, "1", NULL, NULL, "2021-10-25 08:25:04", "2021-11-20 10:39:01", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2021-10-28 06:05:02", "2021-10-25 08:25:04");
INSERT INTO `wp_yoast_indexable` VALUES("43", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg", "126:5085b86309383ea46f05a6bfc3214b6c", "59", "post", "attachment", "1", "0", NULL, NULL, "cabinet-anthoard-podologie-grenoble-fond", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg", NULL, "59", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg", "59", "attachment-image", "{\"width\":786,\"height\":628,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-anthoard-podologie-grenoble-fond.jpg\",\"size\":\"full\",\"id\":59,\"alt\":\"Cabinet anthoard orthopedie podologie a Grenoble\",\"pixels\":493608,\"type\":\"image/jpeg\"}", NULL, NULL, NULL, "2021-10-25 15:47:34", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-25 15:48:23", "2021-10-25 15:47:34");
INSERT INTO `wp_yoast_indexable` VALUES("44", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/99-002657_max.jpg", "99:7c1f853a88a83ed15e91424865454f04", "61", "post", "attachment", "1", "8", NULL, NULL, "99-002657_max", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/99-002657_max.jpg", NULL, "61", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/99-002657_max.jpg", "61", "attachment-image", "{\"width\":658,\"height\":1280,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/99-002657_max.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/99-002657_max.jpg\",\"size\":\"full\",\"id\":61,\"alt\":\"\",\"pixels\":842240,\"type\":\"image/jpeg\"}", NULL, NULL, NULL, "2021-10-25 16:03:06", "2022-11-08 17:43:41", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-25 16:03:06", "2021-10-25 16:03:06");
INSERT INTO `wp_yoast_indexable` VALUES("45", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", "137:46e1dd12f8abc2c46f83b08579f70744", "62", "post", "attachment", "1", "0", NULL, NULL, "cabinet-anthoard-orthopedie-podologie-grenoble-fond", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", NULL, "62", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", "62", "attachment-image", "{\"width\":800,\"height\":746,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png\",\"size\":\"full\",\"id\":62,\"alt\":\"\",\"pixels\":596800,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-25 16:08:51", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-25 16:08:51", "2021-10-25 16:08:51");
INSERT INTO `wp_yoast_indexable` VALUES("46", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", "115:68c483d61c4d7ad05ff904de83ee34f8", "115", "post", "attachment", "1", "26", NULL, NULL, "doc-rendezvous-aubertin-roger", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", NULL, "115", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", "115", "attachment-image", "{\"width\":847,\"height\":174,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png\",\"size\":\"full\",\"id\":115,\"alt\":\"\",\"pixels\":147378,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-26 11:28:11", "2022-11-08 17:44:37", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-26 11:28:11", "2021-10-26 11:28:11");
INSERT INTO `wp_yoast_indexable` VALUES("49", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg", "101:24ceae86035aca555ab5e6199c0cd5b0", "149", "post", "attachment", "1", "0", NULL, NULL, "cabinet-atelier", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg", NULL, "149", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg", "149", "attachment-image", "{\"width\":555,\"height\":371,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-atelier.jpg\",\"size\":\"full\",\"id\":149,\"alt\":\"Atelier Cabinet Podologie\",\"pixels\":205905,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:55", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:02:18", "2021-10-26 12:54:55");
INSERT INTO `wp_yoast_indexable` VALUES("50", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg", "101:d6acc99a8067ec60a945cfaf859b10bf", "150", "post", "attachment", "1", "0", NULL, NULL, "cabinet-couloir", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg", NULL, "150", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg", "150", "attachment-image", "{\"width\":548,\"height\":326,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-couloir.jpg\",\"size\":\"full\",\"id\":150,\"alt\":\"Couloir accès cabinet\",\"pixels\":178648,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:56", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:01:58", "2021-10-26 12:54:56");
INSERT INTO `wp_yoast_indexable` VALUES("51", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", "103:8e804eaca421f0cd4bf9f5d8e1df73e0", "151", "post", "attachment", "1", "0", NULL, NULL, "cabinet-exterieur", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", NULL, "151", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", "151", "attachment-image", "{\"width\":526,\"height\":355,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-exterieur.jpg\",\"size\":\"full\",\"id\":151,\"alt\":\"6 Rue ANTHOARD 38000 Grenoble\",\"pixels\":186730,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:56", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:01:20", "2021-10-26 12:54:56");
INSERT INTO `wp_yoast_indexable` VALUES("52", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg", "113:e8561bea670d5e2f1156645a47e66cb8", "152", "post", "attachment", "1", "0", NULL, NULL, "cabinet-machine-physioforme", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg", NULL, "152", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg", "152", "attachment-image", "{\"width\":567,\"height\":381,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg\",\"size\":\"full\",\"id\":152,\"alt\":\"Machine Physioforme\",\"pixels\":216027,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:56", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:02:12", "2021-10-26 12:54:56");
INSERT INTO `wp_yoast_indexable` VALUES("53", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg", "101:ebdb217a16f2013cab7211a0189501b3", "153", "post", "attachment", "1", "0", NULL, NULL, "cabinet-parking", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg", NULL, "153", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg", "153", "attachment-image", "{\"width\":544,\"height\":346,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-parking.jpg\",\"size\":\"full\",\"id\":153,\"alt\":\"Entrée 6 rue ANTHOARD 38000 Grenoble\",\"pixels\":188224,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:57", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:01:32", "2021-10-26 12:54:57");
INSERT INTO `wp_yoast_indexable` VALUES("54", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg", "107:42afd59bc45efae694fda5e140254576", "154", "post", "attachment", "1", "0", NULL, NULL, "cabinet-salle-attente", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg", NULL, "154", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg", "154", "attachment-image", "{\"width\":545,\"height\":364,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-salle-attente.jpg\",\"size\":\"full\",\"id\":154,\"alt\":\"Salle d\'attente cabinet\",\"pixels\":198380,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:57", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:01:51", "2021-10-26 12:54:57");
INSERT INTO `wp_yoast_indexable` VALUES("55", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg", "108:f3601cb8e8888205c3ed6a2302404f8c", "155", "post", "attachment", "1", "0", NULL, NULL, "cabinet-salle-examen-1", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg", NULL, "155", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg", "155", "attachment-image", "{\"width\":555,\"height\":416,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg\",\"size\":\"full\",\"id\":155,\"alt\":\"Cabinet Podologie\",\"pixels\":230880,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:57", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:02:04", "2021-10-26 12:54:57");
INSERT INTO `wp_yoast_indexable` VALUES("56", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg", "108:e94443b57f58a25f373b4f49970c6937", "156", "post", "attachment", "1", "0", NULL, NULL, "cabinet-salle-examen-2", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg", NULL, "156", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg", "156", "attachment-image", "{\"width\":555,\"height\":416,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg\",\"size\":\"full\",\"id\":156,\"alt\":\"Cabinet Orthopedie\",\"pixels\":230880,\"type\":\"image/jpeg\"}", NULL, "1", NULL, "2021-10-26 12:54:57", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 13:02:08", "2021-10-26 12:54:57");
INSERT INTO `wp_yoast_indexable` VALUES("57", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png", "137:9bdab7874e64272822a0cddb3b6cb5c7", "158", "post", "attachment", "1", "0", NULL, NULL, "cabinet-anthoard-orthopedie-podologie-grenoble-logo", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png", NULL, "158", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png", "158", "attachment-image", "{\"width\":256,\"height\":100,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-logo.png\",\"size\":\"full\",\"id\":158,\"alt\":\"\",\"pixels\":25600,\"type\":\"image/png\"}", NULL, NULL, NULL, "2021-10-26 16:24:52", "2022-12-09 12:41:26", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2021-10-26 16:24:52", "2021-10-26 16:24:52");
INSERT INTO `wp_yoast_indexable` VALUES("58", "https://www.orthopedie-podologie-anthoard-grenoble.com/podologie-grenoble/", "74:693fd314a893979b5f89ff6d2e7065be", "165", "post", "page", "1", "0", "PODOLOGIE Grenoble %%sep%%", "Cabinet de Podologie à Grenoble. pour Venir au Cabinet de podologie Situé Rue Anthoard à Grenoble vous devez prendre un Rendez Vous", "Venir au Cabinet d&rsquo;Orthopédie et de Podologie à Grenoble", "publish", NULL, "0", NULL, NULL, NULL, "Podologie Grenoble", "57", "90", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", NULL, NULL, "first-content-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", NULL, "first-content-image", NULL, "1", NULL, NULL, "2021-10-27 07:10:34", "2021-11-21 15:19:44", "1", NULL, NULL, NULL, NULL, "0", "1", "2", "2021-10-28 05:36:19", "2021-10-27 07:11:57");
INSERT INTO `wp_yoast_indexable` VALUES("73", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", "108:90864782e40598922f9fa575b08b3b07", "200", "post", "attachment", "1", "165", NULL, NULL, "img-podologie-grenoble", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", NULL, "200", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", "200", "attachment-image", "{\"width\":709,\"height\":46,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/img-podologie-grenoble.png\",\"size\":\"full\",\"id\":200,\"alt\":\"\",\"pixels\":32614,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-28 05:31:42", "2022-11-08 17:45:05", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-28 05:31:42", "2021-10-28 05:31:42");
INSERT INTO `wp_yoast_indexable` VALUES("74", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", "109:421c856911b279820eebc9148187f909", "207", "post", "attachment", "1", "52", NULL, NULL, "img-orthesiste-grenoble", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", NULL, "207", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", "207", "attachment-image", "{\"width\":709,\"height\":46,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/img-orthesiste-grenoble.png\",\"size\":\"full\",\"id\":207,\"alt\":\"\",\"pixels\":32614,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-28 06:03:26", "2022-11-08 18:05:47", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-28 06:03:26", "2021-10-28 06:03:26");
INSERT INTO `wp_yoast_indexable` VALUES("75", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", "119:695bda2307747b2709e689a9061f981d", "211", "post", "attachment", "1", "21", NULL, NULL, "img-orthopedie-podologie-grenoble", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", NULL, "211", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", "211", "attachment-image", "{\"width\":709,\"height\":46,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png\",\"size\":\"full\",\"id\":211,\"alt\":\"\",\"pixels\":32614,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-28 06:09:50", "2022-11-08 17:45:46", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-28 06:09:50", "2021-10-28 06:09:50");
INSERT INTO `wp_yoast_indexable` VALUES("76", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", "109:c2ae2c25be42b1365ecd9e962157d5c3", "214", "post", "attachment", "1", "48", NULL, NULL, "img-orthopedie-grenoble", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", NULL, "214", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", "214", "attachment-image", "{\"width\":709,\"height\":46,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/img-orthopedie-grenoble.png\",\"size\":\"full\",\"id\":214,\"alt\":\"\",\"pixels\":32614,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-28 06:13:48", "2022-11-08 18:00:25", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-28 06:13:48", "2021-10-28 06:13:48");
INSERT INTO `wp_yoast_indexable` VALUES("77", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", "110:d528cda31ce63dc54afe946cb4cff33d", "217", "post", "attachment", "1", "50", NULL, NULL, "img-podologiste-grenoble", "inherit", NULL, "0", NULL, NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", NULL, "217", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", "217", "attachment-image", "{\"width\":709,\"height\":46,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png\",\"path\":\"/home/orthopa/www/wp-content/uploads/2021/10/img-podologiste-grenoble.png\",\"size\":\"full\",\"id\":217,\"alt\":\"\",\"pixels\":32614,\"type\":\"image/png\"}", NULL, "1", NULL, "2021-10-28 06:17:27", "2022-11-08 18:03:15", "1", NULL, NULL, NULL, NULL, "1", NULL, "2", "2021-10-28 06:17:27", "2021-10-28 06:17:27");
INSERT INTO `wp_yoast_indexable` VALUES("78", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-scaled.jpg", "104:787a932bd274121c7e8dc3d0f32cca0b", "228", "post", "attachment", "1", "0", NULL, NULL, "Physioforme", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-scaled.jpg", NULL, "228", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-scaled.jpg", "228", "attachment-image", "{\"width\":2560,\"height\":1920,\"filesize\":585320,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-scaled.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2023/01/Physioforme-scaled.jpg\",\"size\":\"full\",\"id\":228,\"alt\":\"Physioforme vue globale\",\"pixels\":4915200,\"type\":\"image/jpeg\"}", NULL, NULL, NULL, "2023-01-19 04:10:40", "2023-01-19 04:11:41", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2023-01-19 04:11:41", "2023-01-19 04:10:40");
INSERT INTO `wp_yoast_indexable` VALUES("79", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-scaled-e1674101767598.jpg", "125:b70401bc337a53fd0b5ebc3b19094d84", "231", "post", "attachment", "1", "0", NULL, NULL, "orthese plantaire", "inherit", "0", "0", "0", NULL, NULL, NULL, NULL, "0", "0", NULL, "0", NULL, NULL, NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-scaled-e1674101767598.jpg", NULL, "231", "attachment-image", NULL, NULL, "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-scaled-e1674101767598.jpg", "231", "attachment-image", "{\"width\":560,\"height\":420,\"filesize\":451923,\"url\":\"https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-scaled-e1674101767598.jpg\",\"path\":\"/home/orthopa/www/wp-content/uploads/2023/01/orthese-plantaire-scaled-e1674101767598.jpg\",\"size\":\"full\",\"id\":231,\"alt\":\"orthèse plantaire\",\"pixels\":235200,\"type\":\"image/jpeg\"}", NULL, NULL, NULL, "2023-01-19 04:15:00", "2023-01-19 04:16:13", "1", NULL, NULL, NULL, NULL, "0", NULL, "2", "2023-01-19 04:16:13", "2023-01-19 04:15:00");

/* INSERT TABLE DATA: wp_yoast_indexable_hierarchy */
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("2", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("6", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("8", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("10", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("12", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("14", "12", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("15", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("16", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("17", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("18", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("19", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("20", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("35", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("36", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("37", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("43", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("44", "12", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("45", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("46", "19", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("49", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("50", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("51", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("52", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("53", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("54", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("55", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("56", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("57", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("58", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("73", "58", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("74", "37", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("75", "17", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("76", "35", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("77", "36", "1", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("78", "0", "0", "1");
INSERT INTO `wp_yoast_indexable_hierarchy` VALUES("79", "0", "0", "1");

/* INSERT TABLE DATA: wp_yoast_migrations */
INSERT INTO `wp_yoast_migrations` VALUES("1", "20171228151840");
INSERT INTO `wp_yoast_migrations` VALUES("2", "20171228151841");
INSERT INTO `wp_yoast_migrations` VALUES("3", "20190529075038");
INSERT INTO `wp_yoast_migrations` VALUES("4", "20191011111109");
INSERT INTO `wp_yoast_migrations` VALUES("5", "20200408101900");
INSERT INTO `wp_yoast_migrations` VALUES("6", "20200420073606");
INSERT INTO `wp_yoast_migrations` VALUES("7", "20200428123747");
INSERT INTO `wp_yoast_migrations` VALUES("8", "20200428194858");
INSERT INTO `wp_yoast_migrations` VALUES("9", "20200429105310");
INSERT INTO `wp_yoast_migrations` VALUES("10", "20200430075614");
INSERT INTO `wp_yoast_migrations` VALUES("11", "20200430150130");
INSERT INTO `wp_yoast_migrations` VALUES("12", "20200507054848");
INSERT INTO `wp_yoast_migrations` VALUES("13", "20200513133401");
INSERT INTO `wp_yoast_migrations` VALUES("14", "20200609154515");
INSERT INTO `wp_yoast_migrations` VALUES("15", "20200616130143");
INSERT INTO `wp_yoast_migrations` VALUES("16", "20200617122511");
INSERT INTO `wp_yoast_migrations` VALUES("17", "20200702141921");
INSERT INTO `wp_yoast_migrations` VALUES("18", "20200728095334");
INSERT INTO `wp_yoast_migrations` VALUES("19", "20201202144329");
INSERT INTO `wp_yoast_migrations` VALUES("20", "20201216124002");
INSERT INTO `wp_yoast_migrations` VALUES("21", "20201216141134");
INSERT INTO `wp_yoast_migrations` VALUES("22", "20210817092415");
INSERT INTO `wp_yoast_migrations` VALUES("23", "20211020091404");

/* INSERT TABLE DATA: wp_yoast_seo_links */
INSERT INTO `wp_yoast_seo_links` VALUES("10", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-anthoard-orthopedie-podologie-grenoble-fond.png", "8", "62", "image-in", "12", "45", "746", "800", "387615", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("11", "https://docrendezvous.fr", "26", NULL, "external", "19", NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("12", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/doc-rendezvous-aubertin-roger.png", "26", "115", "image-in", "19", "46", "174", "847", "30364", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("13", "https://docrendezvous.fr/", "26", NULL, "external", "19", NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("14", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("15", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("16", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("17", "https://fr.orson.io/1371/generateur-mentions-legales", "3", NULL, "external", "2", NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("18", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("19", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("20", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("21", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("22", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("23", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("24", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("25", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("26", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("27", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("28", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("29", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("30", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("31", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("32", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("33", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("34", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("35", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("36", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("37", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("38", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("39", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("40", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("41", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("42", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("43", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("44", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("45", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("46", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("47", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("48", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("49", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("50", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("51", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("52", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("53", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("54", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("55", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("56", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("57", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("58", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("59", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("60", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("61", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("62", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("63", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("64", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("65", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("66", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("67", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("68", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("69", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("70", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("71", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("72", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("73", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("74", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("75", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("76", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("77", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("78", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("79", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("80", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("81", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("82", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("83", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("84", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("85", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("86", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("87", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("88", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("89", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "3", NULL, "internal", "2", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("92", "tel:04.76.00.11.59", "8", NULL, "external", "12", NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("93", "mailto:auberoger.2@orange.fr", "8", NULL, "external", "12", NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("94", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-exterieur.jpg", "28", "151", "image-in", "20", "51", "355", "526", "30913", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("95", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-parking.jpg", "28", "153", "image-in", "20", "53", "346", "544", "29671", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("96", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-attente.jpg", "28", "154", "image-in", "20", "54", "364", "545", "16148", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("97", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-couloir.jpg", "28", "150", "image-in", "20", "50", "326", "548", "12641", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("98", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-1.jpg", "28", "155", "image-in", "20", "55", "416", "555", "24975", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("99", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-salle-examen-2.jpg", "28", "156", "image-in", "20", "56", "416", "555", "21442", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("100", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-machine-physioforme.jpg", "28", "152", "image-in", "20", "52", "381", "567", "28931", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("101", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/cabinet-atelier.jpg", "28", "149", "image-in", "20", "49", "371", "555", "19707", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("102", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologie-grenoble.png", "165", "200", "image-in", "58", "73", "46", "709", "14215", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("103", "https://www.orthopedie-podologie-anthoard-grenoble.com", "165", "8", "internal", "58", "12", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("104", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthesiste-grenoble.png", "52", "207", "image-in", "37", "74", "46", "709", "14215", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("105", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "52", NULL, "internal", "37", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("106", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "21", NULL, "internal", "17", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("107", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-podologie-grenoble.png", "21", "211", "image-in", "17", "75", "46", "709", "14215", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("108", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "48", NULL, "internal", "35", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("109", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-orthopedie-grenoble.png", "48", "214", "image-in", "35", "76", "46", "709", "14215", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("110", "https://www.orthopedie-podologie-anthoard-grenoble.com/", "50", NULL, "internal", "36", "10", NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("111", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2021/10/img-podologiste-grenoble.png", "50", "217", "image-in", "36", "77", "46", "709", "14215", NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("112", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/Physioforme-1024x768.jpg", "28", NULL, "image-in", "20", NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `wp_yoast_seo_links` VALUES("113", "https://www.orthopedie-podologie-anthoard-grenoble.com/wp-content/uploads/2023/01/orthese-plantaire-1024x768.jpg", "28", NULL, "image-in", "20", NULL, NULL, NULL, NULL, NULL, NULL);

SET FOREIGN_KEY_CHECKS = 1; 

/* Duplicator WordPress Timestamp: 2023-01-19 04:47:08*/
/* DUPLICATOR_MYSQLDUMP_EOF */
